""" Cisco_IOS_XR_asr9k_qos_oper 

This module contains a collection of YANG definitions
for Cisco IOS\-XR asr9k\-qos package operational data.

This module contains definitions
for the following management objects\:
  platform\-qos\: QoS ASR9K platform operational data 

Copyright (c) 2013\-2016 by Cisco Systems, Inc.
All rights reserved.

"""
from ydk.entity_utils import get_relative_entity_path as _get_relative_entity_path
from ydk.types import Entity, EntityPath, Identity, Enum, YType, YLeaf, YLeafList, YList, LeafDataList, Bits, Empty, Decimal64
from ydk.filters import YFilter
from ydk.errors import YPYError, YPYModelError
from ydk.errors.error_handler import handle_type_error as _handle_type_error


class Action(Enum):
    """
    Action

    Action type

    .. data:: police_transmit = 0

    	Police action transmit

    .. data:: police_set_transmit = 1

    	Police action set transmit

    .. data:: police_drop = 2

    	Police action drop

    .. data:: police_unknown = 3

    	Police action unknown

    """

    police_transmit = Enum.YLeaf(0, "police-transmit")

    police_set_transmit = Enum.YLeaf(1, "police-set-transmit")

    police_drop = Enum.YLeaf(2, "police-drop")

    police_unknown = Enum.YLeaf(3, "police-unknown")


class ActionOpcode(Enum):
    """
    ActionOpcode

    Action opcode

    .. data:: precedence = 0

    	Precedence

    .. data:: dscp = 1

    	DSCP

    .. data:: discard_class = 2

    	Discard class

    .. data:: qos_group = 3

    	QoS group

    .. data:: cos_inner = 4

    	COS inner

    .. data:: cos = 5

    	COS

    .. data:: exp_top = 6

    	EXP top

    .. data:: exp_imp = 7

    	EXP IMP

    .. data:: tunnel_precedence = 8

    	Tunnel precedence

    .. data:: tunnel_dscp = 9

    	Tunnel DSCP

    .. data:: itag_dei = 10

    	ITAG DEI

    .. data:: itag_cos = 11

    	ITAG COS

    .. data:: cos_imposition = 12

    	COS imposition

    .. data:: dei_imposition = 13

    	DEI imposition

    .. data:: dei = 14

    	DEI

    .. data:: no_marking = 15

    	No marking

    """

    precedence = Enum.YLeaf(0, "precedence")

    dscp = Enum.YLeaf(1, "dscp")

    discard_class = Enum.YLeaf(2, "discard-class")

    qos_group = Enum.YLeaf(3, "qos-group")

    cos_inner = Enum.YLeaf(4, "cos-inner")

    cos = Enum.YLeaf(5, "cos")

    exp_top = Enum.YLeaf(6, "exp-top")

    exp_imp = Enum.YLeaf(7, "exp-imp")

    tunnel_precedence = Enum.YLeaf(8, "tunnel-precedence")

    tunnel_dscp = Enum.YLeaf(9, "tunnel-dscp")

    itag_dei = Enum.YLeaf(10, "itag-dei")

    itag_cos = Enum.YLeaf(11, "itag-cos")

    cos_imposition = Enum.YLeaf(12, "cos-imposition")

    dei_imposition = Enum.YLeaf(13, "dei-imposition")

    dei = Enum.YLeaf(14, "dei")

    no_marking = Enum.YLeaf(15, "no-marking")


class CacState(Enum):
    """
    CacState

    CAC/UBRL class states

    .. data:: unknown = 0

    	unknown

    .. data:: admit = 1

    	admit

    .. data:: redirect = 2

    	redirect

    .. data:: ubrl = 3

    	ubrl

    """

    unknown = Enum.YLeaf(0, "unknown")

    admit = Enum.YLeaf(1, "admit")

    redirect = Enum.YLeaf(2, "redirect")

    ubrl = Enum.YLeaf(3, "ubrl")


class PolicyParamUnit(Enum):
    """
    PolicyParamUnit

    Policy param unit

    .. data:: policy_param_unit_invalid = 0

    	policy param unit invalid

    .. data:: policy_param_unit_bytes = 1

    	policy param unit bytes

    .. data:: policy_param_unit_kbytes = 2

    	policy param unit kbytes

    .. data:: policy_param_unit_mbytes = 3

    	policy param unit mbytes

    .. data:: policy_param_unit_gbytes = 4

    	policy param unit gbytes

    .. data:: policy_param_unit_bitsps = 5

    	policy param unit bitsps

    .. data:: policy_param_unit_kbitsps = 6

    	policy param unit kbitsps

    .. data:: policy_param_unit_mbitsps = 7

    	policy param unit mbitsps

    .. data:: policy_param_unit_gbitsps = 8

    	policy param unit gbitsps

    .. data:: policy_param_unit_cells_ps = 9

    	policy param unit cells ps

    .. data:: policy_param_unit_packets_ps = 10

    	policy param unit packets ps

    .. data:: policy_param_unit_us = 11

    	policy param unit us

    .. data:: policy_param_unit_ms = 12

    	policy param unit ms

    .. data:: policy_param_unit_seconds = 13

    	policy param unit seconds

    .. data:: policy_param_unit_packets = 14

    	policy param unit packets

    .. data:: policy_param_unit_cells = 15

    	policy param unit cells

    .. data:: policy_param_unit_percent = 16

    	policy param unit percent

    .. data:: policy_param_unit_per_thousand = 17

    	policy param unit per thousand

    .. data:: policy_param_unit_per_million = 18

    	policy param unit per million

    .. data:: policy_param_unit_hz = 19

    	policy param unit hz

    .. data:: policy_param_unit_khz = 20

    	policy param unit khz

    .. data:: policy_param_unit_mhz = 21

    	policy param unit mhz

    .. data:: policy_param_unit_ratio = 22

    	policy param unit ratio

    .. data:: policy_param_unit_max = 23

    	policy param unit max

    """

    policy_param_unit_invalid = Enum.YLeaf(0, "policy-param-unit-invalid")

    policy_param_unit_bytes = Enum.YLeaf(1, "policy-param-unit-bytes")

    policy_param_unit_kbytes = Enum.YLeaf(2, "policy-param-unit-kbytes")

    policy_param_unit_mbytes = Enum.YLeaf(3, "policy-param-unit-mbytes")

    policy_param_unit_gbytes = Enum.YLeaf(4, "policy-param-unit-gbytes")

    policy_param_unit_bitsps = Enum.YLeaf(5, "policy-param-unit-bitsps")

    policy_param_unit_kbitsps = Enum.YLeaf(6, "policy-param-unit-kbitsps")

    policy_param_unit_mbitsps = Enum.YLeaf(7, "policy-param-unit-mbitsps")

    policy_param_unit_gbitsps = Enum.YLeaf(8, "policy-param-unit-gbitsps")

    policy_param_unit_cells_ps = Enum.YLeaf(9, "policy-param-unit-cells-ps")

    policy_param_unit_packets_ps = Enum.YLeaf(10, "policy-param-unit-packets-ps")

    policy_param_unit_us = Enum.YLeaf(11, "policy-param-unit-us")

    policy_param_unit_ms = Enum.YLeaf(12, "policy-param-unit-ms")

    policy_param_unit_seconds = Enum.YLeaf(13, "policy-param-unit-seconds")

    policy_param_unit_packets = Enum.YLeaf(14, "policy-param-unit-packets")

    policy_param_unit_cells = Enum.YLeaf(15, "policy-param-unit-cells")

    policy_param_unit_percent = Enum.YLeaf(16, "policy-param-unit-percent")

    policy_param_unit_per_thousand = Enum.YLeaf(17, "policy-param-unit-per-thousand")

    policy_param_unit_per_million = Enum.YLeaf(18, "policy-param-unit-per-million")

    policy_param_unit_hz = Enum.YLeaf(19, "policy-param-unit-hz")

    policy_param_unit_khz = Enum.YLeaf(20, "policy-param-unit-khz")

    policy_param_unit_mhz = Enum.YLeaf(21, "policy-param-unit-mhz")

    policy_param_unit_ratio = Enum.YLeaf(22, "policy-param-unit-ratio")

    policy_param_unit_max = Enum.YLeaf(23, "policy-param-unit-max")


class PolicyState(Enum):
    """
    PolicyState

    Different Interface states

    .. data:: active = 0

    	active

    .. data:: suspended = 1

    	suspended

    """

    active = Enum.YLeaf(0, "active")

    suspended = Enum.YLeaf(1, "suspended")


class QosUnit(Enum):
    """
    QosUnit

    QoS parameter unit

    .. data:: invalid = 0

    	Invalid type

    .. data:: bytes = 1

    	Bytes

    .. data:: kilobytes = 2

    	Kilobytes

    .. data:: megabytes = 3

    	Megabytes

    .. data:: gigabytes = 4

    	Gigabytes

    .. data:: bps = 5

    	Bits per second

    .. data:: kbps = 6

    	Kilo bits per second

    .. data:: mbps = 7

    	Mega bits per second

    .. data:: gbps = 8

    	Giga bits per second

    .. data:: cells_per_second = 9

    	Cells per second

    .. data:: packets_per_second = 10

    	Packets per second

    .. data:: microsecond = 11

    	Microsecond

    .. data:: millisecond = 12

    	Millisecond

    .. data:: packets = 13

    	Number of packets

    .. data:: cells = 14

    	Number of cells

    .. data:: percentage = 15

    	Percentage

    .. data:: ratio = 16

    	Ratio

    """

    invalid = Enum.YLeaf(0, "invalid")

    bytes = Enum.YLeaf(1, "bytes")

    kilobytes = Enum.YLeaf(2, "kilobytes")

    megabytes = Enum.YLeaf(3, "megabytes")

    gigabytes = Enum.YLeaf(4, "gigabytes")

    bps = Enum.YLeaf(5, "bps")

    kbps = Enum.YLeaf(6, "kbps")

    mbps = Enum.YLeaf(7, "mbps")

    gbps = Enum.YLeaf(8, "gbps")

    cells_per_second = Enum.YLeaf(9, "cells-per-second")

    packets_per_second = Enum.YLeaf(10, "packets-per-second")

    microsecond = Enum.YLeaf(11, "microsecond")

    millisecond = Enum.YLeaf(12, "millisecond")

    packets = Enum.YLeaf(13, "packets")

    cells = Enum.YLeaf(14, "cells")

    percentage = Enum.YLeaf(15, "percentage")

    ratio = Enum.YLeaf(16, "ratio")


class Queue(Enum):
    """
    Queue

    Queue type

    .. data:: port_default = 0

    	Port default queue

    .. data:: class_default = 1

    	The default queue in this policy

    .. data:: priority1_queue = 2

    	Create the priority 1 queue in the level which

    	will be shared by other p1 classes

    .. data:: priority2_queue = 3

    	Create the priority 2 queue in the level, which

    	will be shared by other p2 classes

    .. data:: priority3_queue = 4

    	Create the priority 3 queue in the level, which

    	will be shared by other p3 classes

    .. data:: priority4_queue = 5

    	Create the priority 4 queue in the level, which

    	will be shared by other p4 classes

    .. data:: priority5_queue = 6

    	Create the priority 5 queue in the level, which

    	will be shared by other p5 classes

    .. data:: priority6_queue = 7

    	Create the priority 6 queue in the level, which

    	will be shared by other p6 classes

    .. data:: priority7_queue = 8

    	Create the priority 7 queue in the level, which

    	will be shared by other p7 classes

    .. data:: first_p1_class_name = 9

    	Current level's priority 1 queue

    .. data:: first_p2_class_name = 10

    	Current level's priority 2 queue

    .. data:: first_p3_class_name = 11

    	Current level's priority 3 queue

    .. data:: first_p4_class_name = 12

    	Current level's priority 4 queue

    .. data:: first_p5_class_name = 13

    	Current level's priority 5 queue

    .. data:: first_p6_class_name = 14

    	Current level's priority 6 queue

    .. data:: first_p7_class_name = 15

    	Current level's priority 7 queue

    .. data:: port_priority1 = 16

    	Port priority 1 queue

    .. data:: port_priority2 = 17

    	Port priority 2 queue

    .. data:: port_priority3 = 18

    	Port priority 3 queue

    .. data:: port_priority4 = 19

    	Port priority 4 queue

    .. data:: port_priority5 = 20

    	Port priority 5 queue

    .. data:: port_priority6 = 21

    	Port priority 6 queue

    .. data:: port_priority7 = 22

    	Port priority 7 queue

    .. data:: new = 23

    	Create a new queue for this class

    .. data:: parent_class = 24

    	Under parent queue

    .. data:: priority1 = 25

    	Priority 1

    .. data:: priority2 = 26

    	Priority 2

    .. data:: priority3 = 27

    	Priority 3

    .. data:: priority4 = 28

    	Priority 4

    .. data:: priority5 = 29

    	Priority 5

    .. data:: priority6 = 30

    	Priority 6

    .. data:: priority7 = 31

    	Priority 7

    .. data:: priority_ignored_normal = 32

    	Priority ignored level

    .. data:: normal_priority = 33

    	Normal priority

    .. data:: class_unknown = 34

    	Class unknown

    .. data:: unknown_priority = 35

    	Unknown priority

    """

    port_default = Enum.YLeaf(0, "port-default")

    class_default = Enum.YLeaf(1, "class-default")

    priority1_queue = Enum.YLeaf(2, "priority1-queue")

    priority2_queue = Enum.YLeaf(3, "priority2-queue")

    priority3_queue = Enum.YLeaf(4, "priority3-queue")

    priority4_queue = Enum.YLeaf(5, "priority4-queue")

    priority5_queue = Enum.YLeaf(6, "priority5-queue")

    priority6_queue = Enum.YLeaf(7, "priority6-queue")

    priority7_queue = Enum.YLeaf(8, "priority7-queue")

    first_p1_class_name = Enum.YLeaf(9, "first-p1-class-name")

    first_p2_class_name = Enum.YLeaf(10, "first-p2-class-name")

    first_p3_class_name = Enum.YLeaf(11, "first-p3-class-name")

    first_p4_class_name = Enum.YLeaf(12, "first-p4-class-name")

    first_p5_class_name = Enum.YLeaf(13, "first-p5-class-name")

    first_p6_class_name = Enum.YLeaf(14, "first-p6-class-name")

    first_p7_class_name = Enum.YLeaf(15, "first-p7-class-name")

    port_priority1 = Enum.YLeaf(16, "port-priority1")

    port_priority2 = Enum.YLeaf(17, "port-priority2")

    port_priority3 = Enum.YLeaf(18, "port-priority3")

    port_priority4 = Enum.YLeaf(19, "port-priority4")

    port_priority5 = Enum.YLeaf(20, "port-priority5")

    port_priority6 = Enum.YLeaf(21, "port-priority6")

    port_priority7 = Enum.YLeaf(22, "port-priority7")

    new = Enum.YLeaf(23, "new")

    parent_class = Enum.YLeaf(24, "parent-class")

    priority1 = Enum.YLeaf(25, "priority1")

    priority2 = Enum.YLeaf(26, "priority2")

    priority3 = Enum.YLeaf(27, "priority3")

    priority4 = Enum.YLeaf(28, "priority4")

    priority5 = Enum.YLeaf(29, "priority5")

    priority6 = Enum.YLeaf(30, "priority6")

    priority7 = Enum.YLeaf(31, "priority7")

    priority_ignored_normal = Enum.YLeaf(32, "priority-ignored-normal")

    normal_priority = Enum.YLeaf(33, "normal-priority")

    class_unknown = Enum.YLeaf(34, "class-unknown")

    unknown_priority = Enum.YLeaf(35, "unknown-priority")


class ShapeProfiletypeV2(Enum):
    """
    ShapeProfiletypeV2

    SHAPE profile type

    .. data:: invalid = 0

    	Shape Profile Type Invalid

    .. data:: always = 1

    	Shape Profile Type Always

    .. data:: never = 2

    	Shape Profile Type Never

    .. data:: explicit = 3

    	Shape Profile Type Explicit

    .. data:: scale = 4

    	Shape Profile Type Scale

    .. data:: grid = 5

    	Shape Profile Type Grid

    """

    invalid = Enum.YLeaf(0, "invalid")

    always = Enum.YLeaf(1, "always")

    never = Enum.YLeaf(2, "never")

    explicit = Enum.YLeaf(3, "explicit")

    scale = Enum.YLeaf(4, "scale")

    grid = Enum.YLeaf(5, "grid")


class TbAlgorithm(Enum):
    """
    TbAlgorithm

    Tokenbucket type

    .. data:: inactive = 0

    	Inactive, configured but disabled

    .. data:: single = 1

    	Single token bucket

    .. data:: single_rate_tcm = 2

    	Single rate three color marker

    .. data:: two_rate_tcm = 3

    	Two rate three color marker

    .. data:: mef_tcm = 4

    	Allows coupling between CIR and PIR tb's

    .. data:: dummy = 5

    	Internal dummy token bucket for coupled-policer

    	child

    """

    inactive = Enum.YLeaf(0, "inactive")

    single = Enum.YLeaf(1, "single")

    single_rate_tcm = Enum.YLeaf(2, "single-rate-tcm")

    two_rate_tcm = Enum.YLeaf(3, "two-rate-tcm")

    mef_tcm = Enum.YLeaf(4, "mef-tcm")

    dummy = Enum.YLeaf(5, "dummy")


class Wred(Enum):
    """
    Wred

    WRED type

    .. data:: wred_cos = 0

    	WRED based on COS

    .. data:: wred_dscp = 1

    	WRED based on DSCP

    .. data:: wred_precedence = 2

    	WRED based on Precedence

    .. data:: wred_discard_class = 3

    	WRED based on discard class

    .. data:: wred_mpls_exp = 4

    	WRED based on MPLS EXP

    .. data:: red_with_user_min_max = 5

    	RED with user defined min and max

    .. data:: red_with_default_min_max = 6

    	RED with default min and max

    .. data:: wred_dei = 7

    	WRED DEI

    """

    wred_cos = Enum.YLeaf(0, "wred-cos")

    wred_dscp = Enum.YLeaf(1, "wred-dscp")

    wred_precedence = Enum.YLeaf(2, "wred-precedence")

    wred_discard_class = Enum.YLeaf(3, "wred-discard-class")

    wred_mpls_exp = Enum.YLeaf(4, "wred-mpls-exp")

    red_with_user_min_max = Enum.YLeaf(5, "red-with-user-min-max")

    red_with_default_min_max = Enum.YLeaf(6, "red-with-default-min-max")

    wred_dei = Enum.YLeaf(7, "wred-dei")


class Wred1(Enum):
    """
    Wred1

    Wred1

    .. data:: wred_cos_cmd = 0

    	wred cos cmd

    .. data:: wred_dscp_cmd = 1

    	wred dscp cmd

    .. data:: wred_precedence_cmd = 2

    	wred precedence cmd

    .. data:: wred_discard_class_cmd = 3

    	wred discard class cmd

    .. data:: wred_mpls_exp_cmd = 4

    	wred mpls exp cmd

    .. data:: red_with_user_min_max = 5

    	red with user min max

    .. data:: red_with_default_min_max = 6

    	red with default min max

    .. data:: wred_dei_cmd = 7

    	wred dei cmd

    .. data:: wred_ecn_cmd = 8

    	wred ecn cmd

    .. data:: wred_invalid_cmd = 9

    	wred invalid cmd

    """

    wred_cos_cmd = Enum.YLeaf(0, "wred-cos-cmd")

    wred_dscp_cmd = Enum.YLeaf(1, "wred-dscp-cmd")

    wred_precedence_cmd = Enum.YLeaf(2, "wred-precedence-cmd")

    wred_discard_class_cmd = Enum.YLeaf(3, "wred-discard-class-cmd")

    wred_mpls_exp_cmd = Enum.YLeaf(4, "wred-mpls-exp-cmd")

    red_with_user_min_max = Enum.YLeaf(5, "red-with-user-min-max")

    red_with_default_min_max = Enum.YLeaf(6, "red-with-default-min-max")

    wred_dei_cmd = Enum.YLeaf(7, "wred-dei-cmd")

    wred_ecn_cmd = Enum.YLeaf(8, "wred-ecn-cmd")

    wred_invalid_cmd = Enum.YLeaf(9, "wred-invalid-cmd")



class PlatformQos(Entity):
    """
    QoS ASR9K platform operational data 
    
    .. attribute:: nodes
    
    	List of nodes with platform specific QoS configuration
    	**type**\:   :py:class:`Nodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes>`
    
    

    """

    _prefix = 'asr9k-qos-oper'
    _revision = '2015-11-09'

    def __init__(self):
        super(PlatformQos, self).__init__()
        self._top_entity = None

        self.yang_name = "platform-qos"
        self.yang_parent_name = "Cisco-IOS-XR-asr9k-qos-oper"

        self.nodes = PlatformQos.Nodes()
        self.nodes.parent = self
        self._children_name_map["nodes"] = "nodes"
        self._children_yang_names.add("nodes")


    class Nodes(Entity):
        """
        List of nodes with platform specific QoS
        configuration
        
        .. attribute:: node
        
        	Node with platform specific QoS configuration
        	**type**\: list of    :py:class:`Node <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node>`
        
        

        """

        _prefix = 'asr9k-qos-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(PlatformQos.Nodes, self).__init__()

            self.yang_name = "nodes"
            self.yang_parent_name = "platform-qos"

            self.node = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(PlatformQos.Nodes, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(PlatformQos.Nodes, self).__setattr__(name, value)


        class Node(Entity):
            """
            Node with platform specific QoS configuration
            
            .. attribute:: node_name  <key>
            
            	Node name
            	**type**\:  str
            
            	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
            
            .. attribute:: bundle_interfaces
            
            	QoS list of bundle interfaces
            	**type**\:   :py:class:`BundleInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces>`
            
            .. attribute:: capability
            
            	QoS system capability
            	**type**\:   :py:class:`Capability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Capability>`
            
            .. attribute:: interfaces
            
            	QoS list of interfaces
            	**type**\:   :py:class:`Interfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces>`
            
            

            """

            _prefix = 'asr9k-qos-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(PlatformQos.Nodes.Node, self).__init__()

                self.yang_name = "node"
                self.yang_parent_name = "nodes"

                self.node_name = YLeaf(YType.str, "node-name")

                self.bundle_interfaces = PlatformQos.Nodes.Node.BundleInterfaces()
                self.bundle_interfaces.parent = self
                self._children_name_map["bundle_interfaces"] = "bundle-interfaces"
                self._children_yang_names.add("bundle-interfaces")

                self.capability = PlatformQos.Nodes.Node.Capability()
                self.capability.parent = self
                self._children_name_map["capability"] = "capability"
                self._children_yang_names.add("capability")

                self.interfaces = PlatformQos.Nodes.Node.Interfaces()
                self.interfaces.parent = self
                self._children_name_map["interfaces"] = "interfaces"
                self._children_yang_names.add("interfaces")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("node_name") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(PlatformQos.Nodes.Node, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(PlatformQos.Nodes.Node, self).__setattr__(name, value)


            class Capability(Entity):
                """
                QoS system capability
                
                .. attribute:: max_bundle_members
                
                	Maximum bundle members
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: max_classes_per_child_policy
                
                	Maximum classes per child policy
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: max_classes_per_grand_parent_policy
                
                	Maximum classes per parent policy
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: max_classes_per_policy
                
                	Maximum classes per policy
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: max_classmap_name_length
                
                	Maximum classmap name length
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: max_instance_name_length
                
                	Maximum instance name length
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: max_marking_actions_per_class
                
                	Maximum marking action  per class
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: max_matches_per_class
                
                	Maximum matches per class
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: max_police_actions_per_class
                
                	Maximum police actions per class
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: max_policy_hierarchy
                
                	Maximum policy hierarchy
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: max_policy_maps
                
                	Maximum policy maps per system
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: max_policy_name_length
                
                	Maximum policy name length
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'asr9k-qos-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(PlatformQos.Nodes.Node.Capability, self).__init__()

                    self.yang_name = "capability"
                    self.yang_parent_name = "node"

                    self.max_bundle_members = YLeaf(YType.uint32, "max-bundle-members")

                    self.max_classes_per_child_policy = YLeaf(YType.uint32, "max-classes-per-child-policy")

                    self.max_classes_per_grand_parent_policy = YLeaf(YType.uint32, "max-classes-per-grand-parent-policy")

                    self.max_classes_per_policy = YLeaf(YType.uint32, "max-classes-per-policy")

                    self.max_classmap_name_length = YLeaf(YType.uint32, "max-classmap-name-length")

                    self.max_instance_name_length = YLeaf(YType.uint32, "max-instance-name-length")

                    self.max_marking_actions_per_class = YLeaf(YType.uint32, "max-marking-actions-per-class")

                    self.max_matches_per_class = YLeaf(YType.uint32, "max-matches-per-class")

                    self.max_police_actions_per_class = YLeaf(YType.uint32, "max-police-actions-per-class")

                    self.max_policy_hierarchy = YLeaf(YType.uint32, "max-policy-hierarchy")

                    self.max_policy_maps = YLeaf(YType.uint32, "max-policy-maps")

                    self.max_policy_name_length = YLeaf(YType.uint32, "max-policy-name-length")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("max_bundle_members",
                                    "max_classes_per_child_policy",
                                    "max_classes_per_grand_parent_policy",
                                    "max_classes_per_policy",
                                    "max_classmap_name_length",
                                    "max_instance_name_length",
                                    "max_marking_actions_per_class",
                                    "max_matches_per_class",
                                    "max_police_actions_per_class",
                                    "max_policy_hierarchy",
                                    "max_policy_maps",
                                    "max_policy_name_length") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(PlatformQos.Nodes.Node.Capability, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(PlatformQos.Nodes.Node.Capability, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.max_bundle_members.is_set or
                        self.max_classes_per_child_policy.is_set or
                        self.max_classes_per_grand_parent_policy.is_set or
                        self.max_classes_per_policy.is_set or
                        self.max_classmap_name_length.is_set or
                        self.max_instance_name_length.is_set or
                        self.max_marking_actions_per_class.is_set or
                        self.max_matches_per_class.is_set or
                        self.max_police_actions_per_class.is_set or
                        self.max_policy_hierarchy.is_set or
                        self.max_policy_maps.is_set or
                        self.max_policy_name_length.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.max_bundle_members.yfilter != YFilter.not_set or
                        self.max_classes_per_child_policy.yfilter != YFilter.not_set or
                        self.max_classes_per_grand_parent_policy.yfilter != YFilter.not_set or
                        self.max_classes_per_policy.yfilter != YFilter.not_set or
                        self.max_classmap_name_length.yfilter != YFilter.not_set or
                        self.max_instance_name_length.yfilter != YFilter.not_set or
                        self.max_marking_actions_per_class.yfilter != YFilter.not_set or
                        self.max_matches_per_class.yfilter != YFilter.not_set or
                        self.max_police_actions_per_class.yfilter != YFilter.not_set or
                        self.max_policy_hierarchy.yfilter != YFilter.not_set or
                        self.max_policy_maps.yfilter != YFilter.not_set or
                        self.max_policy_name_length.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "capability" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.max_bundle_members.is_set or self.max_bundle_members.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.max_bundle_members.get_name_leafdata())
                    if (self.max_classes_per_child_policy.is_set or self.max_classes_per_child_policy.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.max_classes_per_child_policy.get_name_leafdata())
                    if (self.max_classes_per_grand_parent_policy.is_set or self.max_classes_per_grand_parent_policy.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.max_classes_per_grand_parent_policy.get_name_leafdata())
                    if (self.max_classes_per_policy.is_set or self.max_classes_per_policy.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.max_classes_per_policy.get_name_leafdata())
                    if (self.max_classmap_name_length.is_set or self.max_classmap_name_length.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.max_classmap_name_length.get_name_leafdata())
                    if (self.max_instance_name_length.is_set or self.max_instance_name_length.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.max_instance_name_length.get_name_leafdata())
                    if (self.max_marking_actions_per_class.is_set or self.max_marking_actions_per_class.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.max_marking_actions_per_class.get_name_leafdata())
                    if (self.max_matches_per_class.is_set or self.max_matches_per_class.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.max_matches_per_class.get_name_leafdata())
                    if (self.max_police_actions_per_class.is_set or self.max_police_actions_per_class.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.max_police_actions_per_class.get_name_leafdata())
                    if (self.max_policy_hierarchy.is_set or self.max_policy_hierarchy.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.max_policy_hierarchy.get_name_leafdata())
                    if (self.max_policy_maps.is_set or self.max_policy_maps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.max_policy_maps.get_name_leafdata())
                    if (self.max_policy_name_length.is_set or self.max_policy_name_length.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.max_policy_name_length.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "max-bundle-members" or name == "max-classes-per-child-policy" or name == "max-classes-per-grand-parent-policy" or name == "max-classes-per-policy" or name == "max-classmap-name-length" or name == "max-instance-name-length" or name == "max-marking-actions-per-class" or name == "max-matches-per-class" or name == "max-police-actions-per-class" or name == "max-policy-hierarchy" or name == "max-policy-maps" or name == "max-policy-name-length"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "max-bundle-members"):
                        self.max_bundle_members = value
                        self.max_bundle_members.value_namespace = name_space
                        self.max_bundle_members.value_namespace_prefix = name_space_prefix
                    if(value_path == "max-classes-per-child-policy"):
                        self.max_classes_per_child_policy = value
                        self.max_classes_per_child_policy.value_namespace = name_space
                        self.max_classes_per_child_policy.value_namespace_prefix = name_space_prefix
                    if(value_path == "max-classes-per-grand-parent-policy"):
                        self.max_classes_per_grand_parent_policy = value
                        self.max_classes_per_grand_parent_policy.value_namespace = name_space
                        self.max_classes_per_grand_parent_policy.value_namespace_prefix = name_space_prefix
                    if(value_path == "max-classes-per-policy"):
                        self.max_classes_per_policy = value
                        self.max_classes_per_policy.value_namespace = name_space
                        self.max_classes_per_policy.value_namespace_prefix = name_space_prefix
                    if(value_path == "max-classmap-name-length"):
                        self.max_classmap_name_length = value
                        self.max_classmap_name_length.value_namespace = name_space
                        self.max_classmap_name_length.value_namespace_prefix = name_space_prefix
                    if(value_path == "max-instance-name-length"):
                        self.max_instance_name_length = value
                        self.max_instance_name_length.value_namespace = name_space
                        self.max_instance_name_length.value_namespace_prefix = name_space_prefix
                    if(value_path == "max-marking-actions-per-class"):
                        self.max_marking_actions_per_class = value
                        self.max_marking_actions_per_class.value_namespace = name_space
                        self.max_marking_actions_per_class.value_namespace_prefix = name_space_prefix
                    if(value_path == "max-matches-per-class"):
                        self.max_matches_per_class = value
                        self.max_matches_per_class.value_namespace = name_space
                        self.max_matches_per_class.value_namespace_prefix = name_space_prefix
                    if(value_path == "max-police-actions-per-class"):
                        self.max_police_actions_per_class = value
                        self.max_police_actions_per_class.value_namespace = name_space
                        self.max_police_actions_per_class.value_namespace_prefix = name_space_prefix
                    if(value_path == "max-policy-hierarchy"):
                        self.max_policy_hierarchy = value
                        self.max_policy_hierarchy.value_namespace = name_space
                        self.max_policy_hierarchy.value_namespace_prefix = name_space_prefix
                    if(value_path == "max-policy-maps"):
                        self.max_policy_maps = value
                        self.max_policy_maps.value_namespace = name_space
                        self.max_policy_maps.value_namespace_prefix = name_space_prefix
                    if(value_path == "max-policy-name-length"):
                        self.max_policy_name_length = value
                        self.max_policy_name_length.value_namespace = name_space
                        self.max_policy_name_length.value_namespace_prefix = name_space_prefix


            class Interfaces(Entity):
                """
                QoS list of interfaces
                
                .. attribute:: interface
                
                	QoS interface name
                	**type**\: list of    :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface>`
                
                

                """

                _prefix = 'asr9k-qos-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(PlatformQos.Nodes.Node.Interfaces, self).__init__()

                    self.yang_name = "interfaces"
                    self.yang_parent_name = "node"

                    self.interface = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(PlatformQos.Nodes.Node.Interfaces, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(PlatformQos.Nodes.Node.Interfaces, self).__setattr__(name, value)


                class Interface(Entity):
                    """
                    QoS interface name
                    
                    .. attribute:: interface_name  <key>
                    
                    	The name of the interface
                    	**type**\:  str
                    
                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                    
                    .. attribute:: input
                    
                    	QoS policy direction ingress
                    	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input>`
                    
                    .. attribute:: output
                    
                    	QoS policy direction egress
                    	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output>`
                    
                    

                    """

                    _prefix = 'asr9k-qos-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(PlatformQos.Nodes.Node.Interfaces.Interface, self).__init__()

                        self.yang_name = "interface"
                        self.yang_parent_name = "interfaces"

                        self.interface_name = YLeaf(YType.str, "interface-name")

                        self.input = PlatformQos.Nodes.Node.Interfaces.Interface.Input()
                        self.input.parent = self
                        self._children_name_map["input"] = "input"
                        self._children_yang_names.add("input")

                        self.output = PlatformQos.Nodes.Node.Interfaces.Interface.Output()
                        self.output.parent = self
                        self._children_name_map["output"] = "output"
                        self._children_yang_names.add("output")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("interface_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(PlatformQos.Nodes.Node.Interfaces.Interface, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(PlatformQos.Nodes.Node.Interfaces.Interface, self).__setattr__(name, value)


                    class Input(Entity):
                        """
                        QoS policy direction ingress
                        
                        .. attribute:: details
                        
                        	QoS policy direction egress
                        	**type**\:   :py:class:`Details <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details>`
                        
                        

                        """

                        _prefix = 'asr9k-qos-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input, self).__init__()

                            self.yang_name = "input"
                            self.yang_parent_name = "interface"

                            self.details = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details()
                            self.details.parent = self
                            self._children_name_map["details"] = "details"
                            self._children_yang_names.add("details")


                        class Details(Entity):
                            """
                            QoS policy direction egress
                            
                            .. attribute:: header
                            
                            	QoS policy header
                            	**type**\:   :py:class:`Header <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header>`
                            
                            .. attribute:: policy
                            
                            	Trident QoS policy details
                            	**type**\:   :py:class:`Policy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy>`
                            
                            .. attribute:: policy_typhoon
                            
                            	Typhoon QoS policy details
                            	**type**\:   :py:class:`PolicyTyphoon <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon>`
                            
                            

                            """

                            _prefix = 'asr9k-qos-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details, self).__init__()

                                self.yang_name = "details"
                                self.yang_parent_name = "input"

                                self.header = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header()
                                self.header.parent = self
                                self._children_name_map["header"] = "header"
                                self._children_yang_names.add("header")

                                self.policy = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy()
                                self.policy.parent = self
                                self._children_name_map["policy"] = "policy"
                                self._children_yang_names.add("policy")

                                self.policy_typhoon = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon()
                                self.policy_typhoon.parent = self
                                self._children_name_map["policy_typhoon"] = "policy-typhoon"
                                self._children_yang_names.add("policy-typhoon")


                            class Header(Entity):
                                """
                                QoS policy header
                                
                                .. attribute:: classes
                                
                                	Number of classes
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: interface_parameters
                                
                                	Interface config and programmed parameters
                                	**type**\:   :py:class:`InterfaceParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters>`
                                
                                .. attribute:: policy_name
                                
                                	Policy name
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: programmed_bandwidth
                                
                                	Bandwidth that was programmed
                                	**type**\:   :py:class:`ProgrammedBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.ProgrammedBandwidth>`
                                
                                

                                """

                                _prefix = 'asr9k-qos-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header, self).__init__()

                                    self.yang_name = "header"
                                    self.yang_parent_name = "details"

                                    self.classes = YLeaf(YType.uint16, "classes")

                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                    self.interface_parameters = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters()
                                    self.interface_parameters.parent = self
                                    self._children_name_map["interface_parameters"] = "interface-parameters"
                                    self._children_yang_names.add("interface-parameters")

                                    self.programmed_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.ProgrammedBandwidth()
                                    self.programmed_bandwidth.parent = self
                                    self._children_name_map["programmed_bandwidth"] = "programmed-bandwidth"
                                    self._children_yang_names.add("programmed-bandwidth")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("classes",
                                                    "policy_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header, self).__setattr__(name, value)


                                class InterfaceParameters(Entity):
                                    """
                                    Interface config and programmed parameters
                                    
                                    .. attribute:: ancp_config_bandwidth
                                    
                                    	Bandwidth obtain from IM
                                    	**type**\:   :py:class:`AncpConfigBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.AncpConfigBandwidth>`
                                    
                                    .. attribute:: ancp_programmed_bandwidth
                                    
                                    	ANCP bandwidth that was programmed
                                    	**type**\:   :py:class:`AncpProgrammedBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.AncpProgrammedBandwidth>`
                                    
                                    .. attribute:: port_config_bandwidth
                                    
                                    	Bandwidth due to port speed change
                                    	**type**\:   :py:class:`PortConfigBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.PortConfigBandwidth>`
                                    
                                    .. attribute:: port_shaper_rate
                                    
                                    	Bandwidth that was programmed
                                    	**type**\:   :py:class:`PortShaperRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.PortShaperRate>`
                                    
                                    

                                    """

                                    _prefix = 'asr9k-qos-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters, self).__init__()

                                        self.yang_name = "interface-parameters"
                                        self.yang_parent_name = "header"

                                        self.ancp_config_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.AncpConfigBandwidth()
                                        self.ancp_config_bandwidth.parent = self
                                        self._children_name_map["ancp_config_bandwidth"] = "ancp-config-bandwidth"
                                        self._children_yang_names.add("ancp-config-bandwidth")

                                        self.ancp_programmed_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.AncpProgrammedBandwidth()
                                        self.ancp_programmed_bandwidth.parent = self
                                        self._children_name_map["ancp_programmed_bandwidth"] = "ancp-programmed-bandwidth"
                                        self._children_yang_names.add("ancp-programmed-bandwidth")

                                        self.port_config_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.PortConfigBandwidth()
                                        self.port_config_bandwidth.parent = self
                                        self._children_name_map["port_config_bandwidth"] = "port-config-bandwidth"
                                        self._children_yang_names.add("port-config-bandwidth")

                                        self.port_shaper_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.PortShaperRate()
                                        self.port_shaper_rate.parent = self
                                        self._children_name_map["port_shaper_rate"] = "port-shaper-rate"
                                        self._children_yang_names.add("port-shaper-rate")


                                    class PortConfigBandwidth(Entity):
                                        """
                                        Bandwidth due to port speed change
                                        
                                        .. attribute:: unit
                                        
                                        	Config unit
                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	Config value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.PortConfigBandwidth, self).__init__()

                                            self.yang_name = "port-config-bandwidth"
                                            self.yang_parent_name = "interface-parameters"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.PortConfigBandwidth, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.PortConfigBandwidth, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "port-config-bandwidth" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class AncpConfigBandwidth(Entity):
                                        """
                                        Bandwidth obtain from IM
                                        
                                        .. attribute:: unit
                                        
                                        	Config unit
                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	Config value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.AncpConfigBandwidth, self).__init__()

                                            self.yang_name = "ancp-config-bandwidth"
                                            self.yang_parent_name = "interface-parameters"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.AncpConfigBandwidth, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.AncpConfigBandwidth, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "ancp-config-bandwidth" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class AncpProgrammedBandwidth(Entity):
                                        """
                                        ANCP bandwidth that was programmed
                                        
                                        .. attribute:: unit
                                        
                                        	Config unit
                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	Config value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.AncpProgrammedBandwidth, self).__init__()

                                            self.yang_name = "ancp-programmed-bandwidth"
                                            self.yang_parent_name = "interface-parameters"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.AncpProgrammedBandwidth, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.AncpProgrammedBandwidth, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "ancp-programmed-bandwidth" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class PortShaperRate(Entity):
                                        """
                                        Bandwidth that was programmed
                                        
                                        .. attribute:: unit
                                        
                                        	Config unit
                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	Config value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.PortShaperRate, self).__init__()

                                            self.yang_name = "port-shaper-rate"
                                            self.yang_parent_name = "interface-parameters"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.PortShaperRate, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.PortShaperRate, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "port-shaper-rate" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.ancp_config_bandwidth is not None and self.ancp_config_bandwidth.has_data()) or
                                            (self.ancp_programmed_bandwidth is not None and self.ancp_programmed_bandwidth.has_data()) or
                                            (self.port_config_bandwidth is not None and self.port_config_bandwidth.has_data()) or
                                            (self.port_shaper_rate is not None and self.port_shaper_rate.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.ancp_config_bandwidth is not None and self.ancp_config_bandwidth.has_operation()) or
                                            (self.ancp_programmed_bandwidth is not None and self.ancp_programmed_bandwidth.has_operation()) or
                                            (self.port_config_bandwidth is not None and self.port_config_bandwidth.has_operation()) or
                                            (self.port_shaper_rate is not None and self.port_shaper_rate.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "interface-parameters" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "ancp-config-bandwidth"):
                                            if (self.ancp_config_bandwidth is None):
                                                self.ancp_config_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.AncpConfigBandwidth()
                                                self.ancp_config_bandwidth.parent = self
                                                self._children_name_map["ancp_config_bandwidth"] = "ancp-config-bandwidth"
                                            return self.ancp_config_bandwidth

                                        if (child_yang_name == "ancp-programmed-bandwidth"):
                                            if (self.ancp_programmed_bandwidth is None):
                                                self.ancp_programmed_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.AncpProgrammedBandwidth()
                                                self.ancp_programmed_bandwidth.parent = self
                                                self._children_name_map["ancp_programmed_bandwidth"] = "ancp-programmed-bandwidth"
                                            return self.ancp_programmed_bandwidth

                                        if (child_yang_name == "port-config-bandwidth"):
                                            if (self.port_config_bandwidth is None):
                                                self.port_config_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.PortConfigBandwidth()
                                                self.port_config_bandwidth.parent = self
                                                self._children_name_map["port_config_bandwidth"] = "port-config-bandwidth"
                                            return self.port_config_bandwidth

                                        if (child_yang_name == "port-shaper-rate"):
                                            if (self.port_shaper_rate is None):
                                                self.port_shaper_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters.PortShaperRate()
                                                self.port_shaper_rate.parent = self
                                                self._children_name_map["port_shaper_rate"] = "port-shaper-rate"
                                            return self.port_shaper_rate

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ancp-config-bandwidth" or name == "ancp-programmed-bandwidth" or name == "port-config-bandwidth" or name == "port-shaper-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class ProgrammedBandwidth(Entity):
                                    """
                                    Bandwidth that was programmed
                                    
                                    .. attribute:: unit
                                    
                                    	Config unit
                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                    
                                    .. attribute:: value
                                    
                                    	Config value
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'asr9k-qos-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.ProgrammedBandwidth, self).__init__()

                                        self.yang_name = "programmed-bandwidth"
                                        self.yang_parent_name = "header"

                                        self.unit = YLeaf(YType.enumeration, "unit")

                                        self.value = YLeaf(YType.uint32, "value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("unit",
                                                        "value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.ProgrammedBandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.ProgrammedBandwidth, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.unit.is_set or
                                            self.value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.unit.yfilter != YFilter.not_set or
                                            self.value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "programmed-bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "unit" or name == "value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "unit"):
                                            self.unit = value
                                            self.unit.value_namespace = name_space
                                            self.unit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "value"):
                                            self.value = value
                                            self.value.value_namespace = name_space
                                            self.value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.classes.is_set or
                                        self.policy_name.is_set or
                                        (self.interface_parameters is not None and self.interface_parameters.has_data()) or
                                        (self.programmed_bandwidth is not None and self.programmed_bandwidth.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.classes.yfilter != YFilter.not_set or
                                        self.policy_name.yfilter != YFilter.not_set or
                                        (self.interface_parameters is not None and self.interface_parameters.has_operation()) or
                                        (self.programmed_bandwidth is not None and self.programmed_bandwidth.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "header" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.classes.is_set or self.classes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.classes.get_name_leafdata())
                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.policy_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "interface-parameters"):
                                        if (self.interface_parameters is None):
                                            self.interface_parameters = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.InterfaceParameters()
                                            self.interface_parameters.parent = self
                                            self._children_name_map["interface_parameters"] = "interface-parameters"
                                        return self.interface_parameters

                                    if (child_yang_name == "programmed-bandwidth"):
                                        if (self.programmed_bandwidth is None):
                                            self.programmed_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header.ProgrammedBandwidth()
                                            self.programmed_bandwidth.parent = self
                                            self._children_name_map["programmed_bandwidth"] = "programmed-bandwidth"
                                        return self.programmed_bandwidth

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "interface-parameters" or name == "programmed-bandwidth" or name == "classes" or name == "policy-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "classes"):
                                        self.classes = value
                                        self.classes.value_namespace = name_space
                                        self.classes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "policy-name"):
                                        self.policy_name = value
                                        self.policy_name.value_namespace = name_space
                                        self.policy_name.value_namespace_prefix = name_space_prefix


                            class Policy(Entity):
                                """
                                Trident QoS policy details
                                
                                .. attribute:: qos_show_ea_st_v1
                                
                                	qos show ea st v1
                                	**type**\: list of    :py:class:`QosShowEaStV1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1>`
                                
                                

                                """

                                _prefix = 'asr9k-qos-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy, self).__init__()

                                    self.yang_name = "policy"
                                    self.yang_parent_name = "details"

                                    self.qos_show_ea_st_v1 = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy, self).__setattr__(name, value)


                                class QosShowEaStV1(Entity):
                                    """
                                    qos show ea st v1
                                    
                                    .. attribute:: class_level
                                    
                                    	Class level
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: class_name
                                    
                                    	Class name
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: mark
                                    
                                    	Mark parameters
                                    	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark>`
                                    
                                    .. attribute:: parent_class_name
                                    
                                    	Parent class name
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: parent_policy_name
                                    
                                    	Parent policy name
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: police
                                    
                                    	Police parameters
                                    	**type**\:   :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	Policy name
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: queue
                                    
                                    	Queue parameters
                                    	**type**\:   :py:class:`Queue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Queue>`
                                    
                                    .. attribute:: queue_limit_parameters
                                    
                                    	Queue limit parameters
                                    	**type**\:   :py:class:`QueueLimitParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.QueueLimitParameters>`
                                    
                                    .. attribute:: shape
                                    
                                    	Shape parameters
                                    	**type**\:   :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape>`
                                    
                                    .. attribute:: wfq
                                    
                                    	WFQ parameters
                                    	**type**\:   :py:class:`Wfq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wfq>`
                                    
                                    .. attribute:: wred
                                    
                                    	WRED parameters
                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred>`
                                    
                                    

                                    """

                                    _prefix = 'asr9k-qos-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1, self).__init__()

                                        self.yang_name = "qos-show-ea-st-v1"
                                        self.yang_parent_name = "policy"

                                        self.class_level = YLeaf(YType.uint8, "class-level")

                                        self.class_name = YLeaf(YType.str, "class-name")

                                        self.parent_class_name = YLeaf(YType.str, "parent-class-name")

                                        self.parent_policy_name = YLeaf(YType.str, "parent-policy-name")

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.mark = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark()
                                        self.mark.parent = self
                                        self._children_name_map["mark"] = "mark"
                                        self._children_yang_names.add("mark")

                                        self.police = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police()
                                        self.police.parent = self
                                        self._children_name_map["police"] = "police"
                                        self._children_yang_names.add("police")

                                        self.queue = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Queue()
                                        self.queue.parent = self
                                        self._children_name_map["queue"] = "queue"
                                        self._children_yang_names.add("queue")

                                        self.queue_limit_parameters = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.QueueLimitParameters()
                                        self.queue_limit_parameters.parent = self
                                        self._children_name_map["queue_limit_parameters"] = "queue-limit-parameters"
                                        self._children_yang_names.add("queue-limit-parameters")

                                        self.shape = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape()
                                        self.shape.parent = self
                                        self._children_name_map["shape"] = "shape"
                                        self._children_yang_names.add("shape")

                                        self.wfq = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wfq()
                                        self.wfq.parent = self
                                        self._children_name_map["wfq"] = "wfq"
                                        self._children_yang_names.add("wfq")

                                        self.wred = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred()
                                        self.wred.parent = self
                                        self._children_name_map["wred"] = "wred"
                                        self._children_yang_names.add("wred")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("class_level",
                                                        "class_name",
                                                        "parent_class_name",
                                                        "parent_policy_name",
                                                        "policy_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1, self).__setattr__(name, value)


                                    class Queue(Entity):
                                        """
                                        Queue parameters
                                        
                                        .. attribute:: class_name
                                        
                                        	Class name
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: queue_id
                                        
                                        	Queue ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_type
                                        
                                        	Queue type
                                        	**type**\:   :py:class:`Queue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Queue>`
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Queue, self).__init__()

                                            self.yang_name = "queue"
                                            self.yang_parent_name = "qos-show-ea-st-v1"

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                            self.queue_type = YLeaf(YType.enumeration, "queue-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("class_name",
                                                            "queue_id",
                                                            "queue_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Queue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Queue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.class_name.is_set or
                                                self.queue_id.is_set or
                                                self.queue_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.queue_id.yfilter != YFilter.not_set or
                                                self.queue_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                            if (self.queue_type.is_set or self.queue_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "class-name" or name == "queue-id" or name == "queue-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-id"):
                                                self.queue_id = value
                                                self.queue_id.value_namespace = name_space
                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-type"):
                                                self.queue_type = value
                                                self.queue_type.value_namespace = name_space
                                                self.queue_type.value_namespace_prefix = name_space_prefix


                                    class QueueLimitParameters(Entity):
                                        """
                                        Queue limit parameters
                                        
                                        .. attribute:: config_queue_limit
                                        
                                        	Config queue limit
                                        	**type**\:   :py:class:`ConfigQueueLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit>`
                                        
                                        .. attribute:: profile_id
                                        
                                        	Profile ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_limit
                                        
                                        	Queue limit in kbytes
                                        	**type**\:   :py:class:`QueueLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit>`
                                        
                                        .. attribute:: scaling_profile_id
                                        
                                        	Scaling profile ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.QueueLimitParameters, self).__init__()

                                            self.yang_name = "queue-limit-parameters"
                                            self.yang_parent_name = "qos-show-ea-st-v1"

                                            self.profile_id = YLeaf(YType.uint32, "profile-id")

                                            self.scaling_profile_id = YLeaf(YType.uint32, "scaling-profile-id")

                                            self.config_queue_limit = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit()
                                            self.config_queue_limit.parent = self
                                            self._children_name_map["config_queue_limit"] = "config-queue-limit"
                                            self._children_yang_names.add("config-queue-limit")

                                            self.queue_limit = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit()
                                            self.queue_limit.parent = self
                                            self._children_name_map["queue_limit"] = "queue-limit"
                                            self._children_yang_names.add("queue-limit")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("profile_id",
                                                            "scaling_profile_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.QueueLimitParameters, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.QueueLimitParameters, self).__setattr__(name, value)


                                        class QueueLimit(Entity):
                                            """
                                            Queue limit in kbytes
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit, self).__init__()

                                                self.yang_name = "queue-limit"
                                                self.yang_parent_name = "queue-limit-parameters"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-limit" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class ConfigQueueLimit(Entity):
                                            """
                                            Config queue limit
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit, self).__init__()

                                                self.yang_name = "config-queue-limit"
                                                self.yang_parent_name = "queue-limit-parameters"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "config-queue-limit" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.profile_id.is_set or
                                                self.scaling_profile_id.is_set or
                                                (self.config_queue_limit is not None and self.config_queue_limit.has_data()) or
                                                (self.queue_limit is not None and self.queue_limit.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.profile_id.yfilter != YFilter.not_set or
                                                self.scaling_profile_id.yfilter != YFilter.not_set or
                                                (self.config_queue_limit is not None and self.config_queue_limit.has_operation()) or
                                                (self.queue_limit is not None and self.queue_limit.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-limit-parameters" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.profile_id.get_name_leafdata())
                                            if (self.scaling_profile_id.is_set or self.scaling_profile_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.scaling_profile_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "config-queue-limit"):
                                                if (self.config_queue_limit is None):
                                                    self.config_queue_limit = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit()
                                                    self.config_queue_limit.parent = self
                                                    self._children_name_map["config_queue_limit"] = "config-queue-limit"
                                                return self.config_queue_limit

                                            if (child_yang_name == "queue-limit"):
                                                if (self.queue_limit is None):
                                                    self.queue_limit = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit()
                                                    self.queue_limit.parent = self
                                                    self._children_name_map["queue_limit"] = "queue-limit"
                                                return self.queue_limit

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "config-queue-limit" or name == "queue-limit" or name == "profile-id" or name == "scaling-profile-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "profile-id"):
                                                self.profile_id = value
                                                self.profile_id.value_namespace = name_space
                                                self.profile_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "scaling-profile-id"):
                                                self.scaling_profile_id = value
                                                self.scaling_profile_id.value_namespace = name_space
                                                self.scaling_profile_id.value_namespace_prefix = name_space_prefix


                                    class Shape(Entity):
                                        """
                                        Shape parameters
                                        
                                        .. attribute:: cbs
                                        
                                        	CBS in bytes
                                        	**type**\:   :py:class:`Cbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Cbs>`
                                        
                                        .. attribute:: cir
                                        
                                        	CIR in kbps
                                        	**type**\:   :py:class:`Cir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Cir>`
                                        
                                        .. attribute:: config_bandwidth
                                        
                                        	Config bandwidth
                                        	**type**\:   :py:class:`ConfigBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth>`
                                        
                                        .. attribute:: pbs
                                        
                                        	PBS in bytes
                                        	**type**\:   :py:class:`Pbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Pbs>`
                                        
                                        .. attribute:: pir
                                        
                                        	PIR in kbps
                                        	**type**\:   :py:class:`Pir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Pir>`
                                        
                                        .. attribute:: profile_id
                                        
                                        	Shape profile ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape, self).__init__()

                                            self.yang_name = "shape"
                                            self.yang_parent_name = "qos-show-ea-st-v1"

                                            self.profile_id = YLeaf(YType.uint16, "profile-id")

                                            self.cbs = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Cbs()
                                            self.cbs.parent = self
                                            self._children_name_map["cbs"] = "cbs"
                                            self._children_yang_names.add("cbs")

                                            self.cir = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Cir()
                                            self.cir.parent = self
                                            self._children_name_map["cir"] = "cir"
                                            self._children_yang_names.add("cir")

                                            self.config_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth()
                                            self.config_bandwidth.parent = self
                                            self._children_name_map["config_bandwidth"] = "config-bandwidth"
                                            self._children_yang_names.add("config-bandwidth")

                                            self.pbs = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Pbs()
                                            self.pbs.parent = self
                                            self._children_name_map["pbs"] = "pbs"
                                            self._children_yang_names.add("pbs")

                                            self.pir = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Pir()
                                            self.pir.parent = self
                                            self._children_name_map["pir"] = "pir"
                                            self._children_yang_names.add("pir")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("profile_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape, self).__setattr__(name, value)


                                        class Cir(Entity):
                                            """
                                            CIR in kbps
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Cir, self).__init__()

                                                self.yang_name = "cir"
                                                self.yang_parent_name = "shape"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Cir, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Cir, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cir" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class ConfigBandwidth(Entity):
                                            """
                                            Config bandwidth
                                            
                                            .. attribute:: minimum_rate
                                            
                                            	Minimum bandwidth rate
                                            	**type**\:   :py:class:`MinimumRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth, self).__init__()

                                                self.yang_name = "config-bandwidth"
                                                self.yang_parent_name = "shape"

                                                self.minimum_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate()
                                                self.minimum_rate.parent = self
                                                self._children_name_map["minimum_rate"] = "minimum-rate"
                                                self._children_yang_names.add("minimum-rate")


                                            class MinimumRate(Entity):
                                                """
                                                Minimum bandwidth rate
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate, self).__init__()

                                                    self.yang_name = "minimum-rate"
                                                    self.yang_parent_name = "config-bandwidth"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "minimum-rate" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (self.minimum_rate is not None and self.minimum_rate.has_data())

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    (self.minimum_rate is not None and self.minimum_rate.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "config-bandwidth" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "minimum-rate"):
                                                    if (self.minimum_rate is None):
                                                        self.minimum_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate()
                                                        self.minimum_rate.parent = self
                                                        self._children_name_map["minimum_rate"] = "minimum-rate"
                                                    return self.minimum_rate

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "minimum-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class Cbs(Entity):
                                            """
                                            CBS in bytes
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Cbs, self).__init__()

                                                self.yang_name = "cbs"
                                                self.yang_parent_name = "shape"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Cbs, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Cbs, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cbs" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class Pir(Entity):
                                            """
                                            PIR in kbps
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Pir, self).__init__()

                                                self.yang_name = "pir"
                                                self.yang_parent_name = "shape"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Pir, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Pir, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "pir" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class Pbs(Entity):
                                            """
                                            PBS in bytes
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Pbs, self).__init__()

                                                self.yang_name = "pbs"
                                                self.yang_parent_name = "shape"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Pbs, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Pbs, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "pbs" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.profile_id.is_set or
                                                (self.cbs is not None and self.cbs.has_data()) or
                                                (self.cir is not None and self.cir.has_data()) or
                                                (self.config_bandwidth is not None and self.config_bandwidth.has_data()) or
                                                (self.pbs is not None and self.pbs.has_data()) or
                                                (self.pir is not None and self.pir.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.profile_id.yfilter != YFilter.not_set or
                                                (self.cbs is not None and self.cbs.has_operation()) or
                                                (self.cir is not None and self.cir.has_operation()) or
                                                (self.config_bandwidth is not None and self.config_bandwidth.has_operation()) or
                                                (self.pbs is not None and self.pbs.has_operation()) or
                                                (self.pir is not None and self.pir.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "shape" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.profile_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cbs"):
                                                if (self.cbs is None):
                                                    self.cbs = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Cbs()
                                                    self.cbs.parent = self
                                                    self._children_name_map["cbs"] = "cbs"
                                                return self.cbs

                                            if (child_yang_name == "cir"):
                                                if (self.cir is None):
                                                    self.cir = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Cir()
                                                    self.cir.parent = self
                                                    self._children_name_map["cir"] = "cir"
                                                return self.cir

                                            if (child_yang_name == "config-bandwidth"):
                                                if (self.config_bandwidth is None):
                                                    self.config_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth()
                                                    self.config_bandwidth.parent = self
                                                    self._children_name_map["config_bandwidth"] = "config-bandwidth"
                                                return self.config_bandwidth

                                            if (child_yang_name == "pbs"):
                                                if (self.pbs is None):
                                                    self.pbs = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Pbs()
                                                    self.pbs.parent = self
                                                    self._children_name_map["pbs"] = "pbs"
                                                return self.pbs

                                            if (child_yang_name == "pir"):
                                                if (self.pir is None):
                                                    self.pir = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape.Pir()
                                                    self.pir.parent = self
                                                    self._children_name_map["pir"] = "pir"
                                                return self.pir

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cbs" or name == "cir" or name == "config-bandwidth" or name == "pbs" or name == "pir" or name == "profile-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "profile-id"):
                                                self.profile_id = value
                                                self.profile_id.value_namespace = name_space
                                                self.profile_id.value_namespace_prefix = name_space_prefix


                                    class Police(Entity):
                                        """
                                        Police parameters
                                        
                                        .. attribute:: cbs
                                        
                                        	CBS
                                        	**type**\:   :py:class:`Cbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Cbs>`
                                        
                                        .. attribute:: cir
                                        
                                        	CIR
                                        	**type**\:   :py:class:`Cir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Cir>`
                                        
                                        .. attribute:: pbs
                                        
                                        	PBS
                                        	**type**\:   :py:class:`Pbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Pbs>`
                                        
                                        .. attribute:: pir
                                        
                                        	PIR
                                        	**type**\:   :py:class:`Pir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Pir>`
                                        
                                        .. attribute:: police_config_parameters
                                        
                                        	Police config parameters
                                        	**type**\:   :py:class:`PoliceConfigParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters>`
                                        
                                        .. attribute:: policer_type
                                        
                                        	Policer type
                                        	**type**\:   :py:class:`TbAlgorithm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.TbAlgorithm>`
                                        
                                        .. attribute:: profile_id
                                        
                                        	Police profile ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police, self).__init__()

                                            self.yang_name = "police"
                                            self.yang_parent_name = "qos-show-ea-st-v1"

                                            self.policer_type = YLeaf(YType.enumeration, "policer-type")

                                            self.profile_id = YLeaf(YType.uint32, "profile-id")

                                            self.cbs = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Cbs()
                                            self.cbs.parent = self
                                            self._children_name_map["cbs"] = "cbs"
                                            self._children_yang_names.add("cbs")

                                            self.cir = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Cir()
                                            self.cir.parent = self
                                            self._children_name_map["cir"] = "cir"
                                            self._children_yang_names.add("cir")

                                            self.pbs = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Pbs()
                                            self.pbs.parent = self
                                            self._children_name_map["pbs"] = "pbs"
                                            self._children_yang_names.add("pbs")

                                            self.pir = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Pir()
                                            self.pir.parent = self
                                            self._children_name_map["pir"] = "pir"
                                            self._children_yang_names.add("pir")

                                            self.police_config_parameters = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters()
                                            self.police_config_parameters.parent = self
                                            self._children_name_map["police_config_parameters"] = "police-config-parameters"
                                            self._children_yang_names.add("police-config-parameters")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("policer_type",
                                                            "profile_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police, self).__setattr__(name, value)


                                        class Cir(Entity):
                                            """
                                            CIR
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Cir, self).__init__()

                                                self.yang_name = "cir"
                                                self.yang_parent_name = "police"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Cir, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Cir, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cir" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class Cbs(Entity):
                                            """
                                            CBS
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Cbs, self).__init__()

                                                self.yang_name = "cbs"
                                                self.yang_parent_name = "police"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Cbs, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Cbs, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cbs" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class Pir(Entity):
                                            """
                                            PIR
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Pir, self).__init__()

                                                self.yang_name = "pir"
                                                self.yang_parent_name = "police"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Pir, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Pir, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "pir" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class Pbs(Entity):
                                            """
                                            PBS
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Pbs, self).__init__()

                                                self.yang_name = "pbs"
                                                self.yang_parent_name = "police"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Pbs, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Pbs, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "pbs" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class PoliceConfigParameters(Entity):
                                            """
                                            Police config parameters
                                            
                                            .. attribute:: average_rate
                                            
                                            	Average rate
                                            	**type**\:   :py:class:`AverageRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate>`
                                            
                                            .. attribute:: conform_burst
                                            
                                            	Conform burst
                                            	**type**\:   :py:class:`ConformBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst>`
                                            
                                            .. attribute:: exceed_burst
                                            
                                            	Exceed burst
                                            	**type**\:   :py:class:`ExceedBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst>`
                                            
                                            .. attribute:: peak_rate
                                            
                                            	Peak rate
                                            	**type**\:   :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters, self).__init__()

                                                self.yang_name = "police-config-parameters"
                                                self.yang_parent_name = "police"

                                                self.average_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate()
                                                self.average_rate.parent = self
                                                self._children_name_map["average_rate"] = "average-rate"
                                                self._children_yang_names.add("average-rate")

                                                self.conform_burst = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst()
                                                self.conform_burst.parent = self
                                                self._children_name_map["conform_burst"] = "conform-burst"
                                                self._children_yang_names.add("conform-burst")

                                                self.exceed_burst = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst()
                                                self.exceed_burst.parent = self
                                                self._children_name_map["exceed_burst"] = "exceed-burst"
                                                self._children_yang_names.add("exceed-burst")

                                                self.peak_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate()
                                                self.peak_rate.parent = self
                                                self._children_name_map["peak_rate"] = "peak-rate"
                                                self._children_yang_names.add("peak-rate")


                                            class AverageRate(Entity):
                                                """
                                                Average rate
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate, self).__init__()

                                                    self.yang_name = "average-rate"
                                                    self.yang_parent_name = "police-config-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "average-rate" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class PeakRate(Entity):
                                                """
                                                Peak rate
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate, self).__init__()

                                                    self.yang_name = "peak-rate"
                                                    self.yang_parent_name = "police-config-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "peak-rate" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class ConformBurst(Entity):
                                                """
                                                Conform burst
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst, self).__init__()

                                                    self.yang_name = "conform-burst"
                                                    self.yang_parent_name = "police-config-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "conform-burst" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class ExceedBurst(Entity):
                                                """
                                                Exceed burst
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst, self).__init__()

                                                    self.yang_name = "exceed-burst"
                                                    self.yang_parent_name = "police-config-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "exceed-burst" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    (self.average_rate is not None and self.average_rate.has_data()) or
                                                    (self.conform_burst is not None and self.conform_burst.has_data()) or
                                                    (self.exceed_burst is not None and self.exceed_burst.has_data()) or
                                                    (self.peak_rate is not None and self.peak_rate.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    (self.average_rate is not None and self.average_rate.has_operation()) or
                                                    (self.conform_burst is not None and self.conform_burst.has_operation()) or
                                                    (self.exceed_burst is not None and self.exceed_burst.has_operation()) or
                                                    (self.peak_rate is not None and self.peak_rate.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-config-parameters" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "average-rate"):
                                                    if (self.average_rate is None):
                                                        self.average_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate()
                                                        self.average_rate.parent = self
                                                        self._children_name_map["average_rate"] = "average-rate"
                                                    return self.average_rate

                                                if (child_yang_name == "conform-burst"):
                                                    if (self.conform_burst is None):
                                                        self.conform_burst = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst()
                                                        self.conform_burst.parent = self
                                                        self._children_name_map["conform_burst"] = "conform-burst"
                                                    return self.conform_burst

                                                if (child_yang_name == "exceed-burst"):
                                                    if (self.exceed_burst is None):
                                                        self.exceed_burst = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst()
                                                        self.exceed_burst.parent = self
                                                        self._children_name_map["exceed_burst"] = "exceed-burst"
                                                    return self.exceed_burst

                                                if (child_yang_name == "peak-rate"):
                                                    if (self.peak_rate is None):
                                                        self.peak_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate()
                                                        self.peak_rate.parent = self
                                                        self._children_name_map["peak_rate"] = "peak-rate"
                                                    return self.peak_rate

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "average-rate" or name == "conform-burst" or name == "exceed-burst" or name == "peak-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass

                                        def has_data(self):
                                            return (
                                                self.policer_type.is_set or
                                                self.profile_id.is_set or
                                                (self.cbs is not None and self.cbs.has_data()) or
                                                (self.cir is not None and self.cir.has_data()) or
                                                (self.pbs is not None and self.pbs.has_data()) or
                                                (self.pir is not None and self.pir.has_data()) or
                                                (self.police_config_parameters is not None and self.police_config_parameters.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.policer_type.yfilter != YFilter.not_set or
                                                self.profile_id.yfilter != YFilter.not_set or
                                                (self.cbs is not None and self.cbs.has_operation()) or
                                                (self.cir is not None and self.cir.has_operation()) or
                                                (self.pbs is not None and self.pbs.has_operation()) or
                                                (self.pir is not None and self.pir.has_operation()) or
                                                (self.police_config_parameters is not None and self.police_config_parameters.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "police" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.policer_type.is_set or self.policer_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policer_type.get_name_leafdata())
                                            if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.profile_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cbs"):
                                                if (self.cbs is None):
                                                    self.cbs = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Cbs()
                                                    self.cbs.parent = self
                                                    self._children_name_map["cbs"] = "cbs"
                                                return self.cbs

                                            if (child_yang_name == "cir"):
                                                if (self.cir is None):
                                                    self.cir = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Cir()
                                                    self.cir.parent = self
                                                    self._children_name_map["cir"] = "cir"
                                                return self.cir

                                            if (child_yang_name == "pbs"):
                                                if (self.pbs is None):
                                                    self.pbs = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Pbs()
                                                    self.pbs.parent = self
                                                    self._children_name_map["pbs"] = "pbs"
                                                return self.pbs

                                            if (child_yang_name == "pir"):
                                                if (self.pir is None):
                                                    self.pir = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.Pir()
                                                    self.pir.parent = self
                                                    self._children_name_map["pir"] = "pir"
                                                return self.pir

                                            if (child_yang_name == "police-config-parameters"):
                                                if (self.police_config_parameters is None):
                                                    self.police_config_parameters = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters()
                                                    self.police_config_parameters.parent = self
                                                    self._children_name_map["police_config_parameters"] = "police-config-parameters"
                                                return self.police_config_parameters

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cbs" or name == "cir" or name == "pbs" or name == "pir" or name == "police-config-parameters" or name == "policer-type" or name == "profile-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "policer-type"):
                                                self.policer_type = value
                                                self.policer_type.value_namespace = name_space
                                                self.policer_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "profile-id"):
                                                self.profile_id = value
                                                self.profile_id.value_namespace = name_space
                                                self.profile_id.value_namespace_prefix = name_space_prefix


                                    class Wfq(Entity):
                                        """
                                        WFQ parameters
                                        
                                        .. attribute:: bandwidth
                                        
                                        	CFG Bandwidth
                                        	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wfq.Bandwidth>`
                                        
                                        .. attribute:: chunk_id
                                        
                                        	Chunk ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: committed_weight
                                        
                                        	Committed weight
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: excess_ratio
                                        
                                        	Parent Excess ratio
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: excess_weight
                                        
                                        	Excess weight
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: level
                                        
                                        	Level
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: parent_bandwidth
                                        
                                        	Parent bandwidth
                                        	**type**\:   :py:class:`ParentBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth>`
                                        
                                        .. attribute:: profile_id
                                        
                                        	WFQ profile
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wfq, self).__init__()

                                            self.yang_name = "wfq"
                                            self.yang_parent_name = "qos-show-ea-st-v1"

                                            self.chunk_id = YLeaf(YType.uint32, "chunk-id")

                                            self.committed_weight = YLeaf(YType.uint32, "committed-weight")

                                            self.excess_ratio = YLeaf(YType.uint16, "excess-ratio")

                                            self.excess_weight = YLeaf(YType.uint16, "excess-weight")

                                            self.level = YLeaf(YType.uint8, "level")

                                            self.profile_id = YLeaf(YType.uint32, "profile-id")

                                            self.bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wfq.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                            self._children_yang_names.add("bandwidth")

                                            self.parent_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth()
                                            self.parent_bandwidth.parent = self
                                            self._children_name_map["parent_bandwidth"] = "parent-bandwidth"
                                            self._children_yang_names.add("parent-bandwidth")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("chunk_id",
                                                            "committed_weight",
                                                            "excess_ratio",
                                                            "excess_weight",
                                                            "level",
                                                            "profile_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wfq, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wfq, self).__setattr__(name, value)


                                        class ParentBandwidth(Entity):
                                            """
                                            Parent bandwidth
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth, self).__init__()

                                                self.yang_name = "parent-bandwidth"
                                                self.yang_parent_name = "wfq"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "parent-bandwidth" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class Bandwidth(Entity):
                                            """
                                            CFG Bandwidth
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wfq.Bandwidth, self).__init__()

                                                self.yang_name = "bandwidth"
                                                self.yang_parent_name = "wfq"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wfq.Bandwidth, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wfq.Bandwidth, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bandwidth" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.chunk_id.is_set or
                                                self.committed_weight.is_set or
                                                self.excess_ratio.is_set or
                                                self.excess_weight.is_set or
                                                self.level.is_set or
                                                self.profile_id.is_set or
                                                (self.bandwidth is not None and self.bandwidth.has_data()) or
                                                (self.parent_bandwidth is not None and self.parent_bandwidth.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.chunk_id.yfilter != YFilter.not_set or
                                                self.committed_weight.yfilter != YFilter.not_set or
                                                self.excess_ratio.yfilter != YFilter.not_set or
                                                self.excess_weight.yfilter != YFilter.not_set or
                                                self.level.yfilter != YFilter.not_set or
                                                self.profile_id.yfilter != YFilter.not_set or
                                                (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                                (self.parent_bandwidth is not None and self.parent_bandwidth.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wfq" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.chunk_id.is_set or self.chunk_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.chunk_id.get_name_leafdata())
                                            if (self.committed_weight.is_set or self.committed_weight.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.committed_weight.get_name_leafdata())
                                            if (self.excess_ratio.is_set or self.excess_ratio.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.excess_ratio.get_name_leafdata())
                                            if (self.excess_weight.is_set or self.excess_weight.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.excess_weight.get_name_leafdata())
                                            if (self.level.is_set or self.level.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.level.get_name_leafdata())
                                            if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.profile_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "bandwidth"):
                                                if (self.bandwidth is None):
                                                    self.bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wfq.Bandwidth()
                                                    self.bandwidth.parent = self
                                                    self._children_name_map["bandwidth"] = "bandwidth"
                                                return self.bandwidth

                                            if (child_yang_name == "parent-bandwidth"):
                                                if (self.parent_bandwidth is None):
                                                    self.parent_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth()
                                                    self.parent_bandwidth.parent = self
                                                    self._children_name_map["parent_bandwidth"] = "parent-bandwidth"
                                                return self.parent_bandwidth

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bandwidth" or name == "parent-bandwidth" or name == "chunk-id" or name == "committed-weight" or name == "excess-ratio" or name == "excess-weight" or name == "level" or name == "profile-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "chunk-id"):
                                                self.chunk_id = value
                                                self.chunk_id.value_namespace = name_space
                                                self.chunk_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "committed-weight"):
                                                self.committed_weight = value
                                                self.committed_weight.value_namespace = name_space
                                                self.committed_weight.value_namespace_prefix = name_space_prefix
                                            if(value_path == "excess-ratio"):
                                                self.excess_ratio = value
                                                self.excess_ratio.value_namespace = name_space
                                                self.excess_ratio.value_namespace_prefix = name_space_prefix
                                            if(value_path == "excess-weight"):
                                                self.excess_weight = value
                                                self.excess_weight.value_namespace = name_space
                                                self.excess_weight.value_namespace_prefix = name_space_prefix
                                            if(value_path == "level"):
                                                self.level = value
                                                self.level.value_namespace = name_space
                                                self.level.value_namespace_prefix = name_space_prefix
                                            if(value_path == "profile-id"):
                                                self.profile_id = value
                                                self.profile_id.value_namespace = name_space
                                                self.profile_id.value_namespace_prefix = name_space_prefix


                                    class Wred(Entity):
                                        """
                                        WRED parameters
                                        
                                        .. attribute:: curve
                                        
                                        	Curve details
                                        	**type**\: list of    :py:class:`Curve <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve>`
                                        
                                        .. attribute:: curve_xr
                                        
                                        	Number of curves
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: profile_id
                                        
                                        	Profile ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: scaling_profile_id
                                        
                                        	Scaling profile ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: table_id
                                        
                                        	Table ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: type
                                        
                                        	WRED type
                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Wred>`
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred, self).__init__()

                                            self.yang_name = "wred"
                                            self.yang_parent_name = "qos-show-ea-st-v1"

                                            self.curve_xr = YLeaf(YType.uint16, "curve-xr")

                                            self.profile_id = YLeaf(YType.uint32, "profile-id")

                                            self.scaling_profile_id = YLeaf(YType.uint32, "scaling-profile-id")

                                            self.table_id = YLeaf(YType.uint8, "table-id")

                                            self.type = YLeaf(YType.enumeration, "type")

                                            self.curve = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("curve_xr",
                                                            "profile_id",
                                                            "scaling_profile_id",
                                                            "table_id",
                                                            "type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred, self).__setattr__(name, value)


                                        class Curve(Entity):
                                            """
                                            Curve details
                                            
                                            .. attribute:: match
                                            
                                            	WRED precedence match if precedence start value equals to end value Format\: <start\-value> , else range Format\: <start\-value> <end\-value>
                                            	**type**\:  str
                                            
                                            .. attribute:: max_threshold
                                            
                                            	Maximum threshold
                                            	**type**\:   :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold>`
                                            
                                            .. attribute:: max_threshold_user_config
                                            
                                            	Maximum threshold WRED context
                                            	**type**\:   :py:class:`MaxThresholdUserConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig>`
                                            
                                            .. attribute:: min_threshold
                                            
                                            	Minimum threshold
                                            	**type**\:   :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold>`
                                            
                                            .. attribute:: min_threshold_user_config
                                            
                                            	Minimum threshold WRED context
                                            	**type**\:   :py:class:`MinThresholdUserConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve, self).__init__()

                                                self.yang_name = "curve"
                                                self.yang_parent_name = "wred"

                                                self.match = YLeaf(YType.str, "match")

                                                self.max_threshold = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold()
                                                self.max_threshold.parent = self
                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                self._children_yang_names.add("max-threshold")

                                                self.max_threshold_user_config = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig()
                                                self.max_threshold_user_config.parent = self
                                                self._children_name_map["max_threshold_user_config"] = "max-threshold-user-config"
                                                self._children_yang_names.add("max-threshold-user-config")

                                                self.min_threshold = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold()
                                                self.min_threshold.parent = self
                                                self._children_name_map["min_threshold"] = "min-threshold"
                                                self._children_yang_names.add("min-threshold")

                                                self.min_threshold_user_config = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig()
                                                self.min_threshold_user_config.parent = self
                                                self._children_name_map["min_threshold_user_config"] = "min-threshold-user-config"
                                                self._children_yang_names.add("min-threshold-user-config")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("match") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve, self).__setattr__(name, value)


                                            class MinThreshold(Entity):
                                                """
                                                Minimum threshold
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold, self).__init__()

                                                    self.yang_name = "min-threshold"
                                                    self.yang_parent_name = "curve"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "min-threshold" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class MinThresholdUserConfig(Entity):
                                                """
                                                Minimum threshold WRED context
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig, self).__init__()

                                                    self.yang_name = "min-threshold-user-config"
                                                    self.yang_parent_name = "curve"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "min-threshold-user-config" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class MaxThreshold(Entity):
                                                """
                                                Maximum threshold
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold, self).__init__()

                                                    self.yang_name = "max-threshold"
                                                    self.yang_parent_name = "curve"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "max-threshold" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class MaxThresholdUserConfig(Entity):
                                                """
                                                Maximum threshold WRED context
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig, self).__init__()

                                                    self.yang_name = "max-threshold-user-config"
                                                    self.yang_parent_name = "curve"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "max-threshold-user-config" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.match.is_set or
                                                    (self.max_threshold is not None and self.max_threshold.has_data()) or
                                                    (self.max_threshold_user_config is not None and self.max_threshold_user_config.has_data()) or
                                                    (self.min_threshold is not None and self.min_threshold.has_data()) or
                                                    (self.min_threshold_user_config is not None and self.min_threshold_user_config.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.match.yfilter != YFilter.not_set or
                                                    (self.max_threshold is not None and self.max_threshold.has_operation()) or
                                                    (self.max_threshold_user_config is not None and self.max_threshold_user_config.has_operation()) or
                                                    (self.min_threshold is not None and self.min_threshold.has_operation()) or
                                                    (self.min_threshold_user_config is not None and self.min_threshold_user_config.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "curve" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.match.is_set or self.match.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "max-threshold"):
                                                    if (self.max_threshold is None):
                                                        self.max_threshold = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold()
                                                        self.max_threshold.parent = self
                                                        self._children_name_map["max_threshold"] = "max-threshold"
                                                    return self.max_threshold

                                                if (child_yang_name == "max-threshold-user-config"):
                                                    if (self.max_threshold_user_config is None):
                                                        self.max_threshold_user_config = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig()
                                                        self.max_threshold_user_config.parent = self
                                                        self._children_name_map["max_threshold_user_config"] = "max-threshold-user-config"
                                                    return self.max_threshold_user_config

                                                if (child_yang_name == "min-threshold"):
                                                    if (self.min_threshold is None):
                                                        self.min_threshold = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold()
                                                        self.min_threshold.parent = self
                                                        self._children_name_map["min_threshold"] = "min-threshold"
                                                    return self.min_threshold

                                                if (child_yang_name == "min-threshold-user-config"):
                                                    if (self.min_threshold_user_config is None):
                                                        self.min_threshold_user_config = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig()
                                                        self.min_threshold_user_config.parent = self
                                                        self._children_name_map["min_threshold_user_config"] = "min-threshold-user-config"
                                                    return self.min_threshold_user_config

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "max-threshold" or name == "max-threshold-user-config" or name == "min-threshold" or name == "min-threshold-user-config" or name == "match"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "match"):
                                                    self.match = value
                                                    self.match.value_namespace = name_space
                                                    self.match.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.curve:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.curve_xr.is_set or
                                                self.profile_id.is_set or
                                                self.scaling_profile_id.is_set or
                                                self.table_id.is_set or
                                                self.type.is_set)

                                        def has_operation(self):
                                            for c in self.curve:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.curve_xr.yfilter != YFilter.not_set or
                                                self.profile_id.yfilter != YFilter.not_set or
                                                self.scaling_profile_id.yfilter != YFilter.not_set or
                                                self.table_id.yfilter != YFilter.not_set or
                                                self.type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wred" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.curve_xr.is_set or self.curve_xr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.curve_xr.get_name_leafdata())
                                            if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.profile_id.get_name_leafdata())
                                            if (self.scaling_profile_id.is_set or self.scaling_profile_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.scaling_profile_id.get_name_leafdata())
                                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.table_id.get_name_leafdata())
                                            if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "curve"):
                                                for c in self.curve:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred.Curve()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.curve.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "curve" or name == "curve-xr" or name == "profile-id" or name == "scaling-profile-id" or name == "table-id" or name == "type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "curve-xr"):
                                                self.curve_xr = value
                                                self.curve_xr.value_namespace = name_space
                                                self.curve_xr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "profile-id"):
                                                self.profile_id = value
                                                self.profile_id.value_namespace = name_space
                                                self.profile_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "scaling-profile-id"):
                                                self.scaling_profile_id = value
                                                self.scaling_profile_id.value_namespace = name_space
                                                self.scaling_profile_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "table-id"):
                                                self.table_id = value
                                                self.table_id.value_namespace = name_space
                                                self.table_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "type"):
                                                self.type = value
                                                self.type.value_namespace = name_space
                                                self.type.value_namespace_prefix = name_space_prefix


                                    class Mark(Entity):
                                        """
                                        Mark parameters
                                        
                                        .. attribute:: child_mark
                                        
                                        	Child mark only
                                        	**type**\:   :py:class:`ChildMark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ChildMark>`
                                        
                                        .. attribute:: parent_mark
                                        
                                        	Parent mark only
                                        	**type**\:   :py:class:`ParentMark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentMark>`
                                        
                                        .. attribute:: parent_police_conform
                                        
                                        	Parent police conform mark
                                        	**type**\:   :py:class:`ParentPoliceConform <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform>`
                                        
                                        .. attribute:: parent_police_exceed
                                        
                                        	Parent police exceed mark
                                        	**type**\:   :py:class:`ParentPoliceExceed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed>`
                                        
                                        .. attribute:: parent_police_violate
                                        
                                        	Parent police violate mark
                                        	**type**\:   :py:class:`ParentPoliceViolate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate>`
                                        
                                        .. attribute:: police_conform
                                        
                                        	Child police conform mark
                                        	**type**\:   :py:class:`PoliceConform <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceConform>`
                                        
                                        .. attribute:: police_exceed
                                        
                                        	Child police exceed mark
                                        	**type**\:   :py:class:`PoliceExceed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceExceed>`
                                        
                                        .. attribute:: police_violate
                                        
                                        	Child police violate mark
                                        	**type**\:   :py:class:`PoliceViolate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceViolate>`
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark, self).__init__()

                                            self.yang_name = "mark"
                                            self.yang_parent_name = "qos-show-ea-st-v1"

                                            self.child_mark = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ChildMark()
                                            self.child_mark.parent = self
                                            self._children_name_map["child_mark"] = "child-mark"
                                            self._children_yang_names.add("child-mark")

                                            self.parent_mark = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentMark()
                                            self.parent_mark.parent = self
                                            self._children_name_map["parent_mark"] = "parent-mark"
                                            self._children_yang_names.add("parent-mark")

                                            self.parent_police_conform = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform()
                                            self.parent_police_conform.parent = self
                                            self._children_name_map["parent_police_conform"] = "parent-police-conform"
                                            self._children_yang_names.add("parent-police-conform")

                                            self.parent_police_exceed = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed()
                                            self.parent_police_exceed.parent = self
                                            self._children_name_map["parent_police_exceed"] = "parent-police-exceed"
                                            self._children_yang_names.add("parent-police-exceed")

                                            self.parent_police_violate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate()
                                            self.parent_police_violate.parent = self
                                            self._children_name_map["parent_police_violate"] = "parent-police-violate"
                                            self._children_yang_names.add("parent-police-violate")

                                            self.police_conform = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceConform()
                                            self.police_conform.parent = self
                                            self._children_name_map["police_conform"] = "police-conform"
                                            self._children_yang_names.add("police-conform")

                                            self.police_exceed = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceExceed()
                                            self.police_exceed.parent = self
                                            self._children_name_map["police_exceed"] = "police-exceed"
                                            self._children_yang_names.add("police-exceed")

                                            self.police_violate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceViolate()
                                            self.police_violate.parent = self
                                            self._children_name_map["police_violate"] = "police-violate"
                                            self._children_yang_names.add("police-violate")


                                        class ChildMark(Entity):
                                            """
                                            Child mark only
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ChildMark.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ChildMark, self).__init__()

                                                self.yang_name = "child-mark"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ChildMark, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ChildMark, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ChildMark.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "child-mark"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ChildMark.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ChildMark.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "child-mark" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ChildMark.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class PoliceConform(Entity):
                                            """
                                            Child police conform mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceConform.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceConform, self).__init__()

                                                self.yang_name = "police-conform"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceConform, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceConform, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceConform.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "police-conform"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceConform.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceConform.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-conform" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceConform.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class PoliceExceed(Entity):
                                            """
                                            Child police exceed mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceExceed.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceExceed, self).__init__()

                                                self.yang_name = "police-exceed"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceExceed, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceExceed, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceExceed.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "police-exceed"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceExceed.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceExceed.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-exceed" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceExceed.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class PoliceViolate(Entity):
                                            """
                                            Child police violate mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceViolate.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceViolate, self).__init__()

                                                self.yang_name = "police-violate"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceViolate, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceViolate, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceViolate.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "police-violate"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceViolate.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceViolate.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-violate" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceViolate.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class ParentMark(Entity):
                                            """
                                            Parent mark only
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentMark.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentMark, self).__init__()

                                                self.yang_name = "parent-mark"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentMark, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentMark, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentMark.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "parent-mark"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentMark.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentMark.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "parent-mark" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentMark.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class ParentPoliceConform(Entity):
                                            """
                                            Parent police conform mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform, self).__init__()

                                                self.yang_name = "parent-police-conform"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "parent-police-conform"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "parent-police-conform" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class ParentPoliceExceed(Entity):
                                            """
                                            Parent police exceed mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed, self).__init__()

                                                self.yang_name = "parent-police-exceed"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "parent-police-exceed"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "parent-police-exceed" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class ParentPoliceViolate(Entity):
                                            """
                                            Parent police violate mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate, self).__init__()

                                                self.yang_name = "parent-police-violate"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "parent-police-violate"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "parent-police-violate" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                (self.child_mark is not None and self.child_mark.has_data()) or
                                                (self.parent_mark is not None and self.parent_mark.has_data()) or
                                                (self.parent_police_conform is not None and self.parent_police_conform.has_data()) or
                                                (self.parent_police_exceed is not None and self.parent_police_exceed.has_data()) or
                                                (self.parent_police_violate is not None and self.parent_police_violate.has_data()) or
                                                (self.police_conform is not None and self.police_conform.has_data()) or
                                                (self.police_exceed is not None and self.police_exceed.has_data()) or
                                                (self.police_violate is not None and self.police_violate.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.child_mark is not None and self.child_mark.has_operation()) or
                                                (self.parent_mark is not None and self.parent_mark.has_operation()) or
                                                (self.parent_police_conform is not None and self.parent_police_conform.has_operation()) or
                                                (self.parent_police_exceed is not None and self.parent_police_exceed.has_operation()) or
                                                (self.parent_police_violate is not None and self.parent_police_violate.has_operation()) or
                                                (self.police_conform is not None and self.police_conform.has_operation()) or
                                                (self.police_exceed is not None and self.police_exceed.has_operation()) or
                                                (self.police_violate is not None and self.police_violate.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mark" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "child-mark"):
                                                if (self.child_mark is None):
                                                    self.child_mark = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ChildMark()
                                                    self.child_mark.parent = self
                                                    self._children_name_map["child_mark"] = "child-mark"
                                                return self.child_mark

                                            if (child_yang_name == "parent-mark"):
                                                if (self.parent_mark is None):
                                                    self.parent_mark = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentMark()
                                                    self.parent_mark.parent = self
                                                    self._children_name_map["parent_mark"] = "parent-mark"
                                                return self.parent_mark

                                            if (child_yang_name == "parent-police-conform"):
                                                if (self.parent_police_conform is None):
                                                    self.parent_police_conform = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform()
                                                    self.parent_police_conform.parent = self
                                                    self._children_name_map["parent_police_conform"] = "parent-police-conform"
                                                return self.parent_police_conform

                                            if (child_yang_name == "parent-police-exceed"):
                                                if (self.parent_police_exceed is None):
                                                    self.parent_police_exceed = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed()
                                                    self.parent_police_exceed.parent = self
                                                    self._children_name_map["parent_police_exceed"] = "parent-police-exceed"
                                                return self.parent_police_exceed

                                            if (child_yang_name == "parent-police-violate"):
                                                if (self.parent_police_violate is None):
                                                    self.parent_police_violate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate()
                                                    self.parent_police_violate.parent = self
                                                    self._children_name_map["parent_police_violate"] = "parent-police-violate"
                                                return self.parent_police_violate

                                            if (child_yang_name == "police-conform"):
                                                if (self.police_conform is None):
                                                    self.police_conform = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceConform()
                                                    self.police_conform.parent = self
                                                    self._children_name_map["police_conform"] = "police-conform"
                                                return self.police_conform

                                            if (child_yang_name == "police-exceed"):
                                                if (self.police_exceed is None):
                                                    self.police_exceed = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceExceed()
                                                    self.police_exceed.parent = self
                                                    self._children_name_map["police_exceed"] = "police-exceed"
                                                return self.police_exceed

                                            if (child_yang_name == "police-violate"):
                                                if (self.police_violate is None):
                                                    self.police_violate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark.PoliceViolate()
                                                    self.police_violate.parent = self
                                                    self._children_name_map["police_violate"] = "police-violate"
                                                return self.police_violate

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "child-mark" or name == "parent-mark" or name == "parent-police-conform" or name == "parent-police-exceed" or name == "parent-police-violate" or name == "police-conform" or name == "police-exceed" or name == "police-violate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        return (
                                            self.class_level.is_set or
                                            self.class_name.is_set or
                                            self.parent_class_name.is_set or
                                            self.parent_policy_name.is_set or
                                            self.policy_name.is_set or
                                            (self.mark is not None and self.mark.has_data()) or
                                            (self.police is not None and self.police.has_data()) or
                                            (self.queue is not None and self.queue.has_data()) or
                                            (self.queue_limit_parameters is not None and self.queue_limit_parameters.has_data()) or
                                            (self.shape is not None and self.shape.has_data()) or
                                            (self.wfq is not None and self.wfq.has_data()) or
                                            (self.wred is not None and self.wred.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.class_level.yfilter != YFilter.not_set or
                                            self.class_name.yfilter != YFilter.not_set or
                                            self.parent_class_name.yfilter != YFilter.not_set or
                                            self.parent_policy_name.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            (self.mark is not None and self.mark.has_operation()) or
                                            (self.police is not None and self.police.has_operation()) or
                                            (self.queue is not None and self.queue.has_operation()) or
                                            (self.queue_limit_parameters is not None and self.queue_limit_parameters.has_operation()) or
                                            (self.shape is not None and self.shape.has_operation()) or
                                            (self.wfq is not None and self.wfq.has_operation()) or
                                            (self.wred is not None and self.wred.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "qos-show-ea-st-v1" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.class_level.is_set or self.class_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.class_level.get_name_leafdata())
                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                        if (self.parent_class_name.is_set or self.parent_class_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_class_name.get_name_leafdata())
                                        if (self.parent_policy_name.is_set or self.parent_policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_policy_name.get_name_leafdata())
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "mark"):
                                            if (self.mark is None):
                                                self.mark = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Mark()
                                                self.mark.parent = self
                                                self._children_name_map["mark"] = "mark"
                                            return self.mark

                                        if (child_yang_name == "police"):
                                            if (self.police is None):
                                                self.police = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Police()
                                                self.police.parent = self
                                                self._children_name_map["police"] = "police"
                                            return self.police

                                        if (child_yang_name == "queue"):
                                            if (self.queue is None):
                                                self.queue = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Queue()
                                                self.queue.parent = self
                                                self._children_name_map["queue"] = "queue"
                                            return self.queue

                                        if (child_yang_name == "queue-limit-parameters"):
                                            if (self.queue_limit_parameters is None):
                                                self.queue_limit_parameters = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.QueueLimitParameters()
                                                self.queue_limit_parameters.parent = self
                                                self._children_name_map["queue_limit_parameters"] = "queue-limit-parameters"
                                            return self.queue_limit_parameters

                                        if (child_yang_name == "shape"):
                                            if (self.shape is None):
                                                self.shape = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Shape()
                                                self.shape.parent = self
                                                self._children_name_map["shape"] = "shape"
                                            return self.shape

                                        if (child_yang_name == "wfq"):
                                            if (self.wfq is None):
                                                self.wfq = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wfq()
                                                self.wfq.parent = self
                                                self._children_name_map["wfq"] = "wfq"
                                            return self.wfq

                                        if (child_yang_name == "wred"):
                                            if (self.wred is None):
                                                self.wred = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1.Wred()
                                                self.wred.parent = self
                                                self._children_name_map["wred"] = "wred"
                                            return self.wred

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "mark" or name == "police" or name == "queue" or name == "queue-limit-parameters" or name == "shape" or name == "wfq" or name == "wred" or name == "class-level" or name == "class-name" or name == "parent-class-name" or name == "parent-policy-name" or name == "policy-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "class-level"):
                                            self.class_level = value
                                            self.class_level.value_namespace = name_space
                                            self.class_level.value_namespace_prefix = name_space_prefix
                                        if(value_path == "class-name"):
                                            self.class_name = value
                                            self.class_name.value_namespace = name_space
                                            self.class_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-class-name"):
                                            self.parent_class_name = value
                                            self.parent_class_name.value_namespace = name_space
                                            self.parent_class_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-policy-name"):
                                            self.parent_policy_name = value
                                            self.parent_policy_name.value_namespace = name_space
                                            self.parent_policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.qos_show_ea_st_v1:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.qos_show_ea_st_v1:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "policy" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "qos-show-ea-st-v1"):
                                        for c in self.qos_show_ea_st_v1:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy.QosShowEaStV1()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.qos_show_ea_st_v1.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "qos-show-ea-st-v1"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class PolicyTyphoon(Entity):
                                """
                                Typhoon QoS policy details
                                
                                .. attribute:: qos_show_ea_st_v2
                                
                                	qos show ea st v2
                                	**type**\: list of    :py:class:`QosShowEaStV2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2>`
                                
                                

                                """

                                _prefix = 'asr9k-qos-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon, self).__init__()

                                    self.yang_name = "policy-typhoon"
                                    self.yang_parent_name = "details"

                                    self.qos_show_ea_st_v2 = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon, self).__setattr__(name, value)


                                class QosShowEaStV2(Entity):
                                    """
                                    qos show ea st v2
                                    
                                    .. attribute:: class_level
                                    
                                    	Class level
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: class_name
                                    
                                    	Class name
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: mark
                                    
                                    	Mark parameters
                                    	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark>`
                                    
                                    .. attribute:: parent_class_name
                                    
                                    	Parent class name
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: parent_policy_name
                                    
                                    	Parent policy name
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: police
                                    
                                    	Police parameters
                                    	**type**\:   :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	Policy name
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: queue
                                    
                                    	Queue parameters
                                    	**type**\:   :py:class:`Queue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Queue>`
                                    
                                    .. attribute:: queue_limit_parameters
                                    
                                    	Queue limit parameters
                                    	**type**\:   :py:class:`QueueLimitParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters>`
                                    
                                    .. attribute:: shape
                                    
                                    	Shape parameters
                                    	**type**\:   :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape>`
                                    
                                    .. attribute:: wfq
                                    
                                    	WFQ parameters
                                    	**type**\:   :py:class:`Wfq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wfq>`
                                    
                                    .. attribute:: wred
                                    
                                    	WRED parameters
                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred>`
                                    
                                    

                                    """

                                    _prefix = 'asr9k-qos-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2, self).__init__()

                                        self.yang_name = "qos-show-ea-st-v2"
                                        self.yang_parent_name = "policy-typhoon"

                                        self.class_level = YLeaf(YType.uint8, "class-level")

                                        self.class_name = YLeaf(YType.str, "class-name")

                                        self.parent_class_name = YLeaf(YType.str, "parent-class-name")

                                        self.parent_policy_name = YLeaf(YType.str, "parent-policy-name")

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.mark = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark()
                                        self.mark.parent = self
                                        self._children_name_map["mark"] = "mark"
                                        self._children_yang_names.add("mark")

                                        self.police = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police()
                                        self.police.parent = self
                                        self._children_name_map["police"] = "police"
                                        self._children_yang_names.add("police")

                                        self.queue = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Queue()
                                        self.queue.parent = self
                                        self._children_name_map["queue"] = "queue"
                                        self._children_yang_names.add("queue")

                                        self.queue_limit_parameters = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters()
                                        self.queue_limit_parameters.parent = self
                                        self._children_name_map["queue_limit_parameters"] = "queue-limit-parameters"
                                        self._children_yang_names.add("queue-limit-parameters")

                                        self.shape = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape()
                                        self.shape.parent = self
                                        self._children_name_map["shape"] = "shape"
                                        self._children_yang_names.add("shape")

                                        self.wfq = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wfq()
                                        self.wfq.parent = self
                                        self._children_name_map["wfq"] = "wfq"
                                        self._children_yang_names.add("wfq")

                                        self.wred = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred()
                                        self.wred.parent = self
                                        self._children_name_map["wred"] = "wred"
                                        self._children_yang_names.add("wred")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("class_level",
                                                        "class_name",
                                                        "parent_class_name",
                                                        "parent_policy_name",
                                                        "policy_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2, self).__setattr__(name, value)


                                    class Queue(Entity):
                                        """
                                        Queue parameters
                                        
                                        .. attribute:: class_name
                                        
                                        	Class name
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: queue_id
                                        
                                        	Queue ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_type
                                        
                                        	Queue type
                                        	**type**\:   :py:class:`Queue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Queue>`
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Queue, self).__init__()

                                            self.yang_name = "queue"
                                            self.yang_parent_name = "qos-show-ea-st-v2"

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                            self.queue_type = YLeaf(YType.enumeration, "queue-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("class_name",
                                                            "queue_id",
                                                            "queue_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Queue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Queue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.class_name.is_set or
                                                self.queue_id.is_set or
                                                self.queue_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.queue_id.yfilter != YFilter.not_set or
                                                self.queue_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                            if (self.queue_type.is_set or self.queue_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "class-name" or name == "queue-id" or name == "queue-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-id"):
                                                self.queue_id = value
                                                self.queue_id.value_namespace = name_space
                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-type"):
                                                self.queue_type = value
                                                self.queue_type.value_namespace = name_space
                                                self.queue_type.value_namespace_prefix = name_space_prefix


                                    class QueueLimitParameters(Entity):
                                        """
                                        Queue limit parameters
                                        
                                        .. attribute:: absolute_index
                                        
                                        	Absolute Index
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: config_queue_limit
                                        
                                        	Config queue limit
                                        	**type**\:   :py:class:`ConfigQueueLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit>`
                                        
                                        .. attribute:: curve_id
                                        
                                        	Curve ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: queue_limit
                                        
                                        	Queue limit in kbytes
                                        	**type**\:   :py:class:`QueueLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit>`
                                        
                                        .. attribute:: template_id
                                        
                                        	Template ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters, self).__init__()

                                            self.yang_name = "queue-limit-parameters"
                                            self.yang_parent_name = "qos-show-ea-st-v2"

                                            self.absolute_index = YLeaf(YType.uint16, "absolute-index")

                                            self.curve_id = YLeaf(YType.uint16, "curve-id")

                                            self.template_id = YLeaf(YType.uint16, "template-id")

                                            self.config_queue_limit = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit()
                                            self.config_queue_limit.parent = self
                                            self._children_name_map["config_queue_limit"] = "config-queue-limit"
                                            self._children_yang_names.add("config-queue-limit")

                                            self.queue_limit = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit()
                                            self.queue_limit.parent = self
                                            self._children_name_map["queue_limit"] = "queue-limit"
                                            self._children_yang_names.add("queue-limit")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("absolute_index",
                                                            "curve_id",
                                                            "template_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters, self).__setattr__(name, value)


                                        class QueueLimit(Entity):
                                            """
                                            Queue limit in kbytes
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit, self).__init__()

                                                self.yang_name = "queue-limit"
                                                self.yang_parent_name = "queue-limit-parameters"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-limit" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class ConfigQueueLimit(Entity):
                                            """
                                            Config queue limit
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit, self).__init__()

                                                self.yang_name = "config-queue-limit"
                                                self.yang_parent_name = "queue-limit-parameters"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "config-queue-limit" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.absolute_index.is_set or
                                                self.curve_id.is_set or
                                                self.template_id.is_set or
                                                (self.config_queue_limit is not None and self.config_queue_limit.has_data()) or
                                                (self.queue_limit is not None and self.queue_limit.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.absolute_index.yfilter != YFilter.not_set or
                                                self.curve_id.yfilter != YFilter.not_set or
                                                self.template_id.yfilter != YFilter.not_set or
                                                (self.config_queue_limit is not None and self.config_queue_limit.has_operation()) or
                                                (self.queue_limit is not None and self.queue_limit.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-limit-parameters" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.absolute_index.is_set or self.absolute_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.absolute_index.get_name_leafdata())
                                            if (self.curve_id.is_set or self.curve_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.curve_id.get_name_leafdata())
                                            if (self.template_id.is_set or self.template_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.template_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "config-queue-limit"):
                                                if (self.config_queue_limit is None):
                                                    self.config_queue_limit = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit()
                                                    self.config_queue_limit.parent = self
                                                    self._children_name_map["config_queue_limit"] = "config-queue-limit"
                                                return self.config_queue_limit

                                            if (child_yang_name == "queue-limit"):
                                                if (self.queue_limit is None):
                                                    self.queue_limit = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit()
                                                    self.queue_limit.parent = self
                                                    self._children_name_map["queue_limit"] = "queue-limit"
                                                return self.queue_limit

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "config-queue-limit" or name == "queue-limit" or name == "absolute-index" or name == "curve-id" or name == "template-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "absolute-index"):
                                                self.absolute_index = value
                                                self.absolute_index.value_namespace = name_space
                                                self.absolute_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "curve-id"):
                                                self.curve_id = value
                                                self.curve_id.value_namespace = name_space
                                                self.curve_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "template-id"):
                                                self.template_id = value
                                                self.template_id.value_namespace = name_space
                                                self.template_id.value_namespace_prefix = name_space_prefix


                                    class Shape(Entity):
                                        """
                                        Shape parameters
                                        
                                        .. attribute:: cir_shape
                                        
                                        	CIR shaper params
                                        	**type**\:   :py:class:`CirShape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape>`
                                        
                                        .. attribute:: cir_shape_type
                                        
                                        	CIR Shaper type
                                        	**type**\:   :py:class:`ShapeProfiletypeV2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ShapeProfiletypeV2>`
                                        
                                        .. attribute:: pir_shape
                                        
                                        	PIR shaper params
                                        	**type**\:   :py:class:`PirShape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape>`
                                        
                                        .. attribute:: pir_shape_type
                                        
                                        	PIR Shaper type
                                        	**type**\:   :py:class:`ShapeProfiletypeV2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ShapeProfiletypeV2>`
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape, self).__init__()

                                            self.yang_name = "shape"
                                            self.yang_parent_name = "qos-show-ea-st-v2"

                                            self.cir_shape_type = YLeaf(YType.enumeration, "cir-shape-type")

                                            self.pir_shape_type = YLeaf(YType.enumeration, "pir-shape-type")

                                            self.cir_shape = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape()
                                            self.cir_shape.parent = self
                                            self._children_name_map["cir_shape"] = "cir-shape"
                                            self._children_yang_names.add("cir-shape")

                                            self.pir_shape = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape()
                                            self.pir_shape.parent = self
                                            self._children_name_map["pir_shape"] = "pir-shape"
                                            self._children_yang_names.add("pir-shape")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("cir_shape_type",
                                                            "pir_shape_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape, self).__setattr__(name, value)


                                        class CirShape(Entity):
                                            """
                                            CIR shaper params
                                            
                                            .. attribute:: cbs
                                            
                                            	CBS in bytes
                                            	**type**\:   :py:class:`Cbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs>`
                                            
                                            .. attribute:: chunk_id
                                            
                                            	Shape Chunk ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: cir
                                            
                                            	CIR in kbps
                                            	**type**\:   :py:class:`Cir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir>`
                                            
                                            .. attribute:: config_bandwidth
                                            
                                            	Config bandwidth
                                            	**type**\:   :py:class:`ConfigBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth>`
                                            
                                            .. attribute:: profile_id
                                            
                                            	Shape profile ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: scale_factor
                                            
                                            	Scale Factor
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape, self).__init__()

                                                self.yang_name = "cir-shape"
                                                self.yang_parent_name = "shape"

                                                self.chunk_id = YLeaf(YType.uint32, "chunk-id")

                                                self.profile_id = YLeaf(YType.uint16, "profile-id")

                                                self.scale_factor = YLeaf(YType.uint16, "scale-factor")

                                                self.cbs = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs()
                                                self.cbs.parent = self
                                                self._children_name_map["cbs"] = "cbs"
                                                self._children_yang_names.add("cbs")

                                                self.cir = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir()
                                                self.cir.parent = self
                                                self._children_name_map["cir"] = "cir"
                                                self._children_yang_names.add("cir")

                                                self.config_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth()
                                                self.config_bandwidth.parent = self
                                                self._children_name_map["config_bandwidth"] = "config-bandwidth"
                                                self._children_yang_names.add("config-bandwidth")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("chunk_id",
                                                                "profile_id",
                                                                "scale_factor") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape, self).__setattr__(name, value)


                                            class Cir(Entity):
                                                """
                                                CIR in kbps
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir, self).__init__()

                                                    self.yang_name = "cir"
                                                    self.yang_parent_name = "cir-shape"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "cir" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class ConfigBandwidth(Entity):
                                                """
                                                Config bandwidth
                                                
                                                .. attribute:: minimum_rate
                                                
                                                	Minimum bandwidth rate
                                                	**type**\:   :py:class:`MinimumRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate>`
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth, self).__init__()

                                                    self.yang_name = "config-bandwidth"
                                                    self.yang_parent_name = "cir-shape"

                                                    self.minimum_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate()
                                                    self.minimum_rate.parent = self
                                                    self._children_name_map["minimum_rate"] = "minimum-rate"
                                                    self._children_yang_names.add("minimum-rate")


                                                class MinimumRate(Entity):
                                                    """
                                                    Minimum bandwidth rate
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate, self).__init__()

                                                        self.yang_name = "minimum-rate"
                                                        self.yang_parent_name = "config-bandwidth"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "minimum-rate" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (self.minimum_rate is not None and self.minimum_rate.has_data())

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.minimum_rate is not None and self.minimum_rate.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "config-bandwidth" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "minimum-rate"):
                                                        if (self.minimum_rate is None):
                                                            self.minimum_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate()
                                                            self.minimum_rate.parent = self
                                                            self._children_name_map["minimum_rate"] = "minimum-rate"
                                                        return self.minimum_rate

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "minimum-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class Cbs(Entity):
                                                """
                                                CBS in bytes
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs, self).__init__()

                                                    self.yang_name = "cbs"
                                                    self.yang_parent_name = "cir-shape"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "cbs" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.chunk_id.is_set or
                                                    self.profile_id.is_set or
                                                    self.scale_factor.is_set or
                                                    (self.cbs is not None and self.cbs.has_data()) or
                                                    (self.cir is not None and self.cir.has_data()) or
                                                    (self.config_bandwidth is not None and self.config_bandwidth.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.chunk_id.yfilter != YFilter.not_set or
                                                    self.profile_id.yfilter != YFilter.not_set or
                                                    self.scale_factor.yfilter != YFilter.not_set or
                                                    (self.cbs is not None and self.cbs.has_operation()) or
                                                    (self.cir is not None and self.cir.has_operation()) or
                                                    (self.config_bandwidth is not None and self.config_bandwidth.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cir-shape" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.chunk_id.is_set or self.chunk_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.chunk_id.get_name_leafdata())
                                                if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_id.get_name_leafdata())
                                                if (self.scale_factor.is_set or self.scale_factor.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.scale_factor.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "cbs"):
                                                    if (self.cbs is None):
                                                        self.cbs = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs()
                                                        self.cbs.parent = self
                                                        self._children_name_map["cbs"] = "cbs"
                                                    return self.cbs

                                                if (child_yang_name == "cir"):
                                                    if (self.cir is None):
                                                        self.cir = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir()
                                                        self.cir.parent = self
                                                        self._children_name_map["cir"] = "cir"
                                                    return self.cir

                                                if (child_yang_name == "config-bandwidth"):
                                                    if (self.config_bandwidth is None):
                                                        self.config_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth()
                                                        self.config_bandwidth.parent = self
                                                        self._children_name_map["config_bandwidth"] = "config-bandwidth"
                                                    return self.config_bandwidth

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "cbs" or name == "cir" or name == "config-bandwidth" or name == "chunk-id" or name == "profile-id" or name == "scale-factor"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "chunk-id"):
                                                    self.chunk_id = value
                                                    self.chunk_id.value_namespace = name_space
                                                    self.chunk_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-id"):
                                                    self.profile_id = value
                                                    self.profile_id.value_namespace = name_space
                                                    self.profile_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "scale-factor"):
                                                    self.scale_factor = value
                                                    self.scale_factor.value_namespace = name_space
                                                    self.scale_factor.value_namespace_prefix = name_space_prefix


                                        class PirShape(Entity):
                                            """
                                            PIR shaper params
                                            
                                            .. attribute:: chunk_id
                                            
                                            	Shape Chunk ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: pbs
                                            
                                            	PBS in bytes
                                            	**type**\:   :py:class:`Pbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs>`
                                            
                                            .. attribute:: pir
                                            
                                            	PIR in kbps
                                            	**type**\:   :py:class:`Pir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir>`
                                            
                                            .. attribute:: profile_id
                                            
                                            	Shape profile ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: scale_factor
                                            
                                            	Scale Factor
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape, self).__init__()

                                                self.yang_name = "pir-shape"
                                                self.yang_parent_name = "shape"

                                                self.chunk_id = YLeaf(YType.uint32, "chunk-id")

                                                self.profile_id = YLeaf(YType.uint16, "profile-id")

                                                self.scale_factor = YLeaf(YType.uint16, "scale-factor")

                                                self.pbs = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs()
                                                self.pbs.parent = self
                                                self._children_name_map["pbs"] = "pbs"
                                                self._children_yang_names.add("pbs")

                                                self.pir = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir()
                                                self.pir.parent = self
                                                self._children_name_map["pir"] = "pir"
                                                self._children_yang_names.add("pir")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("chunk_id",
                                                                "profile_id",
                                                                "scale_factor") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape, self).__setattr__(name, value)


                                            class Pir(Entity):
                                                """
                                                PIR in kbps
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir, self).__init__()

                                                    self.yang_name = "pir"
                                                    self.yang_parent_name = "pir-shape"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "pir" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class Pbs(Entity):
                                                """
                                                PBS in bytes
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs, self).__init__()

                                                    self.yang_name = "pbs"
                                                    self.yang_parent_name = "pir-shape"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "pbs" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.chunk_id.is_set or
                                                    self.profile_id.is_set or
                                                    self.scale_factor.is_set or
                                                    (self.pbs is not None and self.pbs.has_data()) or
                                                    (self.pir is not None and self.pir.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.chunk_id.yfilter != YFilter.not_set or
                                                    self.profile_id.yfilter != YFilter.not_set or
                                                    self.scale_factor.yfilter != YFilter.not_set or
                                                    (self.pbs is not None and self.pbs.has_operation()) or
                                                    (self.pir is not None and self.pir.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "pir-shape" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.chunk_id.is_set or self.chunk_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.chunk_id.get_name_leafdata())
                                                if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_id.get_name_leafdata())
                                                if (self.scale_factor.is_set or self.scale_factor.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.scale_factor.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "pbs"):
                                                    if (self.pbs is None):
                                                        self.pbs = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs()
                                                        self.pbs.parent = self
                                                        self._children_name_map["pbs"] = "pbs"
                                                    return self.pbs

                                                if (child_yang_name == "pir"):
                                                    if (self.pir is None):
                                                        self.pir = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir()
                                                        self.pir.parent = self
                                                        self._children_name_map["pir"] = "pir"
                                                    return self.pir

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "pbs" or name == "pir" or name == "chunk-id" or name == "profile-id" or name == "scale-factor"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "chunk-id"):
                                                    self.chunk_id = value
                                                    self.chunk_id.value_namespace = name_space
                                                    self.chunk_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-id"):
                                                    self.profile_id = value
                                                    self.profile_id.value_namespace = name_space
                                                    self.profile_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "scale-factor"):
                                                    self.scale_factor = value
                                                    self.scale_factor.value_namespace = name_space
                                                    self.scale_factor.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.cir_shape_type.is_set or
                                                self.pir_shape_type.is_set or
                                                (self.cir_shape is not None and self.cir_shape.has_data()) or
                                                (self.pir_shape is not None and self.pir_shape.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.cir_shape_type.yfilter != YFilter.not_set or
                                                self.pir_shape_type.yfilter != YFilter.not_set or
                                                (self.cir_shape is not None and self.cir_shape.has_operation()) or
                                                (self.pir_shape is not None and self.pir_shape.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "shape" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.cir_shape_type.is_set or self.cir_shape_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cir_shape_type.get_name_leafdata())
                                            if (self.pir_shape_type.is_set or self.pir_shape_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pir_shape_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cir-shape"):
                                                if (self.cir_shape is None):
                                                    self.cir_shape = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape()
                                                    self.cir_shape.parent = self
                                                    self._children_name_map["cir_shape"] = "cir-shape"
                                                return self.cir_shape

                                            if (child_yang_name == "pir-shape"):
                                                if (self.pir_shape is None):
                                                    self.pir_shape = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape()
                                                    self.pir_shape.parent = self
                                                    self._children_name_map["pir_shape"] = "pir-shape"
                                                return self.pir_shape

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cir-shape" or name == "pir-shape" or name == "cir-shape-type" or name == "pir-shape-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "cir-shape-type"):
                                                self.cir_shape_type = value
                                                self.cir_shape_type.value_namespace = name_space
                                                self.cir_shape_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pir-shape-type"):
                                                self.pir_shape_type = value
                                                self.pir_shape_type.value_namespace = name_space
                                                self.pir_shape_type.value_namespace_prefix = name_space_prefix


                                    class Police(Entity):
                                        """
                                        Police parameters
                                        
                                        .. attribute:: cbs
                                        
                                        	CBS
                                        	**type**\:   :py:class:`Cbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs>`
                                        
                                        .. attribute:: cir
                                        
                                        	CIR
                                        	**type**\:   :py:class:`Cir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir>`
                                        
                                        .. attribute:: pbs
                                        
                                        	PBS
                                        	**type**\:   :py:class:`Pbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs>`
                                        
                                        .. attribute:: pir
                                        
                                        	PIR
                                        	**type**\:   :py:class:`Pir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir>`
                                        
                                        .. attribute:: police_config_parameters
                                        
                                        	Police config parameters
                                        	**type**\:   :py:class:`PoliceConfigParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters>`
                                        
                                        .. attribute:: policer_type
                                        
                                        	Policer type
                                        	**type**\:   :py:class:`TbAlgorithm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.TbAlgorithm>`
                                        
                                        .. attribute:: profile_id
                                        
                                        	Police profile ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police, self).__init__()

                                            self.yang_name = "police"
                                            self.yang_parent_name = "qos-show-ea-st-v2"

                                            self.policer_type = YLeaf(YType.enumeration, "policer-type")

                                            self.profile_id = YLeaf(YType.uint32, "profile-id")

                                            self.cbs = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs()
                                            self.cbs.parent = self
                                            self._children_name_map["cbs"] = "cbs"
                                            self._children_yang_names.add("cbs")

                                            self.cir = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir()
                                            self.cir.parent = self
                                            self._children_name_map["cir"] = "cir"
                                            self._children_yang_names.add("cir")

                                            self.pbs = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs()
                                            self.pbs.parent = self
                                            self._children_name_map["pbs"] = "pbs"
                                            self._children_yang_names.add("pbs")

                                            self.pir = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir()
                                            self.pir.parent = self
                                            self._children_name_map["pir"] = "pir"
                                            self._children_yang_names.add("pir")

                                            self.police_config_parameters = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters()
                                            self.police_config_parameters.parent = self
                                            self._children_name_map["police_config_parameters"] = "police-config-parameters"
                                            self._children_yang_names.add("police-config-parameters")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("policer_type",
                                                            "profile_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police, self).__setattr__(name, value)


                                        class Cir(Entity):
                                            """
                                            CIR
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir, self).__init__()

                                                self.yang_name = "cir"
                                                self.yang_parent_name = "police"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cir" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class Cbs(Entity):
                                            """
                                            CBS
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs, self).__init__()

                                                self.yang_name = "cbs"
                                                self.yang_parent_name = "police"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cbs" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class Pir(Entity):
                                            """
                                            PIR
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir, self).__init__()

                                                self.yang_name = "pir"
                                                self.yang_parent_name = "police"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "pir" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class Pbs(Entity):
                                            """
                                            PBS
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs, self).__init__()

                                                self.yang_name = "pbs"
                                                self.yang_parent_name = "police"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "pbs" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class PoliceConfigParameters(Entity):
                                            """
                                            Police config parameters
                                            
                                            .. attribute:: average_rate
                                            
                                            	Average rate
                                            	**type**\:   :py:class:`AverageRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate>`
                                            
                                            .. attribute:: conform_burst
                                            
                                            	Conform burst
                                            	**type**\:   :py:class:`ConformBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst>`
                                            
                                            .. attribute:: exceed_burst
                                            
                                            	Exceed burst
                                            	**type**\:   :py:class:`ExceedBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst>`
                                            
                                            .. attribute:: peak_rate
                                            
                                            	Peak rate
                                            	**type**\:   :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters, self).__init__()

                                                self.yang_name = "police-config-parameters"
                                                self.yang_parent_name = "police"

                                                self.average_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate()
                                                self.average_rate.parent = self
                                                self._children_name_map["average_rate"] = "average-rate"
                                                self._children_yang_names.add("average-rate")

                                                self.conform_burst = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst()
                                                self.conform_burst.parent = self
                                                self._children_name_map["conform_burst"] = "conform-burst"
                                                self._children_yang_names.add("conform-burst")

                                                self.exceed_burst = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst()
                                                self.exceed_burst.parent = self
                                                self._children_name_map["exceed_burst"] = "exceed-burst"
                                                self._children_yang_names.add("exceed-burst")

                                                self.peak_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate()
                                                self.peak_rate.parent = self
                                                self._children_name_map["peak_rate"] = "peak-rate"
                                                self._children_yang_names.add("peak-rate")


                                            class AverageRate(Entity):
                                                """
                                                Average rate
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate, self).__init__()

                                                    self.yang_name = "average-rate"
                                                    self.yang_parent_name = "police-config-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "average-rate" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class PeakRate(Entity):
                                                """
                                                Peak rate
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate, self).__init__()

                                                    self.yang_name = "peak-rate"
                                                    self.yang_parent_name = "police-config-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "peak-rate" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class ConformBurst(Entity):
                                                """
                                                Conform burst
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst, self).__init__()

                                                    self.yang_name = "conform-burst"
                                                    self.yang_parent_name = "police-config-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "conform-burst" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class ExceedBurst(Entity):
                                                """
                                                Exceed burst
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst, self).__init__()

                                                    self.yang_name = "exceed-burst"
                                                    self.yang_parent_name = "police-config-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "exceed-burst" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    (self.average_rate is not None and self.average_rate.has_data()) or
                                                    (self.conform_burst is not None and self.conform_burst.has_data()) or
                                                    (self.exceed_burst is not None and self.exceed_burst.has_data()) or
                                                    (self.peak_rate is not None and self.peak_rate.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    (self.average_rate is not None and self.average_rate.has_operation()) or
                                                    (self.conform_burst is not None and self.conform_burst.has_operation()) or
                                                    (self.exceed_burst is not None and self.exceed_burst.has_operation()) or
                                                    (self.peak_rate is not None and self.peak_rate.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-config-parameters" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "average-rate"):
                                                    if (self.average_rate is None):
                                                        self.average_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate()
                                                        self.average_rate.parent = self
                                                        self._children_name_map["average_rate"] = "average-rate"
                                                    return self.average_rate

                                                if (child_yang_name == "conform-burst"):
                                                    if (self.conform_burst is None):
                                                        self.conform_burst = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst()
                                                        self.conform_burst.parent = self
                                                        self._children_name_map["conform_burst"] = "conform-burst"
                                                    return self.conform_burst

                                                if (child_yang_name == "exceed-burst"):
                                                    if (self.exceed_burst is None):
                                                        self.exceed_burst = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst()
                                                        self.exceed_burst.parent = self
                                                        self._children_name_map["exceed_burst"] = "exceed-burst"
                                                    return self.exceed_burst

                                                if (child_yang_name == "peak-rate"):
                                                    if (self.peak_rate is None):
                                                        self.peak_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate()
                                                        self.peak_rate.parent = self
                                                        self._children_name_map["peak_rate"] = "peak-rate"
                                                    return self.peak_rate

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "average-rate" or name == "conform-burst" or name == "exceed-burst" or name == "peak-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass

                                        def has_data(self):
                                            return (
                                                self.policer_type.is_set or
                                                self.profile_id.is_set or
                                                (self.cbs is not None and self.cbs.has_data()) or
                                                (self.cir is not None and self.cir.has_data()) or
                                                (self.pbs is not None and self.pbs.has_data()) or
                                                (self.pir is not None and self.pir.has_data()) or
                                                (self.police_config_parameters is not None and self.police_config_parameters.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.policer_type.yfilter != YFilter.not_set or
                                                self.profile_id.yfilter != YFilter.not_set or
                                                (self.cbs is not None and self.cbs.has_operation()) or
                                                (self.cir is not None and self.cir.has_operation()) or
                                                (self.pbs is not None and self.pbs.has_operation()) or
                                                (self.pir is not None and self.pir.has_operation()) or
                                                (self.police_config_parameters is not None and self.police_config_parameters.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "police" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.policer_type.is_set or self.policer_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policer_type.get_name_leafdata())
                                            if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.profile_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cbs"):
                                                if (self.cbs is None):
                                                    self.cbs = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs()
                                                    self.cbs.parent = self
                                                    self._children_name_map["cbs"] = "cbs"
                                                return self.cbs

                                            if (child_yang_name == "cir"):
                                                if (self.cir is None):
                                                    self.cir = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir()
                                                    self.cir.parent = self
                                                    self._children_name_map["cir"] = "cir"
                                                return self.cir

                                            if (child_yang_name == "pbs"):
                                                if (self.pbs is None):
                                                    self.pbs = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs()
                                                    self.pbs.parent = self
                                                    self._children_name_map["pbs"] = "pbs"
                                                return self.pbs

                                            if (child_yang_name == "pir"):
                                                if (self.pir is None):
                                                    self.pir = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir()
                                                    self.pir.parent = self
                                                    self._children_name_map["pir"] = "pir"
                                                return self.pir

                                            if (child_yang_name == "police-config-parameters"):
                                                if (self.police_config_parameters is None):
                                                    self.police_config_parameters = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters()
                                                    self.police_config_parameters.parent = self
                                                    self._children_name_map["police_config_parameters"] = "police-config-parameters"
                                                return self.police_config_parameters

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cbs" or name == "cir" or name == "pbs" or name == "pir" or name == "police-config-parameters" or name == "policer-type" or name == "profile-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "policer-type"):
                                                self.policer_type = value
                                                self.policer_type.value_namespace = name_space
                                                self.policer_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "profile-id"):
                                                self.profile_id = value
                                                self.profile_id.value_namespace = name_space
                                                self.profile_id.value_namespace_prefix = name_space_prefix


                                    class Wfq(Entity):
                                        """
                                        WFQ parameters
                                        
                                        .. attribute:: bandwidth
                                        
                                        	CFG Bandwidth
                                        	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth>`
                                        
                                        .. attribute:: chunk_id
                                        
                                        	Chunk ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: committed_weight
                                        
                                        	Committed weight
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: excess_ratio
                                        
                                        	Parent Excess ratio
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: excess_weight
                                        
                                        	Excess weight
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: level
                                        
                                        	Level
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: parent_bandwidth
                                        
                                        	Parent bandwidth
                                        	**type**\:   :py:class:`ParentBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth>`
                                        
                                        .. attribute:: profile_id
                                        
                                        	WFQ profile
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wfq, self).__init__()

                                            self.yang_name = "wfq"
                                            self.yang_parent_name = "qos-show-ea-st-v2"

                                            self.chunk_id = YLeaf(YType.uint32, "chunk-id")

                                            self.committed_weight = YLeaf(YType.uint32, "committed-weight")

                                            self.excess_ratio = YLeaf(YType.uint16, "excess-ratio")

                                            self.excess_weight = YLeaf(YType.uint16, "excess-weight")

                                            self.level = YLeaf(YType.uint8, "level")

                                            self.profile_id = YLeaf(YType.uint32, "profile-id")

                                            self.bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                            self._children_yang_names.add("bandwidth")

                                            self.parent_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth()
                                            self.parent_bandwidth.parent = self
                                            self._children_name_map["parent_bandwidth"] = "parent-bandwidth"
                                            self._children_yang_names.add("parent-bandwidth")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("chunk_id",
                                                            "committed_weight",
                                                            "excess_ratio",
                                                            "excess_weight",
                                                            "level",
                                                            "profile_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wfq, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wfq, self).__setattr__(name, value)


                                        class ParentBandwidth(Entity):
                                            """
                                            Parent bandwidth
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth, self).__init__()

                                                self.yang_name = "parent-bandwidth"
                                                self.yang_parent_name = "wfq"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "parent-bandwidth" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class Bandwidth(Entity):
                                            """
                                            CFG Bandwidth
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth, self).__init__()

                                                self.yang_name = "bandwidth"
                                                self.yang_parent_name = "wfq"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bandwidth" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.chunk_id.is_set or
                                                self.committed_weight.is_set or
                                                self.excess_ratio.is_set or
                                                self.excess_weight.is_set or
                                                self.level.is_set or
                                                self.profile_id.is_set or
                                                (self.bandwidth is not None and self.bandwidth.has_data()) or
                                                (self.parent_bandwidth is not None and self.parent_bandwidth.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.chunk_id.yfilter != YFilter.not_set or
                                                self.committed_weight.yfilter != YFilter.not_set or
                                                self.excess_ratio.yfilter != YFilter.not_set or
                                                self.excess_weight.yfilter != YFilter.not_set or
                                                self.level.yfilter != YFilter.not_set or
                                                self.profile_id.yfilter != YFilter.not_set or
                                                (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                                (self.parent_bandwidth is not None and self.parent_bandwidth.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wfq" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.chunk_id.is_set or self.chunk_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.chunk_id.get_name_leafdata())
                                            if (self.committed_weight.is_set or self.committed_weight.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.committed_weight.get_name_leafdata())
                                            if (self.excess_ratio.is_set or self.excess_ratio.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.excess_ratio.get_name_leafdata())
                                            if (self.excess_weight.is_set or self.excess_weight.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.excess_weight.get_name_leafdata())
                                            if (self.level.is_set or self.level.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.level.get_name_leafdata())
                                            if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.profile_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "bandwidth"):
                                                if (self.bandwidth is None):
                                                    self.bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth()
                                                    self.bandwidth.parent = self
                                                    self._children_name_map["bandwidth"] = "bandwidth"
                                                return self.bandwidth

                                            if (child_yang_name == "parent-bandwidth"):
                                                if (self.parent_bandwidth is None):
                                                    self.parent_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth()
                                                    self.parent_bandwidth.parent = self
                                                    self._children_name_map["parent_bandwidth"] = "parent-bandwidth"
                                                return self.parent_bandwidth

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bandwidth" or name == "parent-bandwidth" or name == "chunk-id" or name == "committed-weight" or name == "excess-ratio" or name == "excess-weight" or name == "level" or name == "profile-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "chunk-id"):
                                                self.chunk_id = value
                                                self.chunk_id.value_namespace = name_space
                                                self.chunk_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "committed-weight"):
                                                self.committed_weight = value
                                                self.committed_weight.value_namespace = name_space
                                                self.committed_weight.value_namespace_prefix = name_space_prefix
                                            if(value_path == "excess-ratio"):
                                                self.excess_ratio = value
                                                self.excess_ratio.value_namespace = name_space
                                                self.excess_ratio.value_namespace_prefix = name_space_prefix
                                            if(value_path == "excess-weight"):
                                                self.excess_weight = value
                                                self.excess_weight.value_namespace = name_space
                                                self.excess_weight.value_namespace_prefix = name_space_prefix
                                            if(value_path == "level"):
                                                self.level = value
                                                self.level.value_namespace = name_space
                                                self.level.value_namespace_prefix = name_space_prefix
                                            if(value_path == "profile-id"):
                                                self.profile_id = value
                                                self.profile_id.value_namespace = name_space
                                                self.profile_id.value_namespace_prefix = name_space_prefix


                                    class Wred(Entity):
                                        """
                                        WRED parameters
                                        
                                        .. attribute:: curve
                                        
                                        	Curve details
                                        	**type**\: list of    :py:class:`Curve <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve>`
                                        
                                        .. attribute:: curve_xr
                                        
                                        	Number of curves
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: type
                                        
                                        	WRED type
                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Wred>`
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred, self).__init__()

                                            self.yang_name = "wred"
                                            self.yang_parent_name = "qos-show-ea-st-v2"

                                            self.curve_xr = YLeaf(YType.uint16, "curve-xr")

                                            self.type = YLeaf(YType.enumeration, "type")

                                            self.curve = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("curve_xr",
                                                            "type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred, self).__setattr__(name, value)


                                        class Curve(Entity):
                                            """
                                            Curve details
                                            
                                            .. attribute:: absolute_index
                                            
                                            	Absolute Index
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: curve_id
                                            
                                            	Curve ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: exp_match
                                            
                                            	WRED exp match if EXP start value equals to end value Format\: <start\-value> , else range Format\: <start\-value> <end\-value>
                                            	**type**\:  str
                                            
                                            .. attribute:: match
                                            
                                            	WRED match if precedence start value equals to end value Format\: <start\-value> , else range Format\: <start\-value> <end\-value>
                                            	**type**\:  str
                                            
                                            .. attribute:: max_threshold
                                            
                                            	Maximum threshold
                                            	**type**\:   :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold>`
                                            
                                            .. attribute:: max_threshold_user_config
                                            
                                            	Maximum threshold WRED context
                                            	**type**\:   :py:class:`MaxThresholdUserConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig>`
                                            
                                            .. attribute:: min_threshold
                                            
                                            	Minimum threshold
                                            	**type**\:   :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold>`
                                            
                                            .. attribute:: min_threshold_user_config
                                            
                                            	Minimum threshold WRED context
                                            	**type**\:   :py:class:`MinThresholdUserConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig>`
                                            
                                            .. attribute:: template_id
                                            
                                            	Template ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve, self).__init__()

                                                self.yang_name = "curve"
                                                self.yang_parent_name = "wred"

                                                self.absolute_index = YLeaf(YType.uint16, "absolute-index")

                                                self.curve_id = YLeaf(YType.uint16, "curve-id")

                                                self.exp_match = YLeaf(YType.str, "exp-match")

                                                self.match = YLeaf(YType.str, "match")

                                                self.template_id = YLeaf(YType.uint16, "template-id")

                                                self.max_threshold = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold()
                                                self.max_threshold.parent = self
                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                self._children_yang_names.add("max-threshold")

                                                self.max_threshold_user_config = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig()
                                                self.max_threshold_user_config.parent = self
                                                self._children_name_map["max_threshold_user_config"] = "max-threshold-user-config"
                                                self._children_yang_names.add("max-threshold-user-config")

                                                self.min_threshold = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold()
                                                self.min_threshold.parent = self
                                                self._children_name_map["min_threshold"] = "min-threshold"
                                                self._children_yang_names.add("min-threshold")

                                                self.min_threshold_user_config = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig()
                                                self.min_threshold_user_config.parent = self
                                                self._children_name_map["min_threshold_user_config"] = "min-threshold-user-config"
                                                self._children_yang_names.add("min-threshold-user-config")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("absolute_index",
                                                                "curve_id",
                                                                "exp_match",
                                                                "match",
                                                                "template_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve, self).__setattr__(name, value)


                                            class MinThreshold(Entity):
                                                """
                                                Minimum threshold
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold, self).__init__()

                                                    self.yang_name = "min-threshold"
                                                    self.yang_parent_name = "curve"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "min-threshold" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class MinThresholdUserConfig(Entity):
                                                """
                                                Minimum threshold WRED context
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig, self).__init__()

                                                    self.yang_name = "min-threshold-user-config"
                                                    self.yang_parent_name = "curve"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "min-threshold-user-config" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class MaxThreshold(Entity):
                                                """
                                                Maximum threshold
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold, self).__init__()

                                                    self.yang_name = "max-threshold"
                                                    self.yang_parent_name = "curve"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "max-threshold" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class MaxThresholdUserConfig(Entity):
                                                """
                                                Maximum threshold WRED context
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig, self).__init__()

                                                    self.yang_name = "max-threshold-user-config"
                                                    self.yang_parent_name = "curve"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "max-threshold-user-config" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.absolute_index.is_set or
                                                    self.curve_id.is_set or
                                                    self.exp_match.is_set or
                                                    self.match.is_set or
                                                    self.template_id.is_set or
                                                    (self.max_threshold is not None and self.max_threshold.has_data()) or
                                                    (self.max_threshold_user_config is not None and self.max_threshold_user_config.has_data()) or
                                                    (self.min_threshold is not None and self.min_threshold.has_data()) or
                                                    (self.min_threshold_user_config is not None and self.min_threshold_user_config.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.absolute_index.yfilter != YFilter.not_set or
                                                    self.curve_id.yfilter != YFilter.not_set or
                                                    self.exp_match.yfilter != YFilter.not_set or
                                                    self.match.yfilter != YFilter.not_set or
                                                    self.template_id.yfilter != YFilter.not_set or
                                                    (self.max_threshold is not None and self.max_threshold.has_operation()) or
                                                    (self.max_threshold_user_config is not None and self.max_threshold_user_config.has_operation()) or
                                                    (self.min_threshold is not None and self.min_threshold.has_operation()) or
                                                    (self.min_threshold_user_config is not None and self.min_threshold_user_config.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "curve" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.absolute_index.is_set or self.absolute_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.absolute_index.get_name_leafdata())
                                                if (self.curve_id.is_set or self.curve_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.curve_id.get_name_leafdata())
                                                if (self.exp_match.is_set or self.exp_match.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exp_match.get_name_leafdata())
                                                if (self.match.is_set or self.match.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match.get_name_leafdata())
                                                if (self.template_id.is_set or self.template_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.template_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "max-threshold"):
                                                    if (self.max_threshold is None):
                                                        self.max_threshold = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold()
                                                        self.max_threshold.parent = self
                                                        self._children_name_map["max_threshold"] = "max-threshold"
                                                    return self.max_threshold

                                                if (child_yang_name == "max-threshold-user-config"):
                                                    if (self.max_threshold_user_config is None):
                                                        self.max_threshold_user_config = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig()
                                                        self.max_threshold_user_config.parent = self
                                                        self._children_name_map["max_threshold_user_config"] = "max-threshold-user-config"
                                                    return self.max_threshold_user_config

                                                if (child_yang_name == "min-threshold"):
                                                    if (self.min_threshold is None):
                                                        self.min_threshold = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold()
                                                        self.min_threshold.parent = self
                                                        self._children_name_map["min_threshold"] = "min-threshold"
                                                    return self.min_threshold

                                                if (child_yang_name == "min-threshold-user-config"):
                                                    if (self.min_threshold_user_config is None):
                                                        self.min_threshold_user_config = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig()
                                                        self.min_threshold_user_config.parent = self
                                                        self._children_name_map["min_threshold_user_config"] = "min-threshold-user-config"
                                                    return self.min_threshold_user_config

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "max-threshold" or name == "max-threshold-user-config" or name == "min-threshold" or name == "min-threshold-user-config" or name == "absolute-index" or name == "curve-id" or name == "exp-match" or name == "match" or name == "template-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "absolute-index"):
                                                    self.absolute_index = value
                                                    self.absolute_index.value_namespace = name_space
                                                    self.absolute_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "curve-id"):
                                                    self.curve_id = value
                                                    self.curve_id.value_namespace = name_space
                                                    self.curve_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exp-match"):
                                                    self.exp_match = value
                                                    self.exp_match.value_namespace = name_space
                                                    self.exp_match.value_namespace_prefix = name_space_prefix
                                                if(value_path == "match"):
                                                    self.match = value
                                                    self.match.value_namespace = name_space
                                                    self.match.value_namespace_prefix = name_space_prefix
                                                if(value_path == "template-id"):
                                                    self.template_id = value
                                                    self.template_id.value_namespace = name_space
                                                    self.template_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.curve:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.curve_xr.is_set or
                                                self.type.is_set)

                                        def has_operation(self):
                                            for c in self.curve:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.curve_xr.yfilter != YFilter.not_set or
                                                self.type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wred" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.curve_xr.is_set or self.curve_xr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.curve_xr.get_name_leafdata())
                                            if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "curve"):
                                                for c in self.curve:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.curve.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "curve" or name == "curve-xr" or name == "type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "curve-xr"):
                                                self.curve_xr = value
                                                self.curve_xr.value_namespace = name_space
                                                self.curve_xr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "type"):
                                                self.type = value
                                                self.type.value_namespace = name_space
                                                self.type.value_namespace_prefix = name_space_prefix


                                    class Mark(Entity):
                                        """
                                        Mark parameters
                                        
                                        .. attribute:: child_mark
                                        
                                        	Child mark only
                                        	**type**\:   :py:class:`ChildMark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark>`
                                        
                                        .. attribute:: parent_mark
                                        
                                        	Parent mark only
                                        	**type**\:   :py:class:`ParentMark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark>`
                                        
                                        .. attribute:: parent_police_conform
                                        
                                        	Parent police conform mark
                                        	**type**\:   :py:class:`ParentPoliceConform <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform>`
                                        
                                        .. attribute:: parent_police_exceed
                                        
                                        	Parent police exceed mark
                                        	**type**\:   :py:class:`ParentPoliceExceed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed>`
                                        
                                        .. attribute:: parent_police_violate
                                        
                                        	Parent police violate mark
                                        	**type**\:   :py:class:`ParentPoliceViolate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate>`
                                        
                                        .. attribute:: police_conform
                                        
                                        	Child police conform mark
                                        	**type**\:   :py:class:`PoliceConform <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform>`
                                        
                                        .. attribute:: police_exceed
                                        
                                        	Child police exceed mark
                                        	**type**\:   :py:class:`PoliceExceed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed>`
                                        
                                        .. attribute:: police_violate
                                        
                                        	Child police violate mark
                                        	**type**\:   :py:class:`PoliceViolate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate>`
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark, self).__init__()

                                            self.yang_name = "mark"
                                            self.yang_parent_name = "qos-show-ea-st-v2"

                                            self.child_mark = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark()
                                            self.child_mark.parent = self
                                            self._children_name_map["child_mark"] = "child-mark"
                                            self._children_yang_names.add("child-mark")

                                            self.parent_mark = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark()
                                            self.parent_mark.parent = self
                                            self._children_name_map["parent_mark"] = "parent-mark"
                                            self._children_yang_names.add("parent-mark")

                                            self.parent_police_conform = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform()
                                            self.parent_police_conform.parent = self
                                            self._children_name_map["parent_police_conform"] = "parent-police-conform"
                                            self._children_yang_names.add("parent-police-conform")

                                            self.parent_police_exceed = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed()
                                            self.parent_police_exceed.parent = self
                                            self._children_name_map["parent_police_exceed"] = "parent-police-exceed"
                                            self._children_yang_names.add("parent-police-exceed")

                                            self.parent_police_violate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate()
                                            self.parent_police_violate.parent = self
                                            self._children_name_map["parent_police_violate"] = "parent-police-violate"
                                            self._children_yang_names.add("parent-police-violate")

                                            self.police_conform = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform()
                                            self.police_conform.parent = self
                                            self._children_name_map["police_conform"] = "police-conform"
                                            self._children_yang_names.add("police-conform")

                                            self.police_exceed = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed()
                                            self.police_exceed.parent = self
                                            self._children_name_map["police_exceed"] = "police-exceed"
                                            self._children_yang_names.add("police-exceed")

                                            self.police_violate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate()
                                            self.police_violate.parent = self
                                            self._children_name_map["police_violate"] = "police-violate"
                                            self._children_yang_names.add("police-violate")


                                        class ChildMark(Entity):
                                            """
                                            Child mark only
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark, self).__init__()

                                                self.yang_name = "child-mark"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "child-mark"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "child-mark" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class PoliceConform(Entity):
                                            """
                                            Child police conform mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform, self).__init__()

                                                self.yang_name = "police-conform"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "police-conform"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-conform" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class PoliceExceed(Entity):
                                            """
                                            Child police exceed mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed, self).__init__()

                                                self.yang_name = "police-exceed"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "police-exceed"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-exceed" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class PoliceViolate(Entity):
                                            """
                                            Child police violate mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate, self).__init__()

                                                self.yang_name = "police-violate"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "police-violate"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-violate" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class ParentMark(Entity):
                                            """
                                            Parent mark only
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark, self).__init__()

                                                self.yang_name = "parent-mark"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "parent-mark"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "parent-mark" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class ParentPoliceConform(Entity):
                                            """
                                            Parent police conform mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform, self).__init__()

                                                self.yang_name = "parent-police-conform"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "parent-police-conform"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "parent-police-conform" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class ParentPoliceExceed(Entity):
                                            """
                                            Parent police exceed mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed, self).__init__()

                                                self.yang_name = "parent-police-exceed"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "parent-police-exceed"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "parent-police-exceed" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class ParentPoliceViolate(Entity):
                                            """
                                            Parent police violate mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate, self).__init__()

                                                self.yang_name = "parent-police-violate"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "parent-police-violate"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "parent-police-violate" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                (self.child_mark is not None and self.child_mark.has_data()) or
                                                (self.parent_mark is not None and self.parent_mark.has_data()) or
                                                (self.parent_police_conform is not None and self.parent_police_conform.has_data()) or
                                                (self.parent_police_exceed is not None and self.parent_police_exceed.has_data()) or
                                                (self.parent_police_violate is not None and self.parent_police_violate.has_data()) or
                                                (self.police_conform is not None and self.police_conform.has_data()) or
                                                (self.police_exceed is not None and self.police_exceed.has_data()) or
                                                (self.police_violate is not None and self.police_violate.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.child_mark is not None and self.child_mark.has_operation()) or
                                                (self.parent_mark is not None and self.parent_mark.has_operation()) or
                                                (self.parent_police_conform is not None and self.parent_police_conform.has_operation()) or
                                                (self.parent_police_exceed is not None and self.parent_police_exceed.has_operation()) or
                                                (self.parent_police_violate is not None and self.parent_police_violate.has_operation()) or
                                                (self.police_conform is not None and self.police_conform.has_operation()) or
                                                (self.police_exceed is not None and self.police_exceed.has_operation()) or
                                                (self.police_violate is not None and self.police_violate.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mark" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "child-mark"):
                                                if (self.child_mark is None):
                                                    self.child_mark = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark()
                                                    self.child_mark.parent = self
                                                    self._children_name_map["child_mark"] = "child-mark"
                                                return self.child_mark

                                            if (child_yang_name == "parent-mark"):
                                                if (self.parent_mark is None):
                                                    self.parent_mark = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark()
                                                    self.parent_mark.parent = self
                                                    self._children_name_map["parent_mark"] = "parent-mark"
                                                return self.parent_mark

                                            if (child_yang_name == "parent-police-conform"):
                                                if (self.parent_police_conform is None):
                                                    self.parent_police_conform = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform()
                                                    self.parent_police_conform.parent = self
                                                    self._children_name_map["parent_police_conform"] = "parent-police-conform"
                                                return self.parent_police_conform

                                            if (child_yang_name == "parent-police-exceed"):
                                                if (self.parent_police_exceed is None):
                                                    self.parent_police_exceed = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed()
                                                    self.parent_police_exceed.parent = self
                                                    self._children_name_map["parent_police_exceed"] = "parent-police-exceed"
                                                return self.parent_police_exceed

                                            if (child_yang_name == "parent-police-violate"):
                                                if (self.parent_police_violate is None):
                                                    self.parent_police_violate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate()
                                                    self.parent_police_violate.parent = self
                                                    self._children_name_map["parent_police_violate"] = "parent-police-violate"
                                                return self.parent_police_violate

                                            if (child_yang_name == "police-conform"):
                                                if (self.police_conform is None):
                                                    self.police_conform = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform()
                                                    self.police_conform.parent = self
                                                    self._children_name_map["police_conform"] = "police-conform"
                                                return self.police_conform

                                            if (child_yang_name == "police-exceed"):
                                                if (self.police_exceed is None):
                                                    self.police_exceed = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed()
                                                    self.police_exceed.parent = self
                                                    self._children_name_map["police_exceed"] = "police-exceed"
                                                return self.police_exceed

                                            if (child_yang_name == "police-violate"):
                                                if (self.police_violate is None):
                                                    self.police_violate = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate()
                                                    self.police_violate.parent = self
                                                    self._children_name_map["police_violate"] = "police-violate"
                                                return self.police_violate

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "child-mark" or name == "parent-mark" or name == "parent-police-conform" or name == "parent-police-exceed" or name == "parent-police-violate" or name == "police-conform" or name == "police-exceed" or name == "police-violate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        return (
                                            self.class_level.is_set or
                                            self.class_name.is_set or
                                            self.parent_class_name.is_set or
                                            self.parent_policy_name.is_set or
                                            self.policy_name.is_set or
                                            (self.mark is not None and self.mark.has_data()) or
                                            (self.police is not None and self.police.has_data()) or
                                            (self.queue is not None and self.queue.has_data()) or
                                            (self.queue_limit_parameters is not None and self.queue_limit_parameters.has_data()) or
                                            (self.shape is not None and self.shape.has_data()) or
                                            (self.wfq is not None and self.wfq.has_data()) or
                                            (self.wred is not None and self.wred.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.class_level.yfilter != YFilter.not_set or
                                            self.class_name.yfilter != YFilter.not_set or
                                            self.parent_class_name.yfilter != YFilter.not_set or
                                            self.parent_policy_name.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            (self.mark is not None and self.mark.has_operation()) or
                                            (self.police is not None and self.police.has_operation()) or
                                            (self.queue is not None and self.queue.has_operation()) or
                                            (self.queue_limit_parameters is not None and self.queue_limit_parameters.has_operation()) or
                                            (self.shape is not None and self.shape.has_operation()) or
                                            (self.wfq is not None and self.wfq.has_operation()) or
                                            (self.wred is not None and self.wred.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "qos-show-ea-st-v2" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.class_level.is_set or self.class_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.class_level.get_name_leafdata())
                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                        if (self.parent_class_name.is_set or self.parent_class_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_class_name.get_name_leafdata())
                                        if (self.parent_policy_name.is_set or self.parent_policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_policy_name.get_name_leafdata())
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "mark"):
                                            if (self.mark is None):
                                                self.mark = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Mark()
                                                self.mark.parent = self
                                                self._children_name_map["mark"] = "mark"
                                            return self.mark

                                        if (child_yang_name == "police"):
                                            if (self.police is None):
                                                self.police = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Police()
                                                self.police.parent = self
                                                self._children_name_map["police"] = "police"
                                            return self.police

                                        if (child_yang_name == "queue"):
                                            if (self.queue is None):
                                                self.queue = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Queue()
                                                self.queue.parent = self
                                                self._children_name_map["queue"] = "queue"
                                            return self.queue

                                        if (child_yang_name == "queue-limit-parameters"):
                                            if (self.queue_limit_parameters is None):
                                                self.queue_limit_parameters = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters()
                                                self.queue_limit_parameters.parent = self
                                                self._children_name_map["queue_limit_parameters"] = "queue-limit-parameters"
                                            return self.queue_limit_parameters

                                        if (child_yang_name == "shape"):
                                            if (self.shape is None):
                                                self.shape = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Shape()
                                                self.shape.parent = self
                                                self._children_name_map["shape"] = "shape"
                                            return self.shape

                                        if (child_yang_name == "wfq"):
                                            if (self.wfq is None):
                                                self.wfq = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wfq()
                                                self.wfq.parent = self
                                                self._children_name_map["wfq"] = "wfq"
                                            return self.wfq

                                        if (child_yang_name == "wred"):
                                            if (self.wred is None):
                                                self.wred = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2.Wred()
                                                self.wred.parent = self
                                                self._children_name_map["wred"] = "wred"
                                            return self.wred

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "mark" or name == "police" or name == "queue" or name == "queue-limit-parameters" or name == "shape" or name == "wfq" or name == "wred" or name == "class-level" or name == "class-name" or name == "parent-class-name" or name == "parent-policy-name" or name == "policy-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "class-level"):
                                            self.class_level = value
                                            self.class_level.value_namespace = name_space
                                            self.class_level.value_namespace_prefix = name_space_prefix
                                        if(value_path == "class-name"):
                                            self.class_name = value
                                            self.class_name.value_namespace = name_space
                                            self.class_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-class-name"):
                                            self.parent_class_name = value
                                            self.parent_class_name.value_namespace = name_space
                                            self.parent_class_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-policy-name"):
                                            self.parent_policy_name = value
                                            self.parent_policy_name.value_namespace = name_space
                                            self.parent_policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.qos_show_ea_st_v2:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.qos_show_ea_st_v2:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "policy-typhoon" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "qos-show-ea-st-v2"):
                                        for c in self.qos_show_ea_st_v2:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon.QosShowEaStV2()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.qos_show_ea_st_v2.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "qos-show-ea-st-v2"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.header is not None and self.header.has_data()) or
                                    (self.policy is not None and self.policy.has_data()) or
                                    (self.policy_typhoon is not None and self.policy_typhoon.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.header is not None and self.header.has_operation()) or
                                    (self.policy is not None and self.policy.has_operation()) or
                                    (self.policy_typhoon is not None and self.policy_typhoon.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "details" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "header"):
                                    if (self.header is None):
                                        self.header = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Header()
                                        self.header.parent = self
                                        self._children_name_map["header"] = "header"
                                    return self.header

                                if (child_yang_name == "policy"):
                                    if (self.policy is None):
                                        self.policy = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.Policy()
                                        self.policy.parent = self
                                        self._children_name_map["policy"] = "policy"
                                    return self.policy

                                if (child_yang_name == "policy-typhoon"):
                                    if (self.policy_typhoon is None):
                                        self.policy_typhoon = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details.PolicyTyphoon()
                                        self.policy_typhoon.parent = self
                                        self._children_name_map["policy_typhoon"] = "policy-typhoon"
                                    return self.policy_typhoon

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "header" or name == "policy" or name == "policy-typhoon"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (self.details is not None and self.details.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.details is not None and self.details.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "input" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "details"):
                                if (self.details is None):
                                    self.details = PlatformQos.Nodes.Node.Interfaces.Interface.Input.Details()
                                    self.details.parent = self
                                    self._children_name_map["details"] = "details"
                                return self.details

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "details"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Output(Entity):
                        """
                        QoS policy direction egress
                        
                        .. attribute:: details
                        
                        	QoS policy direction egress
                        	**type**\:   :py:class:`Details <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details>`
                        
                        

                        """

                        _prefix = 'asr9k-qos-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output, self).__init__()

                            self.yang_name = "output"
                            self.yang_parent_name = "interface"

                            self.details = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details()
                            self.details.parent = self
                            self._children_name_map["details"] = "details"
                            self._children_yang_names.add("details")


                        class Details(Entity):
                            """
                            QoS policy direction egress
                            
                            .. attribute:: header
                            
                            	QoS policy header
                            	**type**\:   :py:class:`Header <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header>`
                            
                            .. attribute:: policy
                            
                            	Trident QoS policy details
                            	**type**\:   :py:class:`Policy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy>`
                            
                            .. attribute:: policy_typhoon
                            
                            	Typhoon QoS policy details
                            	**type**\:   :py:class:`PolicyTyphoon <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon>`
                            
                            

                            """

                            _prefix = 'asr9k-qos-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details, self).__init__()

                                self.yang_name = "details"
                                self.yang_parent_name = "output"

                                self.header = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header()
                                self.header.parent = self
                                self._children_name_map["header"] = "header"
                                self._children_yang_names.add("header")

                                self.policy = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy()
                                self.policy.parent = self
                                self._children_name_map["policy"] = "policy"
                                self._children_yang_names.add("policy")

                                self.policy_typhoon = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon()
                                self.policy_typhoon.parent = self
                                self._children_name_map["policy_typhoon"] = "policy-typhoon"
                                self._children_yang_names.add("policy-typhoon")


                            class Header(Entity):
                                """
                                QoS policy header
                                
                                .. attribute:: classes
                                
                                	Number of classes
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: interface_parameters
                                
                                	Interface config and programmed parameters
                                	**type**\:   :py:class:`InterfaceParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters>`
                                
                                .. attribute:: policy_name
                                
                                	Policy name
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: programmed_bandwidth
                                
                                	Bandwidth that was programmed
                                	**type**\:   :py:class:`ProgrammedBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.ProgrammedBandwidth>`
                                
                                

                                """

                                _prefix = 'asr9k-qos-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header, self).__init__()

                                    self.yang_name = "header"
                                    self.yang_parent_name = "details"

                                    self.classes = YLeaf(YType.uint16, "classes")

                                    self.policy_name = YLeaf(YType.str, "policy-name")

                                    self.interface_parameters = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters()
                                    self.interface_parameters.parent = self
                                    self._children_name_map["interface_parameters"] = "interface-parameters"
                                    self._children_yang_names.add("interface-parameters")

                                    self.programmed_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.ProgrammedBandwidth()
                                    self.programmed_bandwidth.parent = self
                                    self._children_name_map["programmed_bandwidth"] = "programmed-bandwidth"
                                    self._children_yang_names.add("programmed-bandwidth")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("classes",
                                                    "policy_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header, self).__setattr__(name, value)


                                class InterfaceParameters(Entity):
                                    """
                                    Interface config and programmed parameters
                                    
                                    .. attribute:: ancp_config_bandwidth
                                    
                                    	Bandwidth obtain from IM
                                    	**type**\:   :py:class:`AncpConfigBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.AncpConfigBandwidth>`
                                    
                                    .. attribute:: ancp_programmed_bandwidth
                                    
                                    	ANCP bandwidth that was programmed
                                    	**type**\:   :py:class:`AncpProgrammedBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.AncpProgrammedBandwidth>`
                                    
                                    .. attribute:: port_config_bandwidth
                                    
                                    	Bandwidth due to port speed change
                                    	**type**\:   :py:class:`PortConfigBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.PortConfigBandwidth>`
                                    
                                    .. attribute:: port_shaper_rate
                                    
                                    	Bandwidth that was programmed
                                    	**type**\:   :py:class:`PortShaperRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.PortShaperRate>`
                                    
                                    

                                    """

                                    _prefix = 'asr9k-qos-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters, self).__init__()

                                        self.yang_name = "interface-parameters"
                                        self.yang_parent_name = "header"

                                        self.ancp_config_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.AncpConfigBandwidth()
                                        self.ancp_config_bandwidth.parent = self
                                        self._children_name_map["ancp_config_bandwidth"] = "ancp-config-bandwidth"
                                        self._children_yang_names.add("ancp-config-bandwidth")

                                        self.ancp_programmed_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.AncpProgrammedBandwidth()
                                        self.ancp_programmed_bandwidth.parent = self
                                        self._children_name_map["ancp_programmed_bandwidth"] = "ancp-programmed-bandwidth"
                                        self._children_yang_names.add("ancp-programmed-bandwidth")

                                        self.port_config_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.PortConfigBandwidth()
                                        self.port_config_bandwidth.parent = self
                                        self._children_name_map["port_config_bandwidth"] = "port-config-bandwidth"
                                        self._children_yang_names.add("port-config-bandwidth")

                                        self.port_shaper_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.PortShaperRate()
                                        self.port_shaper_rate.parent = self
                                        self._children_name_map["port_shaper_rate"] = "port-shaper-rate"
                                        self._children_yang_names.add("port-shaper-rate")


                                    class PortConfigBandwidth(Entity):
                                        """
                                        Bandwidth due to port speed change
                                        
                                        .. attribute:: unit
                                        
                                        	Config unit
                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	Config value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.PortConfigBandwidth, self).__init__()

                                            self.yang_name = "port-config-bandwidth"
                                            self.yang_parent_name = "interface-parameters"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.PortConfigBandwidth, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.PortConfigBandwidth, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "port-config-bandwidth" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class AncpConfigBandwidth(Entity):
                                        """
                                        Bandwidth obtain from IM
                                        
                                        .. attribute:: unit
                                        
                                        	Config unit
                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	Config value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.AncpConfigBandwidth, self).__init__()

                                            self.yang_name = "ancp-config-bandwidth"
                                            self.yang_parent_name = "interface-parameters"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.AncpConfigBandwidth, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.AncpConfigBandwidth, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "ancp-config-bandwidth" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class AncpProgrammedBandwidth(Entity):
                                        """
                                        ANCP bandwidth that was programmed
                                        
                                        .. attribute:: unit
                                        
                                        	Config unit
                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	Config value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.AncpProgrammedBandwidth, self).__init__()

                                            self.yang_name = "ancp-programmed-bandwidth"
                                            self.yang_parent_name = "interface-parameters"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.AncpProgrammedBandwidth, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.AncpProgrammedBandwidth, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "ancp-programmed-bandwidth" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix


                                    class PortShaperRate(Entity):
                                        """
                                        Bandwidth that was programmed
                                        
                                        .. attribute:: unit
                                        
                                        	Config unit
                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                        
                                        .. attribute:: value
                                        
                                        	Config value
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.PortShaperRate, self).__init__()

                                            self.yang_name = "port-shaper-rate"
                                            self.yang_parent_name = "interface-parameters"

                                            self.unit = YLeaf(YType.enumeration, "unit")

                                            self.value = YLeaf(YType.uint32, "value")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("unit",
                                                            "value") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.PortShaperRate, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.PortShaperRate, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.unit.is_set or
                                                self.value.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.unit.yfilter != YFilter.not_set or
                                                self.value.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "port-shaper-rate" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.value.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "unit" or name == "value"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "unit"):
                                                self.unit = value
                                                self.unit.value_namespace = name_space
                                                self.unit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "value"):
                                                self.value = value
                                                self.value.value_namespace = name_space
                                                self.value.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.ancp_config_bandwidth is not None and self.ancp_config_bandwidth.has_data()) or
                                            (self.ancp_programmed_bandwidth is not None and self.ancp_programmed_bandwidth.has_data()) or
                                            (self.port_config_bandwidth is not None and self.port_config_bandwidth.has_data()) or
                                            (self.port_shaper_rate is not None and self.port_shaper_rate.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.ancp_config_bandwidth is not None and self.ancp_config_bandwidth.has_operation()) or
                                            (self.ancp_programmed_bandwidth is not None and self.ancp_programmed_bandwidth.has_operation()) or
                                            (self.port_config_bandwidth is not None and self.port_config_bandwidth.has_operation()) or
                                            (self.port_shaper_rate is not None and self.port_shaper_rate.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "interface-parameters" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "ancp-config-bandwidth"):
                                            if (self.ancp_config_bandwidth is None):
                                                self.ancp_config_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.AncpConfigBandwidth()
                                                self.ancp_config_bandwidth.parent = self
                                                self._children_name_map["ancp_config_bandwidth"] = "ancp-config-bandwidth"
                                            return self.ancp_config_bandwidth

                                        if (child_yang_name == "ancp-programmed-bandwidth"):
                                            if (self.ancp_programmed_bandwidth is None):
                                                self.ancp_programmed_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.AncpProgrammedBandwidth()
                                                self.ancp_programmed_bandwidth.parent = self
                                                self._children_name_map["ancp_programmed_bandwidth"] = "ancp-programmed-bandwidth"
                                            return self.ancp_programmed_bandwidth

                                        if (child_yang_name == "port-config-bandwidth"):
                                            if (self.port_config_bandwidth is None):
                                                self.port_config_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.PortConfigBandwidth()
                                                self.port_config_bandwidth.parent = self
                                                self._children_name_map["port_config_bandwidth"] = "port-config-bandwidth"
                                            return self.port_config_bandwidth

                                        if (child_yang_name == "port-shaper-rate"):
                                            if (self.port_shaper_rate is None):
                                                self.port_shaper_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters.PortShaperRate()
                                                self.port_shaper_rate.parent = self
                                                self._children_name_map["port_shaper_rate"] = "port-shaper-rate"
                                            return self.port_shaper_rate

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ancp-config-bandwidth" or name == "ancp-programmed-bandwidth" or name == "port-config-bandwidth" or name == "port-shaper-rate"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class ProgrammedBandwidth(Entity):
                                    """
                                    Bandwidth that was programmed
                                    
                                    .. attribute:: unit
                                    
                                    	Config unit
                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                    
                                    .. attribute:: value
                                    
                                    	Config value
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'asr9k-qos-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.ProgrammedBandwidth, self).__init__()

                                        self.yang_name = "programmed-bandwidth"
                                        self.yang_parent_name = "header"

                                        self.unit = YLeaf(YType.enumeration, "unit")

                                        self.value = YLeaf(YType.uint32, "value")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("unit",
                                                        "value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.ProgrammedBandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.ProgrammedBandwidth, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.unit.is_set or
                                            self.value.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.unit.yfilter != YFilter.not_set or
                                            self.value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "programmed-bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "unit" or name == "value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "unit"):
                                            self.unit = value
                                            self.unit.value_namespace = name_space
                                            self.unit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "value"):
                                            self.value = value
                                            self.value.value_namespace = name_space
                                            self.value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.classes.is_set or
                                        self.policy_name.is_set or
                                        (self.interface_parameters is not None and self.interface_parameters.has_data()) or
                                        (self.programmed_bandwidth is not None and self.programmed_bandwidth.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.classes.yfilter != YFilter.not_set or
                                        self.policy_name.yfilter != YFilter.not_set or
                                        (self.interface_parameters is not None and self.interface_parameters.has_operation()) or
                                        (self.programmed_bandwidth is not None and self.programmed_bandwidth.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "header" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.classes.is_set or self.classes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.classes.get_name_leafdata())
                                    if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.policy_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "interface-parameters"):
                                        if (self.interface_parameters is None):
                                            self.interface_parameters = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.InterfaceParameters()
                                            self.interface_parameters.parent = self
                                            self._children_name_map["interface_parameters"] = "interface-parameters"
                                        return self.interface_parameters

                                    if (child_yang_name == "programmed-bandwidth"):
                                        if (self.programmed_bandwidth is None):
                                            self.programmed_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header.ProgrammedBandwidth()
                                            self.programmed_bandwidth.parent = self
                                            self._children_name_map["programmed_bandwidth"] = "programmed-bandwidth"
                                        return self.programmed_bandwidth

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "interface-parameters" or name == "programmed-bandwidth" or name == "classes" or name == "policy-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "classes"):
                                        self.classes = value
                                        self.classes.value_namespace = name_space
                                        self.classes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "policy-name"):
                                        self.policy_name = value
                                        self.policy_name.value_namespace = name_space
                                        self.policy_name.value_namespace_prefix = name_space_prefix


                            class Policy(Entity):
                                """
                                Trident QoS policy details
                                
                                .. attribute:: qos_show_ea_st_v1
                                
                                	qos show ea st v1
                                	**type**\: list of    :py:class:`QosShowEaStV1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1>`
                                
                                

                                """

                                _prefix = 'asr9k-qos-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy, self).__init__()

                                    self.yang_name = "policy"
                                    self.yang_parent_name = "details"

                                    self.qos_show_ea_st_v1 = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy, self).__setattr__(name, value)


                                class QosShowEaStV1(Entity):
                                    """
                                    qos show ea st v1
                                    
                                    .. attribute:: class_level
                                    
                                    	Class level
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: class_name
                                    
                                    	Class name
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: mark
                                    
                                    	Mark parameters
                                    	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark>`
                                    
                                    .. attribute:: parent_class_name
                                    
                                    	Parent class name
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: parent_policy_name
                                    
                                    	Parent policy name
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: police
                                    
                                    	Police parameters
                                    	**type**\:   :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	Policy name
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: queue
                                    
                                    	Queue parameters
                                    	**type**\:   :py:class:`Queue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Queue>`
                                    
                                    .. attribute:: queue_limit_parameters
                                    
                                    	Queue limit parameters
                                    	**type**\:   :py:class:`QueueLimitParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.QueueLimitParameters>`
                                    
                                    .. attribute:: shape
                                    
                                    	Shape parameters
                                    	**type**\:   :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape>`
                                    
                                    .. attribute:: wfq
                                    
                                    	WFQ parameters
                                    	**type**\:   :py:class:`Wfq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wfq>`
                                    
                                    .. attribute:: wred
                                    
                                    	WRED parameters
                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred>`
                                    
                                    

                                    """

                                    _prefix = 'asr9k-qos-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1, self).__init__()

                                        self.yang_name = "qos-show-ea-st-v1"
                                        self.yang_parent_name = "policy"

                                        self.class_level = YLeaf(YType.uint8, "class-level")

                                        self.class_name = YLeaf(YType.str, "class-name")

                                        self.parent_class_name = YLeaf(YType.str, "parent-class-name")

                                        self.parent_policy_name = YLeaf(YType.str, "parent-policy-name")

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.mark = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark()
                                        self.mark.parent = self
                                        self._children_name_map["mark"] = "mark"
                                        self._children_yang_names.add("mark")

                                        self.police = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police()
                                        self.police.parent = self
                                        self._children_name_map["police"] = "police"
                                        self._children_yang_names.add("police")

                                        self.queue = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Queue()
                                        self.queue.parent = self
                                        self._children_name_map["queue"] = "queue"
                                        self._children_yang_names.add("queue")

                                        self.queue_limit_parameters = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.QueueLimitParameters()
                                        self.queue_limit_parameters.parent = self
                                        self._children_name_map["queue_limit_parameters"] = "queue-limit-parameters"
                                        self._children_yang_names.add("queue-limit-parameters")

                                        self.shape = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape()
                                        self.shape.parent = self
                                        self._children_name_map["shape"] = "shape"
                                        self._children_yang_names.add("shape")

                                        self.wfq = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wfq()
                                        self.wfq.parent = self
                                        self._children_name_map["wfq"] = "wfq"
                                        self._children_yang_names.add("wfq")

                                        self.wred = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred()
                                        self.wred.parent = self
                                        self._children_name_map["wred"] = "wred"
                                        self._children_yang_names.add("wred")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("class_level",
                                                        "class_name",
                                                        "parent_class_name",
                                                        "parent_policy_name",
                                                        "policy_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1, self).__setattr__(name, value)


                                    class Queue(Entity):
                                        """
                                        Queue parameters
                                        
                                        .. attribute:: class_name
                                        
                                        	Class name
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: queue_id
                                        
                                        	Queue ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_type
                                        
                                        	Queue type
                                        	**type**\:   :py:class:`Queue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Queue>`
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Queue, self).__init__()

                                            self.yang_name = "queue"
                                            self.yang_parent_name = "qos-show-ea-st-v1"

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                            self.queue_type = YLeaf(YType.enumeration, "queue-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("class_name",
                                                            "queue_id",
                                                            "queue_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Queue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Queue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.class_name.is_set or
                                                self.queue_id.is_set or
                                                self.queue_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.queue_id.yfilter != YFilter.not_set or
                                                self.queue_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                            if (self.queue_type.is_set or self.queue_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "class-name" or name == "queue-id" or name == "queue-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-id"):
                                                self.queue_id = value
                                                self.queue_id.value_namespace = name_space
                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-type"):
                                                self.queue_type = value
                                                self.queue_type.value_namespace = name_space
                                                self.queue_type.value_namespace_prefix = name_space_prefix


                                    class QueueLimitParameters(Entity):
                                        """
                                        Queue limit parameters
                                        
                                        .. attribute:: config_queue_limit
                                        
                                        	Config queue limit
                                        	**type**\:   :py:class:`ConfigQueueLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit>`
                                        
                                        .. attribute:: profile_id
                                        
                                        	Profile ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_limit
                                        
                                        	Queue limit in kbytes
                                        	**type**\:   :py:class:`QueueLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit>`
                                        
                                        .. attribute:: scaling_profile_id
                                        
                                        	Scaling profile ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.QueueLimitParameters, self).__init__()

                                            self.yang_name = "queue-limit-parameters"
                                            self.yang_parent_name = "qos-show-ea-st-v1"

                                            self.profile_id = YLeaf(YType.uint32, "profile-id")

                                            self.scaling_profile_id = YLeaf(YType.uint32, "scaling-profile-id")

                                            self.config_queue_limit = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit()
                                            self.config_queue_limit.parent = self
                                            self._children_name_map["config_queue_limit"] = "config-queue-limit"
                                            self._children_yang_names.add("config-queue-limit")

                                            self.queue_limit = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit()
                                            self.queue_limit.parent = self
                                            self._children_name_map["queue_limit"] = "queue-limit"
                                            self._children_yang_names.add("queue-limit")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("profile_id",
                                                            "scaling_profile_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.QueueLimitParameters, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.QueueLimitParameters, self).__setattr__(name, value)


                                        class QueueLimit(Entity):
                                            """
                                            Queue limit in kbytes
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit, self).__init__()

                                                self.yang_name = "queue-limit"
                                                self.yang_parent_name = "queue-limit-parameters"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-limit" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class ConfigQueueLimit(Entity):
                                            """
                                            Config queue limit
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit, self).__init__()

                                                self.yang_name = "config-queue-limit"
                                                self.yang_parent_name = "queue-limit-parameters"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "config-queue-limit" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.profile_id.is_set or
                                                self.scaling_profile_id.is_set or
                                                (self.config_queue_limit is not None and self.config_queue_limit.has_data()) or
                                                (self.queue_limit is not None and self.queue_limit.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.profile_id.yfilter != YFilter.not_set or
                                                self.scaling_profile_id.yfilter != YFilter.not_set or
                                                (self.config_queue_limit is not None and self.config_queue_limit.has_operation()) or
                                                (self.queue_limit is not None and self.queue_limit.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-limit-parameters" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.profile_id.get_name_leafdata())
                                            if (self.scaling_profile_id.is_set or self.scaling_profile_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.scaling_profile_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "config-queue-limit"):
                                                if (self.config_queue_limit is None):
                                                    self.config_queue_limit = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit()
                                                    self.config_queue_limit.parent = self
                                                    self._children_name_map["config_queue_limit"] = "config-queue-limit"
                                                return self.config_queue_limit

                                            if (child_yang_name == "queue-limit"):
                                                if (self.queue_limit is None):
                                                    self.queue_limit = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit()
                                                    self.queue_limit.parent = self
                                                    self._children_name_map["queue_limit"] = "queue-limit"
                                                return self.queue_limit

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "config-queue-limit" or name == "queue-limit" or name == "profile-id" or name == "scaling-profile-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "profile-id"):
                                                self.profile_id = value
                                                self.profile_id.value_namespace = name_space
                                                self.profile_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "scaling-profile-id"):
                                                self.scaling_profile_id = value
                                                self.scaling_profile_id.value_namespace = name_space
                                                self.scaling_profile_id.value_namespace_prefix = name_space_prefix


                                    class Shape(Entity):
                                        """
                                        Shape parameters
                                        
                                        .. attribute:: cbs
                                        
                                        	CBS in bytes
                                        	**type**\:   :py:class:`Cbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Cbs>`
                                        
                                        .. attribute:: cir
                                        
                                        	CIR in kbps
                                        	**type**\:   :py:class:`Cir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Cir>`
                                        
                                        .. attribute:: config_bandwidth
                                        
                                        	Config bandwidth
                                        	**type**\:   :py:class:`ConfigBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth>`
                                        
                                        .. attribute:: pbs
                                        
                                        	PBS in bytes
                                        	**type**\:   :py:class:`Pbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Pbs>`
                                        
                                        .. attribute:: pir
                                        
                                        	PIR in kbps
                                        	**type**\:   :py:class:`Pir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Pir>`
                                        
                                        .. attribute:: profile_id
                                        
                                        	Shape profile ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape, self).__init__()

                                            self.yang_name = "shape"
                                            self.yang_parent_name = "qos-show-ea-st-v1"

                                            self.profile_id = YLeaf(YType.uint16, "profile-id")

                                            self.cbs = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Cbs()
                                            self.cbs.parent = self
                                            self._children_name_map["cbs"] = "cbs"
                                            self._children_yang_names.add("cbs")

                                            self.cir = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Cir()
                                            self.cir.parent = self
                                            self._children_name_map["cir"] = "cir"
                                            self._children_yang_names.add("cir")

                                            self.config_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth()
                                            self.config_bandwidth.parent = self
                                            self._children_name_map["config_bandwidth"] = "config-bandwidth"
                                            self._children_yang_names.add("config-bandwidth")

                                            self.pbs = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Pbs()
                                            self.pbs.parent = self
                                            self._children_name_map["pbs"] = "pbs"
                                            self._children_yang_names.add("pbs")

                                            self.pir = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Pir()
                                            self.pir.parent = self
                                            self._children_name_map["pir"] = "pir"
                                            self._children_yang_names.add("pir")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("profile_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape, self).__setattr__(name, value)


                                        class Cir(Entity):
                                            """
                                            CIR in kbps
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Cir, self).__init__()

                                                self.yang_name = "cir"
                                                self.yang_parent_name = "shape"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Cir, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Cir, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cir" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class ConfigBandwidth(Entity):
                                            """
                                            Config bandwidth
                                            
                                            .. attribute:: minimum_rate
                                            
                                            	Minimum bandwidth rate
                                            	**type**\:   :py:class:`MinimumRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth, self).__init__()

                                                self.yang_name = "config-bandwidth"
                                                self.yang_parent_name = "shape"

                                                self.minimum_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate()
                                                self.minimum_rate.parent = self
                                                self._children_name_map["minimum_rate"] = "minimum-rate"
                                                self._children_yang_names.add("minimum-rate")


                                            class MinimumRate(Entity):
                                                """
                                                Minimum bandwidth rate
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate, self).__init__()

                                                    self.yang_name = "minimum-rate"
                                                    self.yang_parent_name = "config-bandwidth"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "minimum-rate" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (self.minimum_rate is not None and self.minimum_rate.has_data())

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    (self.minimum_rate is not None and self.minimum_rate.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "config-bandwidth" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "minimum-rate"):
                                                    if (self.minimum_rate is None):
                                                        self.minimum_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate()
                                                        self.minimum_rate.parent = self
                                                        self._children_name_map["minimum_rate"] = "minimum-rate"
                                                    return self.minimum_rate

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "minimum-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class Cbs(Entity):
                                            """
                                            CBS in bytes
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Cbs, self).__init__()

                                                self.yang_name = "cbs"
                                                self.yang_parent_name = "shape"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Cbs, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Cbs, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cbs" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class Pir(Entity):
                                            """
                                            PIR in kbps
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Pir, self).__init__()

                                                self.yang_name = "pir"
                                                self.yang_parent_name = "shape"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Pir, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Pir, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "pir" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class Pbs(Entity):
                                            """
                                            PBS in bytes
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Pbs, self).__init__()

                                                self.yang_name = "pbs"
                                                self.yang_parent_name = "shape"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Pbs, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Pbs, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "pbs" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.profile_id.is_set or
                                                (self.cbs is not None and self.cbs.has_data()) or
                                                (self.cir is not None and self.cir.has_data()) or
                                                (self.config_bandwidth is not None and self.config_bandwidth.has_data()) or
                                                (self.pbs is not None and self.pbs.has_data()) or
                                                (self.pir is not None and self.pir.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.profile_id.yfilter != YFilter.not_set or
                                                (self.cbs is not None and self.cbs.has_operation()) or
                                                (self.cir is not None and self.cir.has_operation()) or
                                                (self.config_bandwidth is not None and self.config_bandwidth.has_operation()) or
                                                (self.pbs is not None and self.pbs.has_operation()) or
                                                (self.pir is not None and self.pir.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "shape" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.profile_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cbs"):
                                                if (self.cbs is None):
                                                    self.cbs = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Cbs()
                                                    self.cbs.parent = self
                                                    self._children_name_map["cbs"] = "cbs"
                                                return self.cbs

                                            if (child_yang_name == "cir"):
                                                if (self.cir is None):
                                                    self.cir = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Cir()
                                                    self.cir.parent = self
                                                    self._children_name_map["cir"] = "cir"
                                                return self.cir

                                            if (child_yang_name == "config-bandwidth"):
                                                if (self.config_bandwidth is None):
                                                    self.config_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth()
                                                    self.config_bandwidth.parent = self
                                                    self._children_name_map["config_bandwidth"] = "config-bandwidth"
                                                return self.config_bandwidth

                                            if (child_yang_name == "pbs"):
                                                if (self.pbs is None):
                                                    self.pbs = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Pbs()
                                                    self.pbs.parent = self
                                                    self._children_name_map["pbs"] = "pbs"
                                                return self.pbs

                                            if (child_yang_name == "pir"):
                                                if (self.pir is None):
                                                    self.pir = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape.Pir()
                                                    self.pir.parent = self
                                                    self._children_name_map["pir"] = "pir"
                                                return self.pir

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cbs" or name == "cir" or name == "config-bandwidth" or name == "pbs" or name == "pir" or name == "profile-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "profile-id"):
                                                self.profile_id = value
                                                self.profile_id.value_namespace = name_space
                                                self.profile_id.value_namespace_prefix = name_space_prefix


                                    class Police(Entity):
                                        """
                                        Police parameters
                                        
                                        .. attribute:: cbs
                                        
                                        	CBS
                                        	**type**\:   :py:class:`Cbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Cbs>`
                                        
                                        .. attribute:: cir
                                        
                                        	CIR
                                        	**type**\:   :py:class:`Cir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Cir>`
                                        
                                        .. attribute:: pbs
                                        
                                        	PBS
                                        	**type**\:   :py:class:`Pbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Pbs>`
                                        
                                        .. attribute:: pir
                                        
                                        	PIR
                                        	**type**\:   :py:class:`Pir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Pir>`
                                        
                                        .. attribute:: police_config_parameters
                                        
                                        	Police config parameters
                                        	**type**\:   :py:class:`PoliceConfigParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters>`
                                        
                                        .. attribute:: policer_type
                                        
                                        	Policer type
                                        	**type**\:   :py:class:`TbAlgorithm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.TbAlgorithm>`
                                        
                                        .. attribute:: profile_id
                                        
                                        	Police profile ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police, self).__init__()

                                            self.yang_name = "police"
                                            self.yang_parent_name = "qos-show-ea-st-v1"

                                            self.policer_type = YLeaf(YType.enumeration, "policer-type")

                                            self.profile_id = YLeaf(YType.uint32, "profile-id")

                                            self.cbs = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Cbs()
                                            self.cbs.parent = self
                                            self._children_name_map["cbs"] = "cbs"
                                            self._children_yang_names.add("cbs")

                                            self.cir = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Cir()
                                            self.cir.parent = self
                                            self._children_name_map["cir"] = "cir"
                                            self._children_yang_names.add("cir")

                                            self.pbs = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Pbs()
                                            self.pbs.parent = self
                                            self._children_name_map["pbs"] = "pbs"
                                            self._children_yang_names.add("pbs")

                                            self.pir = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Pir()
                                            self.pir.parent = self
                                            self._children_name_map["pir"] = "pir"
                                            self._children_yang_names.add("pir")

                                            self.police_config_parameters = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters()
                                            self.police_config_parameters.parent = self
                                            self._children_name_map["police_config_parameters"] = "police-config-parameters"
                                            self._children_yang_names.add("police-config-parameters")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("policer_type",
                                                            "profile_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police, self).__setattr__(name, value)


                                        class Cir(Entity):
                                            """
                                            CIR
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Cir, self).__init__()

                                                self.yang_name = "cir"
                                                self.yang_parent_name = "police"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Cir, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Cir, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cir" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class Cbs(Entity):
                                            """
                                            CBS
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Cbs, self).__init__()

                                                self.yang_name = "cbs"
                                                self.yang_parent_name = "police"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Cbs, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Cbs, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cbs" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class Pir(Entity):
                                            """
                                            PIR
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Pir, self).__init__()

                                                self.yang_name = "pir"
                                                self.yang_parent_name = "police"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Pir, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Pir, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "pir" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class Pbs(Entity):
                                            """
                                            PBS
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Pbs, self).__init__()

                                                self.yang_name = "pbs"
                                                self.yang_parent_name = "police"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Pbs, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Pbs, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "pbs" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class PoliceConfigParameters(Entity):
                                            """
                                            Police config parameters
                                            
                                            .. attribute:: average_rate
                                            
                                            	Average rate
                                            	**type**\:   :py:class:`AverageRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate>`
                                            
                                            .. attribute:: conform_burst
                                            
                                            	Conform burst
                                            	**type**\:   :py:class:`ConformBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst>`
                                            
                                            .. attribute:: exceed_burst
                                            
                                            	Exceed burst
                                            	**type**\:   :py:class:`ExceedBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst>`
                                            
                                            .. attribute:: peak_rate
                                            
                                            	Peak rate
                                            	**type**\:   :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters, self).__init__()

                                                self.yang_name = "police-config-parameters"
                                                self.yang_parent_name = "police"

                                                self.average_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate()
                                                self.average_rate.parent = self
                                                self._children_name_map["average_rate"] = "average-rate"
                                                self._children_yang_names.add("average-rate")

                                                self.conform_burst = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst()
                                                self.conform_burst.parent = self
                                                self._children_name_map["conform_burst"] = "conform-burst"
                                                self._children_yang_names.add("conform-burst")

                                                self.exceed_burst = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst()
                                                self.exceed_burst.parent = self
                                                self._children_name_map["exceed_burst"] = "exceed-burst"
                                                self._children_yang_names.add("exceed-burst")

                                                self.peak_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate()
                                                self.peak_rate.parent = self
                                                self._children_name_map["peak_rate"] = "peak-rate"
                                                self._children_yang_names.add("peak-rate")


                                            class AverageRate(Entity):
                                                """
                                                Average rate
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate, self).__init__()

                                                    self.yang_name = "average-rate"
                                                    self.yang_parent_name = "police-config-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "average-rate" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class PeakRate(Entity):
                                                """
                                                Peak rate
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate, self).__init__()

                                                    self.yang_name = "peak-rate"
                                                    self.yang_parent_name = "police-config-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "peak-rate" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class ConformBurst(Entity):
                                                """
                                                Conform burst
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst, self).__init__()

                                                    self.yang_name = "conform-burst"
                                                    self.yang_parent_name = "police-config-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "conform-burst" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class ExceedBurst(Entity):
                                                """
                                                Exceed burst
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst, self).__init__()

                                                    self.yang_name = "exceed-burst"
                                                    self.yang_parent_name = "police-config-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "exceed-burst" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    (self.average_rate is not None and self.average_rate.has_data()) or
                                                    (self.conform_burst is not None and self.conform_burst.has_data()) or
                                                    (self.exceed_burst is not None and self.exceed_burst.has_data()) or
                                                    (self.peak_rate is not None and self.peak_rate.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    (self.average_rate is not None and self.average_rate.has_operation()) or
                                                    (self.conform_burst is not None and self.conform_burst.has_operation()) or
                                                    (self.exceed_burst is not None and self.exceed_burst.has_operation()) or
                                                    (self.peak_rate is not None and self.peak_rate.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-config-parameters" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "average-rate"):
                                                    if (self.average_rate is None):
                                                        self.average_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate()
                                                        self.average_rate.parent = self
                                                        self._children_name_map["average_rate"] = "average-rate"
                                                    return self.average_rate

                                                if (child_yang_name == "conform-burst"):
                                                    if (self.conform_burst is None):
                                                        self.conform_burst = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst()
                                                        self.conform_burst.parent = self
                                                        self._children_name_map["conform_burst"] = "conform-burst"
                                                    return self.conform_burst

                                                if (child_yang_name == "exceed-burst"):
                                                    if (self.exceed_burst is None):
                                                        self.exceed_burst = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst()
                                                        self.exceed_burst.parent = self
                                                        self._children_name_map["exceed_burst"] = "exceed-burst"
                                                    return self.exceed_burst

                                                if (child_yang_name == "peak-rate"):
                                                    if (self.peak_rate is None):
                                                        self.peak_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate()
                                                        self.peak_rate.parent = self
                                                        self._children_name_map["peak_rate"] = "peak-rate"
                                                    return self.peak_rate

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "average-rate" or name == "conform-burst" or name == "exceed-burst" or name == "peak-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass

                                        def has_data(self):
                                            return (
                                                self.policer_type.is_set or
                                                self.profile_id.is_set or
                                                (self.cbs is not None and self.cbs.has_data()) or
                                                (self.cir is not None and self.cir.has_data()) or
                                                (self.pbs is not None and self.pbs.has_data()) or
                                                (self.pir is not None and self.pir.has_data()) or
                                                (self.police_config_parameters is not None and self.police_config_parameters.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.policer_type.yfilter != YFilter.not_set or
                                                self.profile_id.yfilter != YFilter.not_set or
                                                (self.cbs is not None and self.cbs.has_operation()) or
                                                (self.cir is not None and self.cir.has_operation()) or
                                                (self.pbs is not None and self.pbs.has_operation()) or
                                                (self.pir is not None and self.pir.has_operation()) or
                                                (self.police_config_parameters is not None and self.police_config_parameters.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "police" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.policer_type.is_set or self.policer_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policer_type.get_name_leafdata())
                                            if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.profile_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cbs"):
                                                if (self.cbs is None):
                                                    self.cbs = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Cbs()
                                                    self.cbs.parent = self
                                                    self._children_name_map["cbs"] = "cbs"
                                                return self.cbs

                                            if (child_yang_name == "cir"):
                                                if (self.cir is None):
                                                    self.cir = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Cir()
                                                    self.cir.parent = self
                                                    self._children_name_map["cir"] = "cir"
                                                return self.cir

                                            if (child_yang_name == "pbs"):
                                                if (self.pbs is None):
                                                    self.pbs = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Pbs()
                                                    self.pbs.parent = self
                                                    self._children_name_map["pbs"] = "pbs"
                                                return self.pbs

                                            if (child_yang_name == "pir"):
                                                if (self.pir is None):
                                                    self.pir = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.Pir()
                                                    self.pir.parent = self
                                                    self._children_name_map["pir"] = "pir"
                                                return self.pir

                                            if (child_yang_name == "police-config-parameters"):
                                                if (self.police_config_parameters is None):
                                                    self.police_config_parameters = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters()
                                                    self.police_config_parameters.parent = self
                                                    self._children_name_map["police_config_parameters"] = "police-config-parameters"
                                                return self.police_config_parameters

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cbs" or name == "cir" or name == "pbs" or name == "pir" or name == "police-config-parameters" or name == "policer-type" or name == "profile-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "policer-type"):
                                                self.policer_type = value
                                                self.policer_type.value_namespace = name_space
                                                self.policer_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "profile-id"):
                                                self.profile_id = value
                                                self.profile_id.value_namespace = name_space
                                                self.profile_id.value_namespace_prefix = name_space_prefix


                                    class Wfq(Entity):
                                        """
                                        WFQ parameters
                                        
                                        .. attribute:: bandwidth
                                        
                                        	CFG Bandwidth
                                        	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wfq.Bandwidth>`
                                        
                                        .. attribute:: chunk_id
                                        
                                        	Chunk ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: committed_weight
                                        
                                        	Committed weight
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: excess_ratio
                                        
                                        	Parent Excess ratio
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: excess_weight
                                        
                                        	Excess weight
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: level
                                        
                                        	Level
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: parent_bandwidth
                                        
                                        	Parent bandwidth
                                        	**type**\:   :py:class:`ParentBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth>`
                                        
                                        .. attribute:: profile_id
                                        
                                        	WFQ profile
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wfq, self).__init__()

                                            self.yang_name = "wfq"
                                            self.yang_parent_name = "qos-show-ea-st-v1"

                                            self.chunk_id = YLeaf(YType.uint32, "chunk-id")

                                            self.committed_weight = YLeaf(YType.uint32, "committed-weight")

                                            self.excess_ratio = YLeaf(YType.uint16, "excess-ratio")

                                            self.excess_weight = YLeaf(YType.uint16, "excess-weight")

                                            self.level = YLeaf(YType.uint8, "level")

                                            self.profile_id = YLeaf(YType.uint32, "profile-id")

                                            self.bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wfq.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                            self._children_yang_names.add("bandwidth")

                                            self.parent_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth()
                                            self.parent_bandwidth.parent = self
                                            self._children_name_map["parent_bandwidth"] = "parent-bandwidth"
                                            self._children_yang_names.add("parent-bandwidth")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("chunk_id",
                                                            "committed_weight",
                                                            "excess_ratio",
                                                            "excess_weight",
                                                            "level",
                                                            "profile_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wfq, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wfq, self).__setattr__(name, value)


                                        class ParentBandwidth(Entity):
                                            """
                                            Parent bandwidth
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth, self).__init__()

                                                self.yang_name = "parent-bandwidth"
                                                self.yang_parent_name = "wfq"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "parent-bandwidth" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class Bandwidth(Entity):
                                            """
                                            CFG Bandwidth
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wfq.Bandwidth, self).__init__()

                                                self.yang_name = "bandwidth"
                                                self.yang_parent_name = "wfq"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wfq.Bandwidth, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wfq.Bandwidth, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bandwidth" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.chunk_id.is_set or
                                                self.committed_weight.is_set or
                                                self.excess_ratio.is_set or
                                                self.excess_weight.is_set or
                                                self.level.is_set or
                                                self.profile_id.is_set or
                                                (self.bandwidth is not None and self.bandwidth.has_data()) or
                                                (self.parent_bandwidth is not None and self.parent_bandwidth.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.chunk_id.yfilter != YFilter.not_set or
                                                self.committed_weight.yfilter != YFilter.not_set or
                                                self.excess_ratio.yfilter != YFilter.not_set or
                                                self.excess_weight.yfilter != YFilter.not_set or
                                                self.level.yfilter != YFilter.not_set or
                                                self.profile_id.yfilter != YFilter.not_set or
                                                (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                                (self.parent_bandwidth is not None and self.parent_bandwidth.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wfq" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.chunk_id.is_set or self.chunk_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.chunk_id.get_name_leafdata())
                                            if (self.committed_weight.is_set or self.committed_weight.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.committed_weight.get_name_leafdata())
                                            if (self.excess_ratio.is_set or self.excess_ratio.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.excess_ratio.get_name_leafdata())
                                            if (self.excess_weight.is_set or self.excess_weight.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.excess_weight.get_name_leafdata())
                                            if (self.level.is_set or self.level.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.level.get_name_leafdata())
                                            if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.profile_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "bandwidth"):
                                                if (self.bandwidth is None):
                                                    self.bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wfq.Bandwidth()
                                                    self.bandwidth.parent = self
                                                    self._children_name_map["bandwidth"] = "bandwidth"
                                                return self.bandwidth

                                            if (child_yang_name == "parent-bandwidth"):
                                                if (self.parent_bandwidth is None):
                                                    self.parent_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth()
                                                    self.parent_bandwidth.parent = self
                                                    self._children_name_map["parent_bandwidth"] = "parent-bandwidth"
                                                return self.parent_bandwidth

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bandwidth" or name == "parent-bandwidth" or name == "chunk-id" or name == "committed-weight" or name == "excess-ratio" or name == "excess-weight" or name == "level" or name == "profile-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "chunk-id"):
                                                self.chunk_id = value
                                                self.chunk_id.value_namespace = name_space
                                                self.chunk_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "committed-weight"):
                                                self.committed_weight = value
                                                self.committed_weight.value_namespace = name_space
                                                self.committed_weight.value_namespace_prefix = name_space_prefix
                                            if(value_path == "excess-ratio"):
                                                self.excess_ratio = value
                                                self.excess_ratio.value_namespace = name_space
                                                self.excess_ratio.value_namespace_prefix = name_space_prefix
                                            if(value_path == "excess-weight"):
                                                self.excess_weight = value
                                                self.excess_weight.value_namespace = name_space
                                                self.excess_weight.value_namespace_prefix = name_space_prefix
                                            if(value_path == "level"):
                                                self.level = value
                                                self.level.value_namespace = name_space
                                                self.level.value_namespace_prefix = name_space_prefix
                                            if(value_path == "profile-id"):
                                                self.profile_id = value
                                                self.profile_id.value_namespace = name_space
                                                self.profile_id.value_namespace_prefix = name_space_prefix


                                    class Wred(Entity):
                                        """
                                        WRED parameters
                                        
                                        .. attribute:: curve
                                        
                                        	Curve details
                                        	**type**\: list of    :py:class:`Curve <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve>`
                                        
                                        .. attribute:: curve_xr
                                        
                                        	Number of curves
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: profile_id
                                        
                                        	Profile ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: scaling_profile_id
                                        
                                        	Scaling profile ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: table_id
                                        
                                        	Table ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: type
                                        
                                        	WRED type
                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Wred>`
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred, self).__init__()

                                            self.yang_name = "wred"
                                            self.yang_parent_name = "qos-show-ea-st-v1"

                                            self.curve_xr = YLeaf(YType.uint16, "curve-xr")

                                            self.profile_id = YLeaf(YType.uint32, "profile-id")

                                            self.scaling_profile_id = YLeaf(YType.uint32, "scaling-profile-id")

                                            self.table_id = YLeaf(YType.uint8, "table-id")

                                            self.type = YLeaf(YType.enumeration, "type")

                                            self.curve = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("curve_xr",
                                                            "profile_id",
                                                            "scaling_profile_id",
                                                            "table_id",
                                                            "type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred, self).__setattr__(name, value)


                                        class Curve(Entity):
                                            """
                                            Curve details
                                            
                                            .. attribute:: match
                                            
                                            	WRED precedence match if precedence start value equals to end value Format\: <start\-value> , else range Format\: <start\-value> <end\-value>
                                            	**type**\:  str
                                            
                                            .. attribute:: max_threshold
                                            
                                            	Maximum threshold
                                            	**type**\:   :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold>`
                                            
                                            .. attribute:: max_threshold_user_config
                                            
                                            	Maximum threshold WRED context
                                            	**type**\:   :py:class:`MaxThresholdUserConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig>`
                                            
                                            .. attribute:: min_threshold
                                            
                                            	Minimum threshold
                                            	**type**\:   :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold>`
                                            
                                            .. attribute:: min_threshold_user_config
                                            
                                            	Minimum threshold WRED context
                                            	**type**\:   :py:class:`MinThresholdUserConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve, self).__init__()

                                                self.yang_name = "curve"
                                                self.yang_parent_name = "wred"

                                                self.match = YLeaf(YType.str, "match")

                                                self.max_threshold = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold()
                                                self.max_threshold.parent = self
                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                self._children_yang_names.add("max-threshold")

                                                self.max_threshold_user_config = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig()
                                                self.max_threshold_user_config.parent = self
                                                self._children_name_map["max_threshold_user_config"] = "max-threshold-user-config"
                                                self._children_yang_names.add("max-threshold-user-config")

                                                self.min_threshold = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold()
                                                self.min_threshold.parent = self
                                                self._children_name_map["min_threshold"] = "min-threshold"
                                                self._children_yang_names.add("min-threshold")

                                                self.min_threshold_user_config = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig()
                                                self.min_threshold_user_config.parent = self
                                                self._children_name_map["min_threshold_user_config"] = "min-threshold-user-config"
                                                self._children_yang_names.add("min-threshold-user-config")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("match") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve, self).__setattr__(name, value)


                                            class MinThreshold(Entity):
                                                """
                                                Minimum threshold
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold, self).__init__()

                                                    self.yang_name = "min-threshold"
                                                    self.yang_parent_name = "curve"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "min-threshold" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class MinThresholdUserConfig(Entity):
                                                """
                                                Minimum threshold WRED context
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig, self).__init__()

                                                    self.yang_name = "min-threshold-user-config"
                                                    self.yang_parent_name = "curve"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "min-threshold-user-config" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class MaxThreshold(Entity):
                                                """
                                                Maximum threshold
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold, self).__init__()

                                                    self.yang_name = "max-threshold"
                                                    self.yang_parent_name = "curve"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "max-threshold" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class MaxThresholdUserConfig(Entity):
                                                """
                                                Maximum threshold WRED context
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig, self).__init__()

                                                    self.yang_name = "max-threshold-user-config"
                                                    self.yang_parent_name = "curve"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "max-threshold-user-config" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.match.is_set or
                                                    (self.max_threshold is not None and self.max_threshold.has_data()) or
                                                    (self.max_threshold_user_config is not None and self.max_threshold_user_config.has_data()) or
                                                    (self.min_threshold is not None and self.min_threshold.has_data()) or
                                                    (self.min_threshold_user_config is not None and self.min_threshold_user_config.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.match.yfilter != YFilter.not_set or
                                                    (self.max_threshold is not None and self.max_threshold.has_operation()) or
                                                    (self.max_threshold_user_config is not None and self.max_threshold_user_config.has_operation()) or
                                                    (self.min_threshold is not None and self.min_threshold.has_operation()) or
                                                    (self.min_threshold_user_config is not None and self.min_threshold_user_config.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "curve" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.match.is_set or self.match.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "max-threshold"):
                                                    if (self.max_threshold is None):
                                                        self.max_threshold = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold()
                                                        self.max_threshold.parent = self
                                                        self._children_name_map["max_threshold"] = "max-threshold"
                                                    return self.max_threshold

                                                if (child_yang_name == "max-threshold-user-config"):
                                                    if (self.max_threshold_user_config is None):
                                                        self.max_threshold_user_config = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig()
                                                        self.max_threshold_user_config.parent = self
                                                        self._children_name_map["max_threshold_user_config"] = "max-threshold-user-config"
                                                    return self.max_threshold_user_config

                                                if (child_yang_name == "min-threshold"):
                                                    if (self.min_threshold is None):
                                                        self.min_threshold = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold()
                                                        self.min_threshold.parent = self
                                                        self._children_name_map["min_threshold"] = "min-threshold"
                                                    return self.min_threshold

                                                if (child_yang_name == "min-threshold-user-config"):
                                                    if (self.min_threshold_user_config is None):
                                                        self.min_threshold_user_config = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig()
                                                        self.min_threshold_user_config.parent = self
                                                        self._children_name_map["min_threshold_user_config"] = "min-threshold-user-config"
                                                    return self.min_threshold_user_config

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "max-threshold" or name == "max-threshold-user-config" or name == "min-threshold" or name == "min-threshold-user-config" or name == "match"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "match"):
                                                    self.match = value
                                                    self.match.value_namespace = name_space
                                                    self.match.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.curve:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.curve_xr.is_set or
                                                self.profile_id.is_set or
                                                self.scaling_profile_id.is_set or
                                                self.table_id.is_set or
                                                self.type.is_set)

                                        def has_operation(self):
                                            for c in self.curve:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.curve_xr.yfilter != YFilter.not_set or
                                                self.profile_id.yfilter != YFilter.not_set or
                                                self.scaling_profile_id.yfilter != YFilter.not_set or
                                                self.table_id.yfilter != YFilter.not_set or
                                                self.type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wred" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.curve_xr.is_set or self.curve_xr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.curve_xr.get_name_leafdata())
                                            if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.profile_id.get_name_leafdata())
                                            if (self.scaling_profile_id.is_set or self.scaling_profile_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.scaling_profile_id.get_name_leafdata())
                                            if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.table_id.get_name_leafdata())
                                            if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "curve"):
                                                for c in self.curve:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred.Curve()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.curve.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "curve" or name == "curve-xr" or name == "profile-id" or name == "scaling-profile-id" or name == "table-id" or name == "type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "curve-xr"):
                                                self.curve_xr = value
                                                self.curve_xr.value_namespace = name_space
                                                self.curve_xr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "profile-id"):
                                                self.profile_id = value
                                                self.profile_id.value_namespace = name_space
                                                self.profile_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "scaling-profile-id"):
                                                self.scaling_profile_id = value
                                                self.scaling_profile_id.value_namespace = name_space
                                                self.scaling_profile_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "table-id"):
                                                self.table_id = value
                                                self.table_id.value_namespace = name_space
                                                self.table_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "type"):
                                                self.type = value
                                                self.type.value_namespace = name_space
                                                self.type.value_namespace_prefix = name_space_prefix


                                    class Mark(Entity):
                                        """
                                        Mark parameters
                                        
                                        .. attribute:: child_mark
                                        
                                        	Child mark only
                                        	**type**\:   :py:class:`ChildMark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ChildMark>`
                                        
                                        .. attribute:: parent_mark
                                        
                                        	Parent mark only
                                        	**type**\:   :py:class:`ParentMark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentMark>`
                                        
                                        .. attribute:: parent_police_conform
                                        
                                        	Parent police conform mark
                                        	**type**\:   :py:class:`ParentPoliceConform <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform>`
                                        
                                        .. attribute:: parent_police_exceed
                                        
                                        	Parent police exceed mark
                                        	**type**\:   :py:class:`ParentPoliceExceed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed>`
                                        
                                        .. attribute:: parent_police_violate
                                        
                                        	Parent police violate mark
                                        	**type**\:   :py:class:`ParentPoliceViolate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate>`
                                        
                                        .. attribute:: police_conform
                                        
                                        	Child police conform mark
                                        	**type**\:   :py:class:`PoliceConform <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceConform>`
                                        
                                        .. attribute:: police_exceed
                                        
                                        	Child police exceed mark
                                        	**type**\:   :py:class:`PoliceExceed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceExceed>`
                                        
                                        .. attribute:: police_violate
                                        
                                        	Child police violate mark
                                        	**type**\:   :py:class:`PoliceViolate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceViolate>`
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark, self).__init__()

                                            self.yang_name = "mark"
                                            self.yang_parent_name = "qos-show-ea-st-v1"

                                            self.child_mark = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ChildMark()
                                            self.child_mark.parent = self
                                            self._children_name_map["child_mark"] = "child-mark"
                                            self._children_yang_names.add("child-mark")

                                            self.parent_mark = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentMark()
                                            self.parent_mark.parent = self
                                            self._children_name_map["parent_mark"] = "parent-mark"
                                            self._children_yang_names.add("parent-mark")

                                            self.parent_police_conform = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform()
                                            self.parent_police_conform.parent = self
                                            self._children_name_map["parent_police_conform"] = "parent-police-conform"
                                            self._children_yang_names.add("parent-police-conform")

                                            self.parent_police_exceed = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed()
                                            self.parent_police_exceed.parent = self
                                            self._children_name_map["parent_police_exceed"] = "parent-police-exceed"
                                            self._children_yang_names.add("parent-police-exceed")

                                            self.parent_police_violate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate()
                                            self.parent_police_violate.parent = self
                                            self._children_name_map["parent_police_violate"] = "parent-police-violate"
                                            self._children_yang_names.add("parent-police-violate")

                                            self.police_conform = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceConform()
                                            self.police_conform.parent = self
                                            self._children_name_map["police_conform"] = "police-conform"
                                            self._children_yang_names.add("police-conform")

                                            self.police_exceed = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceExceed()
                                            self.police_exceed.parent = self
                                            self._children_name_map["police_exceed"] = "police-exceed"
                                            self._children_yang_names.add("police-exceed")

                                            self.police_violate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceViolate()
                                            self.police_violate.parent = self
                                            self._children_name_map["police_violate"] = "police-violate"
                                            self._children_yang_names.add("police-violate")


                                        class ChildMark(Entity):
                                            """
                                            Child mark only
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ChildMark.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ChildMark, self).__init__()

                                                self.yang_name = "child-mark"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ChildMark, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ChildMark, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ChildMark.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "child-mark"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ChildMark.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ChildMark.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "child-mark" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ChildMark.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class PoliceConform(Entity):
                                            """
                                            Child police conform mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceConform.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceConform, self).__init__()

                                                self.yang_name = "police-conform"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceConform, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceConform, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceConform.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "police-conform"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceConform.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceConform.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-conform" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceConform.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class PoliceExceed(Entity):
                                            """
                                            Child police exceed mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceExceed.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceExceed, self).__init__()

                                                self.yang_name = "police-exceed"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceExceed, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceExceed, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceExceed.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "police-exceed"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceExceed.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceExceed.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-exceed" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceExceed.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class PoliceViolate(Entity):
                                            """
                                            Child police violate mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceViolate.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceViolate, self).__init__()

                                                self.yang_name = "police-violate"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceViolate, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceViolate, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceViolate.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "police-violate"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceViolate.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceViolate.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-violate" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceViolate.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class ParentMark(Entity):
                                            """
                                            Parent mark only
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentMark.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentMark, self).__init__()

                                                self.yang_name = "parent-mark"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentMark, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentMark, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentMark.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "parent-mark"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentMark.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentMark.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "parent-mark" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentMark.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class ParentPoliceConform(Entity):
                                            """
                                            Parent police conform mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform, self).__init__()

                                                self.yang_name = "parent-police-conform"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "parent-police-conform"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "parent-police-conform" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class ParentPoliceExceed(Entity):
                                            """
                                            Parent police exceed mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed, self).__init__()

                                                self.yang_name = "parent-police-exceed"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "parent-police-exceed"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "parent-police-exceed" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class ParentPoliceViolate(Entity):
                                            """
                                            Parent police violate mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate, self).__init__()

                                                self.yang_name = "parent-police-violate"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "parent-police-violate"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "parent-police-violate" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                (self.child_mark is not None and self.child_mark.has_data()) or
                                                (self.parent_mark is not None and self.parent_mark.has_data()) or
                                                (self.parent_police_conform is not None and self.parent_police_conform.has_data()) or
                                                (self.parent_police_exceed is not None and self.parent_police_exceed.has_data()) or
                                                (self.parent_police_violate is not None and self.parent_police_violate.has_data()) or
                                                (self.police_conform is not None and self.police_conform.has_data()) or
                                                (self.police_exceed is not None and self.police_exceed.has_data()) or
                                                (self.police_violate is not None and self.police_violate.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.child_mark is not None and self.child_mark.has_operation()) or
                                                (self.parent_mark is not None and self.parent_mark.has_operation()) or
                                                (self.parent_police_conform is not None and self.parent_police_conform.has_operation()) or
                                                (self.parent_police_exceed is not None and self.parent_police_exceed.has_operation()) or
                                                (self.parent_police_violate is not None and self.parent_police_violate.has_operation()) or
                                                (self.police_conform is not None and self.police_conform.has_operation()) or
                                                (self.police_exceed is not None and self.police_exceed.has_operation()) or
                                                (self.police_violate is not None and self.police_violate.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mark" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "child-mark"):
                                                if (self.child_mark is None):
                                                    self.child_mark = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ChildMark()
                                                    self.child_mark.parent = self
                                                    self._children_name_map["child_mark"] = "child-mark"
                                                return self.child_mark

                                            if (child_yang_name == "parent-mark"):
                                                if (self.parent_mark is None):
                                                    self.parent_mark = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentMark()
                                                    self.parent_mark.parent = self
                                                    self._children_name_map["parent_mark"] = "parent-mark"
                                                return self.parent_mark

                                            if (child_yang_name == "parent-police-conform"):
                                                if (self.parent_police_conform is None):
                                                    self.parent_police_conform = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform()
                                                    self.parent_police_conform.parent = self
                                                    self._children_name_map["parent_police_conform"] = "parent-police-conform"
                                                return self.parent_police_conform

                                            if (child_yang_name == "parent-police-exceed"):
                                                if (self.parent_police_exceed is None):
                                                    self.parent_police_exceed = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed()
                                                    self.parent_police_exceed.parent = self
                                                    self._children_name_map["parent_police_exceed"] = "parent-police-exceed"
                                                return self.parent_police_exceed

                                            if (child_yang_name == "parent-police-violate"):
                                                if (self.parent_police_violate is None):
                                                    self.parent_police_violate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate()
                                                    self.parent_police_violate.parent = self
                                                    self._children_name_map["parent_police_violate"] = "parent-police-violate"
                                                return self.parent_police_violate

                                            if (child_yang_name == "police-conform"):
                                                if (self.police_conform is None):
                                                    self.police_conform = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceConform()
                                                    self.police_conform.parent = self
                                                    self._children_name_map["police_conform"] = "police-conform"
                                                return self.police_conform

                                            if (child_yang_name == "police-exceed"):
                                                if (self.police_exceed is None):
                                                    self.police_exceed = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceExceed()
                                                    self.police_exceed.parent = self
                                                    self._children_name_map["police_exceed"] = "police-exceed"
                                                return self.police_exceed

                                            if (child_yang_name == "police-violate"):
                                                if (self.police_violate is None):
                                                    self.police_violate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark.PoliceViolate()
                                                    self.police_violate.parent = self
                                                    self._children_name_map["police_violate"] = "police-violate"
                                                return self.police_violate

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "child-mark" or name == "parent-mark" or name == "parent-police-conform" or name == "parent-police-exceed" or name == "parent-police-violate" or name == "police-conform" or name == "police-exceed" or name == "police-violate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        return (
                                            self.class_level.is_set or
                                            self.class_name.is_set or
                                            self.parent_class_name.is_set or
                                            self.parent_policy_name.is_set or
                                            self.policy_name.is_set or
                                            (self.mark is not None and self.mark.has_data()) or
                                            (self.police is not None and self.police.has_data()) or
                                            (self.queue is not None and self.queue.has_data()) or
                                            (self.queue_limit_parameters is not None and self.queue_limit_parameters.has_data()) or
                                            (self.shape is not None and self.shape.has_data()) or
                                            (self.wfq is not None and self.wfq.has_data()) or
                                            (self.wred is not None and self.wred.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.class_level.yfilter != YFilter.not_set or
                                            self.class_name.yfilter != YFilter.not_set or
                                            self.parent_class_name.yfilter != YFilter.not_set or
                                            self.parent_policy_name.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            (self.mark is not None and self.mark.has_operation()) or
                                            (self.police is not None and self.police.has_operation()) or
                                            (self.queue is not None and self.queue.has_operation()) or
                                            (self.queue_limit_parameters is not None and self.queue_limit_parameters.has_operation()) or
                                            (self.shape is not None and self.shape.has_operation()) or
                                            (self.wfq is not None and self.wfq.has_operation()) or
                                            (self.wred is not None and self.wred.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "qos-show-ea-st-v1" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.class_level.is_set or self.class_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.class_level.get_name_leafdata())
                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                        if (self.parent_class_name.is_set or self.parent_class_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_class_name.get_name_leafdata())
                                        if (self.parent_policy_name.is_set or self.parent_policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_policy_name.get_name_leafdata())
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "mark"):
                                            if (self.mark is None):
                                                self.mark = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Mark()
                                                self.mark.parent = self
                                                self._children_name_map["mark"] = "mark"
                                            return self.mark

                                        if (child_yang_name == "police"):
                                            if (self.police is None):
                                                self.police = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Police()
                                                self.police.parent = self
                                                self._children_name_map["police"] = "police"
                                            return self.police

                                        if (child_yang_name == "queue"):
                                            if (self.queue is None):
                                                self.queue = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Queue()
                                                self.queue.parent = self
                                                self._children_name_map["queue"] = "queue"
                                            return self.queue

                                        if (child_yang_name == "queue-limit-parameters"):
                                            if (self.queue_limit_parameters is None):
                                                self.queue_limit_parameters = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.QueueLimitParameters()
                                                self.queue_limit_parameters.parent = self
                                                self._children_name_map["queue_limit_parameters"] = "queue-limit-parameters"
                                            return self.queue_limit_parameters

                                        if (child_yang_name == "shape"):
                                            if (self.shape is None):
                                                self.shape = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Shape()
                                                self.shape.parent = self
                                                self._children_name_map["shape"] = "shape"
                                            return self.shape

                                        if (child_yang_name == "wfq"):
                                            if (self.wfq is None):
                                                self.wfq = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wfq()
                                                self.wfq.parent = self
                                                self._children_name_map["wfq"] = "wfq"
                                            return self.wfq

                                        if (child_yang_name == "wred"):
                                            if (self.wred is None):
                                                self.wred = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1.Wred()
                                                self.wred.parent = self
                                                self._children_name_map["wred"] = "wred"
                                            return self.wred

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "mark" or name == "police" or name == "queue" or name == "queue-limit-parameters" or name == "shape" or name == "wfq" or name == "wred" or name == "class-level" or name == "class-name" or name == "parent-class-name" or name == "parent-policy-name" or name == "policy-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "class-level"):
                                            self.class_level = value
                                            self.class_level.value_namespace = name_space
                                            self.class_level.value_namespace_prefix = name_space_prefix
                                        if(value_path == "class-name"):
                                            self.class_name = value
                                            self.class_name.value_namespace = name_space
                                            self.class_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-class-name"):
                                            self.parent_class_name = value
                                            self.parent_class_name.value_namespace = name_space
                                            self.parent_class_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-policy-name"):
                                            self.parent_policy_name = value
                                            self.parent_policy_name.value_namespace = name_space
                                            self.parent_policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.qos_show_ea_st_v1:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.qos_show_ea_st_v1:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "policy" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "qos-show-ea-st-v1"):
                                        for c in self.qos_show_ea_st_v1:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy.QosShowEaStV1()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.qos_show_ea_st_v1.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "qos-show-ea-st-v1"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class PolicyTyphoon(Entity):
                                """
                                Typhoon QoS policy details
                                
                                .. attribute:: qos_show_ea_st_v2
                                
                                	qos show ea st v2
                                	**type**\: list of    :py:class:`QosShowEaStV2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2>`
                                
                                

                                """

                                _prefix = 'asr9k-qos-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon, self).__init__()

                                    self.yang_name = "policy-typhoon"
                                    self.yang_parent_name = "details"

                                    self.qos_show_ea_st_v2 = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon, self).__setattr__(name, value)


                                class QosShowEaStV2(Entity):
                                    """
                                    qos show ea st v2
                                    
                                    .. attribute:: class_level
                                    
                                    	Class level
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: class_name
                                    
                                    	Class name
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: mark
                                    
                                    	Mark parameters
                                    	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark>`
                                    
                                    .. attribute:: parent_class_name
                                    
                                    	Parent class name
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: parent_policy_name
                                    
                                    	Parent policy name
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: police
                                    
                                    	Police parameters
                                    	**type**\:   :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police>`
                                    
                                    .. attribute:: policy_name
                                    
                                    	Policy name
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: queue
                                    
                                    	Queue parameters
                                    	**type**\:   :py:class:`Queue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Queue>`
                                    
                                    .. attribute:: queue_limit_parameters
                                    
                                    	Queue limit parameters
                                    	**type**\:   :py:class:`QueueLimitParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters>`
                                    
                                    .. attribute:: shape
                                    
                                    	Shape parameters
                                    	**type**\:   :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape>`
                                    
                                    .. attribute:: wfq
                                    
                                    	WFQ parameters
                                    	**type**\:   :py:class:`Wfq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wfq>`
                                    
                                    .. attribute:: wred
                                    
                                    	WRED parameters
                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred>`
                                    
                                    

                                    """

                                    _prefix = 'asr9k-qos-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2, self).__init__()

                                        self.yang_name = "qos-show-ea-st-v2"
                                        self.yang_parent_name = "policy-typhoon"

                                        self.class_level = YLeaf(YType.uint8, "class-level")

                                        self.class_name = YLeaf(YType.str, "class-name")

                                        self.parent_class_name = YLeaf(YType.str, "parent-class-name")

                                        self.parent_policy_name = YLeaf(YType.str, "parent-policy-name")

                                        self.policy_name = YLeaf(YType.str, "policy-name")

                                        self.mark = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark()
                                        self.mark.parent = self
                                        self._children_name_map["mark"] = "mark"
                                        self._children_yang_names.add("mark")

                                        self.police = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police()
                                        self.police.parent = self
                                        self._children_name_map["police"] = "police"
                                        self._children_yang_names.add("police")

                                        self.queue = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Queue()
                                        self.queue.parent = self
                                        self._children_name_map["queue"] = "queue"
                                        self._children_yang_names.add("queue")

                                        self.queue_limit_parameters = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters()
                                        self.queue_limit_parameters.parent = self
                                        self._children_name_map["queue_limit_parameters"] = "queue-limit-parameters"
                                        self._children_yang_names.add("queue-limit-parameters")

                                        self.shape = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape()
                                        self.shape.parent = self
                                        self._children_name_map["shape"] = "shape"
                                        self._children_yang_names.add("shape")

                                        self.wfq = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wfq()
                                        self.wfq.parent = self
                                        self._children_name_map["wfq"] = "wfq"
                                        self._children_yang_names.add("wfq")

                                        self.wred = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred()
                                        self.wred.parent = self
                                        self._children_name_map["wred"] = "wred"
                                        self._children_yang_names.add("wred")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("class_level",
                                                        "class_name",
                                                        "parent_class_name",
                                                        "parent_policy_name",
                                                        "policy_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2, self).__setattr__(name, value)


                                    class Queue(Entity):
                                        """
                                        Queue parameters
                                        
                                        .. attribute:: class_name
                                        
                                        	Class name
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: queue_id
                                        
                                        	Queue ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: queue_type
                                        
                                        	Queue type
                                        	**type**\:   :py:class:`Queue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Queue>`
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Queue, self).__init__()

                                            self.yang_name = "queue"
                                            self.yang_parent_name = "qos-show-ea-st-v2"

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.queue_id = YLeaf(YType.uint32, "queue-id")

                                            self.queue_type = YLeaf(YType.enumeration, "queue-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("class_name",
                                                            "queue_id",
                                                            "queue_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Queue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Queue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.class_name.is_set or
                                                self.queue_id.is_set or
                                                self.queue_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.class_name.yfilter != YFilter.not_set or
                                                self.queue_id.yfilter != YFilter.not_set or
                                                self.queue_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.class_name.get_name_leafdata())
                                            if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_id.get_name_leafdata())
                                            if (self.queue_type.is_set or self.queue_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.queue_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "class-name" or name == "queue-id" or name == "queue-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "class-name"):
                                                self.class_name = value
                                                self.class_name.value_namespace = name_space
                                                self.class_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-id"):
                                                self.queue_id = value
                                                self.queue_id.value_namespace = name_space
                                                self.queue_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "queue-type"):
                                                self.queue_type = value
                                                self.queue_type.value_namespace = name_space
                                                self.queue_type.value_namespace_prefix = name_space_prefix


                                    class QueueLimitParameters(Entity):
                                        """
                                        Queue limit parameters
                                        
                                        .. attribute:: absolute_index
                                        
                                        	Absolute Index
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: config_queue_limit
                                        
                                        	Config queue limit
                                        	**type**\:   :py:class:`ConfigQueueLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit>`
                                        
                                        .. attribute:: curve_id
                                        
                                        	Curve ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: queue_limit
                                        
                                        	Queue limit in kbytes
                                        	**type**\:   :py:class:`QueueLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit>`
                                        
                                        .. attribute:: template_id
                                        
                                        	Template ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters, self).__init__()

                                            self.yang_name = "queue-limit-parameters"
                                            self.yang_parent_name = "qos-show-ea-st-v2"

                                            self.absolute_index = YLeaf(YType.uint16, "absolute-index")

                                            self.curve_id = YLeaf(YType.uint16, "curve-id")

                                            self.template_id = YLeaf(YType.uint16, "template-id")

                                            self.config_queue_limit = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit()
                                            self.config_queue_limit.parent = self
                                            self._children_name_map["config_queue_limit"] = "config-queue-limit"
                                            self._children_yang_names.add("config-queue-limit")

                                            self.queue_limit = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit()
                                            self.queue_limit.parent = self
                                            self._children_name_map["queue_limit"] = "queue-limit"
                                            self._children_yang_names.add("queue-limit")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("absolute_index",
                                                            "curve_id",
                                                            "template_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters, self).__setattr__(name, value)


                                        class QueueLimit(Entity):
                                            """
                                            Queue limit in kbytes
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit, self).__init__()

                                                self.yang_name = "queue-limit"
                                                self.yang_parent_name = "queue-limit-parameters"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "queue-limit" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class ConfigQueueLimit(Entity):
                                            """
                                            Config queue limit
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit, self).__init__()

                                                self.yang_name = "config-queue-limit"
                                                self.yang_parent_name = "queue-limit-parameters"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "config-queue-limit" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.absolute_index.is_set or
                                                self.curve_id.is_set or
                                                self.template_id.is_set or
                                                (self.config_queue_limit is not None and self.config_queue_limit.has_data()) or
                                                (self.queue_limit is not None and self.queue_limit.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.absolute_index.yfilter != YFilter.not_set or
                                                self.curve_id.yfilter != YFilter.not_set or
                                                self.template_id.yfilter != YFilter.not_set or
                                                (self.config_queue_limit is not None and self.config_queue_limit.has_operation()) or
                                                (self.queue_limit is not None and self.queue_limit.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "queue-limit-parameters" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.absolute_index.is_set or self.absolute_index.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.absolute_index.get_name_leafdata())
                                            if (self.curve_id.is_set or self.curve_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.curve_id.get_name_leafdata())
                                            if (self.template_id.is_set or self.template_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.template_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "config-queue-limit"):
                                                if (self.config_queue_limit is None):
                                                    self.config_queue_limit = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit()
                                                    self.config_queue_limit.parent = self
                                                    self._children_name_map["config_queue_limit"] = "config-queue-limit"
                                                return self.config_queue_limit

                                            if (child_yang_name == "queue-limit"):
                                                if (self.queue_limit is None):
                                                    self.queue_limit = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit()
                                                    self.queue_limit.parent = self
                                                    self._children_name_map["queue_limit"] = "queue-limit"
                                                return self.queue_limit

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "config-queue-limit" or name == "queue-limit" or name == "absolute-index" or name == "curve-id" or name == "template-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "absolute-index"):
                                                self.absolute_index = value
                                                self.absolute_index.value_namespace = name_space
                                                self.absolute_index.value_namespace_prefix = name_space_prefix
                                            if(value_path == "curve-id"):
                                                self.curve_id = value
                                                self.curve_id.value_namespace = name_space
                                                self.curve_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "template-id"):
                                                self.template_id = value
                                                self.template_id.value_namespace = name_space
                                                self.template_id.value_namespace_prefix = name_space_prefix


                                    class Shape(Entity):
                                        """
                                        Shape parameters
                                        
                                        .. attribute:: cir_shape
                                        
                                        	CIR shaper params
                                        	**type**\:   :py:class:`CirShape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape>`
                                        
                                        .. attribute:: cir_shape_type
                                        
                                        	CIR Shaper type
                                        	**type**\:   :py:class:`ShapeProfiletypeV2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ShapeProfiletypeV2>`
                                        
                                        .. attribute:: pir_shape
                                        
                                        	PIR shaper params
                                        	**type**\:   :py:class:`PirShape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape>`
                                        
                                        .. attribute:: pir_shape_type
                                        
                                        	PIR Shaper type
                                        	**type**\:   :py:class:`ShapeProfiletypeV2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ShapeProfiletypeV2>`
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape, self).__init__()

                                            self.yang_name = "shape"
                                            self.yang_parent_name = "qos-show-ea-st-v2"

                                            self.cir_shape_type = YLeaf(YType.enumeration, "cir-shape-type")

                                            self.pir_shape_type = YLeaf(YType.enumeration, "pir-shape-type")

                                            self.cir_shape = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape()
                                            self.cir_shape.parent = self
                                            self._children_name_map["cir_shape"] = "cir-shape"
                                            self._children_yang_names.add("cir-shape")

                                            self.pir_shape = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape()
                                            self.pir_shape.parent = self
                                            self._children_name_map["pir_shape"] = "pir-shape"
                                            self._children_yang_names.add("pir-shape")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("cir_shape_type",
                                                            "pir_shape_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape, self).__setattr__(name, value)


                                        class CirShape(Entity):
                                            """
                                            CIR shaper params
                                            
                                            .. attribute:: cbs
                                            
                                            	CBS in bytes
                                            	**type**\:   :py:class:`Cbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs>`
                                            
                                            .. attribute:: chunk_id
                                            
                                            	Shape Chunk ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: cir
                                            
                                            	CIR in kbps
                                            	**type**\:   :py:class:`Cir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir>`
                                            
                                            .. attribute:: config_bandwidth
                                            
                                            	Config bandwidth
                                            	**type**\:   :py:class:`ConfigBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth>`
                                            
                                            .. attribute:: profile_id
                                            
                                            	Shape profile ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: scale_factor
                                            
                                            	Scale Factor
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape, self).__init__()

                                                self.yang_name = "cir-shape"
                                                self.yang_parent_name = "shape"

                                                self.chunk_id = YLeaf(YType.uint32, "chunk-id")

                                                self.profile_id = YLeaf(YType.uint16, "profile-id")

                                                self.scale_factor = YLeaf(YType.uint16, "scale-factor")

                                                self.cbs = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs()
                                                self.cbs.parent = self
                                                self._children_name_map["cbs"] = "cbs"
                                                self._children_yang_names.add("cbs")

                                                self.cir = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir()
                                                self.cir.parent = self
                                                self._children_name_map["cir"] = "cir"
                                                self._children_yang_names.add("cir")

                                                self.config_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth()
                                                self.config_bandwidth.parent = self
                                                self._children_name_map["config_bandwidth"] = "config-bandwidth"
                                                self._children_yang_names.add("config-bandwidth")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("chunk_id",
                                                                "profile_id",
                                                                "scale_factor") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape, self).__setattr__(name, value)


                                            class Cir(Entity):
                                                """
                                                CIR in kbps
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir, self).__init__()

                                                    self.yang_name = "cir"
                                                    self.yang_parent_name = "cir-shape"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "cir" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class ConfigBandwidth(Entity):
                                                """
                                                Config bandwidth
                                                
                                                .. attribute:: minimum_rate
                                                
                                                	Minimum bandwidth rate
                                                	**type**\:   :py:class:`MinimumRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate>`
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth, self).__init__()

                                                    self.yang_name = "config-bandwidth"
                                                    self.yang_parent_name = "cir-shape"

                                                    self.minimum_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate()
                                                    self.minimum_rate.parent = self
                                                    self._children_name_map["minimum_rate"] = "minimum-rate"
                                                    self._children_yang_names.add("minimum-rate")


                                                class MinimumRate(Entity):
                                                    """
                                                    Minimum bandwidth rate
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate, self).__init__()

                                                        self.yang_name = "minimum-rate"
                                                        self.yang_parent_name = "config-bandwidth"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "minimum-rate" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (self.minimum_rate is not None and self.minimum_rate.has_data())

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.minimum_rate is not None and self.minimum_rate.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "config-bandwidth" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "minimum-rate"):
                                                        if (self.minimum_rate is None):
                                                            self.minimum_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate()
                                                            self.minimum_rate.parent = self
                                                            self._children_name_map["minimum_rate"] = "minimum-rate"
                                                        return self.minimum_rate

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "minimum-rate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass


                                            class Cbs(Entity):
                                                """
                                                CBS in bytes
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs, self).__init__()

                                                    self.yang_name = "cbs"
                                                    self.yang_parent_name = "cir-shape"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "cbs" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.chunk_id.is_set or
                                                    self.profile_id.is_set or
                                                    self.scale_factor.is_set or
                                                    (self.cbs is not None and self.cbs.has_data()) or
                                                    (self.cir is not None and self.cir.has_data()) or
                                                    (self.config_bandwidth is not None and self.config_bandwidth.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.chunk_id.yfilter != YFilter.not_set or
                                                    self.profile_id.yfilter != YFilter.not_set or
                                                    self.scale_factor.yfilter != YFilter.not_set or
                                                    (self.cbs is not None and self.cbs.has_operation()) or
                                                    (self.cir is not None and self.cir.has_operation()) or
                                                    (self.config_bandwidth is not None and self.config_bandwidth.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cir-shape" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.chunk_id.is_set or self.chunk_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.chunk_id.get_name_leafdata())
                                                if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_id.get_name_leafdata())
                                                if (self.scale_factor.is_set or self.scale_factor.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.scale_factor.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "cbs"):
                                                    if (self.cbs is None):
                                                        self.cbs = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs()
                                                        self.cbs.parent = self
                                                        self._children_name_map["cbs"] = "cbs"
                                                    return self.cbs

                                                if (child_yang_name == "cir"):
                                                    if (self.cir is None):
                                                        self.cir = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir()
                                                        self.cir.parent = self
                                                        self._children_name_map["cir"] = "cir"
                                                    return self.cir

                                                if (child_yang_name == "config-bandwidth"):
                                                    if (self.config_bandwidth is None):
                                                        self.config_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth()
                                                        self.config_bandwidth.parent = self
                                                        self._children_name_map["config_bandwidth"] = "config-bandwidth"
                                                    return self.config_bandwidth

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "cbs" or name == "cir" or name == "config-bandwidth" or name == "chunk-id" or name == "profile-id" or name == "scale-factor"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "chunk-id"):
                                                    self.chunk_id = value
                                                    self.chunk_id.value_namespace = name_space
                                                    self.chunk_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-id"):
                                                    self.profile_id = value
                                                    self.profile_id.value_namespace = name_space
                                                    self.profile_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "scale-factor"):
                                                    self.scale_factor = value
                                                    self.scale_factor.value_namespace = name_space
                                                    self.scale_factor.value_namespace_prefix = name_space_prefix


                                        class PirShape(Entity):
                                            """
                                            PIR shaper params
                                            
                                            .. attribute:: chunk_id
                                            
                                            	Shape Chunk ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: pbs
                                            
                                            	PBS in bytes
                                            	**type**\:   :py:class:`Pbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs>`
                                            
                                            .. attribute:: pir
                                            
                                            	PIR in kbps
                                            	**type**\:   :py:class:`Pir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir>`
                                            
                                            .. attribute:: profile_id
                                            
                                            	Shape profile ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: scale_factor
                                            
                                            	Scale Factor
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape, self).__init__()

                                                self.yang_name = "pir-shape"
                                                self.yang_parent_name = "shape"

                                                self.chunk_id = YLeaf(YType.uint32, "chunk-id")

                                                self.profile_id = YLeaf(YType.uint16, "profile-id")

                                                self.scale_factor = YLeaf(YType.uint16, "scale-factor")

                                                self.pbs = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs()
                                                self.pbs.parent = self
                                                self._children_name_map["pbs"] = "pbs"
                                                self._children_yang_names.add("pbs")

                                                self.pir = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir()
                                                self.pir.parent = self
                                                self._children_name_map["pir"] = "pir"
                                                self._children_yang_names.add("pir")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("chunk_id",
                                                                "profile_id",
                                                                "scale_factor") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape, self).__setattr__(name, value)


                                            class Pir(Entity):
                                                """
                                                PIR in kbps
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir, self).__init__()

                                                    self.yang_name = "pir"
                                                    self.yang_parent_name = "pir-shape"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "pir" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class Pbs(Entity):
                                                """
                                                PBS in bytes
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs, self).__init__()

                                                    self.yang_name = "pbs"
                                                    self.yang_parent_name = "pir-shape"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "pbs" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.chunk_id.is_set or
                                                    self.profile_id.is_set or
                                                    self.scale_factor.is_set or
                                                    (self.pbs is not None and self.pbs.has_data()) or
                                                    (self.pir is not None and self.pir.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.chunk_id.yfilter != YFilter.not_set or
                                                    self.profile_id.yfilter != YFilter.not_set or
                                                    self.scale_factor.yfilter != YFilter.not_set or
                                                    (self.pbs is not None and self.pbs.has_operation()) or
                                                    (self.pir is not None and self.pir.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "pir-shape" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.chunk_id.is_set or self.chunk_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.chunk_id.get_name_leafdata())
                                                if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.profile_id.get_name_leafdata())
                                                if (self.scale_factor.is_set or self.scale_factor.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.scale_factor.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "pbs"):
                                                    if (self.pbs is None):
                                                        self.pbs = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs()
                                                        self.pbs.parent = self
                                                        self._children_name_map["pbs"] = "pbs"
                                                    return self.pbs

                                                if (child_yang_name == "pir"):
                                                    if (self.pir is None):
                                                        self.pir = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir()
                                                        self.pir.parent = self
                                                        self._children_name_map["pir"] = "pir"
                                                    return self.pir

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "pbs" or name == "pir" or name == "chunk-id" or name == "profile-id" or name == "scale-factor"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "chunk-id"):
                                                    self.chunk_id = value
                                                    self.chunk_id.value_namespace = name_space
                                                    self.chunk_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "profile-id"):
                                                    self.profile_id = value
                                                    self.profile_id.value_namespace = name_space
                                                    self.profile_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "scale-factor"):
                                                    self.scale_factor = value
                                                    self.scale_factor.value_namespace = name_space
                                                    self.scale_factor.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.cir_shape_type.is_set or
                                                self.pir_shape_type.is_set or
                                                (self.cir_shape is not None and self.cir_shape.has_data()) or
                                                (self.pir_shape is not None and self.pir_shape.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.cir_shape_type.yfilter != YFilter.not_set or
                                                self.pir_shape_type.yfilter != YFilter.not_set or
                                                (self.cir_shape is not None and self.cir_shape.has_operation()) or
                                                (self.pir_shape is not None and self.pir_shape.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "shape" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.cir_shape_type.is_set or self.cir_shape_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cir_shape_type.get_name_leafdata())
                                            if (self.pir_shape_type.is_set or self.pir_shape_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pir_shape_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cir-shape"):
                                                if (self.cir_shape is None):
                                                    self.cir_shape = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape()
                                                    self.cir_shape.parent = self
                                                    self._children_name_map["cir_shape"] = "cir-shape"
                                                return self.cir_shape

                                            if (child_yang_name == "pir-shape"):
                                                if (self.pir_shape is None):
                                                    self.pir_shape = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape()
                                                    self.pir_shape.parent = self
                                                    self._children_name_map["pir_shape"] = "pir-shape"
                                                return self.pir_shape

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cir-shape" or name == "pir-shape" or name == "cir-shape-type" or name == "pir-shape-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "cir-shape-type"):
                                                self.cir_shape_type = value
                                                self.cir_shape_type.value_namespace = name_space
                                                self.cir_shape_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pir-shape-type"):
                                                self.pir_shape_type = value
                                                self.pir_shape_type.value_namespace = name_space
                                                self.pir_shape_type.value_namespace_prefix = name_space_prefix


                                    class Police(Entity):
                                        """
                                        Police parameters
                                        
                                        .. attribute:: cbs
                                        
                                        	CBS
                                        	**type**\:   :py:class:`Cbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs>`
                                        
                                        .. attribute:: cir
                                        
                                        	CIR
                                        	**type**\:   :py:class:`Cir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir>`
                                        
                                        .. attribute:: pbs
                                        
                                        	PBS
                                        	**type**\:   :py:class:`Pbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs>`
                                        
                                        .. attribute:: pir
                                        
                                        	PIR
                                        	**type**\:   :py:class:`Pir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir>`
                                        
                                        .. attribute:: police_config_parameters
                                        
                                        	Police config parameters
                                        	**type**\:   :py:class:`PoliceConfigParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters>`
                                        
                                        .. attribute:: policer_type
                                        
                                        	Policer type
                                        	**type**\:   :py:class:`TbAlgorithm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.TbAlgorithm>`
                                        
                                        .. attribute:: profile_id
                                        
                                        	Police profile ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police, self).__init__()

                                            self.yang_name = "police"
                                            self.yang_parent_name = "qos-show-ea-st-v2"

                                            self.policer_type = YLeaf(YType.enumeration, "policer-type")

                                            self.profile_id = YLeaf(YType.uint32, "profile-id")

                                            self.cbs = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs()
                                            self.cbs.parent = self
                                            self._children_name_map["cbs"] = "cbs"
                                            self._children_yang_names.add("cbs")

                                            self.cir = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir()
                                            self.cir.parent = self
                                            self._children_name_map["cir"] = "cir"
                                            self._children_yang_names.add("cir")

                                            self.pbs = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs()
                                            self.pbs.parent = self
                                            self._children_name_map["pbs"] = "pbs"
                                            self._children_yang_names.add("pbs")

                                            self.pir = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir()
                                            self.pir.parent = self
                                            self._children_name_map["pir"] = "pir"
                                            self._children_yang_names.add("pir")

                                            self.police_config_parameters = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters()
                                            self.police_config_parameters.parent = self
                                            self._children_name_map["police_config_parameters"] = "police-config-parameters"
                                            self._children_yang_names.add("police-config-parameters")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("policer_type",
                                                            "profile_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police, self).__setattr__(name, value)


                                        class Cir(Entity):
                                            """
                                            CIR
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir, self).__init__()

                                                self.yang_name = "cir"
                                                self.yang_parent_name = "police"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cir" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class Cbs(Entity):
                                            """
                                            CBS
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs, self).__init__()

                                                self.yang_name = "cbs"
                                                self.yang_parent_name = "police"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "cbs" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class Pir(Entity):
                                            """
                                            PIR
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir, self).__init__()

                                                self.yang_name = "pir"
                                                self.yang_parent_name = "police"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "pir" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class Pbs(Entity):
                                            """
                                            PBS
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs, self).__init__()

                                                self.yang_name = "pbs"
                                                self.yang_parent_name = "police"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "pbs" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class PoliceConfigParameters(Entity):
                                            """
                                            Police config parameters
                                            
                                            .. attribute:: average_rate
                                            
                                            	Average rate
                                            	**type**\:   :py:class:`AverageRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate>`
                                            
                                            .. attribute:: conform_burst
                                            
                                            	Conform burst
                                            	**type**\:   :py:class:`ConformBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst>`
                                            
                                            .. attribute:: exceed_burst
                                            
                                            	Exceed burst
                                            	**type**\:   :py:class:`ExceedBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst>`
                                            
                                            .. attribute:: peak_rate
                                            
                                            	Peak rate
                                            	**type**\:   :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters, self).__init__()

                                                self.yang_name = "police-config-parameters"
                                                self.yang_parent_name = "police"

                                                self.average_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate()
                                                self.average_rate.parent = self
                                                self._children_name_map["average_rate"] = "average-rate"
                                                self._children_yang_names.add("average-rate")

                                                self.conform_burst = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst()
                                                self.conform_burst.parent = self
                                                self._children_name_map["conform_burst"] = "conform-burst"
                                                self._children_yang_names.add("conform-burst")

                                                self.exceed_burst = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst()
                                                self.exceed_burst.parent = self
                                                self._children_name_map["exceed_burst"] = "exceed-burst"
                                                self._children_yang_names.add("exceed-burst")

                                                self.peak_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate()
                                                self.peak_rate.parent = self
                                                self._children_name_map["peak_rate"] = "peak-rate"
                                                self._children_yang_names.add("peak-rate")


                                            class AverageRate(Entity):
                                                """
                                                Average rate
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate, self).__init__()

                                                    self.yang_name = "average-rate"
                                                    self.yang_parent_name = "police-config-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "average-rate" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class PeakRate(Entity):
                                                """
                                                Peak rate
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate, self).__init__()

                                                    self.yang_name = "peak-rate"
                                                    self.yang_parent_name = "police-config-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "peak-rate" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class ConformBurst(Entity):
                                                """
                                                Conform burst
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst, self).__init__()

                                                    self.yang_name = "conform-burst"
                                                    self.yang_parent_name = "police-config-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "conform-burst" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class ExceedBurst(Entity):
                                                """
                                                Exceed burst
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst, self).__init__()

                                                    self.yang_name = "exceed-burst"
                                                    self.yang_parent_name = "police-config-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "exceed-burst" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    (self.average_rate is not None and self.average_rate.has_data()) or
                                                    (self.conform_burst is not None and self.conform_burst.has_data()) or
                                                    (self.exceed_burst is not None and self.exceed_burst.has_data()) or
                                                    (self.peak_rate is not None and self.peak_rate.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    (self.average_rate is not None and self.average_rate.has_operation()) or
                                                    (self.conform_burst is not None and self.conform_burst.has_operation()) or
                                                    (self.exceed_burst is not None and self.exceed_burst.has_operation()) or
                                                    (self.peak_rate is not None and self.peak_rate.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-config-parameters" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "average-rate"):
                                                    if (self.average_rate is None):
                                                        self.average_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate()
                                                        self.average_rate.parent = self
                                                        self._children_name_map["average_rate"] = "average-rate"
                                                    return self.average_rate

                                                if (child_yang_name == "conform-burst"):
                                                    if (self.conform_burst is None):
                                                        self.conform_burst = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst()
                                                        self.conform_burst.parent = self
                                                        self._children_name_map["conform_burst"] = "conform-burst"
                                                    return self.conform_burst

                                                if (child_yang_name == "exceed-burst"):
                                                    if (self.exceed_burst is None):
                                                        self.exceed_burst = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst()
                                                        self.exceed_burst.parent = self
                                                        self._children_name_map["exceed_burst"] = "exceed-burst"
                                                    return self.exceed_burst

                                                if (child_yang_name == "peak-rate"):
                                                    if (self.peak_rate is None):
                                                        self.peak_rate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate()
                                                        self.peak_rate.parent = self
                                                        self._children_name_map["peak_rate"] = "peak-rate"
                                                    return self.peak_rate

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "average-rate" or name == "conform-burst" or name == "exceed-burst" or name == "peak-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass

                                        def has_data(self):
                                            return (
                                                self.policer_type.is_set or
                                                self.profile_id.is_set or
                                                (self.cbs is not None and self.cbs.has_data()) or
                                                (self.cir is not None and self.cir.has_data()) or
                                                (self.pbs is not None and self.pbs.has_data()) or
                                                (self.pir is not None and self.pir.has_data()) or
                                                (self.police_config_parameters is not None and self.police_config_parameters.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.policer_type.yfilter != YFilter.not_set or
                                                self.profile_id.yfilter != YFilter.not_set or
                                                (self.cbs is not None and self.cbs.has_operation()) or
                                                (self.cir is not None and self.cir.has_operation()) or
                                                (self.pbs is not None and self.pbs.has_operation()) or
                                                (self.pir is not None and self.pir.has_operation()) or
                                                (self.police_config_parameters is not None and self.police_config_parameters.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "police" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.policer_type.is_set or self.policer_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policer_type.get_name_leafdata())
                                            if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.profile_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "cbs"):
                                                if (self.cbs is None):
                                                    self.cbs = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs()
                                                    self.cbs.parent = self
                                                    self._children_name_map["cbs"] = "cbs"
                                                return self.cbs

                                            if (child_yang_name == "cir"):
                                                if (self.cir is None):
                                                    self.cir = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir()
                                                    self.cir.parent = self
                                                    self._children_name_map["cir"] = "cir"
                                                return self.cir

                                            if (child_yang_name == "pbs"):
                                                if (self.pbs is None):
                                                    self.pbs = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs()
                                                    self.pbs.parent = self
                                                    self._children_name_map["pbs"] = "pbs"
                                                return self.pbs

                                            if (child_yang_name == "pir"):
                                                if (self.pir is None):
                                                    self.pir = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir()
                                                    self.pir.parent = self
                                                    self._children_name_map["pir"] = "pir"
                                                return self.pir

                                            if (child_yang_name == "police-config-parameters"):
                                                if (self.police_config_parameters is None):
                                                    self.police_config_parameters = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters()
                                                    self.police_config_parameters.parent = self
                                                    self._children_name_map["police_config_parameters"] = "police-config-parameters"
                                                return self.police_config_parameters

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "cbs" or name == "cir" or name == "pbs" or name == "pir" or name == "police-config-parameters" or name == "policer-type" or name == "profile-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "policer-type"):
                                                self.policer_type = value
                                                self.policer_type.value_namespace = name_space
                                                self.policer_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "profile-id"):
                                                self.profile_id = value
                                                self.profile_id.value_namespace = name_space
                                                self.profile_id.value_namespace_prefix = name_space_prefix


                                    class Wfq(Entity):
                                        """
                                        WFQ parameters
                                        
                                        .. attribute:: bandwidth
                                        
                                        	CFG Bandwidth
                                        	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth>`
                                        
                                        .. attribute:: chunk_id
                                        
                                        	Chunk ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: committed_weight
                                        
                                        	Committed weight
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: excess_ratio
                                        
                                        	Parent Excess ratio
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: excess_weight
                                        
                                        	Excess weight
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: level
                                        
                                        	Level
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: parent_bandwidth
                                        
                                        	Parent bandwidth
                                        	**type**\:   :py:class:`ParentBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth>`
                                        
                                        .. attribute:: profile_id
                                        
                                        	WFQ profile
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wfq, self).__init__()

                                            self.yang_name = "wfq"
                                            self.yang_parent_name = "qos-show-ea-st-v2"

                                            self.chunk_id = YLeaf(YType.uint32, "chunk-id")

                                            self.committed_weight = YLeaf(YType.uint32, "committed-weight")

                                            self.excess_ratio = YLeaf(YType.uint16, "excess-ratio")

                                            self.excess_weight = YLeaf(YType.uint16, "excess-weight")

                                            self.level = YLeaf(YType.uint8, "level")

                                            self.profile_id = YLeaf(YType.uint32, "profile-id")

                                            self.bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                            self._children_yang_names.add("bandwidth")

                                            self.parent_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth()
                                            self.parent_bandwidth.parent = self
                                            self._children_name_map["parent_bandwidth"] = "parent-bandwidth"
                                            self._children_yang_names.add("parent-bandwidth")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("chunk_id",
                                                            "committed_weight",
                                                            "excess_ratio",
                                                            "excess_weight",
                                                            "level",
                                                            "profile_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wfq, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wfq, self).__setattr__(name, value)


                                        class ParentBandwidth(Entity):
                                            """
                                            Parent bandwidth
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth, self).__init__()

                                                self.yang_name = "parent-bandwidth"
                                                self.yang_parent_name = "wfq"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "parent-bandwidth" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix


                                        class Bandwidth(Entity):
                                            """
                                            CFG Bandwidth
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth, self).__init__()

                                                self.yang_name = "bandwidth"
                                                self.yang_parent_name = "wfq"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bandwidth" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.chunk_id.is_set or
                                                self.committed_weight.is_set or
                                                self.excess_ratio.is_set or
                                                self.excess_weight.is_set or
                                                self.level.is_set or
                                                self.profile_id.is_set or
                                                (self.bandwidth is not None and self.bandwidth.has_data()) or
                                                (self.parent_bandwidth is not None and self.parent_bandwidth.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.chunk_id.yfilter != YFilter.not_set or
                                                self.committed_weight.yfilter != YFilter.not_set or
                                                self.excess_ratio.yfilter != YFilter.not_set or
                                                self.excess_weight.yfilter != YFilter.not_set or
                                                self.level.yfilter != YFilter.not_set or
                                                self.profile_id.yfilter != YFilter.not_set or
                                                (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                                (self.parent_bandwidth is not None and self.parent_bandwidth.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wfq" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.chunk_id.is_set or self.chunk_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.chunk_id.get_name_leafdata())
                                            if (self.committed_weight.is_set or self.committed_weight.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.committed_weight.get_name_leafdata())
                                            if (self.excess_ratio.is_set or self.excess_ratio.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.excess_ratio.get_name_leafdata())
                                            if (self.excess_weight.is_set or self.excess_weight.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.excess_weight.get_name_leafdata())
                                            if (self.level.is_set or self.level.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.level.get_name_leafdata())
                                            if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.profile_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "bandwidth"):
                                                if (self.bandwidth is None):
                                                    self.bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth()
                                                    self.bandwidth.parent = self
                                                    self._children_name_map["bandwidth"] = "bandwidth"
                                                return self.bandwidth

                                            if (child_yang_name == "parent-bandwidth"):
                                                if (self.parent_bandwidth is None):
                                                    self.parent_bandwidth = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth()
                                                    self.parent_bandwidth.parent = self
                                                    self._children_name_map["parent_bandwidth"] = "parent-bandwidth"
                                                return self.parent_bandwidth

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bandwidth" or name == "parent-bandwidth" or name == "chunk-id" or name == "committed-weight" or name == "excess-ratio" or name == "excess-weight" or name == "level" or name == "profile-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "chunk-id"):
                                                self.chunk_id = value
                                                self.chunk_id.value_namespace = name_space
                                                self.chunk_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "committed-weight"):
                                                self.committed_weight = value
                                                self.committed_weight.value_namespace = name_space
                                                self.committed_weight.value_namespace_prefix = name_space_prefix
                                            if(value_path == "excess-ratio"):
                                                self.excess_ratio = value
                                                self.excess_ratio.value_namespace = name_space
                                                self.excess_ratio.value_namespace_prefix = name_space_prefix
                                            if(value_path == "excess-weight"):
                                                self.excess_weight = value
                                                self.excess_weight.value_namespace = name_space
                                                self.excess_weight.value_namespace_prefix = name_space_prefix
                                            if(value_path == "level"):
                                                self.level = value
                                                self.level.value_namespace = name_space
                                                self.level.value_namespace_prefix = name_space_prefix
                                            if(value_path == "profile-id"):
                                                self.profile_id = value
                                                self.profile_id.value_namespace = name_space
                                                self.profile_id.value_namespace_prefix = name_space_prefix


                                    class Wred(Entity):
                                        """
                                        WRED parameters
                                        
                                        .. attribute:: curve
                                        
                                        	Curve details
                                        	**type**\: list of    :py:class:`Curve <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve>`
                                        
                                        .. attribute:: curve_xr
                                        
                                        	Number of curves
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: type
                                        
                                        	WRED type
                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Wred>`
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred, self).__init__()

                                            self.yang_name = "wred"
                                            self.yang_parent_name = "qos-show-ea-st-v2"

                                            self.curve_xr = YLeaf(YType.uint16, "curve-xr")

                                            self.type = YLeaf(YType.enumeration, "type")

                                            self.curve = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("curve_xr",
                                                            "type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred, self).__setattr__(name, value)


                                        class Curve(Entity):
                                            """
                                            Curve details
                                            
                                            .. attribute:: absolute_index
                                            
                                            	Absolute Index
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: curve_id
                                            
                                            	Curve ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: exp_match
                                            
                                            	WRED exp match if EXP start value equals to end value Format\: <start\-value> , else range Format\: <start\-value> <end\-value>
                                            	**type**\:  str
                                            
                                            .. attribute:: match
                                            
                                            	WRED match if precedence start value equals to end value Format\: <start\-value> , else range Format\: <start\-value> <end\-value>
                                            	**type**\:  str
                                            
                                            .. attribute:: max_threshold
                                            
                                            	Maximum threshold
                                            	**type**\:   :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold>`
                                            
                                            .. attribute:: max_threshold_user_config
                                            
                                            	Maximum threshold WRED context
                                            	**type**\:   :py:class:`MaxThresholdUserConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig>`
                                            
                                            .. attribute:: min_threshold
                                            
                                            	Minimum threshold
                                            	**type**\:   :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold>`
                                            
                                            .. attribute:: min_threshold_user_config
                                            
                                            	Minimum threshold WRED context
                                            	**type**\:   :py:class:`MinThresholdUserConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig>`
                                            
                                            .. attribute:: template_id
                                            
                                            	Template ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve, self).__init__()

                                                self.yang_name = "curve"
                                                self.yang_parent_name = "wred"

                                                self.absolute_index = YLeaf(YType.uint16, "absolute-index")

                                                self.curve_id = YLeaf(YType.uint16, "curve-id")

                                                self.exp_match = YLeaf(YType.str, "exp-match")

                                                self.match = YLeaf(YType.str, "match")

                                                self.template_id = YLeaf(YType.uint16, "template-id")

                                                self.max_threshold = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold()
                                                self.max_threshold.parent = self
                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                self._children_yang_names.add("max-threshold")

                                                self.max_threshold_user_config = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig()
                                                self.max_threshold_user_config.parent = self
                                                self._children_name_map["max_threshold_user_config"] = "max-threshold-user-config"
                                                self._children_yang_names.add("max-threshold-user-config")

                                                self.min_threshold = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold()
                                                self.min_threshold.parent = self
                                                self._children_name_map["min_threshold"] = "min-threshold"
                                                self._children_yang_names.add("min-threshold")

                                                self.min_threshold_user_config = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig()
                                                self.min_threshold_user_config.parent = self
                                                self._children_name_map["min_threshold_user_config"] = "min-threshold-user-config"
                                                self._children_yang_names.add("min-threshold-user-config")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("absolute_index",
                                                                "curve_id",
                                                                "exp_match",
                                                                "match",
                                                                "template_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve, self).__setattr__(name, value)


                                            class MinThreshold(Entity):
                                                """
                                                Minimum threshold
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold, self).__init__()

                                                    self.yang_name = "min-threshold"
                                                    self.yang_parent_name = "curve"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "min-threshold" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class MinThresholdUserConfig(Entity):
                                                """
                                                Minimum threshold WRED context
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig, self).__init__()

                                                    self.yang_name = "min-threshold-user-config"
                                                    self.yang_parent_name = "curve"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "min-threshold-user-config" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class MaxThreshold(Entity):
                                                """
                                                Maximum threshold
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold, self).__init__()

                                                    self.yang_name = "max-threshold"
                                                    self.yang_parent_name = "curve"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "max-threshold" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class MaxThresholdUserConfig(Entity):
                                                """
                                                Maximum threshold WRED context
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig, self).__init__()

                                                    self.yang_name = "max-threshold-user-config"
                                                    self.yang_parent_name = "curve"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "max-threshold-user-config" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.absolute_index.is_set or
                                                    self.curve_id.is_set or
                                                    self.exp_match.is_set or
                                                    self.match.is_set or
                                                    self.template_id.is_set or
                                                    (self.max_threshold is not None and self.max_threshold.has_data()) or
                                                    (self.max_threshold_user_config is not None and self.max_threshold_user_config.has_data()) or
                                                    (self.min_threshold is not None and self.min_threshold.has_data()) or
                                                    (self.min_threshold_user_config is not None and self.min_threshold_user_config.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.absolute_index.yfilter != YFilter.not_set or
                                                    self.curve_id.yfilter != YFilter.not_set or
                                                    self.exp_match.yfilter != YFilter.not_set or
                                                    self.match.yfilter != YFilter.not_set or
                                                    self.template_id.yfilter != YFilter.not_set or
                                                    (self.max_threshold is not None and self.max_threshold.has_operation()) or
                                                    (self.max_threshold_user_config is not None and self.max_threshold_user_config.has_operation()) or
                                                    (self.min_threshold is not None and self.min_threshold.has_operation()) or
                                                    (self.min_threshold_user_config is not None and self.min_threshold_user_config.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "curve" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.absolute_index.is_set or self.absolute_index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.absolute_index.get_name_leafdata())
                                                if (self.curve_id.is_set or self.curve_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.curve_id.get_name_leafdata())
                                                if (self.exp_match.is_set or self.exp_match.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.exp_match.get_name_leafdata())
                                                if (self.match.is_set or self.match.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.match.get_name_leafdata())
                                                if (self.template_id.is_set or self.template_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.template_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "max-threshold"):
                                                    if (self.max_threshold is None):
                                                        self.max_threshold = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold()
                                                        self.max_threshold.parent = self
                                                        self._children_name_map["max_threshold"] = "max-threshold"
                                                    return self.max_threshold

                                                if (child_yang_name == "max-threshold-user-config"):
                                                    if (self.max_threshold_user_config is None):
                                                        self.max_threshold_user_config = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig()
                                                        self.max_threshold_user_config.parent = self
                                                        self._children_name_map["max_threshold_user_config"] = "max-threshold-user-config"
                                                    return self.max_threshold_user_config

                                                if (child_yang_name == "min-threshold"):
                                                    if (self.min_threshold is None):
                                                        self.min_threshold = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold()
                                                        self.min_threshold.parent = self
                                                        self._children_name_map["min_threshold"] = "min-threshold"
                                                    return self.min_threshold

                                                if (child_yang_name == "min-threshold-user-config"):
                                                    if (self.min_threshold_user_config is None):
                                                        self.min_threshold_user_config = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig()
                                                        self.min_threshold_user_config.parent = self
                                                        self._children_name_map["min_threshold_user_config"] = "min-threshold-user-config"
                                                    return self.min_threshold_user_config

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "max-threshold" or name == "max-threshold-user-config" or name == "min-threshold" or name == "min-threshold-user-config" or name == "absolute-index" or name == "curve-id" or name == "exp-match" or name == "match" or name == "template-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "absolute-index"):
                                                    self.absolute_index = value
                                                    self.absolute_index.value_namespace = name_space
                                                    self.absolute_index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "curve-id"):
                                                    self.curve_id = value
                                                    self.curve_id.value_namespace = name_space
                                                    self.curve_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "exp-match"):
                                                    self.exp_match = value
                                                    self.exp_match.value_namespace = name_space
                                                    self.exp_match.value_namespace_prefix = name_space_prefix
                                                if(value_path == "match"):
                                                    self.match = value
                                                    self.match.value_namespace = name_space
                                                    self.match.value_namespace_prefix = name_space_prefix
                                                if(value_path == "template-id"):
                                                    self.template_id = value
                                                    self.template_id.value_namespace = name_space
                                                    self.template_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.curve:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.curve_xr.is_set or
                                                self.type.is_set)

                                        def has_operation(self):
                                            for c in self.curve:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.curve_xr.yfilter != YFilter.not_set or
                                                self.type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "wred" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.curve_xr.is_set or self.curve_xr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.curve_xr.get_name_leafdata())
                                            if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "curve"):
                                                for c in self.curve:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.curve.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "curve" or name == "curve-xr" or name == "type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "curve-xr"):
                                                self.curve_xr = value
                                                self.curve_xr.value_namespace = name_space
                                                self.curve_xr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "type"):
                                                self.type = value
                                                self.type.value_namespace = name_space
                                                self.type.value_namespace_prefix = name_space_prefix


                                    class Mark(Entity):
                                        """
                                        Mark parameters
                                        
                                        .. attribute:: child_mark
                                        
                                        	Child mark only
                                        	**type**\:   :py:class:`ChildMark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark>`
                                        
                                        .. attribute:: parent_mark
                                        
                                        	Parent mark only
                                        	**type**\:   :py:class:`ParentMark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark>`
                                        
                                        .. attribute:: parent_police_conform
                                        
                                        	Parent police conform mark
                                        	**type**\:   :py:class:`ParentPoliceConform <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform>`
                                        
                                        .. attribute:: parent_police_exceed
                                        
                                        	Parent police exceed mark
                                        	**type**\:   :py:class:`ParentPoliceExceed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed>`
                                        
                                        .. attribute:: parent_police_violate
                                        
                                        	Parent police violate mark
                                        	**type**\:   :py:class:`ParentPoliceViolate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate>`
                                        
                                        .. attribute:: police_conform
                                        
                                        	Child police conform mark
                                        	**type**\:   :py:class:`PoliceConform <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform>`
                                        
                                        .. attribute:: police_exceed
                                        
                                        	Child police exceed mark
                                        	**type**\:   :py:class:`PoliceExceed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed>`
                                        
                                        .. attribute:: police_violate
                                        
                                        	Child police violate mark
                                        	**type**\:   :py:class:`PoliceViolate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate>`
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark, self).__init__()

                                            self.yang_name = "mark"
                                            self.yang_parent_name = "qos-show-ea-st-v2"

                                            self.child_mark = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark()
                                            self.child_mark.parent = self
                                            self._children_name_map["child_mark"] = "child-mark"
                                            self._children_yang_names.add("child-mark")

                                            self.parent_mark = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark()
                                            self.parent_mark.parent = self
                                            self._children_name_map["parent_mark"] = "parent-mark"
                                            self._children_yang_names.add("parent-mark")

                                            self.parent_police_conform = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform()
                                            self.parent_police_conform.parent = self
                                            self._children_name_map["parent_police_conform"] = "parent-police-conform"
                                            self._children_yang_names.add("parent-police-conform")

                                            self.parent_police_exceed = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed()
                                            self.parent_police_exceed.parent = self
                                            self._children_name_map["parent_police_exceed"] = "parent-police-exceed"
                                            self._children_yang_names.add("parent-police-exceed")

                                            self.parent_police_violate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate()
                                            self.parent_police_violate.parent = self
                                            self._children_name_map["parent_police_violate"] = "parent-police-violate"
                                            self._children_yang_names.add("parent-police-violate")

                                            self.police_conform = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform()
                                            self.police_conform.parent = self
                                            self._children_name_map["police_conform"] = "police-conform"
                                            self._children_yang_names.add("police-conform")

                                            self.police_exceed = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed()
                                            self.police_exceed.parent = self
                                            self._children_name_map["police_exceed"] = "police-exceed"
                                            self._children_yang_names.add("police-exceed")

                                            self.police_violate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate()
                                            self.police_violate.parent = self
                                            self._children_name_map["police_violate"] = "police-violate"
                                            self._children_yang_names.add("police-violate")


                                        class ChildMark(Entity):
                                            """
                                            Child mark only
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark, self).__init__()

                                                self.yang_name = "child-mark"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "child-mark"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "child-mark" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class PoliceConform(Entity):
                                            """
                                            Child police conform mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform, self).__init__()

                                                self.yang_name = "police-conform"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "police-conform"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-conform" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class PoliceExceed(Entity):
                                            """
                                            Child police exceed mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed, self).__init__()

                                                self.yang_name = "police-exceed"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "police-exceed"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-exceed" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class PoliceViolate(Entity):
                                            """
                                            Child police violate mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate, self).__init__()

                                                self.yang_name = "police-violate"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "police-violate"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "police-violate" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class ParentMark(Entity):
                                            """
                                            Parent mark only
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark, self).__init__()

                                                self.yang_name = "parent-mark"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "parent-mark"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "parent-mark" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class ParentPoliceConform(Entity):
                                            """
                                            Parent police conform mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform, self).__init__()

                                                self.yang_name = "parent-police-conform"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "parent-police-conform"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "parent-police-conform" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class ParentPoliceExceed(Entity):
                                            """
                                            Parent police exceed mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed, self).__init__()

                                                self.yang_name = "parent-police-exceed"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "parent-police-exceed"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "parent-police-exceed" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix


                                        class ParentPoliceViolate(Entity):
                                            """
                                            Parent police violate mark
                                            
                                            .. attribute:: action_type
                                            
                                            	Action type
                                            	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                            
                                            .. attribute:: mark_detail
                                            
                                            	Mark value
                                            	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate.MarkDetail>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate, self).__init__()

                                                self.yang_name = "parent-police-violate"
                                                self.yang_parent_name = "mark"

                                                self.action_type = YLeaf(YType.enumeration, "action-type")

                                                self.mark_detail = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("action_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate, self).__setattr__(name, value)


                                            class MarkDetail(Entity):
                                                """
                                                Mark value
                                                
                                                .. attribute:: action_opcode
                                                
                                                	Action opcode
                                                	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                
                                                .. attribute:: mark_value
                                                
                                                	Mark value
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate.MarkDetail, self).__init__()

                                                    self.yang_name = "mark-detail"
                                                    self.yang_parent_name = "parent-police-violate"

                                                    self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                    self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("action_opcode",
                                                                    "mark_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate.MarkDetail, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate.MarkDetail, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.action_opcode.is_set or
                                                        self.mark_value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.action_opcode.yfilter != YFilter.not_set or
                                                        self.mark_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark-detail" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                    if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "action-opcode" or name == "mark-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "action-opcode"):
                                                        self.action_opcode = value
                                                        self.action_opcode.value_namespace = name_space
                                                        self.action_opcode.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "mark-value"):
                                                        self.mark_value = value
                                                        self.mark_value.value_namespace = name_space
                                                        self.mark_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.mark_detail:
                                                    if (c.has_data()):
                                                        return True
                                                return self.action_type.is_set

                                            def has_operation(self):
                                                for c in self.mark_detail:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.action_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "parent-police-violate" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.action_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark-detail"):
                                                    for c in self.mark_detail:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate.MarkDetail()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.mark_detail.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark-detail" or name == "action-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "action-type"):
                                                    self.action_type = value
                                                    self.action_type.value_namespace = name_space
                                                    self.action_type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                (self.child_mark is not None and self.child_mark.has_data()) or
                                                (self.parent_mark is not None and self.parent_mark.has_data()) or
                                                (self.parent_police_conform is not None and self.parent_police_conform.has_data()) or
                                                (self.parent_police_exceed is not None and self.parent_police_exceed.has_data()) or
                                                (self.parent_police_violate is not None and self.parent_police_violate.has_data()) or
                                                (self.police_conform is not None and self.police_conform.has_data()) or
                                                (self.police_exceed is not None and self.police_exceed.has_data()) or
                                                (self.police_violate is not None and self.police_violate.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.child_mark is not None and self.child_mark.has_operation()) or
                                                (self.parent_mark is not None and self.parent_mark.has_operation()) or
                                                (self.parent_police_conform is not None and self.parent_police_conform.has_operation()) or
                                                (self.parent_police_exceed is not None and self.parent_police_exceed.has_operation()) or
                                                (self.parent_police_violate is not None and self.parent_police_violate.has_operation()) or
                                                (self.police_conform is not None and self.police_conform.has_operation()) or
                                                (self.police_exceed is not None and self.police_exceed.has_operation()) or
                                                (self.police_violate is not None and self.police_violate.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mark" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "child-mark"):
                                                if (self.child_mark is None):
                                                    self.child_mark = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark()
                                                    self.child_mark.parent = self
                                                    self._children_name_map["child_mark"] = "child-mark"
                                                return self.child_mark

                                            if (child_yang_name == "parent-mark"):
                                                if (self.parent_mark is None):
                                                    self.parent_mark = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark()
                                                    self.parent_mark.parent = self
                                                    self._children_name_map["parent_mark"] = "parent-mark"
                                                return self.parent_mark

                                            if (child_yang_name == "parent-police-conform"):
                                                if (self.parent_police_conform is None):
                                                    self.parent_police_conform = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform()
                                                    self.parent_police_conform.parent = self
                                                    self._children_name_map["parent_police_conform"] = "parent-police-conform"
                                                return self.parent_police_conform

                                            if (child_yang_name == "parent-police-exceed"):
                                                if (self.parent_police_exceed is None):
                                                    self.parent_police_exceed = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed()
                                                    self.parent_police_exceed.parent = self
                                                    self._children_name_map["parent_police_exceed"] = "parent-police-exceed"
                                                return self.parent_police_exceed

                                            if (child_yang_name == "parent-police-violate"):
                                                if (self.parent_police_violate is None):
                                                    self.parent_police_violate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate()
                                                    self.parent_police_violate.parent = self
                                                    self._children_name_map["parent_police_violate"] = "parent-police-violate"
                                                return self.parent_police_violate

                                            if (child_yang_name == "police-conform"):
                                                if (self.police_conform is None):
                                                    self.police_conform = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform()
                                                    self.police_conform.parent = self
                                                    self._children_name_map["police_conform"] = "police-conform"
                                                return self.police_conform

                                            if (child_yang_name == "police-exceed"):
                                                if (self.police_exceed is None):
                                                    self.police_exceed = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed()
                                                    self.police_exceed.parent = self
                                                    self._children_name_map["police_exceed"] = "police-exceed"
                                                return self.police_exceed

                                            if (child_yang_name == "police-violate"):
                                                if (self.police_violate is None):
                                                    self.police_violate = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate()
                                                    self.police_violate.parent = self
                                                    self._children_name_map["police_violate"] = "police-violate"
                                                return self.police_violate

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "child-mark" or name == "parent-mark" or name == "parent-police-conform" or name == "parent-police-exceed" or name == "parent-police-violate" or name == "police-conform" or name == "police-exceed" or name == "police-violate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        return (
                                            self.class_level.is_set or
                                            self.class_name.is_set or
                                            self.parent_class_name.is_set or
                                            self.parent_policy_name.is_set or
                                            self.policy_name.is_set or
                                            (self.mark is not None and self.mark.has_data()) or
                                            (self.police is not None and self.police.has_data()) or
                                            (self.queue is not None and self.queue.has_data()) or
                                            (self.queue_limit_parameters is not None and self.queue_limit_parameters.has_data()) or
                                            (self.shape is not None and self.shape.has_data()) or
                                            (self.wfq is not None and self.wfq.has_data()) or
                                            (self.wred is not None and self.wred.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.class_level.yfilter != YFilter.not_set or
                                            self.class_name.yfilter != YFilter.not_set or
                                            self.parent_class_name.yfilter != YFilter.not_set or
                                            self.parent_policy_name.yfilter != YFilter.not_set or
                                            self.policy_name.yfilter != YFilter.not_set or
                                            (self.mark is not None and self.mark.has_operation()) or
                                            (self.police is not None and self.police.has_operation()) or
                                            (self.queue is not None and self.queue.has_operation()) or
                                            (self.queue_limit_parameters is not None and self.queue_limit_parameters.has_operation()) or
                                            (self.shape is not None and self.shape.has_operation()) or
                                            (self.wfq is not None and self.wfq.has_operation()) or
                                            (self.wred is not None and self.wred.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "qos-show-ea-st-v2" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.class_level.is_set or self.class_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.class_level.get_name_leafdata())
                                        if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.class_name.get_name_leafdata())
                                        if (self.parent_class_name.is_set or self.parent_class_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_class_name.get_name_leafdata())
                                        if (self.parent_policy_name.is_set or self.parent_policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.parent_policy_name.get_name_leafdata())
                                        if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "mark"):
                                            if (self.mark is None):
                                                self.mark = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Mark()
                                                self.mark.parent = self
                                                self._children_name_map["mark"] = "mark"
                                            return self.mark

                                        if (child_yang_name == "police"):
                                            if (self.police is None):
                                                self.police = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Police()
                                                self.police.parent = self
                                                self._children_name_map["police"] = "police"
                                            return self.police

                                        if (child_yang_name == "queue"):
                                            if (self.queue is None):
                                                self.queue = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Queue()
                                                self.queue.parent = self
                                                self._children_name_map["queue"] = "queue"
                                            return self.queue

                                        if (child_yang_name == "queue-limit-parameters"):
                                            if (self.queue_limit_parameters is None):
                                                self.queue_limit_parameters = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters()
                                                self.queue_limit_parameters.parent = self
                                                self._children_name_map["queue_limit_parameters"] = "queue-limit-parameters"
                                            return self.queue_limit_parameters

                                        if (child_yang_name == "shape"):
                                            if (self.shape is None):
                                                self.shape = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Shape()
                                                self.shape.parent = self
                                                self._children_name_map["shape"] = "shape"
                                            return self.shape

                                        if (child_yang_name == "wfq"):
                                            if (self.wfq is None):
                                                self.wfq = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wfq()
                                                self.wfq.parent = self
                                                self._children_name_map["wfq"] = "wfq"
                                            return self.wfq

                                        if (child_yang_name == "wred"):
                                            if (self.wred is None):
                                                self.wred = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2.Wred()
                                                self.wred.parent = self
                                                self._children_name_map["wred"] = "wred"
                                            return self.wred

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "mark" or name == "police" or name == "queue" or name == "queue-limit-parameters" or name == "shape" or name == "wfq" or name == "wred" or name == "class-level" or name == "class-name" or name == "parent-class-name" or name == "parent-policy-name" or name == "policy-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "class-level"):
                                            self.class_level = value
                                            self.class_level.value_namespace = name_space
                                            self.class_level.value_namespace_prefix = name_space_prefix
                                        if(value_path == "class-name"):
                                            self.class_name = value
                                            self.class_name.value_namespace = name_space
                                            self.class_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-class-name"):
                                            self.parent_class_name = value
                                            self.parent_class_name.value_namespace = name_space
                                            self.parent_class_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "parent-policy-name"):
                                            self.parent_policy_name = value
                                            self.parent_policy_name.value_namespace = name_space
                                            self.parent_policy_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-name"):
                                            self.policy_name = value
                                            self.policy_name.value_namespace = name_space
                                            self.policy_name.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.qos_show_ea_st_v2:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.qos_show_ea_st_v2:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "policy-typhoon" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "qos-show-ea-st-v2"):
                                        for c in self.qos_show_ea_st_v2:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon.QosShowEaStV2()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.qos_show_ea_st_v2.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "qos-show-ea-st-v2"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.header is not None and self.header.has_data()) or
                                    (self.policy is not None and self.policy.has_data()) or
                                    (self.policy_typhoon is not None and self.policy_typhoon.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.header is not None and self.header.has_operation()) or
                                    (self.policy is not None and self.policy.has_operation()) or
                                    (self.policy_typhoon is not None and self.policy_typhoon.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "details" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "header"):
                                    if (self.header is None):
                                        self.header = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Header()
                                        self.header.parent = self
                                        self._children_name_map["header"] = "header"
                                    return self.header

                                if (child_yang_name == "policy"):
                                    if (self.policy is None):
                                        self.policy = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.Policy()
                                        self.policy.parent = self
                                        self._children_name_map["policy"] = "policy"
                                    return self.policy

                                if (child_yang_name == "policy-typhoon"):
                                    if (self.policy_typhoon is None):
                                        self.policy_typhoon = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details.PolicyTyphoon()
                                        self.policy_typhoon.parent = self
                                        self._children_name_map["policy_typhoon"] = "policy-typhoon"
                                    return self.policy_typhoon

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "header" or name == "policy" or name == "policy-typhoon"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (self.details is not None and self.details.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.details is not None and self.details.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "output" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "details"):
                                if (self.details is None):
                                    self.details = PlatformQos.Nodes.Node.Interfaces.Interface.Output.Details()
                                    self.details.parent = self
                                    self._children_name_map["details"] = "details"
                                return self.details

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "details"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            self.interface_name.is_set or
                            (self.input is not None and self.input.has_data()) or
                            (self.output is not None and self.output.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.interface_name.yfilter != YFilter.not_set or
                            (self.input is not None and self.input.has_operation()) or
                            (self.output is not None and self.output.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.interface_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "input"):
                            if (self.input is None):
                                self.input = PlatformQos.Nodes.Node.Interfaces.Interface.Input()
                                self.input.parent = self
                                self._children_name_map["input"] = "input"
                            return self.input

                        if (child_yang_name == "output"):
                            if (self.output is None):
                                self.output = PlatformQos.Nodes.Node.Interfaces.Interface.Output()
                                self.output.parent = self
                                self._children_name_map["output"] = "output"
                            return self.output

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "input" or name == "output" or name == "interface-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "interface-name"):
                            self.interface_name = value
                            self.interface_name.value_namespace = name_space
                            self.interface_name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.interface:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.interface:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "interfaces" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "interface"):
                        for c in self.interface:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = PlatformQos.Nodes.Node.Interfaces.Interface()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.interface.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "interface"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class BundleInterfaces(Entity):
                """
                QoS list of bundle interfaces
                
                .. attribute:: bundle_interface
                
                	QoS interface name
                	**type**\: list of    :py:class:`BundleInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface>`
                
                

                """

                _prefix = 'asr9k-qos-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(PlatformQos.Nodes.Node.BundleInterfaces, self).__init__()

                    self.yang_name = "bundle-interfaces"
                    self.yang_parent_name = "node"

                    self.bundle_interface = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(PlatformQos.Nodes.Node.BundleInterfaces, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(PlatformQos.Nodes.Node.BundleInterfaces, self).__setattr__(name, value)


                class BundleInterface(Entity):
                    """
                    QoS interface name
                    
                    .. attribute:: interface_name  <key>
                    
                    	Bundle interface name
                    	**type**\:  str
                    
                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                    
                    .. attribute:: bundle_input
                    
                    	QoS policy direction output
                    	**type**\:   :py:class:`BundleInput <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput>`
                    
                    .. attribute:: bundle_output
                    
                    	QoS policy direction output
                    	**type**\:   :py:class:`BundleOutput <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput>`
                    
                    

                    """

                    _prefix = 'asr9k-qos-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface, self).__init__()

                        self.yang_name = "bundle-interface"
                        self.yang_parent_name = "bundle-interfaces"

                        self.interface_name = YLeaf(YType.str, "interface-name")

                        self.bundle_input = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput()
                        self.bundle_input.parent = self
                        self._children_name_map["bundle_input"] = "bundle-input"
                        self._children_yang_names.add("bundle-input")

                        self.bundle_output = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput()
                        self.bundle_output.parent = self
                        self._children_name_map["bundle_output"] = "bundle-output"
                        self._children_yang_names.add("bundle-output")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("interface_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface, self).__setattr__(name, value)


                    class BundleOutput(Entity):
                        """
                        QoS policy direction output
                        
                        .. attribute:: member_interfaces
                        
                        	QoS list of member interfaces
                        	**type**\:   :py:class:`MemberInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces>`
                        
                        

                        """

                        _prefix = 'asr9k-qos-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput, self).__init__()

                            self.yang_name = "bundle-output"
                            self.yang_parent_name = "bundle-interface"

                            self.member_interfaces = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces()
                            self.member_interfaces.parent = self
                            self._children_name_map["member_interfaces"] = "member-interfaces"
                            self._children_yang_names.add("member-interfaces")


                        class MemberInterfaces(Entity):
                            """
                            QoS list of member interfaces
                            
                            .. attribute:: member_interface
                            
                            	QoS interface name
                            	**type**\: list of    :py:class:`MemberInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface>`
                            
                            

                            """

                            _prefix = 'asr9k-qos-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces, self).__init__()

                                self.yang_name = "member-interfaces"
                                self.yang_parent_name = "bundle-output"

                                self.member_interface = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces, self).__setattr__(name, value)


                            class MemberInterface(Entity):
                                """
                                QoS interface name
                                
                                .. attribute:: interface_name  <key>
                                
                                	Memeber interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: details
                                
                                	QoS policy direction egress
                                	**type**\:   :py:class:`Details <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details>`
                                
                                

                                """

                                _prefix = 'asr9k-qos-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface, self).__init__()

                                    self.yang_name = "member-interface"
                                    self.yang_parent_name = "member-interfaces"

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.details = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details()
                                    self.details.parent = self
                                    self._children_name_map["details"] = "details"
                                    self._children_yang_names.add("details")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface, self).__setattr__(name, value)


                                class Details(Entity):
                                    """
                                    QoS policy direction egress
                                    
                                    .. attribute:: header
                                    
                                    	QoS policy header
                                    	**type**\:   :py:class:`Header <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header>`
                                    
                                    .. attribute:: policy
                                    
                                    	Trident QoS policy details
                                    	**type**\:   :py:class:`Policy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy>`
                                    
                                    .. attribute:: policy_typhoon
                                    
                                    	Typhoon QoS policy details
                                    	**type**\:   :py:class:`PolicyTyphoon <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon>`
                                    
                                    

                                    """

                                    _prefix = 'asr9k-qos-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details, self).__init__()

                                        self.yang_name = "details"
                                        self.yang_parent_name = "member-interface"

                                        self.header = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header()
                                        self.header.parent = self
                                        self._children_name_map["header"] = "header"
                                        self._children_yang_names.add("header")

                                        self.policy = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy()
                                        self.policy.parent = self
                                        self._children_name_map["policy"] = "policy"
                                        self._children_yang_names.add("policy")

                                        self.policy_typhoon = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon()
                                        self.policy_typhoon.parent = self
                                        self._children_name_map["policy_typhoon"] = "policy-typhoon"
                                        self._children_yang_names.add("policy-typhoon")


                                    class Header(Entity):
                                        """
                                        QoS policy header
                                        
                                        .. attribute:: classes
                                        
                                        	Number of classes
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: interface_parameters
                                        
                                        	Interface config and programmed parameters
                                        	**type**\:   :py:class:`InterfaceParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters>`
                                        
                                        .. attribute:: policy_name
                                        
                                        	Policy name
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: programmed_bandwidth
                                        
                                        	Bandwidth that was programmed
                                        	**type**\:   :py:class:`ProgrammedBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.ProgrammedBandwidth>`
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header, self).__init__()

                                            self.yang_name = "header"
                                            self.yang_parent_name = "details"

                                            self.classes = YLeaf(YType.uint16, "classes")

                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                            self.interface_parameters = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters()
                                            self.interface_parameters.parent = self
                                            self._children_name_map["interface_parameters"] = "interface-parameters"
                                            self._children_yang_names.add("interface-parameters")

                                            self.programmed_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.ProgrammedBandwidth()
                                            self.programmed_bandwidth.parent = self
                                            self._children_name_map["programmed_bandwidth"] = "programmed-bandwidth"
                                            self._children_yang_names.add("programmed-bandwidth")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("classes",
                                                            "policy_name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header, self).__setattr__(name, value)


                                        class InterfaceParameters(Entity):
                                            """
                                            Interface config and programmed parameters
                                            
                                            .. attribute:: ancp_config_bandwidth
                                            
                                            	Bandwidth obtain from IM
                                            	**type**\:   :py:class:`AncpConfigBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpConfigBandwidth>`
                                            
                                            .. attribute:: ancp_programmed_bandwidth
                                            
                                            	ANCP bandwidth that was programmed
                                            	**type**\:   :py:class:`AncpProgrammedBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpProgrammedBandwidth>`
                                            
                                            .. attribute:: port_config_bandwidth
                                            
                                            	Bandwidth due to port speed change
                                            	**type**\:   :py:class:`PortConfigBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortConfigBandwidth>`
                                            
                                            .. attribute:: port_shaper_rate
                                            
                                            	Bandwidth that was programmed
                                            	**type**\:   :py:class:`PortShaperRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortShaperRate>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters, self).__init__()

                                                self.yang_name = "interface-parameters"
                                                self.yang_parent_name = "header"

                                                self.ancp_config_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpConfigBandwidth()
                                                self.ancp_config_bandwidth.parent = self
                                                self._children_name_map["ancp_config_bandwidth"] = "ancp-config-bandwidth"
                                                self._children_yang_names.add("ancp-config-bandwidth")

                                                self.ancp_programmed_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpProgrammedBandwidth()
                                                self.ancp_programmed_bandwidth.parent = self
                                                self._children_name_map["ancp_programmed_bandwidth"] = "ancp-programmed-bandwidth"
                                                self._children_yang_names.add("ancp-programmed-bandwidth")

                                                self.port_config_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortConfigBandwidth()
                                                self.port_config_bandwidth.parent = self
                                                self._children_name_map["port_config_bandwidth"] = "port-config-bandwidth"
                                                self._children_yang_names.add("port-config-bandwidth")

                                                self.port_shaper_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortShaperRate()
                                                self.port_shaper_rate.parent = self
                                                self._children_name_map["port_shaper_rate"] = "port-shaper-rate"
                                                self._children_yang_names.add("port-shaper-rate")


                                            class PortConfigBandwidth(Entity):
                                                """
                                                Bandwidth due to port speed change
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortConfigBandwidth, self).__init__()

                                                    self.yang_name = "port-config-bandwidth"
                                                    self.yang_parent_name = "interface-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortConfigBandwidth, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortConfigBandwidth, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "port-config-bandwidth" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class AncpConfigBandwidth(Entity):
                                                """
                                                Bandwidth obtain from IM
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpConfigBandwidth, self).__init__()

                                                    self.yang_name = "ancp-config-bandwidth"
                                                    self.yang_parent_name = "interface-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpConfigBandwidth, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpConfigBandwidth, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ancp-config-bandwidth" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class AncpProgrammedBandwidth(Entity):
                                                """
                                                ANCP bandwidth that was programmed
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpProgrammedBandwidth, self).__init__()

                                                    self.yang_name = "ancp-programmed-bandwidth"
                                                    self.yang_parent_name = "interface-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpProgrammedBandwidth, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpProgrammedBandwidth, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ancp-programmed-bandwidth" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class PortShaperRate(Entity):
                                                """
                                                Bandwidth that was programmed
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortShaperRate, self).__init__()

                                                    self.yang_name = "port-shaper-rate"
                                                    self.yang_parent_name = "interface-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortShaperRate, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortShaperRate, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "port-shaper-rate" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    (self.ancp_config_bandwidth is not None and self.ancp_config_bandwidth.has_data()) or
                                                    (self.ancp_programmed_bandwidth is not None and self.ancp_programmed_bandwidth.has_data()) or
                                                    (self.port_config_bandwidth is not None and self.port_config_bandwidth.has_data()) or
                                                    (self.port_shaper_rate is not None and self.port_shaper_rate.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    (self.ancp_config_bandwidth is not None and self.ancp_config_bandwidth.has_operation()) or
                                                    (self.ancp_programmed_bandwidth is not None and self.ancp_programmed_bandwidth.has_operation()) or
                                                    (self.port_config_bandwidth is not None and self.port_config_bandwidth.has_operation()) or
                                                    (self.port_shaper_rate is not None and self.port_shaper_rate.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "interface-parameters" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "ancp-config-bandwidth"):
                                                    if (self.ancp_config_bandwidth is None):
                                                        self.ancp_config_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpConfigBandwidth()
                                                        self.ancp_config_bandwidth.parent = self
                                                        self._children_name_map["ancp_config_bandwidth"] = "ancp-config-bandwidth"
                                                    return self.ancp_config_bandwidth

                                                if (child_yang_name == "ancp-programmed-bandwidth"):
                                                    if (self.ancp_programmed_bandwidth is None):
                                                        self.ancp_programmed_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpProgrammedBandwidth()
                                                        self.ancp_programmed_bandwidth.parent = self
                                                        self._children_name_map["ancp_programmed_bandwidth"] = "ancp-programmed-bandwidth"
                                                    return self.ancp_programmed_bandwidth

                                                if (child_yang_name == "port-config-bandwidth"):
                                                    if (self.port_config_bandwidth is None):
                                                        self.port_config_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortConfigBandwidth()
                                                        self.port_config_bandwidth.parent = self
                                                        self._children_name_map["port_config_bandwidth"] = "port-config-bandwidth"
                                                    return self.port_config_bandwidth

                                                if (child_yang_name == "port-shaper-rate"):
                                                    if (self.port_shaper_rate is None):
                                                        self.port_shaper_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortShaperRate()
                                                        self.port_shaper_rate.parent = self
                                                        self._children_name_map["port_shaper_rate"] = "port-shaper-rate"
                                                    return self.port_shaper_rate

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "ancp-config-bandwidth" or name == "ancp-programmed-bandwidth" or name == "port-config-bandwidth" or name == "port-shaper-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class ProgrammedBandwidth(Entity):
                                            """
                                            Bandwidth that was programmed
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.ProgrammedBandwidth, self).__init__()

                                                self.yang_name = "programmed-bandwidth"
                                                self.yang_parent_name = "header"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.ProgrammedBandwidth, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.ProgrammedBandwidth, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "programmed-bandwidth" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.classes.is_set or
                                                self.policy_name.is_set or
                                                (self.interface_parameters is not None and self.interface_parameters.has_data()) or
                                                (self.programmed_bandwidth is not None and self.programmed_bandwidth.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.classes.yfilter != YFilter.not_set or
                                                self.policy_name.yfilter != YFilter.not_set or
                                                (self.interface_parameters is not None and self.interface_parameters.has_operation()) or
                                                (self.programmed_bandwidth is not None and self.programmed_bandwidth.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.classes.is_set or self.classes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.classes.get_name_leafdata())
                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "interface-parameters"):
                                                if (self.interface_parameters is None):
                                                    self.interface_parameters = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters()
                                                    self.interface_parameters.parent = self
                                                    self._children_name_map["interface_parameters"] = "interface-parameters"
                                                return self.interface_parameters

                                            if (child_yang_name == "programmed-bandwidth"):
                                                if (self.programmed_bandwidth is None):
                                                    self.programmed_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header.ProgrammedBandwidth()
                                                    self.programmed_bandwidth.parent = self
                                                    self._children_name_map["programmed_bandwidth"] = "programmed-bandwidth"
                                                return self.programmed_bandwidth

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "interface-parameters" or name == "programmed-bandwidth" or name == "classes" or name == "policy-name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "classes"):
                                                self.classes = value
                                                self.classes.value_namespace = name_space
                                                self.classes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-name"):
                                                self.policy_name = value
                                                self.policy_name.value_namespace = name_space
                                                self.policy_name.value_namespace_prefix = name_space_prefix


                                    class Policy(Entity):
                                        """
                                        Trident QoS policy details
                                        
                                        .. attribute:: qos_show_ea_st_v1
                                        
                                        	qos show ea st v1
                                        	**type**\: list of    :py:class:`QosShowEaStV1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1>`
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy, self).__init__()

                                            self.yang_name = "policy"
                                            self.yang_parent_name = "details"

                                            self.qos_show_ea_st_v1 = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy, self).__setattr__(name, value)


                                        class QosShowEaStV1(Entity):
                                            """
                                            qos show ea st v1
                                            
                                            .. attribute:: class_level
                                            
                                            	Class level
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: class_name
                                            
                                            	Class name
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: mark
                                            
                                            	Mark parameters
                                            	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark>`
                                            
                                            .. attribute:: parent_class_name
                                            
                                            	Parent class name
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: parent_policy_name
                                            
                                            	Parent policy name
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: police
                                            
                                            	Police parameters
                                            	**type**\:   :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police>`
                                            
                                            .. attribute:: policy_name
                                            
                                            	Policy name
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: queue
                                            
                                            	Queue parameters
                                            	**type**\:   :py:class:`Queue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Queue>`
                                            
                                            .. attribute:: queue_limit_parameters
                                            
                                            	Queue limit parameters
                                            	**type**\:   :py:class:`QueueLimitParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters>`
                                            
                                            .. attribute:: shape
                                            
                                            	Shape parameters
                                            	**type**\:   :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape>`
                                            
                                            .. attribute:: wfq
                                            
                                            	WFQ parameters
                                            	**type**\:   :py:class:`Wfq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq>`
                                            
                                            .. attribute:: wred
                                            
                                            	WRED parameters
                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1, self).__init__()

                                                self.yang_name = "qos-show-ea-st-v1"
                                                self.yang_parent_name = "policy"

                                                self.class_level = YLeaf(YType.uint8, "class-level")

                                                self.class_name = YLeaf(YType.str, "class-name")

                                                self.parent_class_name = YLeaf(YType.str, "parent-class-name")

                                                self.parent_policy_name = YLeaf(YType.str, "parent-policy-name")

                                                self.policy_name = YLeaf(YType.str, "policy-name")

                                                self.mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark()
                                                self.mark.parent = self
                                                self._children_name_map["mark"] = "mark"
                                                self._children_yang_names.add("mark")

                                                self.police = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police()
                                                self.police.parent = self
                                                self._children_name_map["police"] = "police"
                                                self._children_yang_names.add("police")

                                                self.queue = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Queue()
                                                self.queue.parent = self
                                                self._children_name_map["queue"] = "queue"
                                                self._children_yang_names.add("queue")

                                                self.queue_limit_parameters = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters()
                                                self.queue_limit_parameters.parent = self
                                                self._children_name_map["queue_limit_parameters"] = "queue-limit-parameters"
                                                self._children_yang_names.add("queue-limit-parameters")

                                                self.shape = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape()
                                                self.shape.parent = self
                                                self._children_name_map["shape"] = "shape"
                                                self._children_yang_names.add("shape")

                                                self.wfq = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq()
                                                self.wfq.parent = self
                                                self._children_name_map["wfq"] = "wfq"
                                                self._children_yang_names.add("wfq")

                                                self.wred = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred()
                                                self.wred.parent = self
                                                self._children_name_map["wred"] = "wred"
                                                self._children_yang_names.add("wred")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("class_level",
                                                                "class_name",
                                                                "parent_class_name",
                                                                "parent_policy_name",
                                                                "policy_name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1, self).__setattr__(name, value)


                                            class Queue(Entity):
                                                """
                                                Queue parameters
                                                
                                                .. attribute:: class_name
                                                
                                                	Class name
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_type
                                                
                                                	Queue type
                                                	**type**\:   :py:class:`Queue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Queue>`
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Queue, self).__init__()

                                                    self.yang_name = "queue"
                                                    self.yang_parent_name = "qos-show-ea-st-v1"

                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                    self.queue_type = YLeaf(YType.enumeration, "queue-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("class_name",
                                                                    "queue_id",
                                                                    "queue_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Queue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Queue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.class_name.is_set or
                                                        self.queue_id.is_set or
                                                        self.queue_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.class_name.yfilter != YFilter.not_set or
                                                        self.queue_id.yfilter != YFilter.not_set or
                                                        self.queue_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                    if (self.queue_type.is_set or self.queue_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "class-name" or name == "queue-id" or name == "queue-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "class-name"):
                                                        self.class_name = value
                                                        self.class_name.value_namespace = name_space
                                                        self.class_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-id"):
                                                        self.queue_id = value
                                                        self.queue_id.value_namespace = name_space
                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-type"):
                                                        self.queue_type = value
                                                        self.queue_type.value_namespace = name_space
                                                        self.queue_type.value_namespace_prefix = name_space_prefix


                                            class QueueLimitParameters(Entity):
                                                """
                                                Queue limit parameters
                                                
                                                .. attribute:: config_queue_limit
                                                
                                                	Config queue limit
                                                	**type**\:   :py:class:`ConfigQueueLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit>`
                                                
                                                .. attribute:: profile_id
                                                
                                                	Profile ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_limit
                                                
                                                	Queue limit in kbytes
                                                	**type**\:   :py:class:`QueueLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit>`
                                                
                                                .. attribute:: scaling_profile_id
                                                
                                                	Scaling profile ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters, self).__init__()

                                                    self.yang_name = "queue-limit-parameters"
                                                    self.yang_parent_name = "qos-show-ea-st-v1"

                                                    self.profile_id = YLeaf(YType.uint32, "profile-id")

                                                    self.scaling_profile_id = YLeaf(YType.uint32, "scaling-profile-id")

                                                    self.config_queue_limit = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit()
                                                    self.config_queue_limit.parent = self
                                                    self._children_name_map["config_queue_limit"] = "config-queue-limit"
                                                    self._children_yang_names.add("config-queue-limit")

                                                    self.queue_limit = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit()
                                                    self.queue_limit.parent = self
                                                    self._children_name_map["queue_limit"] = "queue-limit"
                                                    self._children_yang_names.add("queue-limit")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("profile_id",
                                                                    "scaling_profile_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters, self).__setattr__(name, value)


                                                class QueueLimit(Entity):
                                                    """
                                                    Queue limit in kbytes
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit, self).__init__()

                                                        self.yang_name = "queue-limit"
                                                        self.yang_parent_name = "queue-limit-parameters"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-limit" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class ConfigQueueLimit(Entity):
                                                    """
                                                    Config queue limit
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit, self).__init__()

                                                        self.yang_name = "config-queue-limit"
                                                        self.yang_parent_name = "queue-limit-parameters"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "config-queue-limit" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.profile_id.is_set or
                                                        self.scaling_profile_id.is_set or
                                                        (self.config_queue_limit is not None and self.config_queue_limit.has_data()) or
                                                        (self.queue_limit is not None and self.queue_limit.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.profile_id.yfilter != YFilter.not_set or
                                                        self.scaling_profile_id.yfilter != YFilter.not_set or
                                                        (self.config_queue_limit is not None and self.config_queue_limit.has_operation()) or
                                                        (self.queue_limit is not None and self.queue_limit.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-limit-parameters" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_id.get_name_leafdata())
                                                    if (self.scaling_profile_id.is_set or self.scaling_profile_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.scaling_profile_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "config-queue-limit"):
                                                        if (self.config_queue_limit is None):
                                                            self.config_queue_limit = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit()
                                                            self.config_queue_limit.parent = self
                                                            self._children_name_map["config_queue_limit"] = "config-queue-limit"
                                                        return self.config_queue_limit

                                                    if (child_yang_name == "queue-limit"):
                                                        if (self.queue_limit is None):
                                                            self.queue_limit = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit()
                                                            self.queue_limit.parent = self
                                                            self._children_name_map["queue_limit"] = "queue-limit"
                                                        return self.queue_limit

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "config-queue-limit" or name == "queue-limit" or name == "profile-id" or name == "scaling-profile-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "profile-id"):
                                                        self.profile_id = value
                                                        self.profile_id.value_namespace = name_space
                                                        self.profile_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "scaling-profile-id"):
                                                        self.scaling_profile_id = value
                                                        self.scaling_profile_id.value_namespace = name_space
                                                        self.scaling_profile_id.value_namespace_prefix = name_space_prefix


                                            class Shape(Entity):
                                                """
                                                Shape parameters
                                                
                                                .. attribute:: cbs
                                                
                                                	CBS in bytes
                                                	**type**\:   :py:class:`Cbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cbs>`
                                                
                                                .. attribute:: cir
                                                
                                                	CIR in kbps
                                                	**type**\:   :py:class:`Cir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cir>`
                                                
                                                .. attribute:: config_bandwidth
                                                
                                                	Config bandwidth
                                                	**type**\:   :py:class:`ConfigBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth>`
                                                
                                                .. attribute:: pbs
                                                
                                                	PBS in bytes
                                                	**type**\:   :py:class:`Pbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pbs>`
                                                
                                                .. attribute:: pir
                                                
                                                	PIR in kbps
                                                	**type**\:   :py:class:`Pir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pir>`
                                                
                                                .. attribute:: profile_id
                                                
                                                	Shape profile ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape, self).__init__()

                                                    self.yang_name = "shape"
                                                    self.yang_parent_name = "qos-show-ea-st-v1"

                                                    self.profile_id = YLeaf(YType.uint16, "profile-id")

                                                    self.cbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cbs()
                                                    self.cbs.parent = self
                                                    self._children_name_map["cbs"] = "cbs"
                                                    self._children_yang_names.add("cbs")

                                                    self.cir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cir()
                                                    self.cir.parent = self
                                                    self._children_name_map["cir"] = "cir"
                                                    self._children_yang_names.add("cir")

                                                    self.config_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth()
                                                    self.config_bandwidth.parent = self
                                                    self._children_name_map["config_bandwidth"] = "config-bandwidth"
                                                    self._children_yang_names.add("config-bandwidth")

                                                    self.pbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pbs()
                                                    self.pbs.parent = self
                                                    self._children_name_map["pbs"] = "pbs"
                                                    self._children_yang_names.add("pbs")

                                                    self.pir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pir()
                                                    self.pir.parent = self
                                                    self._children_name_map["pir"] = "pir"
                                                    self._children_yang_names.add("pir")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("profile_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape, self).__setattr__(name, value)


                                                class Cir(Entity):
                                                    """
                                                    CIR in kbps
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cir, self).__init__()

                                                        self.yang_name = "cir"
                                                        self.yang_parent_name = "shape"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cir, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cir, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cir" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class ConfigBandwidth(Entity):
                                                    """
                                                    Config bandwidth
                                                    
                                                    .. attribute:: minimum_rate
                                                    
                                                    	Minimum bandwidth rate
                                                    	**type**\:   :py:class:`MinimumRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth, self).__init__()

                                                        self.yang_name = "config-bandwidth"
                                                        self.yang_parent_name = "shape"

                                                        self.minimum_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate()
                                                        self.minimum_rate.parent = self
                                                        self._children_name_map["minimum_rate"] = "minimum-rate"
                                                        self._children_yang_names.add("minimum-rate")


                                                    class MinimumRate(Entity):
                                                        """
                                                        Minimum bandwidth rate
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate, self).__init__()

                                                            self.yang_name = "minimum-rate"
                                                            self.yang_parent_name = "config-bandwidth"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "minimum-rate" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (self.minimum_rate is not None and self.minimum_rate.has_data())

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            (self.minimum_rate is not None and self.minimum_rate.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "config-bandwidth" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "minimum-rate"):
                                                            if (self.minimum_rate is None):
                                                                self.minimum_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate()
                                                                self.minimum_rate.parent = self
                                                                self._children_name_map["minimum_rate"] = "minimum-rate"
                                                            return self.minimum_rate

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "minimum-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        pass


                                                class Cbs(Entity):
                                                    """
                                                    CBS in bytes
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cbs, self).__init__()

                                                        self.yang_name = "cbs"
                                                        self.yang_parent_name = "shape"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cbs, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cbs, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cbs" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class Pir(Entity):
                                                    """
                                                    PIR in kbps
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pir, self).__init__()

                                                        self.yang_name = "pir"
                                                        self.yang_parent_name = "shape"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pir, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pir, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "pir" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class Pbs(Entity):
                                                    """
                                                    PBS in bytes
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pbs, self).__init__()

                                                        self.yang_name = "pbs"
                                                        self.yang_parent_name = "shape"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pbs, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pbs, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "pbs" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.profile_id.is_set or
                                                        (self.cbs is not None and self.cbs.has_data()) or
                                                        (self.cir is not None and self.cir.has_data()) or
                                                        (self.config_bandwidth is not None and self.config_bandwidth.has_data()) or
                                                        (self.pbs is not None and self.pbs.has_data()) or
                                                        (self.pir is not None and self.pir.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.profile_id.yfilter != YFilter.not_set or
                                                        (self.cbs is not None and self.cbs.has_operation()) or
                                                        (self.cir is not None and self.cir.has_operation()) or
                                                        (self.config_bandwidth is not None and self.config_bandwidth.has_operation()) or
                                                        (self.pbs is not None and self.pbs.has_operation()) or
                                                        (self.pir is not None and self.pir.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "shape" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "cbs"):
                                                        if (self.cbs is None):
                                                            self.cbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cbs()
                                                            self.cbs.parent = self
                                                            self._children_name_map["cbs"] = "cbs"
                                                        return self.cbs

                                                    if (child_yang_name == "cir"):
                                                        if (self.cir is None):
                                                            self.cir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cir()
                                                            self.cir.parent = self
                                                            self._children_name_map["cir"] = "cir"
                                                        return self.cir

                                                    if (child_yang_name == "config-bandwidth"):
                                                        if (self.config_bandwidth is None):
                                                            self.config_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth()
                                                            self.config_bandwidth.parent = self
                                                            self._children_name_map["config_bandwidth"] = "config-bandwidth"
                                                        return self.config_bandwidth

                                                    if (child_yang_name == "pbs"):
                                                        if (self.pbs is None):
                                                            self.pbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pbs()
                                                            self.pbs.parent = self
                                                            self._children_name_map["pbs"] = "pbs"
                                                        return self.pbs

                                                    if (child_yang_name == "pir"):
                                                        if (self.pir is None):
                                                            self.pir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pir()
                                                            self.pir.parent = self
                                                            self._children_name_map["pir"] = "pir"
                                                        return self.pir

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "cbs" or name == "cir" or name == "config-bandwidth" or name == "pbs" or name == "pir" or name == "profile-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "profile-id"):
                                                        self.profile_id = value
                                                        self.profile_id.value_namespace = name_space
                                                        self.profile_id.value_namespace_prefix = name_space_prefix


                                            class Police(Entity):
                                                """
                                                Police parameters
                                                
                                                .. attribute:: cbs
                                                
                                                	CBS
                                                	**type**\:   :py:class:`Cbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cbs>`
                                                
                                                .. attribute:: cir
                                                
                                                	CIR
                                                	**type**\:   :py:class:`Cir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cir>`
                                                
                                                .. attribute:: pbs
                                                
                                                	PBS
                                                	**type**\:   :py:class:`Pbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pbs>`
                                                
                                                .. attribute:: pir
                                                
                                                	PIR
                                                	**type**\:   :py:class:`Pir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pir>`
                                                
                                                .. attribute:: police_config_parameters
                                                
                                                	Police config parameters
                                                	**type**\:   :py:class:`PoliceConfigParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters>`
                                                
                                                .. attribute:: policer_type
                                                
                                                	Policer type
                                                	**type**\:   :py:class:`TbAlgorithm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.TbAlgorithm>`
                                                
                                                .. attribute:: profile_id
                                                
                                                	Police profile ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police, self).__init__()

                                                    self.yang_name = "police"
                                                    self.yang_parent_name = "qos-show-ea-st-v1"

                                                    self.policer_type = YLeaf(YType.enumeration, "policer-type")

                                                    self.profile_id = YLeaf(YType.uint32, "profile-id")

                                                    self.cbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cbs()
                                                    self.cbs.parent = self
                                                    self._children_name_map["cbs"] = "cbs"
                                                    self._children_yang_names.add("cbs")

                                                    self.cir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cir()
                                                    self.cir.parent = self
                                                    self._children_name_map["cir"] = "cir"
                                                    self._children_yang_names.add("cir")

                                                    self.pbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pbs()
                                                    self.pbs.parent = self
                                                    self._children_name_map["pbs"] = "pbs"
                                                    self._children_yang_names.add("pbs")

                                                    self.pir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pir()
                                                    self.pir.parent = self
                                                    self._children_name_map["pir"] = "pir"
                                                    self._children_yang_names.add("pir")

                                                    self.police_config_parameters = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters()
                                                    self.police_config_parameters.parent = self
                                                    self._children_name_map["police_config_parameters"] = "police-config-parameters"
                                                    self._children_yang_names.add("police-config-parameters")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("policer_type",
                                                                    "profile_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police, self).__setattr__(name, value)


                                                class Cir(Entity):
                                                    """
                                                    CIR
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cir, self).__init__()

                                                        self.yang_name = "cir"
                                                        self.yang_parent_name = "police"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cir, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cir, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cir" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class Cbs(Entity):
                                                    """
                                                    CBS
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cbs, self).__init__()

                                                        self.yang_name = "cbs"
                                                        self.yang_parent_name = "police"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cbs, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cbs, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cbs" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class Pir(Entity):
                                                    """
                                                    PIR
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pir, self).__init__()

                                                        self.yang_name = "pir"
                                                        self.yang_parent_name = "police"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pir, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pir, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "pir" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class Pbs(Entity):
                                                    """
                                                    PBS
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pbs, self).__init__()

                                                        self.yang_name = "pbs"
                                                        self.yang_parent_name = "police"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pbs, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pbs, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "pbs" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class PoliceConfigParameters(Entity):
                                                    """
                                                    Police config parameters
                                                    
                                                    .. attribute:: average_rate
                                                    
                                                    	Average rate
                                                    	**type**\:   :py:class:`AverageRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate>`
                                                    
                                                    .. attribute:: conform_burst
                                                    
                                                    	Conform burst
                                                    	**type**\:   :py:class:`ConformBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst>`
                                                    
                                                    .. attribute:: exceed_burst
                                                    
                                                    	Exceed burst
                                                    	**type**\:   :py:class:`ExceedBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst>`
                                                    
                                                    .. attribute:: peak_rate
                                                    
                                                    	Peak rate
                                                    	**type**\:   :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters, self).__init__()

                                                        self.yang_name = "police-config-parameters"
                                                        self.yang_parent_name = "police"

                                                        self.average_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate()
                                                        self.average_rate.parent = self
                                                        self._children_name_map["average_rate"] = "average-rate"
                                                        self._children_yang_names.add("average-rate")

                                                        self.conform_burst = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst()
                                                        self.conform_burst.parent = self
                                                        self._children_name_map["conform_burst"] = "conform-burst"
                                                        self._children_yang_names.add("conform-burst")

                                                        self.exceed_burst = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst()
                                                        self.exceed_burst.parent = self
                                                        self._children_name_map["exceed_burst"] = "exceed-burst"
                                                        self._children_yang_names.add("exceed-burst")

                                                        self.peak_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate()
                                                        self.peak_rate.parent = self
                                                        self._children_name_map["peak_rate"] = "peak-rate"
                                                        self._children_yang_names.add("peak-rate")


                                                    class AverageRate(Entity):
                                                        """
                                                        Average rate
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate, self).__init__()

                                                            self.yang_name = "average-rate"
                                                            self.yang_parent_name = "police-config-parameters"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "average-rate" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class PeakRate(Entity):
                                                        """
                                                        Peak rate
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate, self).__init__()

                                                            self.yang_name = "peak-rate"
                                                            self.yang_parent_name = "police-config-parameters"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "peak-rate" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class ConformBurst(Entity):
                                                        """
                                                        Conform burst
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst, self).__init__()

                                                            self.yang_name = "conform-burst"
                                                            self.yang_parent_name = "police-config-parameters"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "conform-burst" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class ExceedBurst(Entity):
                                                        """
                                                        Exceed burst
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst, self).__init__()

                                                            self.yang_name = "exceed-burst"
                                                            self.yang_parent_name = "police-config-parameters"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "exceed-burst" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            (self.average_rate is not None and self.average_rate.has_data()) or
                                                            (self.conform_burst is not None and self.conform_burst.has_data()) or
                                                            (self.exceed_burst is not None and self.exceed_burst.has_data()) or
                                                            (self.peak_rate is not None and self.peak_rate.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            (self.average_rate is not None and self.average_rate.has_operation()) or
                                                            (self.conform_burst is not None and self.conform_burst.has_operation()) or
                                                            (self.exceed_burst is not None and self.exceed_burst.has_operation()) or
                                                            (self.peak_rate is not None and self.peak_rate.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-config-parameters" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "average-rate"):
                                                            if (self.average_rate is None):
                                                                self.average_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate()
                                                                self.average_rate.parent = self
                                                                self._children_name_map["average_rate"] = "average-rate"
                                                            return self.average_rate

                                                        if (child_yang_name == "conform-burst"):
                                                            if (self.conform_burst is None):
                                                                self.conform_burst = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst()
                                                                self.conform_burst.parent = self
                                                                self._children_name_map["conform_burst"] = "conform-burst"
                                                            return self.conform_burst

                                                        if (child_yang_name == "exceed-burst"):
                                                            if (self.exceed_burst is None):
                                                                self.exceed_burst = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst()
                                                                self.exceed_burst.parent = self
                                                                self._children_name_map["exceed_burst"] = "exceed-burst"
                                                            return self.exceed_burst

                                                        if (child_yang_name == "peak-rate"):
                                                            if (self.peak_rate is None):
                                                                self.peak_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate()
                                                                self.peak_rate.parent = self
                                                                self._children_name_map["peak_rate"] = "peak-rate"
                                                            return self.peak_rate

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "average-rate" or name == "conform-burst" or name == "exceed-burst" or name == "peak-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        pass

                                                def has_data(self):
                                                    return (
                                                        self.policer_type.is_set or
                                                        self.profile_id.is_set or
                                                        (self.cbs is not None and self.cbs.has_data()) or
                                                        (self.cir is not None and self.cir.has_data()) or
                                                        (self.pbs is not None and self.pbs.has_data()) or
                                                        (self.pir is not None and self.pir.has_data()) or
                                                        (self.police_config_parameters is not None and self.police_config_parameters.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.policer_type.yfilter != YFilter.not_set or
                                                        self.profile_id.yfilter != YFilter.not_set or
                                                        (self.cbs is not None and self.cbs.has_operation()) or
                                                        (self.cir is not None and self.cir.has_operation()) or
                                                        (self.pbs is not None and self.pbs.has_operation()) or
                                                        (self.pir is not None and self.pir.has_operation()) or
                                                        (self.police_config_parameters is not None and self.police_config_parameters.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "police" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.policer_type.is_set or self.policer_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.policer_type.get_name_leafdata())
                                                    if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "cbs"):
                                                        if (self.cbs is None):
                                                            self.cbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cbs()
                                                            self.cbs.parent = self
                                                            self._children_name_map["cbs"] = "cbs"
                                                        return self.cbs

                                                    if (child_yang_name == "cir"):
                                                        if (self.cir is None):
                                                            self.cir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cir()
                                                            self.cir.parent = self
                                                            self._children_name_map["cir"] = "cir"
                                                        return self.cir

                                                    if (child_yang_name == "pbs"):
                                                        if (self.pbs is None):
                                                            self.pbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pbs()
                                                            self.pbs.parent = self
                                                            self._children_name_map["pbs"] = "pbs"
                                                        return self.pbs

                                                    if (child_yang_name == "pir"):
                                                        if (self.pir is None):
                                                            self.pir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pir()
                                                            self.pir.parent = self
                                                            self._children_name_map["pir"] = "pir"
                                                        return self.pir

                                                    if (child_yang_name == "police-config-parameters"):
                                                        if (self.police_config_parameters is None):
                                                            self.police_config_parameters = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters()
                                                            self.police_config_parameters.parent = self
                                                            self._children_name_map["police_config_parameters"] = "police-config-parameters"
                                                        return self.police_config_parameters

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "cbs" or name == "cir" or name == "pbs" or name == "pir" or name == "police-config-parameters" or name == "policer-type" or name == "profile-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "policer-type"):
                                                        self.policer_type = value
                                                        self.policer_type.value_namespace = name_space
                                                        self.policer_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-id"):
                                                        self.profile_id = value
                                                        self.profile_id.value_namespace = name_space
                                                        self.profile_id.value_namespace_prefix = name_space_prefix


                                            class Wfq(Entity):
                                                """
                                                WFQ parameters
                                                
                                                .. attribute:: bandwidth
                                                
                                                	CFG Bandwidth
                                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.Bandwidth>`
                                                
                                                .. attribute:: chunk_id
                                                
                                                	Chunk ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: committed_weight
                                                
                                                	Committed weight
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: excess_ratio
                                                
                                                	Parent Excess ratio
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: excess_weight
                                                
                                                	Excess weight
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: level
                                                
                                                	Level
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: parent_bandwidth
                                                
                                                	Parent bandwidth
                                                	**type**\:   :py:class:`ParentBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth>`
                                                
                                                .. attribute:: profile_id
                                                
                                                	WFQ profile
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq, self).__init__()

                                                    self.yang_name = "wfq"
                                                    self.yang_parent_name = "qos-show-ea-st-v1"

                                                    self.chunk_id = YLeaf(YType.uint32, "chunk-id")

                                                    self.committed_weight = YLeaf(YType.uint32, "committed-weight")

                                                    self.excess_ratio = YLeaf(YType.uint16, "excess-ratio")

                                                    self.excess_weight = YLeaf(YType.uint16, "excess-weight")

                                                    self.level = YLeaf(YType.uint8, "level")

                                                    self.profile_id = YLeaf(YType.uint32, "profile-id")

                                                    self.bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.Bandwidth()
                                                    self.bandwidth.parent = self
                                                    self._children_name_map["bandwidth"] = "bandwidth"
                                                    self._children_yang_names.add("bandwidth")

                                                    self.parent_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth()
                                                    self.parent_bandwidth.parent = self
                                                    self._children_name_map["parent_bandwidth"] = "parent-bandwidth"
                                                    self._children_yang_names.add("parent-bandwidth")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("chunk_id",
                                                                    "committed_weight",
                                                                    "excess_ratio",
                                                                    "excess_weight",
                                                                    "level",
                                                                    "profile_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq, self).__setattr__(name, value)


                                                class ParentBandwidth(Entity):
                                                    """
                                                    Parent bandwidth
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth, self).__init__()

                                                        self.yang_name = "parent-bandwidth"
                                                        self.yang_parent_name = "wfq"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "parent-bandwidth" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class Bandwidth(Entity):
                                                    """
                                                    CFG Bandwidth
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.Bandwidth, self).__init__()

                                                        self.yang_name = "bandwidth"
                                                        self.yang_parent_name = "wfq"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.Bandwidth, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.Bandwidth, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "bandwidth" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.chunk_id.is_set or
                                                        self.committed_weight.is_set or
                                                        self.excess_ratio.is_set or
                                                        self.excess_weight.is_set or
                                                        self.level.is_set or
                                                        self.profile_id.is_set or
                                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                                        (self.parent_bandwidth is not None and self.parent_bandwidth.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.chunk_id.yfilter != YFilter.not_set or
                                                        self.committed_weight.yfilter != YFilter.not_set or
                                                        self.excess_ratio.yfilter != YFilter.not_set or
                                                        self.excess_weight.yfilter != YFilter.not_set or
                                                        self.level.yfilter != YFilter.not_set or
                                                        self.profile_id.yfilter != YFilter.not_set or
                                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                                        (self.parent_bandwidth is not None and self.parent_bandwidth.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wfq" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.chunk_id.is_set or self.chunk_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.chunk_id.get_name_leafdata())
                                                    if (self.committed_weight.is_set or self.committed_weight.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.committed_weight.get_name_leafdata())
                                                    if (self.excess_ratio.is_set or self.excess_ratio.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.excess_ratio.get_name_leafdata())
                                                    if (self.excess_weight.is_set or self.excess_weight.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.excess_weight.get_name_leafdata())
                                                    if (self.level.is_set or self.level.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.level.get_name_leafdata())
                                                    if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "bandwidth"):
                                                        if (self.bandwidth is None):
                                                            self.bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.Bandwidth()
                                                            self.bandwidth.parent = self
                                                            self._children_name_map["bandwidth"] = "bandwidth"
                                                        return self.bandwidth

                                                    if (child_yang_name == "parent-bandwidth"):
                                                        if (self.parent_bandwidth is None):
                                                            self.parent_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth()
                                                            self.parent_bandwidth.parent = self
                                                            self._children_name_map["parent_bandwidth"] = "parent-bandwidth"
                                                        return self.parent_bandwidth

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "bandwidth" or name == "parent-bandwidth" or name == "chunk-id" or name == "committed-weight" or name == "excess-ratio" or name == "excess-weight" or name == "level" or name == "profile-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "chunk-id"):
                                                        self.chunk_id = value
                                                        self.chunk_id.value_namespace = name_space
                                                        self.chunk_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "committed-weight"):
                                                        self.committed_weight = value
                                                        self.committed_weight.value_namespace = name_space
                                                        self.committed_weight.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "excess-ratio"):
                                                        self.excess_ratio = value
                                                        self.excess_ratio.value_namespace = name_space
                                                        self.excess_ratio.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "excess-weight"):
                                                        self.excess_weight = value
                                                        self.excess_weight.value_namespace = name_space
                                                        self.excess_weight.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "level"):
                                                        self.level = value
                                                        self.level.value_namespace = name_space
                                                        self.level.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-id"):
                                                        self.profile_id = value
                                                        self.profile_id.value_namespace = name_space
                                                        self.profile_id.value_namespace_prefix = name_space_prefix


                                            class Wred(Entity):
                                                """
                                                WRED parameters
                                                
                                                .. attribute:: curve
                                                
                                                	Curve details
                                                	**type**\: list of    :py:class:`Curve <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve>`
                                                
                                                .. attribute:: curve_xr
                                                
                                                	Number of curves
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: profile_id
                                                
                                                	Profile ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: scaling_profile_id
                                                
                                                	Scaling profile ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: table_id
                                                
                                                	Table ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: type
                                                
                                                	WRED type
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred, self).__init__()

                                                    self.yang_name = "wred"
                                                    self.yang_parent_name = "qos-show-ea-st-v1"

                                                    self.curve_xr = YLeaf(YType.uint16, "curve-xr")

                                                    self.profile_id = YLeaf(YType.uint32, "profile-id")

                                                    self.scaling_profile_id = YLeaf(YType.uint32, "scaling-profile-id")

                                                    self.table_id = YLeaf(YType.uint8, "table-id")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.curve = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("curve_xr",
                                                                    "profile_id",
                                                                    "scaling_profile_id",
                                                                    "table_id",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred, self).__setattr__(name, value)


                                                class Curve(Entity):
                                                    """
                                                    Curve details
                                                    
                                                    .. attribute:: match
                                                    
                                                    	WRED precedence match if precedence start value equals to end value Format\: <start\-value> , else range Format\: <start\-value> <end\-value>
                                                    	**type**\:  str
                                                    
                                                    .. attribute:: max_threshold
                                                    
                                                    	Maximum threshold
                                                    	**type**\:   :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold>`
                                                    
                                                    .. attribute:: max_threshold_user_config
                                                    
                                                    	Maximum threshold WRED context
                                                    	**type**\:   :py:class:`MaxThresholdUserConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig>`
                                                    
                                                    .. attribute:: min_threshold
                                                    
                                                    	Minimum threshold
                                                    	**type**\:   :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold>`
                                                    
                                                    .. attribute:: min_threshold_user_config
                                                    
                                                    	Minimum threshold WRED context
                                                    	**type**\:   :py:class:`MinThresholdUserConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve, self).__init__()

                                                        self.yang_name = "curve"
                                                        self.yang_parent_name = "wred"

                                                        self.match = YLeaf(YType.str, "match")

                                                        self.max_threshold = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold()
                                                        self.max_threshold.parent = self
                                                        self._children_name_map["max_threshold"] = "max-threshold"
                                                        self._children_yang_names.add("max-threshold")

                                                        self.max_threshold_user_config = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig()
                                                        self.max_threshold_user_config.parent = self
                                                        self._children_name_map["max_threshold_user_config"] = "max-threshold-user-config"
                                                        self._children_yang_names.add("max-threshold-user-config")

                                                        self.min_threshold = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold()
                                                        self.min_threshold.parent = self
                                                        self._children_name_map["min_threshold"] = "min-threshold"
                                                        self._children_yang_names.add("min-threshold")

                                                        self.min_threshold_user_config = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig()
                                                        self.min_threshold_user_config.parent = self
                                                        self._children_name_map["min_threshold_user_config"] = "min-threshold-user-config"
                                                        self._children_yang_names.add("min-threshold-user-config")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("match") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve, self).__setattr__(name, value)


                                                    class MinThreshold(Entity):
                                                        """
                                                        Minimum threshold
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold, self).__init__()

                                                            self.yang_name = "min-threshold"
                                                            self.yang_parent_name = "curve"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "min-threshold" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class MinThresholdUserConfig(Entity):
                                                        """
                                                        Minimum threshold WRED context
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig, self).__init__()

                                                            self.yang_name = "min-threshold-user-config"
                                                            self.yang_parent_name = "curve"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "min-threshold-user-config" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class MaxThreshold(Entity):
                                                        """
                                                        Maximum threshold
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold, self).__init__()

                                                            self.yang_name = "max-threshold"
                                                            self.yang_parent_name = "curve"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "max-threshold" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class MaxThresholdUserConfig(Entity):
                                                        """
                                                        Maximum threshold WRED context
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig, self).__init__()

                                                            self.yang_name = "max-threshold-user-config"
                                                            self.yang_parent_name = "curve"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "max-threshold-user-config" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.match.is_set or
                                                            (self.max_threshold is not None and self.max_threshold.has_data()) or
                                                            (self.max_threshold_user_config is not None and self.max_threshold_user_config.has_data()) or
                                                            (self.min_threshold is not None and self.min_threshold.has_data()) or
                                                            (self.min_threshold_user_config is not None and self.min_threshold_user_config.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.match.yfilter != YFilter.not_set or
                                                            (self.max_threshold is not None and self.max_threshold.has_operation()) or
                                                            (self.max_threshold_user_config is not None and self.max_threshold_user_config.has_operation()) or
                                                            (self.min_threshold is not None and self.min_threshold.has_operation()) or
                                                            (self.min_threshold_user_config is not None and self.min_threshold_user_config.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "curve" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.match.is_set or self.match.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.match.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "max-threshold"):
                                                            if (self.max_threshold is None):
                                                                self.max_threshold = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold()
                                                                self.max_threshold.parent = self
                                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                            return self.max_threshold

                                                        if (child_yang_name == "max-threshold-user-config"):
                                                            if (self.max_threshold_user_config is None):
                                                                self.max_threshold_user_config = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig()
                                                                self.max_threshold_user_config.parent = self
                                                                self._children_name_map["max_threshold_user_config"] = "max-threshold-user-config"
                                                            return self.max_threshold_user_config

                                                        if (child_yang_name == "min-threshold"):
                                                            if (self.min_threshold is None):
                                                                self.min_threshold = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold()
                                                                self.min_threshold.parent = self
                                                                self._children_name_map["min_threshold"] = "min-threshold"
                                                            return self.min_threshold

                                                        if (child_yang_name == "min-threshold-user-config"):
                                                            if (self.min_threshold_user_config is None):
                                                                self.min_threshold_user_config = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig()
                                                                self.min_threshold_user_config.parent = self
                                                                self._children_name_map["min_threshold_user_config"] = "min-threshold-user-config"
                                                            return self.min_threshold_user_config

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "max-threshold" or name == "max-threshold-user-config" or name == "min-threshold" or name == "min-threshold-user-config" or name == "match"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "match"):
                                                            self.match = value
                                                            self.match.value_namespace = name_space
                                                            self.match.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.curve:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.curve_xr.is_set or
                                                        self.profile_id.is_set or
                                                        self.scaling_profile_id.is_set or
                                                        self.table_id.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    for c in self.curve:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.curve_xr.yfilter != YFilter.not_set or
                                                        self.profile_id.yfilter != YFilter.not_set or
                                                        self.scaling_profile_id.yfilter != YFilter.not_set or
                                                        self.table_id.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wred" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.curve_xr.is_set or self.curve_xr.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.curve_xr.get_name_leafdata())
                                                    if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_id.get_name_leafdata())
                                                    if (self.scaling_profile_id.is_set or self.scaling_profile_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.scaling_profile_id.get_name_leafdata())
                                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "curve"):
                                                        for c in self.curve:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.curve.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "curve" or name == "curve-xr" or name == "profile-id" or name == "scaling-profile-id" or name == "table-id" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "curve-xr"):
                                                        self.curve_xr = value
                                                        self.curve_xr.value_namespace = name_space
                                                        self.curve_xr.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-id"):
                                                        self.profile_id = value
                                                        self.profile_id.value_namespace = name_space
                                                        self.profile_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "scaling-profile-id"):
                                                        self.scaling_profile_id = value
                                                        self.scaling_profile_id.value_namespace = name_space
                                                        self.scaling_profile_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "table-id"):
                                                        self.table_id = value
                                                        self.table_id.value_namespace = name_space
                                                        self.table_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix


                                            class Mark(Entity):
                                                """
                                                Mark parameters
                                                
                                                .. attribute:: child_mark
                                                
                                                	Child mark only
                                                	**type**\:   :py:class:`ChildMark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark>`
                                                
                                                .. attribute:: parent_mark
                                                
                                                	Parent mark only
                                                	**type**\:   :py:class:`ParentMark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark>`
                                                
                                                .. attribute:: parent_police_conform
                                                
                                                	Parent police conform mark
                                                	**type**\:   :py:class:`ParentPoliceConform <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform>`
                                                
                                                .. attribute:: parent_police_exceed
                                                
                                                	Parent police exceed mark
                                                	**type**\:   :py:class:`ParentPoliceExceed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed>`
                                                
                                                .. attribute:: parent_police_violate
                                                
                                                	Parent police violate mark
                                                	**type**\:   :py:class:`ParentPoliceViolate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate>`
                                                
                                                .. attribute:: police_conform
                                                
                                                	Child police conform mark
                                                	**type**\:   :py:class:`PoliceConform <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform>`
                                                
                                                .. attribute:: police_exceed
                                                
                                                	Child police exceed mark
                                                	**type**\:   :py:class:`PoliceExceed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed>`
                                                
                                                .. attribute:: police_violate
                                                
                                                	Child police violate mark
                                                	**type**\:   :py:class:`PoliceViolate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate>`
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark, self).__init__()

                                                    self.yang_name = "mark"
                                                    self.yang_parent_name = "qos-show-ea-st-v1"

                                                    self.child_mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark()
                                                    self.child_mark.parent = self
                                                    self._children_name_map["child_mark"] = "child-mark"
                                                    self._children_yang_names.add("child-mark")

                                                    self.parent_mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark()
                                                    self.parent_mark.parent = self
                                                    self._children_name_map["parent_mark"] = "parent-mark"
                                                    self._children_yang_names.add("parent-mark")

                                                    self.parent_police_conform = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform()
                                                    self.parent_police_conform.parent = self
                                                    self._children_name_map["parent_police_conform"] = "parent-police-conform"
                                                    self._children_yang_names.add("parent-police-conform")

                                                    self.parent_police_exceed = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed()
                                                    self.parent_police_exceed.parent = self
                                                    self._children_name_map["parent_police_exceed"] = "parent-police-exceed"
                                                    self._children_yang_names.add("parent-police-exceed")

                                                    self.parent_police_violate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate()
                                                    self.parent_police_violate.parent = self
                                                    self._children_name_map["parent_police_violate"] = "parent-police-violate"
                                                    self._children_yang_names.add("parent-police-violate")

                                                    self.police_conform = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform()
                                                    self.police_conform.parent = self
                                                    self._children_name_map["police_conform"] = "police-conform"
                                                    self._children_yang_names.add("police-conform")

                                                    self.police_exceed = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed()
                                                    self.police_exceed.parent = self
                                                    self._children_name_map["police_exceed"] = "police-exceed"
                                                    self._children_yang_names.add("police-exceed")

                                                    self.police_violate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate()
                                                    self.police_violate.parent = self
                                                    self._children_name_map["police_violate"] = "police-violate"
                                                    self._children_yang_names.add("police-violate")


                                                class ChildMark(Entity):
                                                    """
                                                    Child mark only
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark, self).__init__()

                                                        self.yang_name = "child-mark"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "child-mark"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "child-mark" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class PoliceConform(Entity):
                                                    """
                                                    Child police conform mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform, self).__init__()

                                                        self.yang_name = "police-conform"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "police-conform"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-conform" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class PoliceExceed(Entity):
                                                    """
                                                    Child police exceed mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed, self).__init__()

                                                        self.yang_name = "police-exceed"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "police-exceed"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-exceed" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class PoliceViolate(Entity):
                                                    """
                                                    Child police violate mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate, self).__init__()

                                                        self.yang_name = "police-violate"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "police-violate"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-violate" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class ParentMark(Entity):
                                                    """
                                                    Parent mark only
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark, self).__init__()

                                                        self.yang_name = "parent-mark"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "parent-mark"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "parent-mark" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class ParentPoliceConform(Entity):
                                                    """
                                                    Parent police conform mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform, self).__init__()

                                                        self.yang_name = "parent-police-conform"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "parent-police-conform"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "parent-police-conform" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class ParentPoliceExceed(Entity):
                                                    """
                                                    Parent police exceed mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed, self).__init__()

                                                        self.yang_name = "parent-police-exceed"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "parent-police-exceed"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "parent-police-exceed" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class ParentPoliceViolate(Entity):
                                                    """
                                                    Parent police violate mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate, self).__init__()

                                                        self.yang_name = "parent-police-violate"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "parent-police-violate"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "parent-police-violate" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        (self.child_mark is not None and self.child_mark.has_data()) or
                                                        (self.parent_mark is not None and self.parent_mark.has_data()) or
                                                        (self.parent_police_conform is not None and self.parent_police_conform.has_data()) or
                                                        (self.parent_police_exceed is not None and self.parent_police_exceed.has_data()) or
                                                        (self.parent_police_violate is not None and self.parent_police_violate.has_data()) or
                                                        (self.police_conform is not None and self.police_conform.has_data()) or
                                                        (self.police_exceed is not None and self.police_exceed.has_data()) or
                                                        (self.police_violate is not None and self.police_violate.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.child_mark is not None and self.child_mark.has_operation()) or
                                                        (self.parent_mark is not None and self.parent_mark.has_operation()) or
                                                        (self.parent_police_conform is not None and self.parent_police_conform.has_operation()) or
                                                        (self.parent_police_exceed is not None and self.parent_police_exceed.has_operation()) or
                                                        (self.parent_police_violate is not None and self.parent_police_violate.has_operation()) or
                                                        (self.police_conform is not None and self.police_conform.has_operation()) or
                                                        (self.police_exceed is not None and self.police_exceed.has_operation()) or
                                                        (self.police_violate is not None and self.police_violate.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "child-mark"):
                                                        if (self.child_mark is None):
                                                            self.child_mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark()
                                                            self.child_mark.parent = self
                                                            self._children_name_map["child_mark"] = "child-mark"
                                                        return self.child_mark

                                                    if (child_yang_name == "parent-mark"):
                                                        if (self.parent_mark is None):
                                                            self.parent_mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark()
                                                            self.parent_mark.parent = self
                                                            self._children_name_map["parent_mark"] = "parent-mark"
                                                        return self.parent_mark

                                                    if (child_yang_name == "parent-police-conform"):
                                                        if (self.parent_police_conform is None):
                                                            self.parent_police_conform = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform()
                                                            self.parent_police_conform.parent = self
                                                            self._children_name_map["parent_police_conform"] = "parent-police-conform"
                                                        return self.parent_police_conform

                                                    if (child_yang_name == "parent-police-exceed"):
                                                        if (self.parent_police_exceed is None):
                                                            self.parent_police_exceed = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed()
                                                            self.parent_police_exceed.parent = self
                                                            self._children_name_map["parent_police_exceed"] = "parent-police-exceed"
                                                        return self.parent_police_exceed

                                                    if (child_yang_name == "parent-police-violate"):
                                                        if (self.parent_police_violate is None):
                                                            self.parent_police_violate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate()
                                                            self.parent_police_violate.parent = self
                                                            self._children_name_map["parent_police_violate"] = "parent-police-violate"
                                                        return self.parent_police_violate

                                                    if (child_yang_name == "police-conform"):
                                                        if (self.police_conform is None):
                                                            self.police_conform = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform()
                                                            self.police_conform.parent = self
                                                            self._children_name_map["police_conform"] = "police-conform"
                                                        return self.police_conform

                                                    if (child_yang_name == "police-exceed"):
                                                        if (self.police_exceed is None):
                                                            self.police_exceed = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed()
                                                            self.police_exceed.parent = self
                                                            self._children_name_map["police_exceed"] = "police-exceed"
                                                        return self.police_exceed

                                                    if (child_yang_name == "police-violate"):
                                                        if (self.police_violate is None):
                                                            self.police_violate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate()
                                                            self.police_violate.parent = self
                                                            self._children_name_map["police_violate"] = "police-violate"
                                                        return self.police_violate

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "child-mark" or name == "parent-mark" or name == "parent-police-conform" or name == "parent-police-exceed" or name == "parent-police-violate" or name == "police-conform" or name == "police-exceed" or name == "police-violate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass

                                            def has_data(self):
                                                return (
                                                    self.class_level.is_set or
                                                    self.class_name.is_set or
                                                    self.parent_class_name.is_set or
                                                    self.parent_policy_name.is_set or
                                                    self.policy_name.is_set or
                                                    (self.mark is not None and self.mark.has_data()) or
                                                    (self.police is not None and self.police.has_data()) or
                                                    (self.queue is not None and self.queue.has_data()) or
                                                    (self.queue_limit_parameters is not None and self.queue_limit_parameters.has_data()) or
                                                    (self.shape is not None and self.shape.has_data()) or
                                                    (self.wfq is not None and self.wfq.has_data()) or
                                                    (self.wred is not None and self.wred.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.class_level.yfilter != YFilter.not_set or
                                                    self.class_name.yfilter != YFilter.not_set or
                                                    self.parent_class_name.yfilter != YFilter.not_set or
                                                    self.parent_policy_name.yfilter != YFilter.not_set or
                                                    self.policy_name.yfilter != YFilter.not_set or
                                                    (self.mark is not None and self.mark.has_operation()) or
                                                    (self.police is not None and self.police.has_operation()) or
                                                    (self.queue is not None and self.queue.has_operation()) or
                                                    (self.queue_limit_parameters is not None and self.queue_limit_parameters.has_operation()) or
                                                    (self.shape is not None and self.shape.has_operation()) or
                                                    (self.wfq is not None and self.wfq.has_operation()) or
                                                    (self.wred is not None and self.wred.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "qos-show-ea-st-v1" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.class_level.is_set or self.class_level.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_level.get_name_leafdata())
                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                if (self.parent_class_name.is_set or self.parent_class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_class_name.get_name_leafdata())
                                                if (self.parent_policy_name.is_set or self.parent_policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_policy_name.get_name_leafdata())
                                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.policy_name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark"):
                                                    if (self.mark is None):
                                                        self.mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark()
                                                        self.mark.parent = self
                                                        self._children_name_map["mark"] = "mark"
                                                    return self.mark

                                                if (child_yang_name == "police"):
                                                    if (self.police is None):
                                                        self.police = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police()
                                                        self.police.parent = self
                                                        self._children_name_map["police"] = "police"
                                                    return self.police

                                                if (child_yang_name == "queue"):
                                                    if (self.queue is None):
                                                        self.queue = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Queue()
                                                        self.queue.parent = self
                                                        self._children_name_map["queue"] = "queue"
                                                    return self.queue

                                                if (child_yang_name == "queue-limit-parameters"):
                                                    if (self.queue_limit_parameters is None):
                                                        self.queue_limit_parameters = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters()
                                                        self.queue_limit_parameters.parent = self
                                                        self._children_name_map["queue_limit_parameters"] = "queue-limit-parameters"
                                                    return self.queue_limit_parameters

                                                if (child_yang_name == "shape"):
                                                    if (self.shape is None):
                                                        self.shape = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape()
                                                        self.shape.parent = self
                                                        self._children_name_map["shape"] = "shape"
                                                    return self.shape

                                                if (child_yang_name == "wfq"):
                                                    if (self.wfq is None):
                                                        self.wfq = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq()
                                                        self.wfq.parent = self
                                                        self._children_name_map["wfq"] = "wfq"
                                                    return self.wfq

                                                if (child_yang_name == "wred"):
                                                    if (self.wred is None):
                                                        self.wred = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred()
                                                        self.wred.parent = self
                                                        self._children_name_map["wred"] = "wred"
                                                    return self.wred

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark" or name == "police" or name == "queue" or name == "queue-limit-parameters" or name == "shape" or name == "wfq" or name == "wred" or name == "class-level" or name == "class-name" or name == "parent-class-name" or name == "parent-policy-name" or name == "policy-name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "class-level"):
                                                    self.class_level = value
                                                    self.class_level.value_namespace = name_space
                                                    self.class_level.value_namespace_prefix = name_space_prefix
                                                if(value_path == "class-name"):
                                                    self.class_name = value
                                                    self.class_name.value_namespace = name_space
                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-class-name"):
                                                    self.parent_class_name = value
                                                    self.parent_class_name.value_namespace = name_space
                                                    self.parent_class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-policy-name"):
                                                    self.parent_policy_name = value
                                                    self.parent_policy_name.value_namespace = name_space
                                                    self.parent_policy_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "policy-name"):
                                                    self.policy_name = value
                                                    self.policy_name.value_namespace = name_space
                                                    self.policy_name.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.qos_show_ea_st_v1:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.qos_show_ea_st_v1:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "qos-show-ea-st-v1"):
                                                for c in self.qos_show_ea_st_v1:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.qos_show_ea_st_v1.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "qos-show-ea-st-v1"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class PolicyTyphoon(Entity):
                                        """
                                        Typhoon QoS policy details
                                        
                                        .. attribute:: qos_show_ea_st_v2
                                        
                                        	qos show ea st v2
                                        	**type**\: list of    :py:class:`QosShowEaStV2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2>`
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon, self).__init__()

                                            self.yang_name = "policy-typhoon"
                                            self.yang_parent_name = "details"

                                            self.qos_show_ea_st_v2 = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon, self).__setattr__(name, value)


                                        class QosShowEaStV2(Entity):
                                            """
                                            qos show ea st v2
                                            
                                            .. attribute:: class_level
                                            
                                            	Class level
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: class_name
                                            
                                            	Class name
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: mark
                                            
                                            	Mark parameters
                                            	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark>`
                                            
                                            .. attribute:: parent_class_name
                                            
                                            	Parent class name
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: parent_policy_name
                                            
                                            	Parent policy name
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: police
                                            
                                            	Police parameters
                                            	**type**\:   :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police>`
                                            
                                            .. attribute:: policy_name
                                            
                                            	Policy name
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: queue
                                            
                                            	Queue parameters
                                            	**type**\:   :py:class:`Queue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Queue>`
                                            
                                            .. attribute:: queue_limit_parameters
                                            
                                            	Queue limit parameters
                                            	**type**\:   :py:class:`QueueLimitParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters>`
                                            
                                            .. attribute:: shape
                                            
                                            	Shape parameters
                                            	**type**\:   :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape>`
                                            
                                            .. attribute:: wfq
                                            
                                            	WFQ parameters
                                            	**type**\:   :py:class:`Wfq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq>`
                                            
                                            .. attribute:: wred
                                            
                                            	WRED parameters
                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2, self).__init__()

                                                self.yang_name = "qos-show-ea-st-v2"
                                                self.yang_parent_name = "policy-typhoon"

                                                self.class_level = YLeaf(YType.uint8, "class-level")

                                                self.class_name = YLeaf(YType.str, "class-name")

                                                self.parent_class_name = YLeaf(YType.str, "parent-class-name")

                                                self.parent_policy_name = YLeaf(YType.str, "parent-policy-name")

                                                self.policy_name = YLeaf(YType.str, "policy-name")

                                                self.mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark()
                                                self.mark.parent = self
                                                self._children_name_map["mark"] = "mark"
                                                self._children_yang_names.add("mark")

                                                self.police = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police()
                                                self.police.parent = self
                                                self._children_name_map["police"] = "police"
                                                self._children_yang_names.add("police")

                                                self.queue = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Queue()
                                                self.queue.parent = self
                                                self._children_name_map["queue"] = "queue"
                                                self._children_yang_names.add("queue")

                                                self.queue_limit_parameters = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters()
                                                self.queue_limit_parameters.parent = self
                                                self._children_name_map["queue_limit_parameters"] = "queue-limit-parameters"
                                                self._children_yang_names.add("queue-limit-parameters")

                                                self.shape = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape()
                                                self.shape.parent = self
                                                self._children_name_map["shape"] = "shape"
                                                self._children_yang_names.add("shape")

                                                self.wfq = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq()
                                                self.wfq.parent = self
                                                self._children_name_map["wfq"] = "wfq"
                                                self._children_yang_names.add("wfq")

                                                self.wred = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred()
                                                self.wred.parent = self
                                                self._children_name_map["wred"] = "wred"
                                                self._children_yang_names.add("wred")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("class_level",
                                                                "class_name",
                                                                "parent_class_name",
                                                                "parent_policy_name",
                                                                "policy_name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2, self).__setattr__(name, value)


                                            class Queue(Entity):
                                                """
                                                Queue parameters
                                                
                                                .. attribute:: class_name
                                                
                                                	Class name
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_type
                                                
                                                	Queue type
                                                	**type**\:   :py:class:`Queue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Queue>`
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Queue, self).__init__()

                                                    self.yang_name = "queue"
                                                    self.yang_parent_name = "qos-show-ea-st-v2"

                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                    self.queue_type = YLeaf(YType.enumeration, "queue-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("class_name",
                                                                    "queue_id",
                                                                    "queue_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Queue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Queue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.class_name.is_set or
                                                        self.queue_id.is_set or
                                                        self.queue_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.class_name.yfilter != YFilter.not_set or
                                                        self.queue_id.yfilter != YFilter.not_set or
                                                        self.queue_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                    if (self.queue_type.is_set or self.queue_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "class-name" or name == "queue-id" or name == "queue-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "class-name"):
                                                        self.class_name = value
                                                        self.class_name.value_namespace = name_space
                                                        self.class_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-id"):
                                                        self.queue_id = value
                                                        self.queue_id.value_namespace = name_space
                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-type"):
                                                        self.queue_type = value
                                                        self.queue_type.value_namespace = name_space
                                                        self.queue_type.value_namespace_prefix = name_space_prefix


                                            class QueueLimitParameters(Entity):
                                                """
                                                Queue limit parameters
                                                
                                                .. attribute:: absolute_index
                                                
                                                	Absolute Index
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: config_queue_limit
                                                
                                                	Config queue limit
                                                	**type**\:   :py:class:`ConfigQueueLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit>`
                                                
                                                .. attribute:: curve_id
                                                
                                                	Curve ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: queue_limit
                                                
                                                	Queue limit in kbytes
                                                	**type**\:   :py:class:`QueueLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit>`
                                                
                                                .. attribute:: template_id
                                                
                                                	Template ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters, self).__init__()

                                                    self.yang_name = "queue-limit-parameters"
                                                    self.yang_parent_name = "qos-show-ea-st-v2"

                                                    self.absolute_index = YLeaf(YType.uint16, "absolute-index")

                                                    self.curve_id = YLeaf(YType.uint16, "curve-id")

                                                    self.template_id = YLeaf(YType.uint16, "template-id")

                                                    self.config_queue_limit = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit()
                                                    self.config_queue_limit.parent = self
                                                    self._children_name_map["config_queue_limit"] = "config-queue-limit"
                                                    self._children_yang_names.add("config-queue-limit")

                                                    self.queue_limit = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit()
                                                    self.queue_limit.parent = self
                                                    self._children_name_map["queue_limit"] = "queue-limit"
                                                    self._children_yang_names.add("queue-limit")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("absolute_index",
                                                                    "curve_id",
                                                                    "template_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters, self).__setattr__(name, value)


                                                class QueueLimit(Entity):
                                                    """
                                                    Queue limit in kbytes
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit, self).__init__()

                                                        self.yang_name = "queue-limit"
                                                        self.yang_parent_name = "queue-limit-parameters"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-limit" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class ConfigQueueLimit(Entity):
                                                    """
                                                    Config queue limit
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit, self).__init__()

                                                        self.yang_name = "config-queue-limit"
                                                        self.yang_parent_name = "queue-limit-parameters"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "config-queue-limit" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.absolute_index.is_set or
                                                        self.curve_id.is_set or
                                                        self.template_id.is_set or
                                                        (self.config_queue_limit is not None and self.config_queue_limit.has_data()) or
                                                        (self.queue_limit is not None and self.queue_limit.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.absolute_index.yfilter != YFilter.not_set or
                                                        self.curve_id.yfilter != YFilter.not_set or
                                                        self.template_id.yfilter != YFilter.not_set or
                                                        (self.config_queue_limit is not None and self.config_queue_limit.has_operation()) or
                                                        (self.queue_limit is not None and self.queue_limit.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-limit-parameters" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.absolute_index.is_set or self.absolute_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.absolute_index.get_name_leafdata())
                                                    if (self.curve_id.is_set or self.curve_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.curve_id.get_name_leafdata())
                                                    if (self.template_id.is_set or self.template_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.template_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "config-queue-limit"):
                                                        if (self.config_queue_limit is None):
                                                            self.config_queue_limit = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit()
                                                            self.config_queue_limit.parent = self
                                                            self._children_name_map["config_queue_limit"] = "config-queue-limit"
                                                        return self.config_queue_limit

                                                    if (child_yang_name == "queue-limit"):
                                                        if (self.queue_limit is None):
                                                            self.queue_limit = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit()
                                                            self.queue_limit.parent = self
                                                            self._children_name_map["queue_limit"] = "queue-limit"
                                                        return self.queue_limit

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "config-queue-limit" or name == "queue-limit" or name == "absolute-index" or name == "curve-id" or name == "template-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "absolute-index"):
                                                        self.absolute_index = value
                                                        self.absolute_index.value_namespace = name_space
                                                        self.absolute_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "curve-id"):
                                                        self.curve_id = value
                                                        self.curve_id.value_namespace = name_space
                                                        self.curve_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "template-id"):
                                                        self.template_id = value
                                                        self.template_id.value_namespace = name_space
                                                        self.template_id.value_namespace_prefix = name_space_prefix


                                            class Shape(Entity):
                                                """
                                                Shape parameters
                                                
                                                .. attribute:: cir_shape
                                                
                                                	CIR shaper params
                                                	**type**\:   :py:class:`CirShape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape>`
                                                
                                                .. attribute:: cir_shape_type
                                                
                                                	CIR Shaper type
                                                	**type**\:   :py:class:`ShapeProfiletypeV2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ShapeProfiletypeV2>`
                                                
                                                .. attribute:: pir_shape
                                                
                                                	PIR shaper params
                                                	**type**\:   :py:class:`PirShape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape>`
                                                
                                                .. attribute:: pir_shape_type
                                                
                                                	PIR Shaper type
                                                	**type**\:   :py:class:`ShapeProfiletypeV2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ShapeProfiletypeV2>`
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape, self).__init__()

                                                    self.yang_name = "shape"
                                                    self.yang_parent_name = "qos-show-ea-st-v2"

                                                    self.cir_shape_type = YLeaf(YType.enumeration, "cir-shape-type")

                                                    self.pir_shape_type = YLeaf(YType.enumeration, "pir-shape-type")

                                                    self.cir_shape = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape()
                                                    self.cir_shape.parent = self
                                                    self._children_name_map["cir_shape"] = "cir-shape"
                                                    self._children_yang_names.add("cir-shape")

                                                    self.pir_shape = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape()
                                                    self.pir_shape.parent = self
                                                    self._children_name_map["pir_shape"] = "pir-shape"
                                                    self._children_yang_names.add("pir-shape")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("cir_shape_type",
                                                                    "pir_shape_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape, self).__setattr__(name, value)


                                                class CirShape(Entity):
                                                    """
                                                    CIR shaper params
                                                    
                                                    .. attribute:: cbs
                                                    
                                                    	CBS in bytes
                                                    	**type**\:   :py:class:`Cbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs>`
                                                    
                                                    .. attribute:: chunk_id
                                                    
                                                    	Shape Chunk ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: cir
                                                    
                                                    	CIR in kbps
                                                    	**type**\:   :py:class:`Cir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir>`
                                                    
                                                    .. attribute:: config_bandwidth
                                                    
                                                    	Config bandwidth
                                                    	**type**\:   :py:class:`ConfigBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth>`
                                                    
                                                    .. attribute:: profile_id
                                                    
                                                    	Shape profile ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: scale_factor
                                                    
                                                    	Scale Factor
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape, self).__init__()

                                                        self.yang_name = "cir-shape"
                                                        self.yang_parent_name = "shape"

                                                        self.chunk_id = YLeaf(YType.uint32, "chunk-id")

                                                        self.profile_id = YLeaf(YType.uint16, "profile-id")

                                                        self.scale_factor = YLeaf(YType.uint16, "scale-factor")

                                                        self.cbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs()
                                                        self.cbs.parent = self
                                                        self._children_name_map["cbs"] = "cbs"
                                                        self._children_yang_names.add("cbs")

                                                        self.cir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir()
                                                        self.cir.parent = self
                                                        self._children_name_map["cir"] = "cir"
                                                        self._children_yang_names.add("cir")

                                                        self.config_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth()
                                                        self.config_bandwidth.parent = self
                                                        self._children_name_map["config_bandwidth"] = "config-bandwidth"
                                                        self._children_yang_names.add("config-bandwidth")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("chunk_id",
                                                                        "profile_id",
                                                                        "scale_factor") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape, self).__setattr__(name, value)


                                                    class Cir(Entity):
                                                        """
                                                        CIR in kbps
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir, self).__init__()

                                                            self.yang_name = "cir"
                                                            self.yang_parent_name = "cir-shape"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "cir" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class ConfigBandwidth(Entity):
                                                        """
                                                        Config bandwidth
                                                        
                                                        .. attribute:: minimum_rate
                                                        
                                                        	Minimum bandwidth rate
                                                        	**type**\:   :py:class:`MinimumRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth, self).__init__()

                                                            self.yang_name = "config-bandwidth"
                                                            self.yang_parent_name = "cir-shape"

                                                            self.minimum_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate()
                                                            self.minimum_rate.parent = self
                                                            self._children_name_map["minimum_rate"] = "minimum-rate"
                                                            self._children_yang_names.add("minimum-rate")


                                                        class MinimumRate(Entity):
                                                            """
                                                            Minimum bandwidth rate
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	Config unit
                                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	Config value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'asr9k-qos-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate, self).__init__()

                                                                self.yang_name = "minimum-rate"
                                                                self.yang_parent_name = "config-bandwidth"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "minimum-rate" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (self.minimum_rate is not None and self.minimum_rate.has_data())

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                (self.minimum_rate is not None and self.minimum_rate.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "config-bandwidth" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "minimum-rate"):
                                                                if (self.minimum_rate is None):
                                                                    self.minimum_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate()
                                                                    self.minimum_rate.parent = self
                                                                    self._children_name_map["minimum_rate"] = "minimum-rate"
                                                                return self.minimum_rate

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "minimum-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass


                                                    class Cbs(Entity):
                                                        """
                                                        CBS in bytes
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs, self).__init__()

                                                            self.yang_name = "cbs"
                                                            self.yang_parent_name = "cir-shape"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "cbs" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.chunk_id.is_set or
                                                            self.profile_id.is_set or
                                                            self.scale_factor.is_set or
                                                            (self.cbs is not None and self.cbs.has_data()) or
                                                            (self.cir is not None and self.cir.has_data()) or
                                                            (self.config_bandwidth is not None and self.config_bandwidth.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.chunk_id.yfilter != YFilter.not_set or
                                                            self.profile_id.yfilter != YFilter.not_set or
                                                            self.scale_factor.yfilter != YFilter.not_set or
                                                            (self.cbs is not None and self.cbs.has_operation()) or
                                                            (self.cir is not None and self.cir.has_operation()) or
                                                            (self.config_bandwidth is not None and self.config_bandwidth.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cir-shape" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.chunk_id.is_set or self.chunk_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.chunk_id.get_name_leafdata())
                                                        if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.profile_id.get_name_leafdata())
                                                        if (self.scale_factor.is_set or self.scale_factor.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.scale_factor.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "cbs"):
                                                            if (self.cbs is None):
                                                                self.cbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs()
                                                                self.cbs.parent = self
                                                                self._children_name_map["cbs"] = "cbs"
                                                            return self.cbs

                                                        if (child_yang_name == "cir"):
                                                            if (self.cir is None):
                                                                self.cir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir()
                                                                self.cir.parent = self
                                                                self._children_name_map["cir"] = "cir"
                                                            return self.cir

                                                        if (child_yang_name == "config-bandwidth"):
                                                            if (self.config_bandwidth is None):
                                                                self.config_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth()
                                                                self.config_bandwidth.parent = self
                                                                self._children_name_map["config_bandwidth"] = "config-bandwidth"
                                                            return self.config_bandwidth

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "cbs" or name == "cir" or name == "config-bandwidth" or name == "chunk-id" or name == "profile-id" or name == "scale-factor"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "chunk-id"):
                                                            self.chunk_id = value
                                                            self.chunk_id.value_namespace = name_space
                                                            self.chunk_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "profile-id"):
                                                            self.profile_id = value
                                                            self.profile_id.value_namespace = name_space
                                                            self.profile_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "scale-factor"):
                                                            self.scale_factor = value
                                                            self.scale_factor.value_namespace = name_space
                                                            self.scale_factor.value_namespace_prefix = name_space_prefix


                                                class PirShape(Entity):
                                                    """
                                                    PIR shaper params
                                                    
                                                    .. attribute:: chunk_id
                                                    
                                                    	Shape Chunk ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: pbs
                                                    
                                                    	PBS in bytes
                                                    	**type**\:   :py:class:`Pbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs>`
                                                    
                                                    .. attribute:: pir
                                                    
                                                    	PIR in kbps
                                                    	**type**\:   :py:class:`Pir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir>`
                                                    
                                                    .. attribute:: profile_id
                                                    
                                                    	Shape profile ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: scale_factor
                                                    
                                                    	Scale Factor
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape, self).__init__()

                                                        self.yang_name = "pir-shape"
                                                        self.yang_parent_name = "shape"

                                                        self.chunk_id = YLeaf(YType.uint32, "chunk-id")

                                                        self.profile_id = YLeaf(YType.uint16, "profile-id")

                                                        self.scale_factor = YLeaf(YType.uint16, "scale-factor")

                                                        self.pbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs()
                                                        self.pbs.parent = self
                                                        self._children_name_map["pbs"] = "pbs"
                                                        self._children_yang_names.add("pbs")

                                                        self.pir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir()
                                                        self.pir.parent = self
                                                        self._children_name_map["pir"] = "pir"
                                                        self._children_yang_names.add("pir")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("chunk_id",
                                                                        "profile_id",
                                                                        "scale_factor") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape, self).__setattr__(name, value)


                                                    class Pir(Entity):
                                                        """
                                                        PIR in kbps
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir, self).__init__()

                                                            self.yang_name = "pir"
                                                            self.yang_parent_name = "pir-shape"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "pir" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class Pbs(Entity):
                                                        """
                                                        PBS in bytes
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs, self).__init__()

                                                            self.yang_name = "pbs"
                                                            self.yang_parent_name = "pir-shape"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "pbs" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.chunk_id.is_set or
                                                            self.profile_id.is_set or
                                                            self.scale_factor.is_set or
                                                            (self.pbs is not None and self.pbs.has_data()) or
                                                            (self.pir is not None and self.pir.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.chunk_id.yfilter != YFilter.not_set or
                                                            self.profile_id.yfilter != YFilter.not_set or
                                                            self.scale_factor.yfilter != YFilter.not_set or
                                                            (self.pbs is not None and self.pbs.has_operation()) or
                                                            (self.pir is not None and self.pir.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "pir-shape" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.chunk_id.is_set or self.chunk_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.chunk_id.get_name_leafdata())
                                                        if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.profile_id.get_name_leafdata())
                                                        if (self.scale_factor.is_set or self.scale_factor.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.scale_factor.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "pbs"):
                                                            if (self.pbs is None):
                                                                self.pbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs()
                                                                self.pbs.parent = self
                                                                self._children_name_map["pbs"] = "pbs"
                                                            return self.pbs

                                                        if (child_yang_name == "pir"):
                                                            if (self.pir is None):
                                                                self.pir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir()
                                                                self.pir.parent = self
                                                                self._children_name_map["pir"] = "pir"
                                                            return self.pir

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "pbs" or name == "pir" or name == "chunk-id" or name == "profile-id" or name == "scale-factor"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "chunk-id"):
                                                            self.chunk_id = value
                                                            self.chunk_id.value_namespace = name_space
                                                            self.chunk_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "profile-id"):
                                                            self.profile_id = value
                                                            self.profile_id.value_namespace = name_space
                                                            self.profile_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "scale-factor"):
                                                            self.scale_factor = value
                                                            self.scale_factor.value_namespace = name_space
                                                            self.scale_factor.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.cir_shape_type.is_set or
                                                        self.pir_shape_type.is_set or
                                                        (self.cir_shape is not None and self.cir_shape.has_data()) or
                                                        (self.pir_shape is not None and self.pir_shape.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.cir_shape_type.yfilter != YFilter.not_set or
                                                        self.pir_shape_type.yfilter != YFilter.not_set or
                                                        (self.cir_shape is not None and self.cir_shape.has_operation()) or
                                                        (self.pir_shape is not None and self.pir_shape.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "shape" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.cir_shape_type.is_set or self.cir_shape_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.cir_shape_type.get_name_leafdata())
                                                    if (self.pir_shape_type.is_set or self.pir_shape_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pir_shape_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "cir-shape"):
                                                        if (self.cir_shape is None):
                                                            self.cir_shape = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape()
                                                            self.cir_shape.parent = self
                                                            self._children_name_map["cir_shape"] = "cir-shape"
                                                        return self.cir_shape

                                                    if (child_yang_name == "pir-shape"):
                                                        if (self.pir_shape is None):
                                                            self.pir_shape = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape()
                                                            self.pir_shape.parent = self
                                                            self._children_name_map["pir_shape"] = "pir-shape"
                                                        return self.pir_shape

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "cir-shape" or name == "pir-shape" or name == "cir-shape-type" or name == "pir-shape-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "cir-shape-type"):
                                                        self.cir_shape_type = value
                                                        self.cir_shape_type.value_namespace = name_space
                                                        self.cir_shape_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pir-shape-type"):
                                                        self.pir_shape_type = value
                                                        self.pir_shape_type.value_namespace = name_space
                                                        self.pir_shape_type.value_namespace_prefix = name_space_prefix


                                            class Police(Entity):
                                                """
                                                Police parameters
                                                
                                                .. attribute:: cbs
                                                
                                                	CBS
                                                	**type**\:   :py:class:`Cbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs>`
                                                
                                                .. attribute:: cir
                                                
                                                	CIR
                                                	**type**\:   :py:class:`Cir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir>`
                                                
                                                .. attribute:: pbs
                                                
                                                	PBS
                                                	**type**\:   :py:class:`Pbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs>`
                                                
                                                .. attribute:: pir
                                                
                                                	PIR
                                                	**type**\:   :py:class:`Pir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir>`
                                                
                                                .. attribute:: police_config_parameters
                                                
                                                	Police config parameters
                                                	**type**\:   :py:class:`PoliceConfigParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters>`
                                                
                                                .. attribute:: policer_type
                                                
                                                	Policer type
                                                	**type**\:   :py:class:`TbAlgorithm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.TbAlgorithm>`
                                                
                                                .. attribute:: profile_id
                                                
                                                	Police profile ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police, self).__init__()

                                                    self.yang_name = "police"
                                                    self.yang_parent_name = "qos-show-ea-st-v2"

                                                    self.policer_type = YLeaf(YType.enumeration, "policer-type")

                                                    self.profile_id = YLeaf(YType.uint32, "profile-id")

                                                    self.cbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs()
                                                    self.cbs.parent = self
                                                    self._children_name_map["cbs"] = "cbs"
                                                    self._children_yang_names.add("cbs")

                                                    self.cir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir()
                                                    self.cir.parent = self
                                                    self._children_name_map["cir"] = "cir"
                                                    self._children_yang_names.add("cir")

                                                    self.pbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs()
                                                    self.pbs.parent = self
                                                    self._children_name_map["pbs"] = "pbs"
                                                    self._children_yang_names.add("pbs")

                                                    self.pir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir()
                                                    self.pir.parent = self
                                                    self._children_name_map["pir"] = "pir"
                                                    self._children_yang_names.add("pir")

                                                    self.police_config_parameters = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters()
                                                    self.police_config_parameters.parent = self
                                                    self._children_name_map["police_config_parameters"] = "police-config-parameters"
                                                    self._children_yang_names.add("police-config-parameters")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("policer_type",
                                                                    "profile_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police, self).__setattr__(name, value)


                                                class Cir(Entity):
                                                    """
                                                    CIR
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir, self).__init__()

                                                        self.yang_name = "cir"
                                                        self.yang_parent_name = "police"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cir" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class Cbs(Entity):
                                                    """
                                                    CBS
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs, self).__init__()

                                                        self.yang_name = "cbs"
                                                        self.yang_parent_name = "police"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cbs" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class Pir(Entity):
                                                    """
                                                    PIR
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir, self).__init__()

                                                        self.yang_name = "pir"
                                                        self.yang_parent_name = "police"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "pir" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class Pbs(Entity):
                                                    """
                                                    PBS
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs, self).__init__()

                                                        self.yang_name = "pbs"
                                                        self.yang_parent_name = "police"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "pbs" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class PoliceConfigParameters(Entity):
                                                    """
                                                    Police config parameters
                                                    
                                                    .. attribute:: average_rate
                                                    
                                                    	Average rate
                                                    	**type**\:   :py:class:`AverageRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate>`
                                                    
                                                    .. attribute:: conform_burst
                                                    
                                                    	Conform burst
                                                    	**type**\:   :py:class:`ConformBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst>`
                                                    
                                                    .. attribute:: exceed_burst
                                                    
                                                    	Exceed burst
                                                    	**type**\:   :py:class:`ExceedBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst>`
                                                    
                                                    .. attribute:: peak_rate
                                                    
                                                    	Peak rate
                                                    	**type**\:   :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters, self).__init__()

                                                        self.yang_name = "police-config-parameters"
                                                        self.yang_parent_name = "police"

                                                        self.average_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate()
                                                        self.average_rate.parent = self
                                                        self._children_name_map["average_rate"] = "average-rate"
                                                        self._children_yang_names.add("average-rate")

                                                        self.conform_burst = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst()
                                                        self.conform_burst.parent = self
                                                        self._children_name_map["conform_burst"] = "conform-burst"
                                                        self._children_yang_names.add("conform-burst")

                                                        self.exceed_burst = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst()
                                                        self.exceed_burst.parent = self
                                                        self._children_name_map["exceed_burst"] = "exceed-burst"
                                                        self._children_yang_names.add("exceed-burst")

                                                        self.peak_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate()
                                                        self.peak_rate.parent = self
                                                        self._children_name_map["peak_rate"] = "peak-rate"
                                                        self._children_yang_names.add("peak-rate")


                                                    class AverageRate(Entity):
                                                        """
                                                        Average rate
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate, self).__init__()

                                                            self.yang_name = "average-rate"
                                                            self.yang_parent_name = "police-config-parameters"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "average-rate" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class PeakRate(Entity):
                                                        """
                                                        Peak rate
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate, self).__init__()

                                                            self.yang_name = "peak-rate"
                                                            self.yang_parent_name = "police-config-parameters"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "peak-rate" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class ConformBurst(Entity):
                                                        """
                                                        Conform burst
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst, self).__init__()

                                                            self.yang_name = "conform-burst"
                                                            self.yang_parent_name = "police-config-parameters"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "conform-burst" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class ExceedBurst(Entity):
                                                        """
                                                        Exceed burst
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst, self).__init__()

                                                            self.yang_name = "exceed-burst"
                                                            self.yang_parent_name = "police-config-parameters"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "exceed-burst" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            (self.average_rate is not None and self.average_rate.has_data()) or
                                                            (self.conform_burst is not None and self.conform_burst.has_data()) or
                                                            (self.exceed_burst is not None and self.exceed_burst.has_data()) or
                                                            (self.peak_rate is not None and self.peak_rate.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            (self.average_rate is not None and self.average_rate.has_operation()) or
                                                            (self.conform_burst is not None and self.conform_burst.has_operation()) or
                                                            (self.exceed_burst is not None and self.exceed_burst.has_operation()) or
                                                            (self.peak_rate is not None and self.peak_rate.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-config-parameters" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "average-rate"):
                                                            if (self.average_rate is None):
                                                                self.average_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate()
                                                                self.average_rate.parent = self
                                                                self._children_name_map["average_rate"] = "average-rate"
                                                            return self.average_rate

                                                        if (child_yang_name == "conform-burst"):
                                                            if (self.conform_burst is None):
                                                                self.conform_burst = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst()
                                                                self.conform_burst.parent = self
                                                                self._children_name_map["conform_burst"] = "conform-burst"
                                                            return self.conform_burst

                                                        if (child_yang_name == "exceed-burst"):
                                                            if (self.exceed_burst is None):
                                                                self.exceed_burst = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst()
                                                                self.exceed_burst.parent = self
                                                                self._children_name_map["exceed_burst"] = "exceed-burst"
                                                            return self.exceed_burst

                                                        if (child_yang_name == "peak-rate"):
                                                            if (self.peak_rate is None):
                                                                self.peak_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate()
                                                                self.peak_rate.parent = self
                                                                self._children_name_map["peak_rate"] = "peak-rate"
                                                            return self.peak_rate

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "average-rate" or name == "conform-burst" or name == "exceed-burst" or name == "peak-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        pass

                                                def has_data(self):
                                                    return (
                                                        self.policer_type.is_set or
                                                        self.profile_id.is_set or
                                                        (self.cbs is not None and self.cbs.has_data()) or
                                                        (self.cir is not None and self.cir.has_data()) or
                                                        (self.pbs is not None and self.pbs.has_data()) or
                                                        (self.pir is not None and self.pir.has_data()) or
                                                        (self.police_config_parameters is not None and self.police_config_parameters.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.policer_type.yfilter != YFilter.not_set or
                                                        self.profile_id.yfilter != YFilter.not_set or
                                                        (self.cbs is not None and self.cbs.has_operation()) or
                                                        (self.cir is not None and self.cir.has_operation()) or
                                                        (self.pbs is not None and self.pbs.has_operation()) or
                                                        (self.pir is not None and self.pir.has_operation()) or
                                                        (self.police_config_parameters is not None and self.police_config_parameters.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "police" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.policer_type.is_set or self.policer_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.policer_type.get_name_leafdata())
                                                    if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "cbs"):
                                                        if (self.cbs is None):
                                                            self.cbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs()
                                                            self.cbs.parent = self
                                                            self._children_name_map["cbs"] = "cbs"
                                                        return self.cbs

                                                    if (child_yang_name == "cir"):
                                                        if (self.cir is None):
                                                            self.cir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir()
                                                            self.cir.parent = self
                                                            self._children_name_map["cir"] = "cir"
                                                        return self.cir

                                                    if (child_yang_name == "pbs"):
                                                        if (self.pbs is None):
                                                            self.pbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs()
                                                            self.pbs.parent = self
                                                            self._children_name_map["pbs"] = "pbs"
                                                        return self.pbs

                                                    if (child_yang_name == "pir"):
                                                        if (self.pir is None):
                                                            self.pir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir()
                                                            self.pir.parent = self
                                                            self._children_name_map["pir"] = "pir"
                                                        return self.pir

                                                    if (child_yang_name == "police-config-parameters"):
                                                        if (self.police_config_parameters is None):
                                                            self.police_config_parameters = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters()
                                                            self.police_config_parameters.parent = self
                                                            self._children_name_map["police_config_parameters"] = "police-config-parameters"
                                                        return self.police_config_parameters

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "cbs" or name == "cir" or name == "pbs" or name == "pir" or name == "police-config-parameters" or name == "policer-type" or name == "profile-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "policer-type"):
                                                        self.policer_type = value
                                                        self.policer_type.value_namespace = name_space
                                                        self.policer_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-id"):
                                                        self.profile_id = value
                                                        self.profile_id.value_namespace = name_space
                                                        self.profile_id.value_namespace_prefix = name_space_prefix


                                            class Wfq(Entity):
                                                """
                                                WFQ parameters
                                                
                                                .. attribute:: bandwidth
                                                
                                                	CFG Bandwidth
                                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth>`
                                                
                                                .. attribute:: chunk_id
                                                
                                                	Chunk ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: committed_weight
                                                
                                                	Committed weight
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: excess_ratio
                                                
                                                	Parent Excess ratio
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: excess_weight
                                                
                                                	Excess weight
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: level
                                                
                                                	Level
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: parent_bandwidth
                                                
                                                	Parent bandwidth
                                                	**type**\:   :py:class:`ParentBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth>`
                                                
                                                .. attribute:: profile_id
                                                
                                                	WFQ profile
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq, self).__init__()

                                                    self.yang_name = "wfq"
                                                    self.yang_parent_name = "qos-show-ea-st-v2"

                                                    self.chunk_id = YLeaf(YType.uint32, "chunk-id")

                                                    self.committed_weight = YLeaf(YType.uint32, "committed-weight")

                                                    self.excess_ratio = YLeaf(YType.uint16, "excess-ratio")

                                                    self.excess_weight = YLeaf(YType.uint16, "excess-weight")

                                                    self.level = YLeaf(YType.uint8, "level")

                                                    self.profile_id = YLeaf(YType.uint32, "profile-id")

                                                    self.bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth()
                                                    self.bandwidth.parent = self
                                                    self._children_name_map["bandwidth"] = "bandwidth"
                                                    self._children_yang_names.add("bandwidth")

                                                    self.parent_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth()
                                                    self.parent_bandwidth.parent = self
                                                    self._children_name_map["parent_bandwidth"] = "parent-bandwidth"
                                                    self._children_yang_names.add("parent-bandwidth")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("chunk_id",
                                                                    "committed_weight",
                                                                    "excess_ratio",
                                                                    "excess_weight",
                                                                    "level",
                                                                    "profile_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq, self).__setattr__(name, value)


                                                class ParentBandwidth(Entity):
                                                    """
                                                    Parent bandwidth
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth, self).__init__()

                                                        self.yang_name = "parent-bandwidth"
                                                        self.yang_parent_name = "wfq"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "parent-bandwidth" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class Bandwidth(Entity):
                                                    """
                                                    CFG Bandwidth
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth, self).__init__()

                                                        self.yang_name = "bandwidth"
                                                        self.yang_parent_name = "wfq"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "bandwidth" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.chunk_id.is_set or
                                                        self.committed_weight.is_set or
                                                        self.excess_ratio.is_set or
                                                        self.excess_weight.is_set or
                                                        self.level.is_set or
                                                        self.profile_id.is_set or
                                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                                        (self.parent_bandwidth is not None and self.parent_bandwidth.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.chunk_id.yfilter != YFilter.not_set or
                                                        self.committed_weight.yfilter != YFilter.not_set or
                                                        self.excess_ratio.yfilter != YFilter.not_set or
                                                        self.excess_weight.yfilter != YFilter.not_set or
                                                        self.level.yfilter != YFilter.not_set or
                                                        self.profile_id.yfilter != YFilter.not_set or
                                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                                        (self.parent_bandwidth is not None and self.parent_bandwidth.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wfq" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.chunk_id.is_set or self.chunk_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.chunk_id.get_name_leafdata())
                                                    if (self.committed_weight.is_set or self.committed_weight.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.committed_weight.get_name_leafdata())
                                                    if (self.excess_ratio.is_set or self.excess_ratio.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.excess_ratio.get_name_leafdata())
                                                    if (self.excess_weight.is_set or self.excess_weight.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.excess_weight.get_name_leafdata())
                                                    if (self.level.is_set or self.level.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.level.get_name_leafdata())
                                                    if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "bandwidth"):
                                                        if (self.bandwidth is None):
                                                            self.bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth()
                                                            self.bandwidth.parent = self
                                                            self._children_name_map["bandwidth"] = "bandwidth"
                                                        return self.bandwidth

                                                    if (child_yang_name == "parent-bandwidth"):
                                                        if (self.parent_bandwidth is None):
                                                            self.parent_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth()
                                                            self.parent_bandwidth.parent = self
                                                            self._children_name_map["parent_bandwidth"] = "parent-bandwidth"
                                                        return self.parent_bandwidth

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "bandwidth" or name == "parent-bandwidth" or name == "chunk-id" or name == "committed-weight" or name == "excess-ratio" or name == "excess-weight" or name == "level" or name == "profile-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "chunk-id"):
                                                        self.chunk_id = value
                                                        self.chunk_id.value_namespace = name_space
                                                        self.chunk_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "committed-weight"):
                                                        self.committed_weight = value
                                                        self.committed_weight.value_namespace = name_space
                                                        self.committed_weight.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "excess-ratio"):
                                                        self.excess_ratio = value
                                                        self.excess_ratio.value_namespace = name_space
                                                        self.excess_ratio.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "excess-weight"):
                                                        self.excess_weight = value
                                                        self.excess_weight.value_namespace = name_space
                                                        self.excess_weight.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "level"):
                                                        self.level = value
                                                        self.level.value_namespace = name_space
                                                        self.level.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-id"):
                                                        self.profile_id = value
                                                        self.profile_id.value_namespace = name_space
                                                        self.profile_id.value_namespace_prefix = name_space_prefix


                                            class Wred(Entity):
                                                """
                                                WRED parameters
                                                
                                                .. attribute:: curve
                                                
                                                	Curve details
                                                	**type**\: list of    :py:class:`Curve <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve>`
                                                
                                                .. attribute:: curve_xr
                                                
                                                	Number of curves
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: type
                                                
                                                	WRED type
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred, self).__init__()

                                                    self.yang_name = "wred"
                                                    self.yang_parent_name = "qos-show-ea-st-v2"

                                                    self.curve_xr = YLeaf(YType.uint16, "curve-xr")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.curve = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("curve_xr",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred, self).__setattr__(name, value)


                                                class Curve(Entity):
                                                    """
                                                    Curve details
                                                    
                                                    .. attribute:: absolute_index
                                                    
                                                    	Absolute Index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: curve_id
                                                    
                                                    	Curve ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: exp_match
                                                    
                                                    	WRED exp match if EXP start value equals to end value Format\: <start\-value> , else range Format\: <start\-value> <end\-value>
                                                    	**type**\:  str
                                                    
                                                    .. attribute:: match
                                                    
                                                    	WRED match if precedence start value equals to end value Format\: <start\-value> , else range Format\: <start\-value> <end\-value>
                                                    	**type**\:  str
                                                    
                                                    .. attribute:: max_threshold
                                                    
                                                    	Maximum threshold
                                                    	**type**\:   :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold>`
                                                    
                                                    .. attribute:: max_threshold_user_config
                                                    
                                                    	Maximum threshold WRED context
                                                    	**type**\:   :py:class:`MaxThresholdUserConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig>`
                                                    
                                                    .. attribute:: min_threshold
                                                    
                                                    	Minimum threshold
                                                    	**type**\:   :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold>`
                                                    
                                                    .. attribute:: min_threshold_user_config
                                                    
                                                    	Minimum threshold WRED context
                                                    	**type**\:   :py:class:`MinThresholdUserConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig>`
                                                    
                                                    .. attribute:: template_id
                                                    
                                                    	Template ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve, self).__init__()

                                                        self.yang_name = "curve"
                                                        self.yang_parent_name = "wred"

                                                        self.absolute_index = YLeaf(YType.uint16, "absolute-index")

                                                        self.curve_id = YLeaf(YType.uint16, "curve-id")

                                                        self.exp_match = YLeaf(YType.str, "exp-match")

                                                        self.match = YLeaf(YType.str, "match")

                                                        self.template_id = YLeaf(YType.uint16, "template-id")

                                                        self.max_threshold = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold()
                                                        self.max_threshold.parent = self
                                                        self._children_name_map["max_threshold"] = "max-threshold"
                                                        self._children_yang_names.add("max-threshold")

                                                        self.max_threshold_user_config = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig()
                                                        self.max_threshold_user_config.parent = self
                                                        self._children_name_map["max_threshold_user_config"] = "max-threshold-user-config"
                                                        self._children_yang_names.add("max-threshold-user-config")

                                                        self.min_threshold = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold()
                                                        self.min_threshold.parent = self
                                                        self._children_name_map["min_threshold"] = "min-threshold"
                                                        self._children_yang_names.add("min-threshold")

                                                        self.min_threshold_user_config = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig()
                                                        self.min_threshold_user_config.parent = self
                                                        self._children_name_map["min_threshold_user_config"] = "min-threshold-user-config"
                                                        self._children_yang_names.add("min-threshold-user-config")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("absolute_index",
                                                                        "curve_id",
                                                                        "exp_match",
                                                                        "match",
                                                                        "template_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve, self).__setattr__(name, value)


                                                    class MinThreshold(Entity):
                                                        """
                                                        Minimum threshold
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold, self).__init__()

                                                            self.yang_name = "min-threshold"
                                                            self.yang_parent_name = "curve"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "min-threshold" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class MinThresholdUserConfig(Entity):
                                                        """
                                                        Minimum threshold WRED context
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig, self).__init__()

                                                            self.yang_name = "min-threshold-user-config"
                                                            self.yang_parent_name = "curve"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "min-threshold-user-config" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class MaxThreshold(Entity):
                                                        """
                                                        Maximum threshold
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold, self).__init__()

                                                            self.yang_name = "max-threshold"
                                                            self.yang_parent_name = "curve"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "max-threshold" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class MaxThresholdUserConfig(Entity):
                                                        """
                                                        Maximum threshold WRED context
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig, self).__init__()

                                                            self.yang_name = "max-threshold-user-config"
                                                            self.yang_parent_name = "curve"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "max-threshold-user-config" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.absolute_index.is_set or
                                                            self.curve_id.is_set or
                                                            self.exp_match.is_set or
                                                            self.match.is_set or
                                                            self.template_id.is_set or
                                                            (self.max_threshold is not None and self.max_threshold.has_data()) or
                                                            (self.max_threshold_user_config is not None and self.max_threshold_user_config.has_data()) or
                                                            (self.min_threshold is not None and self.min_threshold.has_data()) or
                                                            (self.min_threshold_user_config is not None and self.min_threshold_user_config.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.absolute_index.yfilter != YFilter.not_set or
                                                            self.curve_id.yfilter != YFilter.not_set or
                                                            self.exp_match.yfilter != YFilter.not_set or
                                                            self.match.yfilter != YFilter.not_set or
                                                            self.template_id.yfilter != YFilter.not_set or
                                                            (self.max_threshold is not None and self.max_threshold.has_operation()) or
                                                            (self.max_threshold_user_config is not None and self.max_threshold_user_config.has_operation()) or
                                                            (self.min_threshold is not None and self.min_threshold.has_operation()) or
                                                            (self.min_threshold_user_config is not None and self.min_threshold_user_config.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "curve" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.absolute_index.is_set or self.absolute_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.absolute_index.get_name_leafdata())
                                                        if (self.curve_id.is_set or self.curve_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.curve_id.get_name_leafdata())
                                                        if (self.exp_match.is_set or self.exp_match.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exp_match.get_name_leafdata())
                                                        if (self.match.is_set or self.match.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.match.get_name_leafdata())
                                                        if (self.template_id.is_set or self.template_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.template_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "max-threshold"):
                                                            if (self.max_threshold is None):
                                                                self.max_threshold = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold()
                                                                self.max_threshold.parent = self
                                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                            return self.max_threshold

                                                        if (child_yang_name == "max-threshold-user-config"):
                                                            if (self.max_threshold_user_config is None):
                                                                self.max_threshold_user_config = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig()
                                                                self.max_threshold_user_config.parent = self
                                                                self._children_name_map["max_threshold_user_config"] = "max-threshold-user-config"
                                                            return self.max_threshold_user_config

                                                        if (child_yang_name == "min-threshold"):
                                                            if (self.min_threshold is None):
                                                                self.min_threshold = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold()
                                                                self.min_threshold.parent = self
                                                                self._children_name_map["min_threshold"] = "min-threshold"
                                                            return self.min_threshold

                                                        if (child_yang_name == "min-threshold-user-config"):
                                                            if (self.min_threshold_user_config is None):
                                                                self.min_threshold_user_config = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig()
                                                                self.min_threshold_user_config.parent = self
                                                                self._children_name_map["min_threshold_user_config"] = "min-threshold-user-config"
                                                            return self.min_threshold_user_config

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "max-threshold" or name == "max-threshold-user-config" or name == "min-threshold" or name == "min-threshold-user-config" or name == "absolute-index" or name == "curve-id" or name == "exp-match" or name == "match" or name == "template-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "absolute-index"):
                                                            self.absolute_index = value
                                                            self.absolute_index.value_namespace = name_space
                                                            self.absolute_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "curve-id"):
                                                            self.curve_id = value
                                                            self.curve_id.value_namespace = name_space
                                                            self.curve_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exp-match"):
                                                            self.exp_match = value
                                                            self.exp_match.value_namespace = name_space
                                                            self.exp_match.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "match"):
                                                            self.match = value
                                                            self.match.value_namespace = name_space
                                                            self.match.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "template-id"):
                                                            self.template_id = value
                                                            self.template_id.value_namespace = name_space
                                                            self.template_id.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.curve:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.curve_xr.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    for c in self.curve:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.curve_xr.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wred" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.curve_xr.is_set or self.curve_xr.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.curve_xr.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "curve"):
                                                        for c in self.curve:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.curve.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "curve" or name == "curve-xr" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "curve-xr"):
                                                        self.curve_xr = value
                                                        self.curve_xr.value_namespace = name_space
                                                        self.curve_xr.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix


                                            class Mark(Entity):
                                                """
                                                Mark parameters
                                                
                                                .. attribute:: child_mark
                                                
                                                	Child mark only
                                                	**type**\:   :py:class:`ChildMark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark>`
                                                
                                                .. attribute:: parent_mark
                                                
                                                	Parent mark only
                                                	**type**\:   :py:class:`ParentMark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark>`
                                                
                                                .. attribute:: parent_police_conform
                                                
                                                	Parent police conform mark
                                                	**type**\:   :py:class:`ParentPoliceConform <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform>`
                                                
                                                .. attribute:: parent_police_exceed
                                                
                                                	Parent police exceed mark
                                                	**type**\:   :py:class:`ParentPoliceExceed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed>`
                                                
                                                .. attribute:: parent_police_violate
                                                
                                                	Parent police violate mark
                                                	**type**\:   :py:class:`ParentPoliceViolate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate>`
                                                
                                                .. attribute:: police_conform
                                                
                                                	Child police conform mark
                                                	**type**\:   :py:class:`PoliceConform <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform>`
                                                
                                                .. attribute:: police_exceed
                                                
                                                	Child police exceed mark
                                                	**type**\:   :py:class:`PoliceExceed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed>`
                                                
                                                .. attribute:: police_violate
                                                
                                                	Child police violate mark
                                                	**type**\:   :py:class:`PoliceViolate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate>`
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark, self).__init__()

                                                    self.yang_name = "mark"
                                                    self.yang_parent_name = "qos-show-ea-st-v2"

                                                    self.child_mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark()
                                                    self.child_mark.parent = self
                                                    self._children_name_map["child_mark"] = "child-mark"
                                                    self._children_yang_names.add("child-mark")

                                                    self.parent_mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark()
                                                    self.parent_mark.parent = self
                                                    self._children_name_map["parent_mark"] = "parent-mark"
                                                    self._children_yang_names.add("parent-mark")

                                                    self.parent_police_conform = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform()
                                                    self.parent_police_conform.parent = self
                                                    self._children_name_map["parent_police_conform"] = "parent-police-conform"
                                                    self._children_yang_names.add("parent-police-conform")

                                                    self.parent_police_exceed = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed()
                                                    self.parent_police_exceed.parent = self
                                                    self._children_name_map["parent_police_exceed"] = "parent-police-exceed"
                                                    self._children_yang_names.add("parent-police-exceed")

                                                    self.parent_police_violate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate()
                                                    self.parent_police_violate.parent = self
                                                    self._children_name_map["parent_police_violate"] = "parent-police-violate"
                                                    self._children_yang_names.add("parent-police-violate")

                                                    self.police_conform = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform()
                                                    self.police_conform.parent = self
                                                    self._children_name_map["police_conform"] = "police-conform"
                                                    self._children_yang_names.add("police-conform")

                                                    self.police_exceed = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed()
                                                    self.police_exceed.parent = self
                                                    self._children_name_map["police_exceed"] = "police-exceed"
                                                    self._children_yang_names.add("police-exceed")

                                                    self.police_violate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate()
                                                    self.police_violate.parent = self
                                                    self._children_name_map["police_violate"] = "police-violate"
                                                    self._children_yang_names.add("police-violate")


                                                class ChildMark(Entity):
                                                    """
                                                    Child mark only
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark, self).__init__()

                                                        self.yang_name = "child-mark"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "child-mark"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "child-mark" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class PoliceConform(Entity):
                                                    """
                                                    Child police conform mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform, self).__init__()

                                                        self.yang_name = "police-conform"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "police-conform"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-conform" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class PoliceExceed(Entity):
                                                    """
                                                    Child police exceed mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed, self).__init__()

                                                        self.yang_name = "police-exceed"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "police-exceed"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-exceed" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class PoliceViolate(Entity):
                                                    """
                                                    Child police violate mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate, self).__init__()

                                                        self.yang_name = "police-violate"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "police-violate"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-violate" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class ParentMark(Entity):
                                                    """
                                                    Parent mark only
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark, self).__init__()

                                                        self.yang_name = "parent-mark"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "parent-mark"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "parent-mark" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class ParentPoliceConform(Entity):
                                                    """
                                                    Parent police conform mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform, self).__init__()

                                                        self.yang_name = "parent-police-conform"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "parent-police-conform"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "parent-police-conform" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class ParentPoliceExceed(Entity):
                                                    """
                                                    Parent police exceed mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed, self).__init__()

                                                        self.yang_name = "parent-police-exceed"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "parent-police-exceed"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "parent-police-exceed" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class ParentPoliceViolate(Entity):
                                                    """
                                                    Parent police violate mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate, self).__init__()

                                                        self.yang_name = "parent-police-violate"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "parent-police-violate"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "parent-police-violate" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        (self.child_mark is not None and self.child_mark.has_data()) or
                                                        (self.parent_mark is not None and self.parent_mark.has_data()) or
                                                        (self.parent_police_conform is not None and self.parent_police_conform.has_data()) or
                                                        (self.parent_police_exceed is not None and self.parent_police_exceed.has_data()) or
                                                        (self.parent_police_violate is not None and self.parent_police_violate.has_data()) or
                                                        (self.police_conform is not None and self.police_conform.has_data()) or
                                                        (self.police_exceed is not None and self.police_exceed.has_data()) or
                                                        (self.police_violate is not None and self.police_violate.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.child_mark is not None and self.child_mark.has_operation()) or
                                                        (self.parent_mark is not None and self.parent_mark.has_operation()) or
                                                        (self.parent_police_conform is not None and self.parent_police_conform.has_operation()) or
                                                        (self.parent_police_exceed is not None and self.parent_police_exceed.has_operation()) or
                                                        (self.parent_police_violate is not None and self.parent_police_violate.has_operation()) or
                                                        (self.police_conform is not None and self.police_conform.has_operation()) or
                                                        (self.police_exceed is not None and self.police_exceed.has_operation()) or
                                                        (self.police_violate is not None and self.police_violate.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "child-mark"):
                                                        if (self.child_mark is None):
                                                            self.child_mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark()
                                                            self.child_mark.parent = self
                                                            self._children_name_map["child_mark"] = "child-mark"
                                                        return self.child_mark

                                                    if (child_yang_name == "parent-mark"):
                                                        if (self.parent_mark is None):
                                                            self.parent_mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark()
                                                            self.parent_mark.parent = self
                                                            self._children_name_map["parent_mark"] = "parent-mark"
                                                        return self.parent_mark

                                                    if (child_yang_name == "parent-police-conform"):
                                                        if (self.parent_police_conform is None):
                                                            self.parent_police_conform = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform()
                                                            self.parent_police_conform.parent = self
                                                            self._children_name_map["parent_police_conform"] = "parent-police-conform"
                                                        return self.parent_police_conform

                                                    if (child_yang_name == "parent-police-exceed"):
                                                        if (self.parent_police_exceed is None):
                                                            self.parent_police_exceed = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed()
                                                            self.parent_police_exceed.parent = self
                                                            self._children_name_map["parent_police_exceed"] = "parent-police-exceed"
                                                        return self.parent_police_exceed

                                                    if (child_yang_name == "parent-police-violate"):
                                                        if (self.parent_police_violate is None):
                                                            self.parent_police_violate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate()
                                                            self.parent_police_violate.parent = self
                                                            self._children_name_map["parent_police_violate"] = "parent-police-violate"
                                                        return self.parent_police_violate

                                                    if (child_yang_name == "police-conform"):
                                                        if (self.police_conform is None):
                                                            self.police_conform = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform()
                                                            self.police_conform.parent = self
                                                            self._children_name_map["police_conform"] = "police-conform"
                                                        return self.police_conform

                                                    if (child_yang_name == "police-exceed"):
                                                        if (self.police_exceed is None):
                                                            self.police_exceed = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed()
                                                            self.police_exceed.parent = self
                                                            self._children_name_map["police_exceed"] = "police-exceed"
                                                        return self.police_exceed

                                                    if (child_yang_name == "police-violate"):
                                                        if (self.police_violate is None):
                                                            self.police_violate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate()
                                                            self.police_violate.parent = self
                                                            self._children_name_map["police_violate"] = "police-violate"
                                                        return self.police_violate

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "child-mark" or name == "parent-mark" or name == "parent-police-conform" or name == "parent-police-exceed" or name == "parent-police-violate" or name == "police-conform" or name == "police-exceed" or name == "police-violate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass

                                            def has_data(self):
                                                return (
                                                    self.class_level.is_set or
                                                    self.class_name.is_set or
                                                    self.parent_class_name.is_set or
                                                    self.parent_policy_name.is_set or
                                                    self.policy_name.is_set or
                                                    (self.mark is not None and self.mark.has_data()) or
                                                    (self.police is not None and self.police.has_data()) or
                                                    (self.queue is not None and self.queue.has_data()) or
                                                    (self.queue_limit_parameters is not None and self.queue_limit_parameters.has_data()) or
                                                    (self.shape is not None and self.shape.has_data()) or
                                                    (self.wfq is not None and self.wfq.has_data()) or
                                                    (self.wred is not None and self.wred.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.class_level.yfilter != YFilter.not_set or
                                                    self.class_name.yfilter != YFilter.not_set or
                                                    self.parent_class_name.yfilter != YFilter.not_set or
                                                    self.parent_policy_name.yfilter != YFilter.not_set or
                                                    self.policy_name.yfilter != YFilter.not_set or
                                                    (self.mark is not None and self.mark.has_operation()) or
                                                    (self.police is not None and self.police.has_operation()) or
                                                    (self.queue is not None and self.queue.has_operation()) or
                                                    (self.queue_limit_parameters is not None and self.queue_limit_parameters.has_operation()) or
                                                    (self.shape is not None and self.shape.has_operation()) or
                                                    (self.wfq is not None and self.wfq.has_operation()) or
                                                    (self.wred is not None and self.wred.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "qos-show-ea-st-v2" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.class_level.is_set or self.class_level.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_level.get_name_leafdata())
                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                if (self.parent_class_name.is_set or self.parent_class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_class_name.get_name_leafdata())
                                                if (self.parent_policy_name.is_set or self.parent_policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_policy_name.get_name_leafdata())
                                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.policy_name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark"):
                                                    if (self.mark is None):
                                                        self.mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark()
                                                        self.mark.parent = self
                                                        self._children_name_map["mark"] = "mark"
                                                    return self.mark

                                                if (child_yang_name == "police"):
                                                    if (self.police is None):
                                                        self.police = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police()
                                                        self.police.parent = self
                                                        self._children_name_map["police"] = "police"
                                                    return self.police

                                                if (child_yang_name == "queue"):
                                                    if (self.queue is None):
                                                        self.queue = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Queue()
                                                        self.queue.parent = self
                                                        self._children_name_map["queue"] = "queue"
                                                    return self.queue

                                                if (child_yang_name == "queue-limit-parameters"):
                                                    if (self.queue_limit_parameters is None):
                                                        self.queue_limit_parameters = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters()
                                                        self.queue_limit_parameters.parent = self
                                                        self._children_name_map["queue_limit_parameters"] = "queue-limit-parameters"
                                                    return self.queue_limit_parameters

                                                if (child_yang_name == "shape"):
                                                    if (self.shape is None):
                                                        self.shape = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape()
                                                        self.shape.parent = self
                                                        self._children_name_map["shape"] = "shape"
                                                    return self.shape

                                                if (child_yang_name == "wfq"):
                                                    if (self.wfq is None):
                                                        self.wfq = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq()
                                                        self.wfq.parent = self
                                                        self._children_name_map["wfq"] = "wfq"
                                                    return self.wfq

                                                if (child_yang_name == "wred"):
                                                    if (self.wred is None):
                                                        self.wred = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred()
                                                        self.wred.parent = self
                                                        self._children_name_map["wred"] = "wred"
                                                    return self.wred

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark" or name == "police" or name == "queue" or name == "queue-limit-parameters" or name == "shape" or name == "wfq" or name == "wred" or name == "class-level" or name == "class-name" or name == "parent-class-name" or name == "parent-policy-name" or name == "policy-name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "class-level"):
                                                    self.class_level = value
                                                    self.class_level.value_namespace = name_space
                                                    self.class_level.value_namespace_prefix = name_space_prefix
                                                if(value_path == "class-name"):
                                                    self.class_name = value
                                                    self.class_name.value_namespace = name_space
                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-class-name"):
                                                    self.parent_class_name = value
                                                    self.parent_class_name.value_namespace = name_space
                                                    self.parent_class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-policy-name"):
                                                    self.parent_policy_name = value
                                                    self.parent_policy_name.value_namespace = name_space
                                                    self.parent_policy_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "policy-name"):
                                                    self.policy_name = value
                                                    self.policy_name.value_namespace = name_space
                                                    self.policy_name.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.qos_show_ea_st_v2:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.qos_show_ea_st_v2:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-typhoon" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "qos-show-ea-st-v2"):
                                                for c in self.qos_show_ea_st_v2:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.qos_show_ea_st_v2.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "qos-show-ea-st-v2"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        return (
                                            (self.header is not None and self.header.has_data()) or
                                            (self.policy is not None and self.policy.has_data()) or
                                            (self.policy_typhoon is not None and self.policy_typhoon.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.header is not None and self.header.has_operation()) or
                                            (self.policy is not None and self.policy.has_operation()) or
                                            (self.policy_typhoon is not None and self.policy_typhoon.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "details" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "header"):
                                            if (self.header is None):
                                                self.header = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Header()
                                                self.header.parent = self
                                                self._children_name_map["header"] = "header"
                                            return self.header

                                        if (child_yang_name == "policy"):
                                            if (self.policy is None):
                                                self.policy = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.Policy()
                                                self.policy.parent = self
                                                self._children_name_map["policy"] = "policy"
                                            return self.policy

                                        if (child_yang_name == "policy-typhoon"):
                                            if (self.policy_typhoon is None):
                                                self.policy_typhoon = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon()
                                                self.policy_typhoon.parent = self
                                                self._children_name_map["policy_typhoon"] = "policy-typhoon"
                                            return self.policy_typhoon

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "header" or name == "policy" or name == "policy-typhoon"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.interface_name.is_set or
                                        (self.details is not None and self.details.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        (self.details is not None and self.details.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "member-interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "details"):
                                        if (self.details is None):
                                            self.details = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface.Details()
                                            self.details.parent = self
                                            self._children_name_map["details"] = "details"
                                        return self.details

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "details" or name == "interface-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.member_interface:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.member_interface:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "member-interfaces" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "member-interface"):
                                    for c in self.member_interface:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces.MemberInterface()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.member_interface.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "member-interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (self.member_interfaces is not None and self.member_interfaces.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.member_interfaces is not None and self.member_interfaces.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bundle-output" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "member-interfaces"):
                                if (self.member_interfaces is None):
                                    self.member_interfaces = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput.MemberInterfaces()
                                    self.member_interfaces.parent = self
                                    self._children_name_map["member_interfaces"] = "member-interfaces"
                                return self.member_interfaces

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "member-interfaces"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class BundleInput(Entity):
                        """
                        QoS policy direction output
                        
                        .. attribute:: member_interfaces
                        
                        	QoS list of member interfaces
                        	**type**\:   :py:class:`MemberInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces>`
                        
                        

                        """

                        _prefix = 'asr9k-qos-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput, self).__init__()

                            self.yang_name = "bundle-input"
                            self.yang_parent_name = "bundle-interface"

                            self.member_interfaces = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces()
                            self.member_interfaces.parent = self
                            self._children_name_map["member_interfaces"] = "member-interfaces"
                            self._children_yang_names.add("member-interfaces")


                        class MemberInterfaces(Entity):
                            """
                            QoS list of member interfaces
                            
                            .. attribute:: member_interface
                            
                            	QoS interface name
                            	**type**\: list of    :py:class:`MemberInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface>`
                            
                            

                            """

                            _prefix = 'asr9k-qos-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces, self).__init__()

                                self.yang_name = "member-interfaces"
                                self.yang_parent_name = "bundle-input"

                                self.member_interface = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces, self).__setattr__(name, value)


                            class MemberInterface(Entity):
                                """
                                QoS interface name
                                
                                .. attribute:: interface_name  <key>
                                
                                	Memeber interface
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: details
                                
                                	QoS policy direction egress
                                	**type**\:   :py:class:`Details <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details>`
                                
                                

                                """

                                _prefix = 'asr9k-qos-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface, self).__init__()

                                    self.yang_name = "member-interface"
                                    self.yang_parent_name = "member-interfaces"

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.details = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details()
                                    self.details.parent = self
                                    self._children_name_map["details"] = "details"
                                    self._children_yang_names.add("details")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface, self).__setattr__(name, value)


                                class Details(Entity):
                                    """
                                    QoS policy direction egress
                                    
                                    .. attribute:: header
                                    
                                    	QoS policy header
                                    	**type**\:   :py:class:`Header <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header>`
                                    
                                    .. attribute:: policy
                                    
                                    	Trident QoS policy details
                                    	**type**\:   :py:class:`Policy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy>`
                                    
                                    .. attribute:: policy_typhoon
                                    
                                    	Typhoon QoS policy details
                                    	**type**\:   :py:class:`PolicyTyphoon <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon>`
                                    
                                    

                                    """

                                    _prefix = 'asr9k-qos-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details, self).__init__()

                                        self.yang_name = "details"
                                        self.yang_parent_name = "member-interface"

                                        self.header = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header()
                                        self.header.parent = self
                                        self._children_name_map["header"] = "header"
                                        self._children_yang_names.add("header")

                                        self.policy = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy()
                                        self.policy.parent = self
                                        self._children_name_map["policy"] = "policy"
                                        self._children_yang_names.add("policy")

                                        self.policy_typhoon = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon()
                                        self.policy_typhoon.parent = self
                                        self._children_name_map["policy_typhoon"] = "policy-typhoon"
                                        self._children_yang_names.add("policy-typhoon")


                                    class Header(Entity):
                                        """
                                        QoS policy header
                                        
                                        .. attribute:: classes
                                        
                                        	Number of classes
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: interface_parameters
                                        
                                        	Interface config and programmed parameters
                                        	**type**\:   :py:class:`InterfaceParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters>`
                                        
                                        .. attribute:: policy_name
                                        
                                        	Policy name
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: programmed_bandwidth
                                        
                                        	Bandwidth that was programmed
                                        	**type**\:   :py:class:`ProgrammedBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.ProgrammedBandwidth>`
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header, self).__init__()

                                            self.yang_name = "header"
                                            self.yang_parent_name = "details"

                                            self.classes = YLeaf(YType.uint16, "classes")

                                            self.policy_name = YLeaf(YType.str, "policy-name")

                                            self.interface_parameters = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters()
                                            self.interface_parameters.parent = self
                                            self._children_name_map["interface_parameters"] = "interface-parameters"
                                            self._children_yang_names.add("interface-parameters")

                                            self.programmed_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.ProgrammedBandwidth()
                                            self.programmed_bandwidth.parent = self
                                            self._children_name_map["programmed_bandwidth"] = "programmed-bandwidth"
                                            self._children_yang_names.add("programmed-bandwidth")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("classes",
                                                            "policy_name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header, self).__setattr__(name, value)


                                        class InterfaceParameters(Entity):
                                            """
                                            Interface config and programmed parameters
                                            
                                            .. attribute:: ancp_config_bandwidth
                                            
                                            	Bandwidth obtain from IM
                                            	**type**\:   :py:class:`AncpConfigBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpConfigBandwidth>`
                                            
                                            .. attribute:: ancp_programmed_bandwidth
                                            
                                            	ANCP bandwidth that was programmed
                                            	**type**\:   :py:class:`AncpProgrammedBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpProgrammedBandwidth>`
                                            
                                            .. attribute:: port_config_bandwidth
                                            
                                            	Bandwidth due to port speed change
                                            	**type**\:   :py:class:`PortConfigBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortConfigBandwidth>`
                                            
                                            .. attribute:: port_shaper_rate
                                            
                                            	Bandwidth that was programmed
                                            	**type**\:   :py:class:`PortShaperRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortShaperRate>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters, self).__init__()

                                                self.yang_name = "interface-parameters"
                                                self.yang_parent_name = "header"

                                                self.ancp_config_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpConfigBandwidth()
                                                self.ancp_config_bandwidth.parent = self
                                                self._children_name_map["ancp_config_bandwidth"] = "ancp-config-bandwidth"
                                                self._children_yang_names.add("ancp-config-bandwidth")

                                                self.ancp_programmed_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpProgrammedBandwidth()
                                                self.ancp_programmed_bandwidth.parent = self
                                                self._children_name_map["ancp_programmed_bandwidth"] = "ancp-programmed-bandwidth"
                                                self._children_yang_names.add("ancp-programmed-bandwidth")

                                                self.port_config_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortConfigBandwidth()
                                                self.port_config_bandwidth.parent = self
                                                self._children_name_map["port_config_bandwidth"] = "port-config-bandwidth"
                                                self._children_yang_names.add("port-config-bandwidth")

                                                self.port_shaper_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortShaperRate()
                                                self.port_shaper_rate.parent = self
                                                self._children_name_map["port_shaper_rate"] = "port-shaper-rate"
                                                self._children_yang_names.add("port-shaper-rate")


                                            class PortConfigBandwidth(Entity):
                                                """
                                                Bandwidth due to port speed change
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortConfigBandwidth, self).__init__()

                                                    self.yang_name = "port-config-bandwidth"
                                                    self.yang_parent_name = "interface-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortConfigBandwidth, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortConfigBandwidth, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "port-config-bandwidth" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class AncpConfigBandwidth(Entity):
                                                """
                                                Bandwidth obtain from IM
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpConfigBandwidth, self).__init__()

                                                    self.yang_name = "ancp-config-bandwidth"
                                                    self.yang_parent_name = "interface-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpConfigBandwidth, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpConfigBandwidth, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ancp-config-bandwidth" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class AncpProgrammedBandwidth(Entity):
                                                """
                                                ANCP bandwidth that was programmed
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpProgrammedBandwidth, self).__init__()

                                                    self.yang_name = "ancp-programmed-bandwidth"
                                                    self.yang_parent_name = "interface-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpProgrammedBandwidth, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpProgrammedBandwidth, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ancp-programmed-bandwidth" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix


                                            class PortShaperRate(Entity):
                                                """
                                                Bandwidth that was programmed
                                                
                                                .. attribute:: unit
                                                
                                                	Config unit
                                                	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                
                                                .. attribute:: value
                                                
                                                	Config value
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortShaperRate, self).__init__()

                                                    self.yang_name = "port-shaper-rate"
                                                    self.yang_parent_name = "interface-parameters"

                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                    self.value = YLeaf(YType.uint32, "value")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("unit",
                                                                    "value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortShaperRate, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortShaperRate, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.unit.is_set or
                                                        self.value.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.unit.yfilter != YFilter.not_set or
                                                        self.value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "port-shaper-rate" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.unit.get_name_leafdata())
                                                    if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "unit" or name == "value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "unit"):
                                                        self.unit = value
                                                        self.unit.value_namespace = name_space
                                                        self.unit.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "value"):
                                                        self.value = value
                                                        self.value.value_namespace = name_space
                                                        self.value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    (self.ancp_config_bandwidth is not None and self.ancp_config_bandwidth.has_data()) or
                                                    (self.ancp_programmed_bandwidth is not None and self.ancp_programmed_bandwidth.has_data()) or
                                                    (self.port_config_bandwidth is not None and self.port_config_bandwidth.has_data()) or
                                                    (self.port_shaper_rate is not None and self.port_shaper_rate.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    (self.ancp_config_bandwidth is not None and self.ancp_config_bandwidth.has_operation()) or
                                                    (self.ancp_programmed_bandwidth is not None and self.ancp_programmed_bandwidth.has_operation()) or
                                                    (self.port_config_bandwidth is not None and self.port_config_bandwidth.has_operation()) or
                                                    (self.port_shaper_rate is not None and self.port_shaper_rate.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "interface-parameters" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "ancp-config-bandwidth"):
                                                    if (self.ancp_config_bandwidth is None):
                                                        self.ancp_config_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpConfigBandwidth()
                                                        self.ancp_config_bandwidth.parent = self
                                                        self._children_name_map["ancp_config_bandwidth"] = "ancp-config-bandwidth"
                                                    return self.ancp_config_bandwidth

                                                if (child_yang_name == "ancp-programmed-bandwidth"):
                                                    if (self.ancp_programmed_bandwidth is None):
                                                        self.ancp_programmed_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.AncpProgrammedBandwidth()
                                                        self.ancp_programmed_bandwidth.parent = self
                                                        self._children_name_map["ancp_programmed_bandwidth"] = "ancp-programmed-bandwidth"
                                                    return self.ancp_programmed_bandwidth

                                                if (child_yang_name == "port-config-bandwidth"):
                                                    if (self.port_config_bandwidth is None):
                                                        self.port_config_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortConfigBandwidth()
                                                        self.port_config_bandwidth.parent = self
                                                        self._children_name_map["port_config_bandwidth"] = "port-config-bandwidth"
                                                    return self.port_config_bandwidth

                                                if (child_yang_name == "port-shaper-rate"):
                                                    if (self.port_shaper_rate is None):
                                                        self.port_shaper_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters.PortShaperRate()
                                                        self.port_shaper_rate.parent = self
                                                        self._children_name_map["port_shaper_rate"] = "port-shaper-rate"
                                                    return self.port_shaper_rate

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "ancp-config-bandwidth" or name == "ancp-programmed-bandwidth" or name == "port-config-bandwidth" or name == "port-shaper-rate"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class ProgrammedBandwidth(Entity):
                                            """
                                            Bandwidth that was programmed
                                            
                                            .. attribute:: unit
                                            
                                            	Config unit
                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                            
                                            .. attribute:: value
                                            
                                            	Config value
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.ProgrammedBandwidth, self).__init__()

                                                self.yang_name = "programmed-bandwidth"
                                                self.yang_parent_name = "header"

                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                self.value = YLeaf(YType.uint32, "value")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("unit",
                                                                "value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.ProgrammedBandwidth, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.ProgrammedBandwidth, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.unit.is_set or
                                                    self.value.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.unit.yfilter != YFilter.not_set or
                                                    self.value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "programmed-bandwidth" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "unit" or name == "value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "unit"):
                                                    self.unit = value
                                                    self.unit.value_namespace = name_space
                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                if(value_path == "value"):
                                                    self.value = value
                                                    self.value.value_namespace = name_space
                                                    self.value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.classes.is_set or
                                                self.policy_name.is_set or
                                                (self.interface_parameters is not None and self.interface_parameters.has_data()) or
                                                (self.programmed_bandwidth is not None and self.programmed_bandwidth.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.classes.yfilter != YFilter.not_set or
                                                self.policy_name.yfilter != YFilter.not_set or
                                                (self.interface_parameters is not None and self.interface_parameters.has_operation()) or
                                                (self.programmed_bandwidth is not None and self.programmed_bandwidth.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "header" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.classes.is_set or self.classes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.classes.get_name_leafdata())
                                            if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "interface-parameters"):
                                                if (self.interface_parameters is None):
                                                    self.interface_parameters = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.InterfaceParameters()
                                                    self.interface_parameters.parent = self
                                                    self._children_name_map["interface_parameters"] = "interface-parameters"
                                                return self.interface_parameters

                                            if (child_yang_name == "programmed-bandwidth"):
                                                if (self.programmed_bandwidth is None):
                                                    self.programmed_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header.ProgrammedBandwidth()
                                                    self.programmed_bandwidth.parent = self
                                                    self._children_name_map["programmed_bandwidth"] = "programmed-bandwidth"
                                                return self.programmed_bandwidth

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "interface-parameters" or name == "programmed-bandwidth" or name == "classes" or name == "policy-name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "classes"):
                                                self.classes = value
                                                self.classes.value_namespace = name_space
                                                self.classes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-name"):
                                                self.policy_name = value
                                                self.policy_name.value_namespace = name_space
                                                self.policy_name.value_namespace_prefix = name_space_prefix


                                    class Policy(Entity):
                                        """
                                        Trident QoS policy details
                                        
                                        .. attribute:: qos_show_ea_st_v1
                                        
                                        	qos show ea st v1
                                        	**type**\: list of    :py:class:`QosShowEaStV1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1>`
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy, self).__init__()

                                            self.yang_name = "policy"
                                            self.yang_parent_name = "details"

                                            self.qos_show_ea_st_v1 = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy, self).__setattr__(name, value)


                                        class QosShowEaStV1(Entity):
                                            """
                                            qos show ea st v1
                                            
                                            .. attribute:: class_level
                                            
                                            	Class level
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: class_name
                                            
                                            	Class name
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: mark
                                            
                                            	Mark parameters
                                            	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark>`
                                            
                                            .. attribute:: parent_class_name
                                            
                                            	Parent class name
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: parent_policy_name
                                            
                                            	Parent policy name
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: police
                                            
                                            	Police parameters
                                            	**type**\:   :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police>`
                                            
                                            .. attribute:: policy_name
                                            
                                            	Policy name
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: queue
                                            
                                            	Queue parameters
                                            	**type**\:   :py:class:`Queue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Queue>`
                                            
                                            .. attribute:: queue_limit_parameters
                                            
                                            	Queue limit parameters
                                            	**type**\:   :py:class:`QueueLimitParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters>`
                                            
                                            .. attribute:: shape
                                            
                                            	Shape parameters
                                            	**type**\:   :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape>`
                                            
                                            .. attribute:: wfq
                                            
                                            	WFQ parameters
                                            	**type**\:   :py:class:`Wfq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq>`
                                            
                                            .. attribute:: wred
                                            
                                            	WRED parameters
                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1, self).__init__()

                                                self.yang_name = "qos-show-ea-st-v1"
                                                self.yang_parent_name = "policy"

                                                self.class_level = YLeaf(YType.uint8, "class-level")

                                                self.class_name = YLeaf(YType.str, "class-name")

                                                self.parent_class_name = YLeaf(YType.str, "parent-class-name")

                                                self.parent_policy_name = YLeaf(YType.str, "parent-policy-name")

                                                self.policy_name = YLeaf(YType.str, "policy-name")

                                                self.mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark()
                                                self.mark.parent = self
                                                self._children_name_map["mark"] = "mark"
                                                self._children_yang_names.add("mark")

                                                self.police = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police()
                                                self.police.parent = self
                                                self._children_name_map["police"] = "police"
                                                self._children_yang_names.add("police")

                                                self.queue = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Queue()
                                                self.queue.parent = self
                                                self._children_name_map["queue"] = "queue"
                                                self._children_yang_names.add("queue")

                                                self.queue_limit_parameters = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters()
                                                self.queue_limit_parameters.parent = self
                                                self._children_name_map["queue_limit_parameters"] = "queue-limit-parameters"
                                                self._children_yang_names.add("queue-limit-parameters")

                                                self.shape = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape()
                                                self.shape.parent = self
                                                self._children_name_map["shape"] = "shape"
                                                self._children_yang_names.add("shape")

                                                self.wfq = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq()
                                                self.wfq.parent = self
                                                self._children_name_map["wfq"] = "wfq"
                                                self._children_yang_names.add("wfq")

                                                self.wred = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred()
                                                self.wred.parent = self
                                                self._children_name_map["wred"] = "wred"
                                                self._children_yang_names.add("wred")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("class_level",
                                                                "class_name",
                                                                "parent_class_name",
                                                                "parent_policy_name",
                                                                "policy_name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1, self).__setattr__(name, value)


                                            class Queue(Entity):
                                                """
                                                Queue parameters
                                                
                                                .. attribute:: class_name
                                                
                                                	Class name
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_type
                                                
                                                	Queue type
                                                	**type**\:   :py:class:`Queue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Queue>`
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Queue, self).__init__()

                                                    self.yang_name = "queue"
                                                    self.yang_parent_name = "qos-show-ea-st-v1"

                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                    self.queue_type = YLeaf(YType.enumeration, "queue-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("class_name",
                                                                    "queue_id",
                                                                    "queue_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Queue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Queue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.class_name.is_set or
                                                        self.queue_id.is_set or
                                                        self.queue_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.class_name.yfilter != YFilter.not_set or
                                                        self.queue_id.yfilter != YFilter.not_set or
                                                        self.queue_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                    if (self.queue_type.is_set or self.queue_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "class-name" or name == "queue-id" or name == "queue-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "class-name"):
                                                        self.class_name = value
                                                        self.class_name.value_namespace = name_space
                                                        self.class_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-id"):
                                                        self.queue_id = value
                                                        self.queue_id.value_namespace = name_space
                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-type"):
                                                        self.queue_type = value
                                                        self.queue_type.value_namespace = name_space
                                                        self.queue_type.value_namespace_prefix = name_space_prefix


                                            class QueueLimitParameters(Entity):
                                                """
                                                Queue limit parameters
                                                
                                                .. attribute:: config_queue_limit
                                                
                                                	Config queue limit
                                                	**type**\:   :py:class:`ConfigQueueLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit>`
                                                
                                                .. attribute:: profile_id
                                                
                                                	Profile ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_limit
                                                
                                                	Queue limit in kbytes
                                                	**type**\:   :py:class:`QueueLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit>`
                                                
                                                .. attribute:: scaling_profile_id
                                                
                                                	Scaling profile ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters, self).__init__()

                                                    self.yang_name = "queue-limit-parameters"
                                                    self.yang_parent_name = "qos-show-ea-st-v1"

                                                    self.profile_id = YLeaf(YType.uint32, "profile-id")

                                                    self.scaling_profile_id = YLeaf(YType.uint32, "scaling-profile-id")

                                                    self.config_queue_limit = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit()
                                                    self.config_queue_limit.parent = self
                                                    self._children_name_map["config_queue_limit"] = "config-queue-limit"
                                                    self._children_yang_names.add("config-queue-limit")

                                                    self.queue_limit = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit()
                                                    self.queue_limit.parent = self
                                                    self._children_name_map["queue_limit"] = "queue-limit"
                                                    self._children_yang_names.add("queue-limit")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("profile_id",
                                                                    "scaling_profile_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters, self).__setattr__(name, value)


                                                class QueueLimit(Entity):
                                                    """
                                                    Queue limit in kbytes
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit, self).__init__()

                                                        self.yang_name = "queue-limit"
                                                        self.yang_parent_name = "queue-limit-parameters"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-limit" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class ConfigQueueLimit(Entity):
                                                    """
                                                    Config queue limit
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit, self).__init__()

                                                        self.yang_name = "config-queue-limit"
                                                        self.yang_parent_name = "queue-limit-parameters"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "config-queue-limit" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.profile_id.is_set or
                                                        self.scaling_profile_id.is_set or
                                                        (self.config_queue_limit is not None and self.config_queue_limit.has_data()) or
                                                        (self.queue_limit is not None and self.queue_limit.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.profile_id.yfilter != YFilter.not_set or
                                                        self.scaling_profile_id.yfilter != YFilter.not_set or
                                                        (self.config_queue_limit is not None and self.config_queue_limit.has_operation()) or
                                                        (self.queue_limit is not None and self.queue_limit.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-limit-parameters" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_id.get_name_leafdata())
                                                    if (self.scaling_profile_id.is_set or self.scaling_profile_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.scaling_profile_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "config-queue-limit"):
                                                        if (self.config_queue_limit is None):
                                                            self.config_queue_limit = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.ConfigQueueLimit()
                                                            self.config_queue_limit.parent = self
                                                            self._children_name_map["config_queue_limit"] = "config-queue-limit"
                                                        return self.config_queue_limit

                                                    if (child_yang_name == "queue-limit"):
                                                        if (self.queue_limit is None):
                                                            self.queue_limit = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters.QueueLimit()
                                                            self.queue_limit.parent = self
                                                            self._children_name_map["queue_limit"] = "queue-limit"
                                                        return self.queue_limit

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "config-queue-limit" or name == "queue-limit" or name == "profile-id" or name == "scaling-profile-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "profile-id"):
                                                        self.profile_id = value
                                                        self.profile_id.value_namespace = name_space
                                                        self.profile_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "scaling-profile-id"):
                                                        self.scaling_profile_id = value
                                                        self.scaling_profile_id.value_namespace = name_space
                                                        self.scaling_profile_id.value_namespace_prefix = name_space_prefix


                                            class Shape(Entity):
                                                """
                                                Shape parameters
                                                
                                                .. attribute:: cbs
                                                
                                                	CBS in bytes
                                                	**type**\:   :py:class:`Cbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cbs>`
                                                
                                                .. attribute:: cir
                                                
                                                	CIR in kbps
                                                	**type**\:   :py:class:`Cir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cir>`
                                                
                                                .. attribute:: config_bandwidth
                                                
                                                	Config bandwidth
                                                	**type**\:   :py:class:`ConfigBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth>`
                                                
                                                .. attribute:: pbs
                                                
                                                	PBS in bytes
                                                	**type**\:   :py:class:`Pbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pbs>`
                                                
                                                .. attribute:: pir
                                                
                                                	PIR in kbps
                                                	**type**\:   :py:class:`Pir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pir>`
                                                
                                                .. attribute:: profile_id
                                                
                                                	Shape profile ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape, self).__init__()

                                                    self.yang_name = "shape"
                                                    self.yang_parent_name = "qos-show-ea-st-v1"

                                                    self.profile_id = YLeaf(YType.uint16, "profile-id")

                                                    self.cbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cbs()
                                                    self.cbs.parent = self
                                                    self._children_name_map["cbs"] = "cbs"
                                                    self._children_yang_names.add("cbs")

                                                    self.cir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cir()
                                                    self.cir.parent = self
                                                    self._children_name_map["cir"] = "cir"
                                                    self._children_yang_names.add("cir")

                                                    self.config_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth()
                                                    self.config_bandwidth.parent = self
                                                    self._children_name_map["config_bandwidth"] = "config-bandwidth"
                                                    self._children_yang_names.add("config-bandwidth")

                                                    self.pbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pbs()
                                                    self.pbs.parent = self
                                                    self._children_name_map["pbs"] = "pbs"
                                                    self._children_yang_names.add("pbs")

                                                    self.pir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pir()
                                                    self.pir.parent = self
                                                    self._children_name_map["pir"] = "pir"
                                                    self._children_yang_names.add("pir")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("profile_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape, self).__setattr__(name, value)


                                                class Cir(Entity):
                                                    """
                                                    CIR in kbps
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cir, self).__init__()

                                                        self.yang_name = "cir"
                                                        self.yang_parent_name = "shape"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cir, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cir, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cir" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class ConfigBandwidth(Entity):
                                                    """
                                                    Config bandwidth
                                                    
                                                    .. attribute:: minimum_rate
                                                    
                                                    	Minimum bandwidth rate
                                                    	**type**\:   :py:class:`MinimumRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth, self).__init__()

                                                        self.yang_name = "config-bandwidth"
                                                        self.yang_parent_name = "shape"

                                                        self.minimum_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate()
                                                        self.minimum_rate.parent = self
                                                        self._children_name_map["minimum_rate"] = "minimum-rate"
                                                        self._children_yang_names.add("minimum-rate")


                                                    class MinimumRate(Entity):
                                                        """
                                                        Minimum bandwidth rate
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate, self).__init__()

                                                            self.yang_name = "minimum-rate"
                                                            self.yang_parent_name = "config-bandwidth"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "minimum-rate" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (self.minimum_rate is not None and self.minimum_rate.has_data())

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            (self.minimum_rate is not None and self.minimum_rate.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "config-bandwidth" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "minimum-rate"):
                                                            if (self.minimum_rate is None):
                                                                self.minimum_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth.MinimumRate()
                                                                self.minimum_rate.parent = self
                                                                self._children_name_map["minimum_rate"] = "minimum-rate"
                                                            return self.minimum_rate

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "minimum-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        pass


                                                class Cbs(Entity):
                                                    """
                                                    CBS in bytes
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cbs, self).__init__()

                                                        self.yang_name = "cbs"
                                                        self.yang_parent_name = "shape"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cbs, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cbs, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cbs" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class Pir(Entity):
                                                    """
                                                    PIR in kbps
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pir, self).__init__()

                                                        self.yang_name = "pir"
                                                        self.yang_parent_name = "shape"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pir, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pir, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "pir" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class Pbs(Entity):
                                                    """
                                                    PBS in bytes
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pbs, self).__init__()

                                                        self.yang_name = "pbs"
                                                        self.yang_parent_name = "shape"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pbs, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pbs, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "pbs" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.profile_id.is_set or
                                                        (self.cbs is not None and self.cbs.has_data()) or
                                                        (self.cir is not None and self.cir.has_data()) or
                                                        (self.config_bandwidth is not None and self.config_bandwidth.has_data()) or
                                                        (self.pbs is not None and self.pbs.has_data()) or
                                                        (self.pir is not None and self.pir.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.profile_id.yfilter != YFilter.not_set or
                                                        (self.cbs is not None and self.cbs.has_operation()) or
                                                        (self.cir is not None and self.cir.has_operation()) or
                                                        (self.config_bandwidth is not None and self.config_bandwidth.has_operation()) or
                                                        (self.pbs is not None and self.pbs.has_operation()) or
                                                        (self.pir is not None and self.pir.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "shape" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "cbs"):
                                                        if (self.cbs is None):
                                                            self.cbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cbs()
                                                            self.cbs.parent = self
                                                            self._children_name_map["cbs"] = "cbs"
                                                        return self.cbs

                                                    if (child_yang_name == "cir"):
                                                        if (self.cir is None):
                                                            self.cir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Cir()
                                                            self.cir.parent = self
                                                            self._children_name_map["cir"] = "cir"
                                                        return self.cir

                                                    if (child_yang_name == "config-bandwidth"):
                                                        if (self.config_bandwidth is None):
                                                            self.config_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.ConfigBandwidth()
                                                            self.config_bandwidth.parent = self
                                                            self._children_name_map["config_bandwidth"] = "config-bandwidth"
                                                        return self.config_bandwidth

                                                    if (child_yang_name == "pbs"):
                                                        if (self.pbs is None):
                                                            self.pbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pbs()
                                                            self.pbs.parent = self
                                                            self._children_name_map["pbs"] = "pbs"
                                                        return self.pbs

                                                    if (child_yang_name == "pir"):
                                                        if (self.pir is None):
                                                            self.pir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape.Pir()
                                                            self.pir.parent = self
                                                            self._children_name_map["pir"] = "pir"
                                                        return self.pir

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "cbs" or name == "cir" or name == "config-bandwidth" or name == "pbs" or name == "pir" or name == "profile-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "profile-id"):
                                                        self.profile_id = value
                                                        self.profile_id.value_namespace = name_space
                                                        self.profile_id.value_namespace_prefix = name_space_prefix


                                            class Police(Entity):
                                                """
                                                Police parameters
                                                
                                                .. attribute:: cbs
                                                
                                                	CBS
                                                	**type**\:   :py:class:`Cbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cbs>`
                                                
                                                .. attribute:: cir
                                                
                                                	CIR
                                                	**type**\:   :py:class:`Cir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cir>`
                                                
                                                .. attribute:: pbs
                                                
                                                	PBS
                                                	**type**\:   :py:class:`Pbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pbs>`
                                                
                                                .. attribute:: pir
                                                
                                                	PIR
                                                	**type**\:   :py:class:`Pir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pir>`
                                                
                                                .. attribute:: police_config_parameters
                                                
                                                	Police config parameters
                                                	**type**\:   :py:class:`PoliceConfigParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters>`
                                                
                                                .. attribute:: policer_type
                                                
                                                	Policer type
                                                	**type**\:   :py:class:`TbAlgorithm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.TbAlgorithm>`
                                                
                                                .. attribute:: profile_id
                                                
                                                	Police profile ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police, self).__init__()

                                                    self.yang_name = "police"
                                                    self.yang_parent_name = "qos-show-ea-st-v1"

                                                    self.policer_type = YLeaf(YType.enumeration, "policer-type")

                                                    self.profile_id = YLeaf(YType.uint32, "profile-id")

                                                    self.cbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cbs()
                                                    self.cbs.parent = self
                                                    self._children_name_map["cbs"] = "cbs"
                                                    self._children_yang_names.add("cbs")

                                                    self.cir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cir()
                                                    self.cir.parent = self
                                                    self._children_name_map["cir"] = "cir"
                                                    self._children_yang_names.add("cir")

                                                    self.pbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pbs()
                                                    self.pbs.parent = self
                                                    self._children_name_map["pbs"] = "pbs"
                                                    self._children_yang_names.add("pbs")

                                                    self.pir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pir()
                                                    self.pir.parent = self
                                                    self._children_name_map["pir"] = "pir"
                                                    self._children_yang_names.add("pir")

                                                    self.police_config_parameters = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters()
                                                    self.police_config_parameters.parent = self
                                                    self._children_name_map["police_config_parameters"] = "police-config-parameters"
                                                    self._children_yang_names.add("police-config-parameters")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("policer_type",
                                                                    "profile_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police, self).__setattr__(name, value)


                                                class Cir(Entity):
                                                    """
                                                    CIR
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cir, self).__init__()

                                                        self.yang_name = "cir"
                                                        self.yang_parent_name = "police"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cir, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cir, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cir" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class Cbs(Entity):
                                                    """
                                                    CBS
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cbs, self).__init__()

                                                        self.yang_name = "cbs"
                                                        self.yang_parent_name = "police"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cbs, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cbs, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cbs" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class Pir(Entity):
                                                    """
                                                    PIR
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pir, self).__init__()

                                                        self.yang_name = "pir"
                                                        self.yang_parent_name = "police"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pir, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pir, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "pir" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class Pbs(Entity):
                                                    """
                                                    PBS
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pbs, self).__init__()

                                                        self.yang_name = "pbs"
                                                        self.yang_parent_name = "police"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pbs, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pbs, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "pbs" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class PoliceConfigParameters(Entity):
                                                    """
                                                    Police config parameters
                                                    
                                                    .. attribute:: average_rate
                                                    
                                                    	Average rate
                                                    	**type**\:   :py:class:`AverageRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate>`
                                                    
                                                    .. attribute:: conform_burst
                                                    
                                                    	Conform burst
                                                    	**type**\:   :py:class:`ConformBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst>`
                                                    
                                                    .. attribute:: exceed_burst
                                                    
                                                    	Exceed burst
                                                    	**type**\:   :py:class:`ExceedBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst>`
                                                    
                                                    .. attribute:: peak_rate
                                                    
                                                    	Peak rate
                                                    	**type**\:   :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters, self).__init__()

                                                        self.yang_name = "police-config-parameters"
                                                        self.yang_parent_name = "police"

                                                        self.average_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate()
                                                        self.average_rate.parent = self
                                                        self._children_name_map["average_rate"] = "average-rate"
                                                        self._children_yang_names.add("average-rate")

                                                        self.conform_burst = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst()
                                                        self.conform_burst.parent = self
                                                        self._children_name_map["conform_burst"] = "conform-burst"
                                                        self._children_yang_names.add("conform-burst")

                                                        self.exceed_burst = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst()
                                                        self.exceed_burst.parent = self
                                                        self._children_name_map["exceed_burst"] = "exceed-burst"
                                                        self._children_yang_names.add("exceed-burst")

                                                        self.peak_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate()
                                                        self.peak_rate.parent = self
                                                        self._children_name_map["peak_rate"] = "peak-rate"
                                                        self._children_yang_names.add("peak-rate")


                                                    class AverageRate(Entity):
                                                        """
                                                        Average rate
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate, self).__init__()

                                                            self.yang_name = "average-rate"
                                                            self.yang_parent_name = "police-config-parameters"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "average-rate" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class PeakRate(Entity):
                                                        """
                                                        Peak rate
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate, self).__init__()

                                                            self.yang_name = "peak-rate"
                                                            self.yang_parent_name = "police-config-parameters"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "peak-rate" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class ConformBurst(Entity):
                                                        """
                                                        Conform burst
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst, self).__init__()

                                                            self.yang_name = "conform-burst"
                                                            self.yang_parent_name = "police-config-parameters"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "conform-burst" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class ExceedBurst(Entity):
                                                        """
                                                        Exceed burst
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst, self).__init__()

                                                            self.yang_name = "exceed-burst"
                                                            self.yang_parent_name = "police-config-parameters"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "exceed-burst" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            (self.average_rate is not None and self.average_rate.has_data()) or
                                                            (self.conform_burst is not None and self.conform_burst.has_data()) or
                                                            (self.exceed_burst is not None and self.exceed_burst.has_data()) or
                                                            (self.peak_rate is not None and self.peak_rate.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            (self.average_rate is not None and self.average_rate.has_operation()) or
                                                            (self.conform_burst is not None and self.conform_burst.has_operation()) or
                                                            (self.exceed_burst is not None and self.exceed_burst.has_operation()) or
                                                            (self.peak_rate is not None and self.peak_rate.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-config-parameters" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "average-rate"):
                                                            if (self.average_rate is None):
                                                                self.average_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.AverageRate()
                                                                self.average_rate.parent = self
                                                                self._children_name_map["average_rate"] = "average-rate"
                                                            return self.average_rate

                                                        if (child_yang_name == "conform-burst"):
                                                            if (self.conform_burst is None):
                                                                self.conform_burst = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ConformBurst()
                                                                self.conform_burst.parent = self
                                                                self._children_name_map["conform_burst"] = "conform-burst"
                                                            return self.conform_burst

                                                        if (child_yang_name == "exceed-burst"):
                                                            if (self.exceed_burst is None):
                                                                self.exceed_burst = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.ExceedBurst()
                                                                self.exceed_burst.parent = self
                                                                self._children_name_map["exceed_burst"] = "exceed-burst"
                                                            return self.exceed_burst

                                                        if (child_yang_name == "peak-rate"):
                                                            if (self.peak_rate is None):
                                                                self.peak_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters.PeakRate()
                                                                self.peak_rate.parent = self
                                                                self._children_name_map["peak_rate"] = "peak-rate"
                                                            return self.peak_rate

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "average-rate" or name == "conform-burst" or name == "exceed-burst" or name == "peak-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        pass

                                                def has_data(self):
                                                    return (
                                                        self.policer_type.is_set or
                                                        self.profile_id.is_set or
                                                        (self.cbs is not None and self.cbs.has_data()) or
                                                        (self.cir is not None and self.cir.has_data()) or
                                                        (self.pbs is not None and self.pbs.has_data()) or
                                                        (self.pir is not None and self.pir.has_data()) or
                                                        (self.police_config_parameters is not None and self.police_config_parameters.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.policer_type.yfilter != YFilter.not_set or
                                                        self.profile_id.yfilter != YFilter.not_set or
                                                        (self.cbs is not None and self.cbs.has_operation()) or
                                                        (self.cir is not None and self.cir.has_operation()) or
                                                        (self.pbs is not None and self.pbs.has_operation()) or
                                                        (self.pir is not None and self.pir.has_operation()) or
                                                        (self.police_config_parameters is not None and self.police_config_parameters.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "police" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.policer_type.is_set or self.policer_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.policer_type.get_name_leafdata())
                                                    if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "cbs"):
                                                        if (self.cbs is None):
                                                            self.cbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cbs()
                                                            self.cbs.parent = self
                                                            self._children_name_map["cbs"] = "cbs"
                                                        return self.cbs

                                                    if (child_yang_name == "cir"):
                                                        if (self.cir is None):
                                                            self.cir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Cir()
                                                            self.cir.parent = self
                                                            self._children_name_map["cir"] = "cir"
                                                        return self.cir

                                                    if (child_yang_name == "pbs"):
                                                        if (self.pbs is None):
                                                            self.pbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pbs()
                                                            self.pbs.parent = self
                                                            self._children_name_map["pbs"] = "pbs"
                                                        return self.pbs

                                                    if (child_yang_name == "pir"):
                                                        if (self.pir is None):
                                                            self.pir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.Pir()
                                                            self.pir.parent = self
                                                            self._children_name_map["pir"] = "pir"
                                                        return self.pir

                                                    if (child_yang_name == "police-config-parameters"):
                                                        if (self.police_config_parameters is None):
                                                            self.police_config_parameters = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police.PoliceConfigParameters()
                                                            self.police_config_parameters.parent = self
                                                            self._children_name_map["police_config_parameters"] = "police-config-parameters"
                                                        return self.police_config_parameters

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "cbs" or name == "cir" or name == "pbs" or name == "pir" or name == "police-config-parameters" or name == "policer-type" or name == "profile-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "policer-type"):
                                                        self.policer_type = value
                                                        self.policer_type.value_namespace = name_space
                                                        self.policer_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-id"):
                                                        self.profile_id = value
                                                        self.profile_id.value_namespace = name_space
                                                        self.profile_id.value_namespace_prefix = name_space_prefix


                                            class Wfq(Entity):
                                                """
                                                WFQ parameters
                                                
                                                .. attribute:: bandwidth
                                                
                                                	CFG Bandwidth
                                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.Bandwidth>`
                                                
                                                .. attribute:: chunk_id
                                                
                                                	Chunk ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: committed_weight
                                                
                                                	Committed weight
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: excess_ratio
                                                
                                                	Parent Excess ratio
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: excess_weight
                                                
                                                	Excess weight
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: level
                                                
                                                	Level
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: parent_bandwidth
                                                
                                                	Parent bandwidth
                                                	**type**\:   :py:class:`ParentBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth>`
                                                
                                                .. attribute:: profile_id
                                                
                                                	WFQ profile
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq, self).__init__()

                                                    self.yang_name = "wfq"
                                                    self.yang_parent_name = "qos-show-ea-st-v1"

                                                    self.chunk_id = YLeaf(YType.uint32, "chunk-id")

                                                    self.committed_weight = YLeaf(YType.uint32, "committed-weight")

                                                    self.excess_ratio = YLeaf(YType.uint16, "excess-ratio")

                                                    self.excess_weight = YLeaf(YType.uint16, "excess-weight")

                                                    self.level = YLeaf(YType.uint8, "level")

                                                    self.profile_id = YLeaf(YType.uint32, "profile-id")

                                                    self.bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.Bandwidth()
                                                    self.bandwidth.parent = self
                                                    self._children_name_map["bandwidth"] = "bandwidth"
                                                    self._children_yang_names.add("bandwidth")

                                                    self.parent_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth()
                                                    self.parent_bandwidth.parent = self
                                                    self._children_name_map["parent_bandwidth"] = "parent-bandwidth"
                                                    self._children_yang_names.add("parent-bandwidth")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("chunk_id",
                                                                    "committed_weight",
                                                                    "excess_ratio",
                                                                    "excess_weight",
                                                                    "level",
                                                                    "profile_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq, self).__setattr__(name, value)


                                                class ParentBandwidth(Entity):
                                                    """
                                                    Parent bandwidth
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth, self).__init__()

                                                        self.yang_name = "parent-bandwidth"
                                                        self.yang_parent_name = "wfq"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "parent-bandwidth" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class Bandwidth(Entity):
                                                    """
                                                    CFG Bandwidth
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.Bandwidth, self).__init__()

                                                        self.yang_name = "bandwidth"
                                                        self.yang_parent_name = "wfq"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.Bandwidth, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.Bandwidth, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "bandwidth" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.chunk_id.is_set or
                                                        self.committed_weight.is_set or
                                                        self.excess_ratio.is_set or
                                                        self.excess_weight.is_set or
                                                        self.level.is_set or
                                                        self.profile_id.is_set or
                                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                                        (self.parent_bandwidth is not None and self.parent_bandwidth.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.chunk_id.yfilter != YFilter.not_set or
                                                        self.committed_weight.yfilter != YFilter.not_set or
                                                        self.excess_ratio.yfilter != YFilter.not_set or
                                                        self.excess_weight.yfilter != YFilter.not_set or
                                                        self.level.yfilter != YFilter.not_set or
                                                        self.profile_id.yfilter != YFilter.not_set or
                                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                                        (self.parent_bandwidth is not None and self.parent_bandwidth.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wfq" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.chunk_id.is_set or self.chunk_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.chunk_id.get_name_leafdata())
                                                    if (self.committed_weight.is_set or self.committed_weight.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.committed_weight.get_name_leafdata())
                                                    if (self.excess_ratio.is_set or self.excess_ratio.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.excess_ratio.get_name_leafdata())
                                                    if (self.excess_weight.is_set or self.excess_weight.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.excess_weight.get_name_leafdata())
                                                    if (self.level.is_set or self.level.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.level.get_name_leafdata())
                                                    if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "bandwidth"):
                                                        if (self.bandwidth is None):
                                                            self.bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.Bandwidth()
                                                            self.bandwidth.parent = self
                                                            self._children_name_map["bandwidth"] = "bandwidth"
                                                        return self.bandwidth

                                                    if (child_yang_name == "parent-bandwidth"):
                                                        if (self.parent_bandwidth is None):
                                                            self.parent_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq.ParentBandwidth()
                                                            self.parent_bandwidth.parent = self
                                                            self._children_name_map["parent_bandwidth"] = "parent-bandwidth"
                                                        return self.parent_bandwidth

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "bandwidth" or name == "parent-bandwidth" or name == "chunk-id" or name == "committed-weight" or name == "excess-ratio" or name == "excess-weight" or name == "level" or name == "profile-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "chunk-id"):
                                                        self.chunk_id = value
                                                        self.chunk_id.value_namespace = name_space
                                                        self.chunk_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "committed-weight"):
                                                        self.committed_weight = value
                                                        self.committed_weight.value_namespace = name_space
                                                        self.committed_weight.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "excess-ratio"):
                                                        self.excess_ratio = value
                                                        self.excess_ratio.value_namespace = name_space
                                                        self.excess_ratio.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "excess-weight"):
                                                        self.excess_weight = value
                                                        self.excess_weight.value_namespace = name_space
                                                        self.excess_weight.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "level"):
                                                        self.level = value
                                                        self.level.value_namespace = name_space
                                                        self.level.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-id"):
                                                        self.profile_id = value
                                                        self.profile_id.value_namespace = name_space
                                                        self.profile_id.value_namespace_prefix = name_space_prefix


                                            class Wred(Entity):
                                                """
                                                WRED parameters
                                                
                                                .. attribute:: curve
                                                
                                                	Curve details
                                                	**type**\: list of    :py:class:`Curve <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve>`
                                                
                                                .. attribute:: curve_xr
                                                
                                                	Number of curves
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: profile_id
                                                
                                                	Profile ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: scaling_profile_id
                                                
                                                	Scaling profile ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: table_id
                                                
                                                	Table ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: type
                                                
                                                	WRED type
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred, self).__init__()

                                                    self.yang_name = "wred"
                                                    self.yang_parent_name = "qos-show-ea-st-v1"

                                                    self.curve_xr = YLeaf(YType.uint16, "curve-xr")

                                                    self.profile_id = YLeaf(YType.uint32, "profile-id")

                                                    self.scaling_profile_id = YLeaf(YType.uint32, "scaling-profile-id")

                                                    self.table_id = YLeaf(YType.uint8, "table-id")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.curve = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("curve_xr",
                                                                    "profile_id",
                                                                    "scaling_profile_id",
                                                                    "table_id",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred, self).__setattr__(name, value)


                                                class Curve(Entity):
                                                    """
                                                    Curve details
                                                    
                                                    .. attribute:: match
                                                    
                                                    	WRED precedence match if precedence start value equals to end value Format\: <start\-value> , else range Format\: <start\-value> <end\-value>
                                                    	**type**\:  str
                                                    
                                                    .. attribute:: max_threshold
                                                    
                                                    	Maximum threshold
                                                    	**type**\:   :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold>`
                                                    
                                                    .. attribute:: max_threshold_user_config
                                                    
                                                    	Maximum threshold WRED context
                                                    	**type**\:   :py:class:`MaxThresholdUserConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig>`
                                                    
                                                    .. attribute:: min_threshold
                                                    
                                                    	Minimum threshold
                                                    	**type**\:   :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold>`
                                                    
                                                    .. attribute:: min_threshold_user_config
                                                    
                                                    	Minimum threshold WRED context
                                                    	**type**\:   :py:class:`MinThresholdUserConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve, self).__init__()

                                                        self.yang_name = "curve"
                                                        self.yang_parent_name = "wred"

                                                        self.match = YLeaf(YType.str, "match")

                                                        self.max_threshold = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold()
                                                        self.max_threshold.parent = self
                                                        self._children_name_map["max_threshold"] = "max-threshold"
                                                        self._children_yang_names.add("max-threshold")

                                                        self.max_threshold_user_config = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig()
                                                        self.max_threshold_user_config.parent = self
                                                        self._children_name_map["max_threshold_user_config"] = "max-threshold-user-config"
                                                        self._children_yang_names.add("max-threshold-user-config")

                                                        self.min_threshold = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold()
                                                        self.min_threshold.parent = self
                                                        self._children_name_map["min_threshold"] = "min-threshold"
                                                        self._children_yang_names.add("min-threshold")

                                                        self.min_threshold_user_config = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig()
                                                        self.min_threshold_user_config.parent = self
                                                        self._children_name_map["min_threshold_user_config"] = "min-threshold-user-config"
                                                        self._children_yang_names.add("min-threshold-user-config")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("match") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve, self).__setattr__(name, value)


                                                    class MinThreshold(Entity):
                                                        """
                                                        Minimum threshold
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold, self).__init__()

                                                            self.yang_name = "min-threshold"
                                                            self.yang_parent_name = "curve"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "min-threshold" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class MinThresholdUserConfig(Entity):
                                                        """
                                                        Minimum threshold WRED context
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig, self).__init__()

                                                            self.yang_name = "min-threshold-user-config"
                                                            self.yang_parent_name = "curve"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "min-threshold-user-config" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class MaxThreshold(Entity):
                                                        """
                                                        Maximum threshold
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold, self).__init__()

                                                            self.yang_name = "max-threshold"
                                                            self.yang_parent_name = "curve"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "max-threshold" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class MaxThresholdUserConfig(Entity):
                                                        """
                                                        Maximum threshold WRED context
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig, self).__init__()

                                                            self.yang_name = "max-threshold-user-config"
                                                            self.yang_parent_name = "curve"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "max-threshold-user-config" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.match.is_set or
                                                            (self.max_threshold is not None and self.max_threshold.has_data()) or
                                                            (self.max_threshold_user_config is not None and self.max_threshold_user_config.has_data()) or
                                                            (self.min_threshold is not None and self.min_threshold.has_data()) or
                                                            (self.min_threshold_user_config is not None and self.min_threshold_user_config.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.match.yfilter != YFilter.not_set or
                                                            (self.max_threshold is not None and self.max_threshold.has_operation()) or
                                                            (self.max_threshold_user_config is not None and self.max_threshold_user_config.has_operation()) or
                                                            (self.min_threshold is not None and self.min_threshold.has_operation()) or
                                                            (self.min_threshold_user_config is not None and self.min_threshold_user_config.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "curve" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.match.is_set or self.match.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.match.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "max-threshold"):
                                                            if (self.max_threshold is None):
                                                                self.max_threshold = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThreshold()
                                                                self.max_threshold.parent = self
                                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                            return self.max_threshold

                                                        if (child_yang_name == "max-threshold-user-config"):
                                                            if (self.max_threshold_user_config is None):
                                                                self.max_threshold_user_config = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MaxThresholdUserConfig()
                                                                self.max_threshold_user_config.parent = self
                                                                self._children_name_map["max_threshold_user_config"] = "max-threshold-user-config"
                                                            return self.max_threshold_user_config

                                                        if (child_yang_name == "min-threshold"):
                                                            if (self.min_threshold is None):
                                                                self.min_threshold = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThreshold()
                                                                self.min_threshold.parent = self
                                                                self._children_name_map["min_threshold"] = "min-threshold"
                                                            return self.min_threshold

                                                        if (child_yang_name == "min-threshold-user-config"):
                                                            if (self.min_threshold_user_config is None):
                                                                self.min_threshold_user_config = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve.MinThresholdUserConfig()
                                                                self.min_threshold_user_config.parent = self
                                                                self._children_name_map["min_threshold_user_config"] = "min-threshold-user-config"
                                                            return self.min_threshold_user_config

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "max-threshold" or name == "max-threshold-user-config" or name == "min-threshold" or name == "min-threshold-user-config" or name == "match"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "match"):
                                                            self.match = value
                                                            self.match.value_namespace = name_space
                                                            self.match.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.curve:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.curve_xr.is_set or
                                                        self.profile_id.is_set or
                                                        self.scaling_profile_id.is_set or
                                                        self.table_id.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    for c in self.curve:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.curve_xr.yfilter != YFilter.not_set or
                                                        self.profile_id.yfilter != YFilter.not_set or
                                                        self.scaling_profile_id.yfilter != YFilter.not_set or
                                                        self.table_id.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wred" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.curve_xr.is_set or self.curve_xr.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.curve_xr.get_name_leafdata())
                                                    if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_id.get_name_leafdata())
                                                    if (self.scaling_profile_id.is_set or self.scaling_profile_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.scaling_profile_id.get_name_leafdata())
                                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.table_id.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "curve"):
                                                        for c in self.curve:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred.Curve()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.curve.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "curve" or name == "curve-xr" or name == "profile-id" or name == "scaling-profile-id" or name == "table-id" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "curve-xr"):
                                                        self.curve_xr = value
                                                        self.curve_xr.value_namespace = name_space
                                                        self.curve_xr.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-id"):
                                                        self.profile_id = value
                                                        self.profile_id.value_namespace = name_space
                                                        self.profile_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "scaling-profile-id"):
                                                        self.scaling_profile_id = value
                                                        self.scaling_profile_id.value_namespace = name_space
                                                        self.scaling_profile_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "table-id"):
                                                        self.table_id = value
                                                        self.table_id.value_namespace = name_space
                                                        self.table_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix


                                            class Mark(Entity):
                                                """
                                                Mark parameters
                                                
                                                .. attribute:: child_mark
                                                
                                                	Child mark only
                                                	**type**\:   :py:class:`ChildMark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark>`
                                                
                                                .. attribute:: parent_mark
                                                
                                                	Parent mark only
                                                	**type**\:   :py:class:`ParentMark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark>`
                                                
                                                .. attribute:: parent_police_conform
                                                
                                                	Parent police conform mark
                                                	**type**\:   :py:class:`ParentPoliceConform <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform>`
                                                
                                                .. attribute:: parent_police_exceed
                                                
                                                	Parent police exceed mark
                                                	**type**\:   :py:class:`ParentPoliceExceed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed>`
                                                
                                                .. attribute:: parent_police_violate
                                                
                                                	Parent police violate mark
                                                	**type**\:   :py:class:`ParentPoliceViolate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate>`
                                                
                                                .. attribute:: police_conform
                                                
                                                	Child police conform mark
                                                	**type**\:   :py:class:`PoliceConform <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform>`
                                                
                                                .. attribute:: police_exceed
                                                
                                                	Child police exceed mark
                                                	**type**\:   :py:class:`PoliceExceed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed>`
                                                
                                                .. attribute:: police_violate
                                                
                                                	Child police violate mark
                                                	**type**\:   :py:class:`PoliceViolate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate>`
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark, self).__init__()

                                                    self.yang_name = "mark"
                                                    self.yang_parent_name = "qos-show-ea-st-v1"

                                                    self.child_mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark()
                                                    self.child_mark.parent = self
                                                    self._children_name_map["child_mark"] = "child-mark"
                                                    self._children_yang_names.add("child-mark")

                                                    self.parent_mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark()
                                                    self.parent_mark.parent = self
                                                    self._children_name_map["parent_mark"] = "parent-mark"
                                                    self._children_yang_names.add("parent-mark")

                                                    self.parent_police_conform = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform()
                                                    self.parent_police_conform.parent = self
                                                    self._children_name_map["parent_police_conform"] = "parent-police-conform"
                                                    self._children_yang_names.add("parent-police-conform")

                                                    self.parent_police_exceed = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed()
                                                    self.parent_police_exceed.parent = self
                                                    self._children_name_map["parent_police_exceed"] = "parent-police-exceed"
                                                    self._children_yang_names.add("parent-police-exceed")

                                                    self.parent_police_violate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate()
                                                    self.parent_police_violate.parent = self
                                                    self._children_name_map["parent_police_violate"] = "parent-police-violate"
                                                    self._children_yang_names.add("parent-police-violate")

                                                    self.police_conform = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform()
                                                    self.police_conform.parent = self
                                                    self._children_name_map["police_conform"] = "police-conform"
                                                    self._children_yang_names.add("police-conform")

                                                    self.police_exceed = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed()
                                                    self.police_exceed.parent = self
                                                    self._children_name_map["police_exceed"] = "police-exceed"
                                                    self._children_yang_names.add("police-exceed")

                                                    self.police_violate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate()
                                                    self.police_violate.parent = self
                                                    self._children_name_map["police_violate"] = "police-violate"
                                                    self._children_yang_names.add("police-violate")


                                                class ChildMark(Entity):
                                                    """
                                                    Child mark only
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark, self).__init__()

                                                        self.yang_name = "child-mark"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "child-mark"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "child-mark" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class PoliceConform(Entity):
                                                    """
                                                    Child police conform mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform, self).__init__()

                                                        self.yang_name = "police-conform"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "police-conform"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-conform" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class PoliceExceed(Entity):
                                                    """
                                                    Child police exceed mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed, self).__init__()

                                                        self.yang_name = "police-exceed"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "police-exceed"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-exceed" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class PoliceViolate(Entity):
                                                    """
                                                    Child police violate mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate, self).__init__()

                                                        self.yang_name = "police-violate"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "police-violate"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-violate" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class ParentMark(Entity):
                                                    """
                                                    Parent mark only
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark, self).__init__()

                                                        self.yang_name = "parent-mark"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "parent-mark"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "parent-mark" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class ParentPoliceConform(Entity):
                                                    """
                                                    Parent police conform mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform, self).__init__()

                                                        self.yang_name = "parent-police-conform"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "parent-police-conform"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "parent-police-conform" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class ParentPoliceExceed(Entity):
                                                    """
                                                    Parent police exceed mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed, self).__init__()

                                                        self.yang_name = "parent-police-exceed"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "parent-police-exceed"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "parent-police-exceed" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class ParentPoliceViolate(Entity):
                                                    """
                                                    Parent police violate mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate, self).__init__()

                                                        self.yang_name = "parent-police-violate"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "parent-police-violate"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "parent-police-violate" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        (self.child_mark is not None and self.child_mark.has_data()) or
                                                        (self.parent_mark is not None and self.parent_mark.has_data()) or
                                                        (self.parent_police_conform is not None and self.parent_police_conform.has_data()) or
                                                        (self.parent_police_exceed is not None and self.parent_police_exceed.has_data()) or
                                                        (self.parent_police_violate is not None and self.parent_police_violate.has_data()) or
                                                        (self.police_conform is not None and self.police_conform.has_data()) or
                                                        (self.police_exceed is not None and self.police_exceed.has_data()) or
                                                        (self.police_violate is not None and self.police_violate.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.child_mark is not None and self.child_mark.has_operation()) or
                                                        (self.parent_mark is not None and self.parent_mark.has_operation()) or
                                                        (self.parent_police_conform is not None and self.parent_police_conform.has_operation()) or
                                                        (self.parent_police_exceed is not None and self.parent_police_exceed.has_operation()) or
                                                        (self.parent_police_violate is not None and self.parent_police_violate.has_operation()) or
                                                        (self.police_conform is not None and self.police_conform.has_operation()) or
                                                        (self.police_exceed is not None and self.police_exceed.has_operation()) or
                                                        (self.police_violate is not None and self.police_violate.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "child-mark"):
                                                        if (self.child_mark is None):
                                                            self.child_mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ChildMark()
                                                            self.child_mark.parent = self
                                                            self._children_name_map["child_mark"] = "child-mark"
                                                        return self.child_mark

                                                    if (child_yang_name == "parent-mark"):
                                                        if (self.parent_mark is None):
                                                            self.parent_mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentMark()
                                                            self.parent_mark.parent = self
                                                            self._children_name_map["parent_mark"] = "parent-mark"
                                                        return self.parent_mark

                                                    if (child_yang_name == "parent-police-conform"):
                                                        if (self.parent_police_conform is None):
                                                            self.parent_police_conform = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceConform()
                                                            self.parent_police_conform.parent = self
                                                            self._children_name_map["parent_police_conform"] = "parent-police-conform"
                                                        return self.parent_police_conform

                                                    if (child_yang_name == "parent-police-exceed"):
                                                        if (self.parent_police_exceed is None):
                                                            self.parent_police_exceed = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceExceed()
                                                            self.parent_police_exceed.parent = self
                                                            self._children_name_map["parent_police_exceed"] = "parent-police-exceed"
                                                        return self.parent_police_exceed

                                                    if (child_yang_name == "parent-police-violate"):
                                                        if (self.parent_police_violate is None):
                                                            self.parent_police_violate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.ParentPoliceViolate()
                                                            self.parent_police_violate.parent = self
                                                            self._children_name_map["parent_police_violate"] = "parent-police-violate"
                                                        return self.parent_police_violate

                                                    if (child_yang_name == "police-conform"):
                                                        if (self.police_conform is None):
                                                            self.police_conform = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceConform()
                                                            self.police_conform.parent = self
                                                            self._children_name_map["police_conform"] = "police-conform"
                                                        return self.police_conform

                                                    if (child_yang_name == "police-exceed"):
                                                        if (self.police_exceed is None):
                                                            self.police_exceed = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceExceed()
                                                            self.police_exceed.parent = self
                                                            self._children_name_map["police_exceed"] = "police-exceed"
                                                        return self.police_exceed

                                                    if (child_yang_name == "police-violate"):
                                                        if (self.police_violate is None):
                                                            self.police_violate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark.PoliceViolate()
                                                            self.police_violate.parent = self
                                                            self._children_name_map["police_violate"] = "police-violate"
                                                        return self.police_violate

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "child-mark" or name == "parent-mark" or name == "parent-police-conform" or name == "parent-police-exceed" or name == "parent-police-violate" or name == "police-conform" or name == "police-exceed" or name == "police-violate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass

                                            def has_data(self):
                                                return (
                                                    self.class_level.is_set or
                                                    self.class_name.is_set or
                                                    self.parent_class_name.is_set or
                                                    self.parent_policy_name.is_set or
                                                    self.policy_name.is_set or
                                                    (self.mark is not None and self.mark.has_data()) or
                                                    (self.police is not None and self.police.has_data()) or
                                                    (self.queue is not None and self.queue.has_data()) or
                                                    (self.queue_limit_parameters is not None and self.queue_limit_parameters.has_data()) or
                                                    (self.shape is not None and self.shape.has_data()) or
                                                    (self.wfq is not None and self.wfq.has_data()) or
                                                    (self.wred is not None and self.wred.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.class_level.yfilter != YFilter.not_set or
                                                    self.class_name.yfilter != YFilter.not_set or
                                                    self.parent_class_name.yfilter != YFilter.not_set or
                                                    self.parent_policy_name.yfilter != YFilter.not_set or
                                                    self.policy_name.yfilter != YFilter.not_set or
                                                    (self.mark is not None and self.mark.has_operation()) or
                                                    (self.police is not None and self.police.has_operation()) or
                                                    (self.queue is not None and self.queue.has_operation()) or
                                                    (self.queue_limit_parameters is not None and self.queue_limit_parameters.has_operation()) or
                                                    (self.shape is not None and self.shape.has_operation()) or
                                                    (self.wfq is not None and self.wfq.has_operation()) or
                                                    (self.wred is not None and self.wred.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "qos-show-ea-st-v1" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.class_level.is_set or self.class_level.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_level.get_name_leafdata())
                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                if (self.parent_class_name.is_set or self.parent_class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_class_name.get_name_leafdata())
                                                if (self.parent_policy_name.is_set or self.parent_policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_policy_name.get_name_leafdata())
                                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.policy_name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark"):
                                                    if (self.mark is None):
                                                        self.mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Mark()
                                                        self.mark.parent = self
                                                        self._children_name_map["mark"] = "mark"
                                                    return self.mark

                                                if (child_yang_name == "police"):
                                                    if (self.police is None):
                                                        self.police = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Police()
                                                        self.police.parent = self
                                                        self._children_name_map["police"] = "police"
                                                    return self.police

                                                if (child_yang_name == "queue"):
                                                    if (self.queue is None):
                                                        self.queue = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Queue()
                                                        self.queue.parent = self
                                                        self._children_name_map["queue"] = "queue"
                                                    return self.queue

                                                if (child_yang_name == "queue-limit-parameters"):
                                                    if (self.queue_limit_parameters is None):
                                                        self.queue_limit_parameters = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.QueueLimitParameters()
                                                        self.queue_limit_parameters.parent = self
                                                        self._children_name_map["queue_limit_parameters"] = "queue-limit-parameters"
                                                    return self.queue_limit_parameters

                                                if (child_yang_name == "shape"):
                                                    if (self.shape is None):
                                                        self.shape = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Shape()
                                                        self.shape.parent = self
                                                        self._children_name_map["shape"] = "shape"
                                                    return self.shape

                                                if (child_yang_name == "wfq"):
                                                    if (self.wfq is None):
                                                        self.wfq = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wfq()
                                                        self.wfq.parent = self
                                                        self._children_name_map["wfq"] = "wfq"
                                                    return self.wfq

                                                if (child_yang_name == "wred"):
                                                    if (self.wred is None):
                                                        self.wred = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1.Wred()
                                                        self.wred.parent = self
                                                        self._children_name_map["wred"] = "wred"
                                                    return self.wred

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark" or name == "police" or name == "queue" or name == "queue-limit-parameters" or name == "shape" or name == "wfq" or name == "wred" or name == "class-level" or name == "class-name" or name == "parent-class-name" or name == "parent-policy-name" or name == "policy-name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "class-level"):
                                                    self.class_level = value
                                                    self.class_level.value_namespace = name_space
                                                    self.class_level.value_namespace_prefix = name_space_prefix
                                                if(value_path == "class-name"):
                                                    self.class_name = value
                                                    self.class_name.value_namespace = name_space
                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-class-name"):
                                                    self.parent_class_name = value
                                                    self.parent_class_name.value_namespace = name_space
                                                    self.parent_class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-policy-name"):
                                                    self.parent_policy_name = value
                                                    self.parent_policy_name.value_namespace = name_space
                                                    self.parent_policy_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "policy-name"):
                                                    self.policy_name = value
                                                    self.policy_name.value_namespace = name_space
                                                    self.policy_name.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.qos_show_ea_st_v1:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.qos_show_ea_st_v1:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "qos-show-ea-st-v1"):
                                                for c in self.qos_show_ea_st_v1:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy.QosShowEaStV1()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.qos_show_ea_st_v1.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "qos-show-ea-st-v1"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class PolicyTyphoon(Entity):
                                        """
                                        Typhoon QoS policy details
                                        
                                        .. attribute:: qos_show_ea_st_v2
                                        
                                        	qos show ea st v2
                                        	**type**\: list of    :py:class:`QosShowEaStV2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2>`
                                        
                                        

                                        """

                                        _prefix = 'asr9k-qos-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon, self).__init__()

                                            self.yang_name = "policy-typhoon"
                                            self.yang_parent_name = "details"

                                            self.qos_show_ea_st_v2 = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon, self).__setattr__(name, value)


                                        class QosShowEaStV2(Entity):
                                            """
                                            qos show ea st v2
                                            
                                            .. attribute:: class_level
                                            
                                            	Class level
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: class_name
                                            
                                            	Class name
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: mark
                                            
                                            	Mark parameters
                                            	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark>`
                                            
                                            .. attribute:: parent_class_name
                                            
                                            	Parent class name
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: parent_policy_name
                                            
                                            	Parent policy name
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: police
                                            
                                            	Police parameters
                                            	**type**\:   :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police>`
                                            
                                            .. attribute:: policy_name
                                            
                                            	Policy name
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: queue
                                            
                                            	Queue parameters
                                            	**type**\:   :py:class:`Queue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Queue>`
                                            
                                            .. attribute:: queue_limit_parameters
                                            
                                            	Queue limit parameters
                                            	**type**\:   :py:class:`QueueLimitParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters>`
                                            
                                            .. attribute:: shape
                                            
                                            	Shape parameters
                                            	**type**\:   :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape>`
                                            
                                            .. attribute:: wfq
                                            
                                            	WFQ parameters
                                            	**type**\:   :py:class:`Wfq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq>`
                                            
                                            .. attribute:: wred
                                            
                                            	WRED parameters
                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred>`
                                            
                                            

                                            """

                                            _prefix = 'asr9k-qos-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2, self).__init__()

                                                self.yang_name = "qos-show-ea-st-v2"
                                                self.yang_parent_name = "policy-typhoon"

                                                self.class_level = YLeaf(YType.uint8, "class-level")

                                                self.class_name = YLeaf(YType.str, "class-name")

                                                self.parent_class_name = YLeaf(YType.str, "parent-class-name")

                                                self.parent_policy_name = YLeaf(YType.str, "parent-policy-name")

                                                self.policy_name = YLeaf(YType.str, "policy-name")

                                                self.mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark()
                                                self.mark.parent = self
                                                self._children_name_map["mark"] = "mark"
                                                self._children_yang_names.add("mark")

                                                self.police = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police()
                                                self.police.parent = self
                                                self._children_name_map["police"] = "police"
                                                self._children_yang_names.add("police")

                                                self.queue = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Queue()
                                                self.queue.parent = self
                                                self._children_name_map["queue"] = "queue"
                                                self._children_yang_names.add("queue")

                                                self.queue_limit_parameters = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters()
                                                self.queue_limit_parameters.parent = self
                                                self._children_name_map["queue_limit_parameters"] = "queue-limit-parameters"
                                                self._children_yang_names.add("queue-limit-parameters")

                                                self.shape = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape()
                                                self.shape.parent = self
                                                self._children_name_map["shape"] = "shape"
                                                self._children_yang_names.add("shape")

                                                self.wfq = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq()
                                                self.wfq.parent = self
                                                self._children_name_map["wfq"] = "wfq"
                                                self._children_yang_names.add("wfq")

                                                self.wred = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred()
                                                self.wred.parent = self
                                                self._children_name_map["wred"] = "wred"
                                                self._children_yang_names.add("wred")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("class_level",
                                                                "class_name",
                                                                "parent_class_name",
                                                                "parent_policy_name",
                                                                "policy_name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2, self).__setattr__(name, value)


                                            class Queue(Entity):
                                                """
                                                Queue parameters
                                                
                                                .. attribute:: class_name
                                                
                                                	Class name
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: queue_id
                                                
                                                	Queue ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: queue_type
                                                
                                                	Queue type
                                                	**type**\:   :py:class:`Queue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Queue>`
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Queue, self).__init__()

                                                    self.yang_name = "queue"
                                                    self.yang_parent_name = "qos-show-ea-st-v2"

                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                    self.queue_id = YLeaf(YType.uint32, "queue-id")

                                                    self.queue_type = YLeaf(YType.enumeration, "queue-type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("class_name",
                                                                    "queue_id",
                                                                    "queue_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Queue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Queue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.class_name.is_set or
                                                        self.queue_id.is_set or
                                                        self.queue_type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.class_name.yfilter != YFilter.not_set or
                                                        self.queue_id.yfilter != YFilter.not_set or
                                                        self.queue_type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.class_name.get_name_leafdata())
                                                    if (self.queue_id.is_set or self.queue_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_id.get_name_leafdata())
                                                    if (self.queue_type.is_set or self.queue_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.queue_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "class-name" or name == "queue-id" or name == "queue-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "class-name"):
                                                        self.class_name = value
                                                        self.class_name.value_namespace = name_space
                                                        self.class_name.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-id"):
                                                        self.queue_id = value
                                                        self.queue_id.value_namespace = name_space
                                                        self.queue_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "queue-type"):
                                                        self.queue_type = value
                                                        self.queue_type.value_namespace = name_space
                                                        self.queue_type.value_namespace_prefix = name_space_prefix


                                            class QueueLimitParameters(Entity):
                                                """
                                                Queue limit parameters
                                                
                                                .. attribute:: absolute_index
                                                
                                                	Absolute Index
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: config_queue_limit
                                                
                                                	Config queue limit
                                                	**type**\:   :py:class:`ConfigQueueLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit>`
                                                
                                                .. attribute:: curve_id
                                                
                                                	Curve ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: queue_limit
                                                
                                                	Queue limit in kbytes
                                                	**type**\:   :py:class:`QueueLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit>`
                                                
                                                .. attribute:: template_id
                                                
                                                	Template ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters, self).__init__()

                                                    self.yang_name = "queue-limit-parameters"
                                                    self.yang_parent_name = "qos-show-ea-st-v2"

                                                    self.absolute_index = YLeaf(YType.uint16, "absolute-index")

                                                    self.curve_id = YLeaf(YType.uint16, "curve-id")

                                                    self.template_id = YLeaf(YType.uint16, "template-id")

                                                    self.config_queue_limit = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit()
                                                    self.config_queue_limit.parent = self
                                                    self._children_name_map["config_queue_limit"] = "config-queue-limit"
                                                    self._children_yang_names.add("config-queue-limit")

                                                    self.queue_limit = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit()
                                                    self.queue_limit.parent = self
                                                    self._children_name_map["queue_limit"] = "queue-limit"
                                                    self._children_yang_names.add("queue-limit")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("absolute_index",
                                                                    "curve_id",
                                                                    "template_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters, self).__setattr__(name, value)


                                                class QueueLimit(Entity):
                                                    """
                                                    Queue limit in kbytes
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit, self).__init__()

                                                        self.yang_name = "queue-limit"
                                                        self.yang_parent_name = "queue-limit-parameters"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "queue-limit" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class ConfigQueueLimit(Entity):
                                                    """
                                                    Config queue limit
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit, self).__init__()

                                                        self.yang_name = "config-queue-limit"
                                                        self.yang_parent_name = "queue-limit-parameters"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "config-queue-limit" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.absolute_index.is_set or
                                                        self.curve_id.is_set or
                                                        self.template_id.is_set or
                                                        (self.config_queue_limit is not None and self.config_queue_limit.has_data()) or
                                                        (self.queue_limit is not None and self.queue_limit.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.absolute_index.yfilter != YFilter.not_set or
                                                        self.curve_id.yfilter != YFilter.not_set or
                                                        self.template_id.yfilter != YFilter.not_set or
                                                        (self.config_queue_limit is not None and self.config_queue_limit.has_operation()) or
                                                        (self.queue_limit is not None and self.queue_limit.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "queue-limit-parameters" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.absolute_index.is_set or self.absolute_index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.absolute_index.get_name_leafdata())
                                                    if (self.curve_id.is_set or self.curve_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.curve_id.get_name_leafdata())
                                                    if (self.template_id.is_set or self.template_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.template_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "config-queue-limit"):
                                                        if (self.config_queue_limit is None):
                                                            self.config_queue_limit = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.ConfigQueueLimit()
                                                            self.config_queue_limit.parent = self
                                                            self._children_name_map["config_queue_limit"] = "config-queue-limit"
                                                        return self.config_queue_limit

                                                    if (child_yang_name == "queue-limit"):
                                                        if (self.queue_limit is None):
                                                            self.queue_limit = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters.QueueLimit()
                                                            self.queue_limit.parent = self
                                                            self._children_name_map["queue_limit"] = "queue-limit"
                                                        return self.queue_limit

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "config-queue-limit" or name == "queue-limit" or name == "absolute-index" or name == "curve-id" or name == "template-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "absolute-index"):
                                                        self.absolute_index = value
                                                        self.absolute_index.value_namespace = name_space
                                                        self.absolute_index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "curve-id"):
                                                        self.curve_id = value
                                                        self.curve_id.value_namespace = name_space
                                                        self.curve_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "template-id"):
                                                        self.template_id = value
                                                        self.template_id.value_namespace = name_space
                                                        self.template_id.value_namespace_prefix = name_space_prefix


                                            class Shape(Entity):
                                                """
                                                Shape parameters
                                                
                                                .. attribute:: cir_shape
                                                
                                                	CIR shaper params
                                                	**type**\:   :py:class:`CirShape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape>`
                                                
                                                .. attribute:: cir_shape_type
                                                
                                                	CIR Shaper type
                                                	**type**\:   :py:class:`ShapeProfiletypeV2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ShapeProfiletypeV2>`
                                                
                                                .. attribute:: pir_shape
                                                
                                                	PIR shaper params
                                                	**type**\:   :py:class:`PirShape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape>`
                                                
                                                .. attribute:: pir_shape_type
                                                
                                                	PIR Shaper type
                                                	**type**\:   :py:class:`ShapeProfiletypeV2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ShapeProfiletypeV2>`
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape, self).__init__()

                                                    self.yang_name = "shape"
                                                    self.yang_parent_name = "qos-show-ea-st-v2"

                                                    self.cir_shape_type = YLeaf(YType.enumeration, "cir-shape-type")

                                                    self.pir_shape_type = YLeaf(YType.enumeration, "pir-shape-type")

                                                    self.cir_shape = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape()
                                                    self.cir_shape.parent = self
                                                    self._children_name_map["cir_shape"] = "cir-shape"
                                                    self._children_yang_names.add("cir-shape")

                                                    self.pir_shape = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape()
                                                    self.pir_shape.parent = self
                                                    self._children_name_map["pir_shape"] = "pir-shape"
                                                    self._children_yang_names.add("pir-shape")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("cir_shape_type",
                                                                    "pir_shape_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape, self).__setattr__(name, value)


                                                class CirShape(Entity):
                                                    """
                                                    CIR shaper params
                                                    
                                                    .. attribute:: cbs
                                                    
                                                    	CBS in bytes
                                                    	**type**\:   :py:class:`Cbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs>`
                                                    
                                                    .. attribute:: chunk_id
                                                    
                                                    	Shape Chunk ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: cir
                                                    
                                                    	CIR in kbps
                                                    	**type**\:   :py:class:`Cir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir>`
                                                    
                                                    .. attribute:: config_bandwidth
                                                    
                                                    	Config bandwidth
                                                    	**type**\:   :py:class:`ConfigBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth>`
                                                    
                                                    .. attribute:: profile_id
                                                    
                                                    	Shape profile ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: scale_factor
                                                    
                                                    	Scale Factor
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape, self).__init__()

                                                        self.yang_name = "cir-shape"
                                                        self.yang_parent_name = "shape"

                                                        self.chunk_id = YLeaf(YType.uint32, "chunk-id")

                                                        self.profile_id = YLeaf(YType.uint16, "profile-id")

                                                        self.scale_factor = YLeaf(YType.uint16, "scale-factor")

                                                        self.cbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs()
                                                        self.cbs.parent = self
                                                        self._children_name_map["cbs"] = "cbs"
                                                        self._children_yang_names.add("cbs")

                                                        self.cir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir()
                                                        self.cir.parent = self
                                                        self._children_name_map["cir"] = "cir"
                                                        self._children_yang_names.add("cir")

                                                        self.config_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth()
                                                        self.config_bandwidth.parent = self
                                                        self._children_name_map["config_bandwidth"] = "config-bandwidth"
                                                        self._children_yang_names.add("config-bandwidth")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("chunk_id",
                                                                        "profile_id",
                                                                        "scale_factor") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape, self).__setattr__(name, value)


                                                    class Cir(Entity):
                                                        """
                                                        CIR in kbps
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir, self).__init__()

                                                            self.yang_name = "cir"
                                                            self.yang_parent_name = "cir-shape"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "cir" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class ConfigBandwidth(Entity):
                                                        """
                                                        Config bandwidth
                                                        
                                                        .. attribute:: minimum_rate
                                                        
                                                        	Minimum bandwidth rate
                                                        	**type**\:   :py:class:`MinimumRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth, self).__init__()

                                                            self.yang_name = "config-bandwidth"
                                                            self.yang_parent_name = "cir-shape"

                                                            self.minimum_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate()
                                                            self.minimum_rate.parent = self
                                                            self._children_name_map["minimum_rate"] = "minimum-rate"
                                                            self._children_yang_names.add("minimum-rate")


                                                        class MinimumRate(Entity):
                                                            """
                                                            Minimum bandwidth rate
                                                            
                                                            .. attribute:: unit
                                                            
                                                            	Config unit
                                                            	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                            
                                                            .. attribute:: value
                                                            
                                                            	Config value
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            

                                                            """

                                                            _prefix = 'asr9k-qos-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate, self).__init__()

                                                                self.yang_name = "minimum-rate"
                                                                self.yang_parent_name = "config-bandwidth"

                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                self.value = YLeaf(YType.uint32, "value")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("unit",
                                                                                "value") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.unit.is_set or
                                                                    self.value.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.unit.yfilter != YFilter.not_set or
                                                                    self.value.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "minimum-rate" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.unit.get_name_leafdata())
                                                                if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.value.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "unit" or name == "value"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "unit"):
                                                                    self.unit = value
                                                                    self.unit.value_namespace = name_space
                                                                    self.unit.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "value"):
                                                                    self.value = value
                                                                    self.value.value_namespace = name_space
                                                                    self.value.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (self.minimum_rate is not None and self.minimum_rate.has_data())

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                (self.minimum_rate is not None and self.minimum_rate.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "config-bandwidth" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "minimum-rate"):
                                                                if (self.minimum_rate is None):
                                                                    self.minimum_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth.MinimumRate()
                                                                    self.minimum_rate.parent = self
                                                                    self._children_name_map["minimum_rate"] = "minimum-rate"
                                                                return self.minimum_rate

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "minimum-rate"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            pass


                                                    class Cbs(Entity):
                                                        """
                                                        CBS in bytes
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs, self).__init__()

                                                            self.yang_name = "cbs"
                                                            self.yang_parent_name = "cir-shape"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "cbs" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.chunk_id.is_set or
                                                            self.profile_id.is_set or
                                                            self.scale_factor.is_set or
                                                            (self.cbs is not None and self.cbs.has_data()) or
                                                            (self.cir is not None and self.cir.has_data()) or
                                                            (self.config_bandwidth is not None and self.config_bandwidth.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.chunk_id.yfilter != YFilter.not_set or
                                                            self.profile_id.yfilter != YFilter.not_set or
                                                            self.scale_factor.yfilter != YFilter.not_set or
                                                            (self.cbs is not None and self.cbs.has_operation()) or
                                                            (self.cir is not None and self.cir.has_operation()) or
                                                            (self.config_bandwidth is not None and self.config_bandwidth.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cir-shape" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.chunk_id.is_set or self.chunk_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.chunk_id.get_name_leafdata())
                                                        if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.profile_id.get_name_leafdata())
                                                        if (self.scale_factor.is_set or self.scale_factor.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.scale_factor.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "cbs"):
                                                            if (self.cbs is None):
                                                                self.cbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cbs()
                                                                self.cbs.parent = self
                                                                self._children_name_map["cbs"] = "cbs"
                                                            return self.cbs

                                                        if (child_yang_name == "cir"):
                                                            if (self.cir is None):
                                                                self.cir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.Cir()
                                                                self.cir.parent = self
                                                                self._children_name_map["cir"] = "cir"
                                                            return self.cir

                                                        if (child_yang_name == "config-bandwidth"):
                                                            if (self.config_bandwidth is None):
                                                                self.config_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape.ConfigBandwidth()
                                                                self.config_bandwidth.parent = self
                                                                self._children_name_map["config_bandwidth"] = "config-bandwidth"
                                                            return self.config_bandwidth

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "cbs" or name == "cir" or name == "config-bandwidth" or name == "chunk-id" or name == "profile-id" or name == "scale-factor"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "chunk-id"):
                                                            self.chunk_id = value
                                                            self.chunk_id.value_namespace = name_space
                                                            self.chunk_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "profile-id"):
                                                            self.profile_id = value
                                                            self.profile_id.value_namespace = name_space
                                                            self.profile_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "scale-factor"):
                                                            self.scale_factor = value
                                                            self.scale_factor.value_namespace = name_space
                                                            self.scale_factor.value_namespace_prefix = name_space_prefix


                                                class PirShape(Entity):
                                                    """
                                                    PIR shaper params
                                                    
                                                    .. attribute:: chunk_id
                                                    
                                                    	Shape Chunk ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: pbs
                                                    
                                                    	PBS in bytes
                                                    	**type**\:   :py:class:`Pbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs>`
                                                    
                                                    .. attribute:: pir
                                                    
                                                    	PIR in kbps
                                                    	**type**\:   :py:class:`Pir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir>`
                                                    
                                                    .. attribute:: profile_id
                                                    
                                                    	Shape profile ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: scale_factor
                                                    
                                                    	Scale Factor
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape, self).__init__()

                                                        self.yang_name = "pir-shape"
                                                        self.yang_parent_name = "shape"

                                                        self.chunk_id = YLeaf(YType.uint32, "chunk-id")

                                                        self.profile_id = YLeaf(YType.uint16, "profile-id")

                                                        self.scale_factor = YLeaf(YType.uint16, "scale-factor")

                                                        self.pbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs()
                                                        self.pbs.parent = self
                                                        self._children_name_map["pbs"] = "pbs"
                                                        self._children_yang_names.add("pbs")

                                                        self.pir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir()
                                                        self.pir.parent = self
                                                        self._children_name_map["pir"] = "pir"
                                                        self._children_yang_names.add("pir")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("chunk_id",
                                                                        "profile_id",
                                                                        "scale_factor") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape, self).__setattr__(name, value)


                                                    class Pir(Entity):
                                                        """
                                                        PIR in kbps
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir, self).__init__()

                                                            self.yang_name = "pir"
                                                            self.yang_parent_name = "pir-shape"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "pir" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class Pbs(Entity):
                                                        """
                                                        PBS in bytes
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs, self).__init__()

                                                            self.yang_name = "pbs"
                                                            self.yang_parent_name = "pir-shape"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "pbs" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.chunk_id.is_set or
                                                            self.profile_id.is_set or
                                                            self.scale_factor.is_set or
                                                            (self.pbs is not None and self.pbs.has_data()) or
                                                            (self.pir is not None and self.pir.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.chunk_id.yfilter != YFilter.not_set or
                                                            self.profile_id.yfilter != YFilter.not_set or
                                                            self.scale_factor.yfilter != YFilter.not_set or
                                                            (self.pbs is not None and self.pbs.has_operation()) or
                                                            (self.pir is not None and self.pir.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "pir-shape" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.chunk_id.is_set or self.chunk_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.chunk_id.get_name_leafdata())
                                                        if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.profile_id.get_name_leafdata())
                                                        if (self.scale_factor.is_set or self.scale_factor.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.scale_factor.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "pbs"):
                                                            if (self.pbs is None):
                                                                self.pbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pbs()
                                                                self.pbs.parent = self
                                                                self._children_name_map["pbs"] = "pbs"
                                                            return self.pbs

                                                        if (child_yang_name == "pir"):
                                                            if (self.pir is None):
                                                                self.pir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape.Pir()
                                                                self.pir.parent = self
                                                                self._children_name_map["pir"] = "pir"
                                                            return self.pir

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "pbs" or name == "pir" or name == "chunk-id" or name == "profile-id" or name == "scale-factor"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "chunk-id"):
                                                            self.chunk_id = value
                                                            self.chunk_id.value_namespace = name_space
                                                            self.chunk_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "profile-id"):
                                                            self.profile_id = value
                                                            self.profile_id.value_namespace = name_space
                                                            self.profile_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "scale-factor"):
                                                            self.scale_factor = value
                                                            self.scale_factor.value_namespace = name_space
                                                            self.scale_factor.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.cir_shape_type.is_set or
                                                        self.pir_shape_type.is_set or
                                                        (self.cir_shape is not None and self.cir_shape.has_data()) or
                                                        (self.pir_shape is not None and self.pir_shape.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.cir_shape_type.yfilter != YFilter.not_set or
                                                        self.pir_shape_type.yfilter != YFilter.not_set or
                                                        (self.cir_shape is not None and self.cir_shape.has_operation()) or
                                                        (self.pir_shape is not None and self.pir_shape.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "shape" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.cir_shape_type.is_set or self.cir_shape_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.cir_shape_type.get_name_leafdata())
                                                    if (self.pir_shape_type.is_set or self.pir_shape_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.pir_shape_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "cir-shape"):
                                                        if (self.cir_shape is None):
                                                            self.cir_shape = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.CirShape()
                                                            self.cir_shape.parent = self
                                                            self._children_name_map["cir_shape"] = "cir-shape"
                                                        return self.cir_shape

                                                    if (child_yang_name == "pir-shape"):
                                                        if (self.pir_shape is None):
                                                            self.pir_shape = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape.PirShape()
                                                            self.pir_shape.parent = self
                                                            self._children_name_map["pir_shape"] = "pir-shape"
                                                        return self.pir_shape

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "cir-shape" or name == "pir-shape" or name == "cir-shape-type" or name == "pir-shape-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "cir-shape-type"):
                                                        self.cir_shape_type = value
                                                        self.cir_shape_type.value_namespace = name_space
                                                        self.cir_shape_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "pir-shape-type"):
                                                        self.pir_shape_type = value
                                                        self.pir_shape_type.value_namespace = name_space
                                                        self.pir_shape_type.value_namespace_prefix = name_space_prefix


                                            class Police(Entity):
                                                """
                                                Police parameters
                                                
                                                .. attribute:: cbs
                                                
                                                	CBS
                                                	**type**\:   :py:class:`Cbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs>`
                                                
                                                .. attribute:: cir
                                                
                                                	CIR
                                                	**type**\:   :py:class:`Cir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir>`
                                                
                                                .. attribute:: pbs
                                                
                                                	PBS
                                                	**type**\:   :py:class:`Pbs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs>`
                                                
                                                .. attribute:: pir
                                                
                                                	PIR
                                                	**type**\:   :py:class:`Pir <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir>`
                                                
                                                .. attribute:: police_config_parameters
                                                
                                                	Police config parameters
                                                	**type**\:   :py:class:`PoliceConfigParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters>`
                                                
                                                .. attribute:: policer_type
                                                
                                                	Policer type
                                                	**type**\:   :py:class:`TbAlgorithm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.TbAlgorithm>`
                                                
                                                .. attribute:: profile_id
                                                
                                                	Police profile ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police, self).__init__()

                                                    self.yang_name = "police"
                                                    self.yang_parent_name = "qos-show-ea-st-v2"

                                                    self.policer_type = YLeaf(YType.enumeration, "policer-type")

                                                    self.profile_id = YLeaf(YType.uint32, "profile-id")

                                                    self.cbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs()
                                                    self.cbs.parent = self
                                                    self._children_name_map["cbs"] = "cbs"
                                                    self._children_yang_names.add("cbs")

                                                    self.cir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir()
                                                    self.cir.parent = self
                                                    self._children_name_map["cir"] = "cir"
                                                    self._children_yang_names.add("cir")

                                                    self.pbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs()
                                                    self.pbs.parent = self
                                                    self._children_name_map["pbs"] = "pbs"
                                                    self._children_yang_names.add("pbs")

                                                    self.pir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir()
                                                    self.pir.parent = self
                                                    self._children_name_map["pir"] = "pir"
                                                    self._children_yang_names.add("pir")

                                                    self.police_config_parameters = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters()
                                                    self.police_config_parameters.parent = self
                                                    self._children_name_map["police_config_parameters"] = "police-config-parameters"
                                                    self._children_yang_names.add("police-config-parameters")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("policer_type",
                                                                    "profile_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police, self).__setattr__(name, value)


                                                class Cir(Entity):
                                                    """
                                                    CIR
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir, self).__init__()

                                                        self.yang_name = "cir"
                                                        self.yang_parent_name = "police"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cir" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class Cbs(Entity):
                                                    """
                                                    CBS
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs, self).__init__()

                                                        self.yang_name = "cbs"
                                                        self.yang_parent_name = "police"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "cbs" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class Pir(Entity):
                                                    """
                                                    PIR
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir, self).__init__()

                                                        self.yang_name = "pir"
                                                        self.yang_parent_name = "police"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "pir" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class Pbs(Entity):
                                                    """
                                                    PBS
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs, self).__init__()

                                                        self.yang_name = "pbs"
                                                        self.yang_parent_name = "police"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "pbs" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class PoliceConfigParameters(Entity):
                                                    """
                                                    Police config parameters
                                                    
                                                    .. attribute:: average_rate
                                                    
                                                    	Average rate
                                                    	**type**\:   :py:class:`AverageRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate>`
                                                    
                                                    .. attribute:: conform_burst
                                                    
                                                    	Conform burst
                                                    	**type**\:   :py:class:`ConformBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst>`
                                                    
                                                    .. attribute:: exceed_burst
                                                    
                                                    	Exceed burst
                                                    	**type**\:   :py:class:`ExceedBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst>`
                                                    
                                                    .. attribute:: peak_rate
                                                    
                                                    	Peak rate
                                                    	**type**\:   :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters, self).__init__()

                                                        self.yang_name = "police-config-parameters"
                                                        self.yang_parent_name = "police"

                                                        self.average_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate()
                                                        self.average_rate.parent = self
                                                        self._children_name_map["average_rate"] = "average-rate"
                                                        self._children_yang_names.add("average-rate")

                                                        self.conform_burst = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst()
                                                        self.conform_burst.parent = self
                                                        self._children_name_map["conform_burst"] = "conform-burst"
                                                        self._children_yang_names.add("conform-burst")

                                                        self.exceed_burst = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst()
                                                        self.exceed_burst.parent = self
                                                        self._children_name_map["exceed_burst"] = "exceed-burst"
                                                        self._children_yang_names.add("exceed-burst")

                                                        self.peak_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate()
                                                        self.peak_rate.parent = self
                                                        self._children_name_map["peak_rate"] = "peak-rate"
                                                        self._children_yang_names.add("peak-rate")


                                                    class AverageRate(Entity):
                                                        """
                                                        Average rate
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate, self).__init__()

                                                            self.yang_name = "average-rate"
                                                            self.yang_parent_name = "police-config-parameters"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "average-rate" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class PeakRate(Entity):
                                                        """
                                                        Peak rate
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate, self).__init__()

                                                            self.yang_name = "peak-rate"
                                                            self.yang_parent_name = "police-config-parameters"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "peak-rate" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class ConformBurst(Entity):
                                                        """
                                                        Conform burst
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst, self).__init__()

                                                            self.yang_name = "conform-burst"
                                                            self.yang_parent_name = "police-config-parameters"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "conform-burst" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class ExceedBurst(Entity):
                                                        """
                                                        Exceed burst
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst, self).__init__()

                                                            self.yang_name = "exceed-burst"
                                                            self.yang_parent_name = "police-config-parameters"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "exceed-burst" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            (self.average_rate is not None and self.average_rate.has_data()) or
                                                            (self.conform_burst is not None and self.conform_burst.has_data()) or
                                                            (self.exceed_burst is not None and self.exceed_burst.has_data()) or
                                                            (self.peak_rate is not None and self.peak_rate.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            (self.average_rate is not None and self.average_rate.has_operation()) or
                                                            (self.conform_burst is not None and self.conform_burst.has_operation()) or
                                                            (self.exceed_burst is not None and self.exceed_burst.has_operation()) or
                                                            (self.peak_rate is not None and self.peak_rate.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-config-parameters" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "average-rate"):
                                                            if (self.average_rate is None):
                                                                self.average_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.AverageRate()
                                                                self.average_rate.parent = self
                                                                self._children_name_map["average_rate"] = "average-rate"
                                                            return self.average_rate

                                                        if (child_yang_name == "conform-burst"):
                                                            if (self.conform_burst is None):
                                                                self.conform_burst = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ConformBurst()
                                                                self.conform_burst.parent = self
                                                                self._children_name_map["conform_burst"] = "conform-burst"
                                                            return self.conform_burst

                                                        if (child_yang_name == "exceed-burst"):
                                                            if (self.exceed_burst is None):
                                                                self.exceed_burst = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.ExceedBurst()
                                                                self.exceed_burst.parent = self
                                                                self._children_name_map["exceed_burst"] = "exceed-burst"
                                                            return self.exceed_burst

                                                        if (child_yang_name == "peak-rate"):
                                                            if (self.peak_rate is None):
                                                                self.peak_rate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters.PeakRate()
                                                                self.peak_rate.parent = self
                                                                self._children_name_map["peak_rate"] = "peak-rate"
                                                            return self.peak_rate

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "average-rate" or name == "conform-burst" or name == "exceed-burst" or name == "peak-rate"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        pass

                                                def has_data(self):
                                                    return (
                                                        self.policer_type.is_set or
                                                        self.profile_id.is_set or
                                                        (self.cbs is not None and self.cbs.has_data()) or
                                                        (self.cir is not None and self.cir.has_data()) or
                                                        (self.pbs is not None and self.pbs.has_data()) or
                                                        (self.pir is not None and self.pir.has_data()) or
                                                        (self.police_config_parameters is not None and self.police_config_parameters.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.policer_type.yfilter != YFilter.not_set or
                                                        self.profile_id.yfilter != YFilter.not_set or
                                                        (self.cbs is not None and self.cbs.has_operation()) or
                                                        (self.cir is not None and self.cir.has_operation()) or
                                                        (self.pbs is not None and self.pbs.has_operation()) or
                                                        (self.pir is not None and self.pir.has_operation()) or
                                                        (self.police_config_parameters is not None and self.police_config_parameters.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "police" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.policer_type.is_set or self.policer_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.policer_type.get_name_leafdata())
                                                    if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "cbs"):
                                                        if (self.cbs is None):
                                                            self.cbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cbs()
                                                            self.cbs.parent = self
                                                            self._children_name_map["cbs"] = "cbs"
                                                        return self.cbs

                                                    if (child_yang_name == "cir"):
                                                        if (self.cir is None):
                                                            self.cir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Cir()
                                                            self.cir.parent = self
                                                            self._children_name_map["cir"] = "cir"
                                                        return self.cir

                                                    if (child_yang_name == "pbs"):
                                                        if (self.pbs is None):
                                                            self.pbs = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pbs()
                                                            self.pbs.parent = self
                                                            self._children_name_map["pbs"] = "pbs"
                                                        return self.pbs

                                                    if (child_yang_name == "pir"):
                                                        if (self.pir is None):
                                                            self.pir = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.Pir()
                                                            self.pir.parent = self
                                                            self._children_name_map["pir"] = "pir"
                                                        return self.pir

                                                    if (child_yang_name == "police-config-parameters"):
                                                        if (self.police_config_parameters is None):
                                                            self.police_config_parameters = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police.PoliceConfigParameters()
                                                            self.police_config_parameters.parent = self
                                                            self._children_name_map["police_config_parameters"] = "police-config-parameters"
                                                        return self.police_config_parameters

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "cbs" or name == "cir" or name == "pbs" or name == "pir" or name == "police-config-parameters" or name == "policer-type" or name == "profile-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "policer-type"):
                                                        self.policer_type = value
                                                        self.policer_type.value_namespace = name_space
                                                        self.policer_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-id"):
                                                        self.profile_id = value
                                                        self.profile_id.value_namespace = name_space
                                                        self.profile_id.value_namespace_prefix = name_space_prefix


                                            class Wfq(Entity):
                                                """
                                                WFQ parameters
                                                
                                                .. attribute:: bandwidth
                                                
                                                	CFG Bandwidth
                                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth>`
                                                
                                                .. attribute:: chunk_id
                                                
                                                	Chunk ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: committed_weight
                                                
                                                	Committed weight
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: excess_ratio
                                                
                                                	Parent Excess ratio
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: excess_weight
                                                
                                                	Excess weight
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: level
                                                
                                                	Level
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: parent_bandwidth
                                                
                                                	Parent bandwidth
                                                	**type**\:   :py:class:`ParentBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth>`
                                                
                                                .. attribute:: profile_id
                                                
                                                	WFQ profile
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq, self).__init__()

                                                    self.yang_name = "wfq"
                                                    self.yang_parent_name = "qos-show-ea-st-v2"

                                                    self.chunk_id = YLeaf(YType.uint32, "chunk-id")

                                                    self.committed_weight = YLeaf(YType.uint32, "committed-weight")

                                                    self.excess_ratio = YLeaf(YType.uint16, "excess-ratio")

                                                    self.excess_weight = YLeaf(YType.uint16, "excess-weight")

                                                    self.level = YLeaf(YType.uint8, "level")

                                                    self.profile_id = YLeaf(YType.uint32, "profile-id")

                                                    self.bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth()
                                                    self.bandwidth.parent = self
                                                    self._children_name_map["bandwidth"] = "bandwidth"
                                                    self._children_yang_names.add("bandwidth")

                                                    self.parent_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth()
                                                    self.parent_bandwidth.parent = self
                                                    self._children_name_map["parent_bandwidth"] = "parent-bandwidth"
                                                    self._children_yang_names.add("parent-bandwidth")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("chunk_id",
                                                                    "committed_weight",
                                                                    "excess_ratio",
                                                                    "excess_weight",
                                                                    "level",
                                                                    "profile_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq, self).__setattr__(name, value)


                                                class ParentBandwidth(Entity):
                                                    """
                                                    Parent bandwidth
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth, self).__init__()

                                                        self.yang_name = "parent-bandwidth"
                                                        self.yang_parent_name = "wfq"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "parent-bandwidth" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix


                                                class Bandwidth(Entity):
                                                    """
                                                    CFG Bandwidth
                                                    
                                                    .. attribute:: unit
                                                    
                                                    	Config unit
                                                    	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Config value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth, self).__init__()

                                                        self.yang_name = "bandwidth"
                                                        self.yang_parent_name = "wfq"

                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                        self.value = YLeaf(YType.uint32, "value")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("unit",
                                                                        "value") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.unit.is_set or
                                                            self.value.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.unit.yfilter != YFilter.not_set or
                                                            self.value.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "bandwidth" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.unit.get_name_leafdata())
                                                        if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.value.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "unit" or name == "value"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "unit"):
                                                            self.unit = value
                                                            self.unit.value_namespace = name_space
                                                            self.unit.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "value"):
                                                            self.value = value
                                                            self.value.value_namespace = name_space
                                                            self.value.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.chunk_id.is_set or
                                                        self.committed_weight.is_set or
                                                        self.excess_ratio.is_set or
                                                        self.excess_weight.is_set or
                                                        self.level.is_set or
                                                        self.profile_id.is_set or
                                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                                        (self.parent_bandwidth is not None and self.parent_bandwidth.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.chunk_id.yfilter != YFilter.not_set or
                                                        self.committed_weight.yfilter != YFilter.not_set or
                                                        self.excess_ratio.yfilter != YFilter.not_set or
                                                        self.excess_weight.yfilter != YFilter.not_set or
                                                        self.level.yfilter != YFilter.not_set or
                                                        self.profile_id.yfilter != YFilter.not_set or
                                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                                        (self.parent_bandwidth is not None and self.parent_bandwidth.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wfq" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.chunk_id.is_set or self.chunk_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.chunk_id.get_name_leafdata())
                                                    if (self.committed_weight.is_set or self.committed_weight.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.committed_weight.get_name_leafdata())
                                                    if (self.excess_ratio.is_set or self.excess_ratio.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.excess_ratio.get_name_leafdata())
                                                    if (self.excess_weight.is_set or self.excess_weight.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.excess_weight.get_name_leafdata())
                                                    if (self.level.is_set or self.level.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.level.get_name_leafdata())
                                                    if (self.profile_id.is_set or self.profile_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.profile_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "bandwidth"):
                                                        if (self.bandwidth is None):
                                                            self.bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.Bandwidth()
                                                            self.bandwidth.parent = self
                                                            self._children_name_map["bandwidth"] = "bandwidth"
                                                        return self.bandwidth

                                                    if (child_yang_name == "parent-bandwidth"):
                                                        if (self.parent_bandwidth is None):
                                                            self.parent_bandwidth = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq.ParentBandwidth()
                                                            self.parent_bandwidth.parent = self
                                                            self._children_name_map["parent_bandwidth"] = "parent-bandwidth"
                                                        return self.parent_bandwidth

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "bandwidth" or name == "parent-bandwidth" or name == "chunk-id" or name == "committed-weight" or name == "excess-ratio" or name == "excess-weight" or name == "level" or name == "profile-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "chunk-id"):
                                                        self.chunk_id = value
                                                        self.chunk_id.value_namespace = name_space
                                                        self.chunk_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "committed-weight"):
                                                        self.committed_weight = value
                                                        self.committed_weight.value_namespace = name_space
                                                        self.committed_weight.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "excess-ratio"):
                                                        self.excess_ratio = value
                                                        self.excess_ratio.value_namespace = name_space
                                                        self.excess_ratio.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "excess-weight"):
                                                        self.excess_weight = value
                                                        self.excess_weight.value_namespace = name_space
                                                        self.excess_weight.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "level"):
                                                        self.level = value
                                                        self.level.value_namespace = name_space
                                                        self.level.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "profile-id"):
                                                        self.profile_id = value
                                                        self.profile_id.value_namespace = name_space
                                                        self.profile_id.value_namespace_prefix = name_space_prefix


                                            class Wred(Entity):
                                                """
                                                WRED parameters
                                                
                                                .. attribute:: curve
                                                
                                                	Curve details
                                                	**type**\: list of    :py:class:`Curve <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve>`
                                                
                                                .. attribute:: curve_xr
                                                
                                                	Number of curves
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: type
                                                
                                                	WRED type
                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Wred>`
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred, self).__init__()

                                                    self.yang_name = "wred"
                                                    self.yang_parent_name = "qos-show-ea-st-v2"

                                                    self.curve_xr = YLeaf(YType.uint16, "curve-xr")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.curve = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("curve_xr",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred, self).__setattr__(name, value)


                                                class Curve(Entity):
                                                    """
                                                    Curve details
                                                    
                                                    .. attribute:: absolute_index
                                                    
                                                    	Absolute Index
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: curve_id
                                                    
                                                    	Curve ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: exp_match
                                                    
                                                    	WRED exp match if EXP start value equals to end value Format\: <start\-value> , else range Format\: <start\-value> <end\-value>
                                                    	**type**\:  str
                                                    
                                                    .. attribute:: match
                                                    
                                                    	WRED match if precedence start value equals to end value Format\: <start\-value> , else range Format\: <start\-value> <end\-value>
                                                    	**type**\:  str
                                                    
                                                    .. attribute:: max_threshold
                                                    
                                                    	Maximum threshold
                                                    	**type**\:   :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold>`
                                                    
                                                    .. attribute:: max_threshold_user_config
                                                    
                                                    	Maximum threshold WRED context
                                                    	**type**\:   :py:class:`MaxThresholdUserConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig>`
                                                    
                                                    .. attribute:: min_threshold
                                                    
                                                    	Minimum threshold
                                                    	**type**\:   :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold>`
                                                    
                                                    .. attribute:: min_threshold_user_config
                                                    
                                                    	Minimum threshold WRED context
                                                    	**type**\:   :py:class:`MinThresholdUserConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig>`
                                                    
                                                    .. attribute:: template_id
                                                    
                                                    	Template ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve, self).__init__()

                                                        self.yang_name = "curve"
                                                        self.yang_parent_name = "wred"

                                                        self.absolute_index = YLeaf(YType.uint16, "absolute-index")

                                                        self.curve_id = YLeaf(YType.uint16, "curve-id")

                                                        self.exp_match = YLeaf(YType.str, "exp-match")

                                                        self.match = YLeaf(YType.str, "match")

                                                        self.template_id = YLeaf(YType.uint16, "template-id")

                                                        self.max_threshold = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold()
                                                        self.max_threshold.parent = self
                                                        self._children_name_map["max_threshold"] = "max-threshold"
                                                        self._children_yang_names.add("max-threshold")

                                                        self.max_threshold_user_config = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig()
                                                        self.max_threshold_user_config.parent = self
                                                        self._children_name_map["max_threshold_user_config"] = "max-threshold-user-config"
                                                        self._children_yang_names.add("max-threshold-user-config")

                                                        self.min_threshold = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold()
                                                        self.min_threshold.parent = self
                                                        self._children_name_map["min_threshold"] = "min-threshold"
                                                        self._children_yang_names.add("min-threshold")

                                                        self.min_threshold_user_config = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig()
                                                        self.min_threshold_user_config.parent = self
                                                        self._children_name_map["min_threshold_user_config"] = "min-threshold-user-config"
                                                        self._children_yang_names.add("min-threshold-user-config")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("absolute_index",
                                                                        "curve_id",
                                                                        "exp_match",
                                                                        "match",
                                                                        "template_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve, self).__setattr__(name, value)


                                                    class MinThreshold(Entity):
                                                        """
                                                        Minimum threshold
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold, self).__init__()

                                                            self.yang_name = "min-threshold"
                                                            self.yang_parent_name = "curve"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "min-threshold" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class MinThresholdUserConfig(Entity):
                                                        """
                                                        Minimum threshold WRED context
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig, self).__init__()

                                                            self.yang_name = "min-threshold-user-config"
                                                            self.yang_parent_name = "curve"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "min-threshold-user-config" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class MaxThreshold(Entity):
                                                        """
                                                        Maximum threshold
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold, self).__init__()

                                                            self.yang_name = "max-threshold"
                                                            self.yang_parent_name = "curve"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "max-threshold" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix


                                                    class MaxThresholdUserConfig(Entity):
                                                        """
                                                        Maximum threshold WRED context
                                                        
                                                        .. attribute:: unit
                                                        
                                                        	Config unit
                                                        	**type**\:   :py:class:`QosUnit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.QosUnit>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	Config value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig, self).__init__()

                                                            self.yang_name = "max-threshold-user-config"
                                                            self.yang_parent_name = "curve"

                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                            self.value = YLeaf(YType.uint32, "value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("unit",
                                                                            "value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.unit.is_set or
                                                                self.value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.unit.yfilter != YFilter.not_set or
                                                                self.value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "max-threshold-user-config" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.unit.is_set or self.unit.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.unit.get_name_leafdata())
                                                            if (self.value.is_set or self.value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "unit" or name == "value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "unit"):
                                                                self.unit = value
                                                                self.unit.value_namespace = name_space
                                                                self.unit.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "value"):
                                                                self.value = value
                                                                self.value.value_namespace = name_space
                                                                self.value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.absolute_index.is_set or
                                                            self.curve_id.is_set or
                                                            self.exp_match.is_set or
                                                            self.match.is_set or
                                                            self.template_id.is_set or
                                                            (self.max_threshold is not None and self.max_threshold.has_data()) or
                                                            (self.max_threshold_user_config is not None and self.max_threshold_user_config.has_data()) or
                                                            (self.min_threshold is not None and self.min_threshold.has_data()) or
                                                            (self.min_threshold_user_config is not None and self.min_threshold_user_config.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.absolute_index.yfilter != YFilter.not_set or
                                                            self.curve_id.yfilter != YFilter.not_set or
                                                            self.exp_match.yfilter != YFilter.not_set or
                                                            self.match.yfilter != YFilter.not_set or
                                                            self.template_id.yfilter != YFilter.not_set or
                                                            (self.max_threshold is not None and self.max_threshold.has_operation()) or
                                                            (self.max_threshold_user_config is not None and self.max_threshold_user_config.has_operation()) or
                                                            (self.min_threshold is not None and self.min_threshold.has_operation()) or
                                                            (self.min_threshold_user_config is not None and self.min_threshold_user_config.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "curve" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.absolute_index.is_set or self.absolute_index.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.absolute_index.get_name_leafdata())
                                                        if (self.curve_id.is_set or self.curve_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.curve_id.get_name_leafdata())
                                                        if (self.exp_match.is_set or self.exp_match.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exp_match.get_name_leafdata())
                                                        if (self.match.is_set or self.match.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.match.get_name_leafdata())
                                                        if (self.template_id.is_set or self.template_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.template_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "max-threshold"):
                                                            if (self.max_threshold is None):
                                                                self.max_threshold = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThreshold()
                                                                self.max_threshold.parent = self
                                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                            return self.max_threshold

                                                        if (child_yang_name == "max-threshold-user-config"):
                                                            if (self.max_threshold_user_config is None):
                                                                self.max_threshold_user_config = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MaxThresholdUserConfig()
                                                                self.max_threshold_user_config.parent = self
                                                                self._children_name_map["max_threshold_user_config"] = "max-threshold-user-config"
                                                            return self.max_threshold_user_config

                                                        if (child_yang_name == "min-threshold"):
                                                            if (self.min_threshold is None):
                                                                self.min_threshold = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThreshold()
                                                                self.min_threshold.parent = self
                                                                self._children_name_map["min_threshold"] = "min-threshold"
                                                            return self.min_threshold

                                                        if (child_yang_name == "min-threshold-user-config"):
                                                            if (self.min_threshold_user_config is None):
                                                                self.min_threshold_user_config = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve.MinThresholdUserConfig()
                                                                self.min_threshold_user_config.parent = self
                                                                self._children_name_map["min_threshold_user_config"] = "min-threshold-user-config"
                                                            return self.min_threshold_user_config

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "max-threshold" or name == "max-threshold-user-config" or name == "min-threshold" or name == "min-threshold-user-config" or name == "absolute-index" or name == "curve-id" or name == "exp-match" or name == "match" or name == "template-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "absolute-index"):
                                                            self.absolute_index = value
                                                            self.absolute_index.value_namespace = name_space
                                                            self.absolute_index.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "curve-id"):
                                                            self.curve_id = value
                                                            self.curve_id.value_namespace = name_space
                                                            self.curve_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exp-match"):
                                                            self.exp_match = value
                                                            self.exp_match.value_namespace = name_space
                                                            self.exp_match.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "match"):
                                                            self.match = value
                                                            self.match.value_namespace = name_space
                                                            self.match.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "template-id"):
                                                            self.template_id = value
                                                            self.template_id.value_namespace = name_space
                                                            self.template_id.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.curve:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.curve_xr.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    for c in self.curve:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.curve_xr.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "wred" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.curve_xr.is_set or self.curve_xr.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.curve_xr.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "curve"):
                                                        for c in self.curve:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred.Curve()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.curve.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "curve" or name == "curve-xr" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "curve-xr"):
                                                        self.curve_xr = value
                                                        self.curve_xr.value_namespace = name_space
                                                        self.curve_xr.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix


                                            class Mark(Entity):
                                                """
                                                Mark parameters
                                                
                                                .. attribute:: child_mark
                                                
                                                	Child mark only
                                                	**type**\:   :py:class:`ChildMark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark>`
                                                
                                                .. attribute:: parent_mark
                                                
                                                	Parent mark only
                                                	**type**\:   :py:class:`ParentMark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark>`
                                                
                                                .. attribute:: parent_police_conform
                                                
                                                	Parent police conform mark
                                                	**type**\:   :py:class:`ParentPoliceConform <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform>`
                                                
                                                .. attribute:: parent_police_exceed
                                                
                                                	Parent police exceed mark
                                                	**type**\:   :py:class:`ParentPoliceExceed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed>`
                                                
                                                .. attribute:: parent_police_violate
                                                
                                                	Parent police violate mark
                                                	**type**\:   :py:class:`ParentPoliceViolate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate>`
                                                
                                                .. attribute:: police_conform
                                                
                                                	Child police conform mark
                                                	**type**\:   :py:class:`PoliceConform <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform>`
                                                
                                                .. attribute:: police_exceed
                                                
                                                	Child police exceed mark
                                                	**type**\:   :py:class:`PoliceExceed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed>`
                                                
                                                .. attribute:: police_violate
                                                
                                                	Child police violate mark
                                                	**type**\:   :py:class:`PoliceViolate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate>`
                                                
                                                

                                                """

                                                _prefix = 'asr9k-qos-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark, self).__init__()

                                                    self.yang_name = "mark"
                                                    self.yang_parent_name = "qos-show-ea-st-v2"

                                                    self.child_mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark()
                                                    self.child_mark.parent = self
                                                    self._children_name_map["child_mark"] = "child-mark"
                                                    self._children_yang_names.add("child-mark")

                                                    self.parent_mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark()
                                                    self.parent_mark.parent = self
                                                    self._children_name_map["parent_mark"] = "parent-mark"
                                                    self._children_yang_names.add("parent-mark")

                                                    self.parent_police_conform = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform()
                                                    self.parent_police_conform.parent = self
                                                    self._children_name_map["parent_police_conform"] = "parent-police-conform"
                                                    self._children_yang_names.add("parent-police-conform")

                                                    self.parent_police_exceed = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed()
                                                    self.parent_police_exceed.parent = self
                                                    self._children_name_map["parent_police_exceed"] = "parent-police-exceed"
                                                    self._children_yang_names.add("parent-police-exceed")

                                                    self.parent_police_violate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate()
                                                    self.parent_police_violate.parent = self
                                                    self._children_name_map["parent_police_violate"] = "parent-police-violate"
                                                    self._children_yang_names.add("parent-police-violate")

                                                    self.police_conform = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform()
                                                    self.police_conform.parent = self
                                                    self._children_name_map["police_conform"] = "police-conform"
                                                    self._children_yang_names.add("police-conform")

                                                    self.police_exceed = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed()
                                                    self.police_exceed.parent = self
                                                    self._children_name_map["police_exceed"] = "police-exceed"
                                                    self._children_yang_names.add("police-exceed")

                                                    self.police_violate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate()
                                                    self.police_violate.parent = self
                                                    self._children_name_map["police_violate"] = "police-violate"
                                                    self._children_yang_names.add("police-violate")


                                                class ChildMark(Entity):
                                                    """
                                                    Child mark only
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark, self).__init__()

                                                        self.yang_name = "child-mark"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "child-mark"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "child-mark" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class PoliceConform(Entity):
                                                    """
                                                    Child police conform mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform, self).__init__()

                                                        self.yang_name = "police-conform"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "police-conform"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-conform" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class PoliceExceed(Entity):
                                                    """
                                                    Child police exceed mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed, self).__init__()

                                                        self.yang_name = "police-exceed"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "police-exceed"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-exceed" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class PoliceViolate(Entity):
                                                    """
                                                    Child police violate mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate, self).__init__()

                                                        self.yang_name = "police-violate"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "police-violate"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "police-violate" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class ParentMark(Entity):
                                                    """
                                                    Parent mark only
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark, self).__init__()

                                                        self.yang_name = "parent-mark"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "parent-mark"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "parent-mark" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class ParentPoliceConform(Entity):
                                                    """
                                                    Parent police conform mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform, self).__init__()

                                                        self.yang_name = "parent-police-conform"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "parent-police-conform"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "parent-police-conform" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class ParentPoliceExceed(Entity):
                                                    """
                                                    Parent police exceed mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed, self).__init__()

                                                        self.yang_name = "parent-police-exceed"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "parent-police-exceed"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "parent-police-exceed" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix


                                                class ParentPoliceViolate(Entity):
                                                    """
                                                    Parent police violate mark
                                                    
                                                    .. attribute:: action_type
                                                    
                                                    	Action type
                                                    	**type**\:   :py:class:`Action <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.Action>`
                                                    
                                                    .. attribute:: mark_detail
                                                    
                                                    	Mark value
                                                    	**type**\: list of    :py:class:`MarkDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate.MarkDetail>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'asr9k-qos-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate, self).__init__()

                                                        self.yang_name = "parent-police-violate"
                                                        self.yang_parent_name = "mark"

                                                        self.action_type = YLeaf(YType.enumeration, "action-type")

                                                        self.mark_detail = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("action_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate, self).__setattr__(name, value)


                                                    class MarkDetail(Entity):
                                                        """
                                                        Mark value
                                                        
                                                        .. attribute:: action_opcode
                                                        
                                                        	Action opcode
                                                        	**type**\:   :py:class:`ActionOpcode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_asr9k_qos_oper.ActionOpcode>`
                                                        
                                                        .. attribute:: mark_value
                                                        
                                                        	Mark value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'asr9k-qos-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate.MarkDetail, self).__init__()

                                                            self.yang_name = "mark-detail"
                                                            self.yang_parent_name = "parent-police-violate"

                                                            self.action_opcode = YLeaf(YType.enumeration, "action-opcode")

                                                            self.mark_value = YLeaf(YType.uint8, "mark-value")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("action_opcode",
                                                                            "mark_value") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate.MarkDetail, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate.MarkDetail, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.action_opcode.is_set or
                                                                self.mark_value.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.action_opcode.yfilter != YFilter.not_set or
                                                                self.mark_value.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "mark-detail" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.action_opcode.is_set or self.action_opcode.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.action_opcode.get_name_leafdata())
                                                            if (self.mark_value.is_set or self.mark_value.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.mark_value.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "action-opcode" or name == "mark-value"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "action-opcode"):
                                                                self.action_opcode = value
                                                                self.action_opcode.value_namespace = name_space
                                                                self.action_opcode.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "mark-value"):
                                                                self.mark_value = value
                                                                self.mark_value.value_namespace = name_space
                                                                self.mark_value.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_data()):
                                                                return True
                                                        return self.action_type.is_set

                                                    def has_operation(self):
                                                        for c in self.mark_detail:
                                                            if (c.has_operation()):
                                                                return True
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.action_type.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "parent-police-violate" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.action_type.is_set or self.action_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.action_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "mark-detail"):
                                                            for c in self.mark_detail:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate.MarkDetail()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.mark_detail.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "mark-detail" or name == "action-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "action-type"):
                                                            self.action_type = value
                                                            self.action_type.value_namespace = name_space
                                                            self.action_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        (self.child_mark is not None and self.child_mark.has_data()) or
                                                        (self.parent_mark is not None and self.parent_mark.has_data()) or
                                                        (self.parent_police_conform is not None and self.parent_police_conform.has_data()) or
                                                        (self.parent_police_exceed is not None and self.parent_police_exceed.has_data()) or
                                                        (self.parent_police_violate is not None and self.parent_police_violate.has_data()) or
                                                        (self.police_conform is not None and self.police_conform.has_data()) or
                                                        (self.police_exceed is not None and self.police_exceed.has_data()) or
                                                        (self.police_violate is not None and self.police_violate.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        (self.child_mark is not None and self.child_mark.has_operation()) or
                                                        (self.parent_mark is not None and self.parent_mark.has_operation()) or
                                                        (self.parent_police_conform is not None and self.parent_police_conform.has_operation()) or
                                                        (self.parent_police_exceed is not None and self.parent_police_exceed.has_operation()) or
                                                        (self.parent_police_violate is not None and self.parent_police_violate.has_operation()) or
                                                        (self.police_conform is not None and self.police_conform.has_operation()) or
                                                        (self.police_exceed is not None and self.police_exceed.has_operation()) or
                                                        (self.police_violate is not None and self.police_violate.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mark" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "child-mark"):
                                                        if (self.child_mark is None):
                                                            self.child_mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ChildMark()
                                                            self.child_mark.parent = self
                                                            self._children_name_map["child_mark"] = "child-mark"
                                                        return self.child_mark

                                                    if (child_yang_name == "parent-mark"):
                                                        if (self.parent_mark is None):
                                                            self.parent_mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentMark()
                                                            self.parent_mark.parent = self
                                                            self._children_name_map["parent_mark"] = "parent-mark"
                                                        return self.parent_mark

                                                    if (child_yang_name == "parent-police-conform"):
                                                        if (self.parent_police_conform is None):
                                                            self.parent_police_conform = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceConform()
                                                            self.parent_police_conform.parent = self
                                                            self._children_name_map["parent_police_conform"] = "parent-police-conform"
                                                        return self.parent_police_conform

                                                    if (child_yang_name == "parent-police-exceed"):
                                                        if (self.parent_police_exceed is None):
                                                            self.parent_police_exceed = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceExceed()
                                                            self.parent_police_exceed.parent = self
                                                            self._children_name_map["parent_police_exceed"] = "parent-police-exceed"
                                                        return self.parent_police_exceed

                                                    if (child_yang_name == "parent-police-violate"):
                                                        if (self.parent_police_violate is None):
                                                            self.parent_police_violate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.ParentPoliceViolate()
                                                            self.parent_police_violate.parent = self
                                                            self._children_name_map["parent_police_violate"] = "parent-police-violate"
                                                        return self.parent_police_violate

                                                    if (child_yang_name == "police-conform"):
                                                        if (self.police_conform is None):
                                                            self.police_conform = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceConform()
                                                            self.police_conform.parent = self
                                                            self._children_name_map["police_conform"] = "police-conform"
                                                        return self.police_conform

                                                    if (child_yang_name == "police-exceed"):
                                                        if (self.police_exceed is None):
                                                            self.police_exceed = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceExceed()
                                                            self.police_exceed.parent = self
                                                            self._children_name_map["police_exceed"] = "police-exceed"
                                                        return self.police_exceed

                                                    if (child_yang_name == "police-violate"):
                                                        if (self.police_violate is None):
                                                            self.police_violate = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark.PoliceViolate()
                                                            self.police_violate.parent = self
                                                            self._children_name_map["police_violate"] = "police-violate"
                                                        return self.police_violate

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "child-mark" or name == "parent-mark" or name == "parent-police-conform" or name == "parent-police-exceed" or name == "parent-police-violate" or name == "police-conform" or name == "police-exceed" or name == "police-violate"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass

                                            def has_data(self):
                                                return (
                                                    self.class_level.is_set or
                                                    self.class_name.is_set or
                                                    self.parent_class_name.is_set or
                                                    self.parent_policy_name.is_set or
                                                    self.policy_name.is_set or
                                                    (self.mark is not None and self.mark.has_data()) or
                                                    (self.police is not None and self.police.has_data()) or
                                                    (self.queue is not None and self.queue.has_data()) or
                                                    (self.queue_limit_parameters is not None and self.queue_limit_parameters.has_data()) or
                                                    (self.shape is not None and self.shape.has_data()) or
                                                    (self.wfq is not None and self.wfq.has_data()) or
                                                    (self.wred is not None and self.wred.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.class_level.yfilter != YFilter.not_set or
                                                    self.class_name.yfilter != YFilter.not_set or
                                                    self.parent_class_name.yfilter != YFilter.not_set or
                                                    self.parent_policy_name.yfilter != YFilter.not_set or
                                                    self.policy_name.yfilter != YFilter.not_set or
                                                    (self.mark is not None and self.mark.has_operation()) or
                                                    (self.police is not None and self.police.has_operation()) or
                                                    (self.queue is not None and self.queue.has_operation()) or
                                                    (self.queue_limit_parameters is not None and self.queue_limit_parameters.has_operation()) or
                                                    (self.shape is not None and self.shape.has_operation()) or
                                                    (self.wfq is not None and self.wfq.has_operation()) or
                                                    (self.wred is not None and self.wred.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "qos-show-ea-st-v2" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.class_level.is_set or self.class_level.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_level.get_name_leafdata())
                                                if (self.class_name.is_set or self.class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.class_name.get_name_leafdata())
                                                if (self.parent_class_name.is_set or self.parent_class_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_class_name.get_name_leafdata())
                                                if (self.parent_policy_name.is_set or self.parent_policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.parent_policy_name.get_name_leafdata())
                                                if (self.policy_name.is_set or self.policy_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.policy_name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mark"):
                                                    if (self.mark is None):
                                                        self.mark = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Mark()
                                                        self.mark.parent = self
                                                        self._children_name_map["mark"] = "mark"
                                                    return self.mark

                                                if (child_yang_name == "police"):
                                                    if (self.police is None):
                                                        self.police = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Police()
                                                        self.police.parent = self
                                                        self._children_name_map["police"] = "police"
                                                    return self.police

                                                if (child_yang_name == "queue"):
                                                    if (self.queue is None):
                                                        self.queue = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Queue()
                                                        self.queue.parent = self
                                                        self._children_name_map["queue"] = "queue"
                                                    return self.queue

                                                if (child_yang_name == "queue-limit-parameters"):
                                                    if (self.queue_limit_parameters is None):
                                                        self.queue_limit_parameters = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.QueueLimitParameters()
                                                        self.queue_limit_parameters.parent = self
                                                        self._children_name_map["queue_limit_parameters"] = "queue-limit-parameters"
                                                    return self.queue_limit_parameters

                                                if (child_yang_name == "shape"):
                                                    if (self.shape is None):
                                                        self.shape = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Shape()
                                                        self.shape.parent = self
                                                        self._children_name_map["shape"] = "shape"
                                                    return self.shape

                                                if (child_yang_name == "wfq"):
                                                    if (self.wfq is None):
                                                        self.wfq = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wfq()
                                                        self.wfq.parent = self
                                                        self._children_name_map["wfq"] = "wfq"
                                                    return self.wfq

                                                if (child_yang_name == "wred"):
                                                    if (self.wred is None):
                                                        self.wred = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2.Wred()
                                                        self.wred.parent = self
                                                        self._children_name_map["wred"] = "wred"
                                                    return self.wred

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mark" or name == "police" or name == "queue" or name == "queue-limit-parameters" or name == "shape" or name == "wfq" or name == "wred" or name == "class-level" or name == "class-name" or name == "parent-class-name" or name == "parent-policy-name" or name == "policy-name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "class-level"):
                                                    self.class_level = value
                                                    self.class_level.value_namespace = name_space
                                                    self.class_level.value_namespace_prefix = name_space_prefix
                                                if(value_path == "class-name"):
                                                    self.class_name = value
                                                    self.class_name.value_namespace = name_space
                                                    self.class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-class-name"):
                                                    self.parent_class_name = value
                                                    self.parent_class_name.value_namespace = name_space
                                                    self.parent_class_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "parent-policy-name"):
                                                    self.parent_policy_name = value
                                                    self.parent_policy_name.value_namespace = name_space
                                                    self.parent_policy_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "policy-name"):
                                                    self.policy_name = value
                                                    self.policy_name.value_namespace = name_space
                                                    self.policy_name.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.qos_show_ea_st_v2:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.qos_show_ea_st_v2:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-typhoon" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "qos-show-ea-st-v2"):
                                                for c in self.qos_show_ea_st_v2:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon.QosShowEaStV2()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.qos_show_ea_st_v2.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "qos-show-ea-st-v2"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        return (
                                            (self.header is not None and self.header.has_data()) or
                                            (self.policy is not None and self.policy.has_data()) or
                                            (self.policy_typhoon is not None and self.policy_typhoon.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.header is not None and self.header.has_operation()) or
                                            (self.policy is not None and self.policy.has_operation()) or
                                            (self.policy_typhoon is not None and self.policy_typhoon.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "details" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "header"):
                                            if (self.header is None):
                                                self.header = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Header()
                                                self.header.parent = self
                                                self._children_name_map["header"] = "header"
                                            return self.header

                                        if (child_yang_name == "policy"):
                                            if (self.policy is None):
                                                self.policy = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.Policy()
                                                self.policy.parent = self
                                                self._children_name_map["policy"] = "policy"
                                            return self.policy

                                        if (child_yang_name == "policy-typhoon"):
                                            if (self.policy_typhoon is None):
                                                self.policy_typhoon = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details.PolicyTyphoon()
                                                self.policy_typhoon.parent = self
                                                self._children_name_map["policy_typhoon"] = "policy-typhoon"
                                            return self.policy_typhoon

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "header" or name == "policy" or name == "policy-typhoon"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.interface_name.is_set or
                                        (self.details is not None and self.details.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        (self.details is not None and self.details.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "member-interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "details"):
                                        if (self.details is None):
                                            self.details = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface.Details()
                                            self.details.parent = self
                                            self._children_name_map["details"] = "details"
                                        return self.details

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "details" or name == "interface-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.member_interface:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.member_interface:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "member-interfaces" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "member-interface"):
                                    for c in self.member_interface:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces.MemberInterface()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.member_interface.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "member-interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (self.member_interfaces is not None and self.member_interfaces.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.member_interfaces is not None and self.member_interfaces.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bundle-input" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "member-interfaces"):
                                if (self.member_interfaces is None):
                                    self.member_interfaces = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput.MemberInterfaces()
                                    self.member_interfaces.parent = self
                                    self._children_name_map["member_interfaces"] = "member-interfaces"
                                return self.member_interfaces

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "member-interfaces"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            self.interface_name.is_set or
                            (self.bundle_input is not None and self.bundle_input.has_data()) or
                            (self.bundle_output is not None and self.bundle_output.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.interface_name.yfilter != YFilter.not_set or
                            (self.bundle_input is not None and self.bundle_input.has_operation()) or
                            (self.bundle_output is not None and self.bundle_output.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "bundle-interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.interface_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "bundle-input"):
                            if (self.bundle_input is None):
                                self.bundle_input = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleInput()
                                self.bundle_input.parent = self
                                self._children_name_map["bundle_input"] = "bundle-input"
                            return self.bundle_input

                        if (child_yang_name == "bundle-output"):
                            if (self.bundle_output is None):
                                self.bundle_output = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface.BundleOutput()
                                self.bundle_output.parent = self
                                self._children_name_map["bundle_output"] = "bundle-output"
                            return self.bundle_output

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "bundle-input" or name == "bundle-output" or name == "interface-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "interface-name"):
                            self.interface_name = value
                            self.interface_name.value_namespace = name_space
                            self.interface_name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.bundle_interface:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.bundle_interface:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "bundle-interfaces" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "bundle-interface"):
                        for c in self.bundle_interface:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = PlatformQos.Nodes.Node.BundleInterfaces.BundleInterface()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.bundle_interface.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "bundle-interface"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass

            def has_data(self):
                return (
                    self.node_name.is_set or
                    (self.bundle_interfaces is not None and self.bundle_interfaces.has_data()) or
                    (self.capability is not None and self.capability.has_data()) or
                    (self.interfaces is not None and self.interfaces.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.node_name.yfilter != YFilter.not_set or
                    (self.bundle_interfaces is not None and self.bundle_interfaces.has_operation()) or
                    (self.capability is not None and self.capability.has_operation()) or
                    (self.interfaces is not None and self.interfaces.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "node" + "[node-name='" + self.node_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-asr9k-qos-oper:platform-qos/nodes/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.node_name.is_set or self.node_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.node_name.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "bundle-interfaces"):
                    if (self.bundle_interfaces is None):
                        self.bundle_interfaces = PlatformQos.Nodes.Node.BundleInterfaces()
                        self.bundle_interfaces.parent = self
                        self._children_name_map["bundle_interfaces"] = "bundle-interfaces"
                    return self.bundle_interfaces

                if (child_yang_name == "capability"):
                    if (self.capability is None):
                        self.capability = PlatformQos.Nodes.Node.Capability()
                        self.capability.parent = self
                        self._children_name_map["capability"] = "capability"
                    return self.capability

                if (child_yang_name == "interfaces"):
                    if (self.interfaces is None):
                        self.interfaces = PlatformQos.Nodes.Node.Interfaces()
                        self.interfaces.parent = self
                        self._children_name_map["interfaces"] = "interfaces"
                    return self.interfaces

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "bundle-interfaces" or name == "capability" or name == "interfaces" or name == "node-name"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "node-name"):
                    self.node_name = value
                    self.node_name.value_namespace = name_space
                    self.node_name.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.node:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.node:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "nodes" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-asr9k-qos-oper:platform-qos/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "node"):
                for c in self.node:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = PlatformQos.Nodes.Node()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.node.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "node"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass

    def has_data(self):
        return (self.nodes is not None and self.nodes.has_data())

    def has_operation(self):
        return (
            self.yfilter != YFilter.not_set or
            (self.nodes is not None and self.nodes.has_operation()))

    def get_segment_path(self):
        path_buffer = ""
        path_buffer = "Cisco-IOS-XR-asr9k-qos-oper:platform-qos" + path_buffer

        return path_buffer

    def get_entity_path(self, ancestor):
        path_buffer = ""
        if (not ancestor is None):
            raise YPYModelError("ancestor has to be None for top-level node")

        path_buffer = self.get_segment_path()
        leaf_name_data = LeafDataList()

        entity_path = EntityPath(path_buffer, leaf_name_data)
        return entity_path

    def get_child_by_name(self, child_yang_name, segment_path):
        child = self._get_child_by_seg_name([child_yang_name, segment_path])
        if child is not None:
            return child

        if (child_yang_name == "nodes"):
            if (self.nodes is None):
                self.nodes = PlatformQos.Nodes()
                self.nodes.parent = self
                self._children_name_map["nodes"] = "nodes"
            return self.nodes

        return None

    def has_leaf_or_child_of_name(self, name):
        if(name == "nodes"):
            return True
        return False

    def set_value(self, value_path, value, name_space, name_space_prefix):
        pass

    def clone_ptr(self):
        self._top_entity = PlatformQos()
        return self._top_entity

